/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/m/InstanceManager','sap/f/FlexibleColumnLayout','sap/ui/base/Object','sap/ui/core/routing/History',"sap/base/Log"],function(I,F,B,H,L){"use strict";var T=B.extend("sap.f.routing.TargetHandler",{constructor:function(c){this._aQueue=[];this._oNavigationOrderPromise=Promise.resolve();if(c===undefined){this._bCloseDialogs=true;}else{this._bCloseDialogs=!!c;}}});T.prototype.setCloseDialogs=function(c){this._bCloseDialogs=!!c;return this;};T.prototype.getCloseDialogs=function(){return this._bCloseDialogs;};T.prototype.addNavigation=function(p){this._aQueue.push(p);};T.prototype.navigate=function(d){var r=this._createResultingNavigations(d.navigationIdentifier),c=false,b=this._getDirection(d),n;while(r.length){n=this._applyNavigationResult(r.shift().oParams,b);c=c||n;}if(c){this._closeDialogs();}};T.prototype._chainNavigation=function(n,N){var p=this._oNavigationOrderPromise.then(n);this._oNavigationOrderPromise=p.catch(function(e){L.error("The following error occurred while displaying routing target with name '"+N+"': "+e);});return p;};T.prototype._getDirection=function(d){var t=d.level,h=H.getInstance(),b=false;if(d.direction==="Backwards"){b=true;}else if(isNaN(t)||isNaN(this._iCurrentLevel)||t===this._iCurrentLevel){if(d.askHistory){b=h.getDirection()==="Backwards";}}else{b=t<this._iCurrentLevel;}this._iCurrentLevel=t;return b;};T.prototype._createResultingNavigations=function(n){var i,c,C,o,r=[],R;while(this._aQueue.length){c=this._aQueue.shift();C=c.targetControl;o={oContainer:C,oParams:c,placeholderConfig:c.placeholderConfig};if(!a(C)){continue;}for(i=0;i<r.length;i++){R=r[i];if(R.oContainer!==C){continue;}}r.push(o);}return r;};T.prototype._applyNavigationResult=function(p,b){var t=p.targetControl,A=p.eventData,s=p.placeholderShown?"show":(p.transition||""),o=p.transitionParameters,v=p.view.getId(),c,i=t instanceof F,S=false,P=p.placeholderConfig;if(i){c=[t.getCurrentBeginColumnPage(),t.getCurrentMidColumnPage(),t.getCurrentEndColumnPage()];S=c.some(function(C){return C&&C.getId()===v;});}if(S){if(P.autoClose){t.hidePlaceholder(P);}L.info("navigation to view with id: "+v+" is skipped since it already is displayed by its targetControl","sap.f.routing.TargetHandler");return false;}L.info("navigation to view with id: "+v+" the targetControl is "+t.getId()+" backwards is "+b);if(b){t._safeBackToPage(v,s,A,o);}else{t.to(v,s,A,o);}if(P.autoClose){t.hidePlaceholder(P);}return true;};T.prototype._closeDialogs=function(){if(!this._bCloseDialogs){return;}if(I.hasOpenPopover()){I.closeAllPopovers();}if(I.hasOpenDialog()){I.closeAllDialogs();}if(I.hasOpenLightBox()){I.closeAllLightBoxes();}};function a(c){return c&&c.isA(["sap.m.NavContainer","sap.m.SplitContainer","sap.f.FlexibleColumnLayout"]);}T.prototype.showPlaceholder=function(s){var c=s.container,n=true,o;if(s.object&&!(s.object instanceof Promise)){o=s.object;}if(s.container&&typeof s.container.needPlaceholder==="function"){n=s.container.needPlaceholder(s.aggregation,o);}if(n){return c.showPlaceholder(s);}else{return Promise.resolve();}};return T;});
