/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/m/Title","sap/m/Image","sap/m/MenuButton","sap/m/OverflowToolbar","sap/m/OverflowToolbarButton","sap/m/ToolbarSpacer","sap/m/OverflowToolbarLayoutData","sap/m/FlexItemData","./CoPilot","./Accessibility","sap/m/library","sap/ui/core/library","sap/m/HBox"],function(T,I,M,O,a,b,c,F,C,A,l,d,H){"use strict";var e=l.OverflowToolbarPriority;var f=l.ToolbarDesign;var B=l.ButtonType;var g=d.TitleLevel;var h=function(o){this._oContext=o;this._oControls={};this._oAcc=new A();};h.prototype.getOverflowToolbar=function(){var o=this._oAcc;if(!this._oControls.oOverflowToolbar){this._oControls.oOverflowToolbar=new O({design:f.Transparent,style:"Clear"}).addStyleClass("sapFShellBarOTB").setLayoutData(new F({growFactor:1,shrinkFactor:1,minWidth:"0px",maxWidth:"100%"}))._setEnableAccessibilty(false);this._oControls.oOverflowToolbar._getOverflowButton().addStyleClass("sapFShellBarItem sapFShellBarOverflowButton");}this._oControls.oOverflowToolbar._getOverflowButton()._updateBadgeInvisibleText=function(v){this._getBadgeInvisibleText().setText(v+o.getEntityTooltip("NOTIFICATIONS"));};return this._oControls.oOverflowToolbar;};h.prototype.getAdditionalBox=function(){if(!this._oControls.oAdditionalBox){this._oControls.oAdditionalBox=new H({alignItems:"Center"}).addStyleClass("sapFShellBarOAHB");}return this._oControls.oAdditionalBox;};h.prototype.getToolbarSpacer=function(){if(!this._oControls.oToolbarSpacer){this._oControls.oToolbarSpacer=new b();}return this._oControls.oToolbarSpacer;};h.prototype.getSecondTitle=function(){if(!this._oControls.oSecondTitle){this._oControls.oSecondTitle=new T({titleStyle:g.H6}).addStyleClass("sapFShellBarSecondTitle").setLayoutData(new F({shrinkFactor:2,minWidth:"1px"}));}return this._oControls.oSecondTitle;};h.prototype.getHomeIcon=function(){if(!this._oControls.oHomeIcon){this._oControls.oHomeIcon=new I({densityAware:false,tooltip:this._oAcc.getEntityTooltip("LOGO"),press:function(){this._oContext.fireEvent("homeIconPressed",{icon:this._oControls.oHomeIcon});}.bind(this)}).addStyleClass("sapFShellBarHomeIcon");}return this._oControls.oHomeIcon;};h.prototype.getMegaMenu=function(){if(!this._oControls.oMegaMenu){this._oControls.oMegaMenu=new M({type:B.Transparent,iconDensityAware:false,layoutData:new F({shrinkFactor:0,minWidth:"0px",maxWidth:"100%"})}).addStyleClass("sapFSHMegaMenu");}return this._oControls.oMegaMenu;};h.prototype.getPrimaryTitle=function(){if(!this._oControls.oPrimaryTitle){this._oControls.oPrimaryTitle=new T({titleStyle:g.H6,level:g.H1}).setLayoutData(new F({shrinkFactor:0,minWidth:"0px",maxWidth:"100%"})).addStyleClass("sapFShellBarPrimaryTitle");}return this._oControls.oPrimaryTitle;};h.prototype.getCopilot=function(){if(!this._oControls.oCopilot){this._oControls.oCopilot=new C({tooltip:this._oAcc.getEntityTooltip("COPILOT"),press:function(){this._oContext.fireEvent("copilotPressed",{image:this._oControls.oCopilot});}.bind(this)});}return this._oControls.oCopilot;};h.prototype.getSearch=function(){if(!this._oControls.oSearch){this._oControls.oSearch=new a({text:"Search",icon:"sap-icon://search",type:B.Transparent,tooltip:this._oAcc.getEntityTooltip("SEARCH"),press:function(){this._oContext.fireEvent("searchButtonPressed",{button:this._oControls.oSearch});}.bind(this)}).setLayoutData(new c({priority:e.Low}));}return this._oControls.oSearch;};h.prototype.getManagedSearch=function(){if(!this._oControls.oManagedSearch){this._oControls.oManagedSearch=this._oContext.getSearchManager()._oSearch;}return this._oControls.oManagedSearch;};h.prototype.getNavButton=function(){if(!this._oControls.oNavButton){this._oControls.oNavButton=new a({icon:"sap-icon://nav-back",type:B.Transparent,tooltip:this._oAcc.getEntityTooltip("BACK"),press:function(){this._oContext.fireEvent("navButtonPressed",{button:this._oControls.oNavButton});}.bind(this)});}return this._oControls.oNavButton;};h.prototype.getMenuButton=function(){if(!this._oControls.oMenuButton){this._oControls.oMenuButton=new a({ariaHasPopup:A.AriaHasPopup.MENU,icon:"sap-icon://menu2",type:B.Transparent,tooltip:this._oAcc.getEntityTooltip("MENU"),press:function(){this._oContext.fireEvent("menuButtonPressed",{button:this._oControls.oMenuButton});}.bind(this)});}return this._oControls.oMenuButton;};h.prototype.getNotifications=function(){var o=this._oAcc;if(!this._oControls.oNotifications){this._oControls.oNotifications=new a({ariaHasPopup:A.AriaHasPopup.NOTIFICATIONS,text:"Notifications",icon:"sap-icon://bell",type:B.Transparent,tooltip:o.getEntityTooltip("NOTIFICATIONS"),press:function(){this._oContext.fireEvent("notificationsPressed",{button:this._oControls.oNotifications});}.bind(this)}).addStyleClass("sapFButtonNotifications").setLayoutData(new c({priority:e.Low}));this._oControls.oNotifications._updateBadgeInvisibleText=function(v){this._getBadgeInvisibleText().setText(v+o.getEntityTooltip("NOTIFICATIONS"));};}return this._oControls.oNotifications;};h.prototype.getProductSwitcher=function(){if(!this._oControls.oProductSwitcher){this._oControls.oProductSwitcher=new a({ariaHasPopup:A.AriaHasPopup.PRODUCTS,text:"My products",icon:"sap-icon://grid",type:B.Transparent,tooltip:this._oAcc.getEntityTooltip("PRODUCTS"),press:function(){this._oContext.fireEvent("productSwitcherPressed",{button:this._oControls.oProductSwitcher});}.bind(this)}).addStyleClass("sapFShellBarGridButton").addStyleClass("sapFShellBarItem");}return this._oControls.oProductSwitcher;};h.prototype.destroy=function(){Object.keys(this._oControls).forEach(function(k){var o=this._oControls[k];if(o){o.destroy();}}.bind(this));};return h;});
