/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/core/Renderer","sap/ui/core/library","sap/ui/core/Core","sap/ui/Device","sap/base/Log","./library","./ListItemBaseRenderer"],function(R,c,C,D,L,l,a){"use strict";var P=l.PopinDisplay;var V=c.VerticalAlign;var b=R.extend(a);b.apiVersion=2;b.render=function(r,o){var t=o.getTable();if(!t){return;}a.render.apply(this,arguments);if(o.getVisible()&&t.hasPopin()){this.renderPopin(r,o,t);}};b.renderHighlight=function(r,o){r.openStart("td");r.class("sapMListTblHighlightCell");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderHighlight.apply(this,arguments);r.close("td");};b.renderNavigated=function(r,o){r.openStart("td");r.class("sapMListTblNavigatedCell");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderNavigated.apply(this,arguments);r.close("td");};b.renderType=function(r,o){r.openStart("td");r.class("sapMListTblNavCol");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderType.apply(this,arguments);r.close("td");};b.renderModeContent=function(r,o){r.openStart("td");r.class("sapMListTblSelCol");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderModeContent.apply(this,arguments);r.close("td");};b.renderCounter=function(r,o){};b.getAriaRole=function(o){return"";};b.renderLIAttributes=function(r,o){r.class("sapMListTblRow");var A=o.getVAlign();if(A!=V.Inherit){r.class("sapMListTblRow"+A);}var t=o.getTable();if(t&&t.getAlternateRowColors()){var p=t.indexOfItem(o);if(p%2==0){r.class("sapMListTblRowAlternate");}}};b.renderLIContentWrapper=function(r,o){var t=o.getTable();if(!t){return;}var d=t.getColumns(true),e=o.getCells();o._destroyClonedHeaders();d.forEach(function(f,i){var h,g=true,j=e[f.getInitialOrder()];if(!f.getVisible()||!j||f.isPopin()){f.setIndex(-1);return;}r.openStart("td",o.getId()+"_cell"+i);r.class("sapMListTblCell");r.attr("data-sap-ui-column",f.getId());if(f){var s=f.getStyleClass(true).split(" ");s&&s.forEach(function(u){r.class(u);});h=f.getHeader();if(h){r.attr("headers",f.getId());}if(!t.hasPopin()&&f.getMergeDuplicates()){var F=f.getMergeFunctionName(),k=F.split("#"),m=k[1],n=k[0];if(typeof j[n]!="function"){L.warning("mergeFunctionName property is defined on "+f+" but this is not function of "+j);}else if(t._bRendering||!j.bOutput){var p=f.getLastValue(),q=j[n](m);if(p===q){g=C.getConfiguration().getAccessibility();j.addStyleClass("sapMListTblCellDupCnt");r.class("sapMListTblCellDup");}else{f.setLastValue(q);}}else if(j.hasStyleClass("sapMListTblCellDupCnt")){r.class("sapMListTblCellDup");}}f.getVAlign()!="Inherit"&&r.style("vertical-align",f.getVAlign().toLowerCase());r.style("text-align",f.getCssAlign());if(f.isHidden()){r.style("display","none");r.attr("aria-hidden","true");}}r.openEnd();if(g){this.applyAriaLabelledBy(h,j);r.renderControl(j);}r.close("td");},this);};b.renderDummyCell=function(r,t){r.openStart("td");r.class("sapMListTblDummyCell");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();r.close("td");};b.applyAriaLabelledBy=function(h,o){if(h&&h.getText&&h.getVisible()&&o.getAriaLabelledBy&&(o.getAriaLabelledBy()||[]).indexOf(h.getId())==-1){o.addAriaLabelledBy(h);}};b.renderPopin=function(r,o,t){o.removePopin();r.openStart("tr",o.getPopin());r.class("sapMListTblSubRow");r.attr("tabindex","-1");if(o.isSelectable()){r.attr("aria-selected",o.getSelected());}r.openEnd();this.renderHighlight(r,o);r.openStart("td",o.getId()+"-subcell");r.class("sapMListTblSubRowCell");r.attr("colspan",t.shouldRenderDummyColumn()?t.getColSpan()+1:t.getColSpan());var p=t.getPopinLayout();r.attr("aria-labelledby",this.getAriaAnnouncement(null,"TABLE_POPIN_ROLE_DESCRIPTION"));r.openEnd();r.openStart("div");r.class("sapMListTblSubCnt");r.class("sapMListTblSubCnt"+p);r.openEnd();var d=o.getCells(),e=t.getColumns(true);e.forEach(function(f){if(!f.getVisible()||!f.isPopin()){return;}var g=d[f.getInitialOrder()],h=f.getHeader();if(!h&&!g){return;}var s=f.getStyleClass().split(" "),i=f.getPopinDisplay();r.openStart("div");r.class("sapMListTblSubCntRow");if(i==P.Inline){r.class("sapMListTblSubCntRowInline");}s&&s.forEach(function(j){r.class(j);});r.openEnd();if(h&&i!=P.WithoutHeader){r.openStart("div").class("sapMListTblSubCntHdr").openEnd();h=h.clone();f.addDependent(h);o._addClonedHeader(h);r.renderControl(h);r.openStart("span").class("sapMListTblSubCntSpr");r.attr("data-popin-colon",C.getLibraryResourceBundle("sap.m").getText("TABLE_POPIN_LABEL_COLON"));r.openEnd().close("span");r.close("div");}if(g){r.openStart("div");r.class("sapMListTblSubCntVal");r.class("sapMListTblSubCntVal"+i);r.openEnd();this.applyAriaLabelledBy(h,g);r.renderControl(g);r.close("div");}r.close("div");},this);r.close("div");r.close("td");this.renderNavigated(r,o);r.close("tr");};b.addLegacyOutlineClass=function(r,o){var t=o.isA("sap.m.Table")?o:o.getTable();if(t&&!t.hasPopin()&&t.shouldRenderDummyColumn()){r.class("sapMTableRowCustomFocus");}};b.renderContentLatter=function(r,o){var t=o.getTable();if(t&&t.shouldRenderDummyColumn()){if(!t.hasPopin()){a.renderContentLatter.apply(this,arguments);b.renderDummyCell(r,t);}else{b.renderDummyCell(r,t);a.renderContentLatter.apply(this,arguments);}}else{a.renderContentLatter.apply(this,arguments);}};return b;},true);
