/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/core/format/DateFormat','sap/ui/core/format/NumberFormat','sap/ui/core/Locale','sap/ui/core/LocaleData',"sap/base/Log","sap/base/util/deepExtend","sap/base/util/isEmptyObject","sap/ui/core/date/UniversalDateUtils","./library"],function(D,N,L,a,b,d,c,U,l){"use strict";var e=function(){throw new Error();};var _=sap.ui.getCore().getLibraryResourceBundle("sap.m");var g={};var h={};var p={"DATE":["date"],"DATERANGE":["date","date"],"LASTDAYS":["int"],"LASTWEEKS":["int"],"LASTMONTHS":["int"],"LASTQUARTERS":["int"],"LASTYEARS":["int"],"NEXTDAYS":["int"],"NEXTWEEKS":["int"],"NEXTMONTHS":["int"],"NEXTQUARTERS":["int"],"NEXTYEARS":["int"],"FROM":["date"],"TO":["date"],"SPECIFICMONTH":["month"],"TODAYFROMTO":["int","int"]};var s=Object.keys(l.StandardDynamicDateRangeKeys);for(var i=0;i<s.length;i++){var k=s[i];var P=_.getText("DYNAMIC_DATE_"+k.toUpperCase()+"_FORMAT");var S=P.split('{').map(function(f){var C=f.indexOf('}');if(C!==-1){return f.slice(C+1);}return f;});g[k]=S;var m=[];var n=P.indexOf('{');var o=-1;var q=-1;while(n!==-1){o=P.indexOf('}');q=parseInt(P.slice(n+1,o-o-1));m.push(q);P=P.slice(o+1);n=P.indexOf('{');}h[k]=m;}e.getInstance=function(f,j){return this.createInstance(f,j);};e.oDefaultDynamicDateFormat={"date":{},"month":{pattern:"MMMM"},"int":{}};e.createInstance=function(F,j){var r=Object.create(this.prototype);if(F instanceof L){j=F;F=undefined;}if(!j){j=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();}r.oLocale=j;r.oLocaleData=a.getInstance(j);r.oOriginalFormatOptions=d({},e.oDefaultDynamicDateFormat,F);r._dateFormatter=D.getInstance(r.oOriginalFormatOptions["date"]);[r._dateFormatter].concat(r._dateFormatter.aFallbackFormats).forEach(function(f){f.parseRelative=function(){return null;};});r._monthFormatter=D.getInstance(r.oOriginalFormatOptions["month"]);r._numberFormatter=N.getInstance(r.oOriginalFormatOptions["int"]);r._resourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");return r;};e.prototype.format=function(O){var k=O.operator;var m=O.values.slice(0);if(k==="SPECIFICMONTH"){var f=new Date();f.setMonth(m[0]);m[0]=this._monthFormatter.format(f);}else if(k==="LASTDAYS"&&m[0]===1){k="YESTERDAY";m=[];}else if(k==="NEXTDAYS"&&m[0]===1){k="TOMORROW";m=[];}else if((k==="LASTDAYS"||k==="NEXTDAYS")&&m[0]===0){k="TODAY";m=[];}var F=m.map(function(j){if(j instanceof Date){return this._dateFormatter.format(j);}if(typeof(j)==="number"){return this._numberFormatter.format(j);}else{return j.toString();}},this);return this._resourceBundle.getText("DYNAMIC_DATE_"+k.toUpperCase()+"_FORMAT",F);};e.prototype.parse=function(v,k){var r;var S=g[k];var R="^"+S.join("(.*)")+"$";if(k==="TODAYFROMTO"){R=R.replace("+","\\+");}var f=new RegExp(R,"i");var t=v.match(f);if(t){r={};r.values=[];for(var j=0;j<h[k].length;j++){var I=h[k][j];var T=p[k][I];var V;var C=t[j+1];switch(T){case"date":V=this._dateFormatter.parse(C);break;case"month":var M=[0,1,2,3,4,5,6,7,8,9,10,11].map(function(i){var w=new Date();w.setMonth(i);return this._monthFormatter.format(w);},this);var u=M.indexOf(C);V=u!==-1?u:null;break;case"int":V=this._numberFormatter.parse(C);break;case"string":V=C;break;default:break;}if(!V){r=null;break;}r.values[I]=V;}if(r){r.operator=k;return r;}}};return e;});
