/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/Log","./library",'sap/ui/core/Core',"sap/ui/thirdparty/jquery"],function(L,l,C,q){"use strict";var S='sap-ui-illustration-pool',a='-Patterns',b='sapIllus',c=sap.ui.require.toUrl("sap/m/themes/base/illustrations/"),d=Object.keys(l.IllustratedMessageType);var s=Object.create(null);s[b]={sPath:c,aSymbols:d,bIsPending:false};var e=[],A=Object.create(null),o=Object.create(null),r=Object.create(null);var I={};I.loadAsset=function(f,i){var g;if(f===""){L.error("ID of the asset can not be blank/empty.");return;}if(i){r[i]=f;}if(A[f]){L.info("The asset with ID '"+f+"' is either loaded or being loaded.");if(i&&o[f]){I._updateDOMPool();}return;}g=f.split("-")[0];if(!s[g]){L.error("The illustration set '"+g+"' is not registered. Please register it before requiring one of its assets.");return;}A[f]=true;I._requireSVG(g,f,i);};I.loadRestOfTheAssets=function(i){var f;if(!s[i]){throw new Error("The illustration set '"+i+"' is not registered. Please register it before requiring rest of its assets.");}f=s[i].aSymbols;if(Array.isArray(f)){f.forEach(function(g){I.loadAsset(i+"-Spot-"+g);I.loadAsset(i+"-Dialog-"+g);I.loadAsset(i+"-Scene-"+g);});}};I.registerIllustrationSet=function(f,g){var n=f.setFamily,p=f.setURI;if(s[n]){if(s[n].bIsPending){L.warning("Illustration Set is currently being loaded.");}else{L.warning("Illustration Set already registered.");}return;}if(p.substr(p.length-1)!=="/"){p+="/";}s[n]=Object.create(null);s[n].sPath=p;s[n].bIsPending=true;I._loadMetadata(n,p,g);};I._addAssetToDOMPool=function(h,i){I._getDOMPool().insertAdjacentHTML("beforeend",h);if(i){e.push(i);}};I._getDOMPool=function(){var D=document.getElementById(S);if(D===null){D=document.createElement("div");D.id=S;C.getStaticAreaRef().appendChild(D);I.loadAsset(b+a);}return D;};I._loadMetadata=function(n,p,f){var m=p+"metadata.json";return new Promise(function(R){q.ajax(m,{type:"GET",dataType:"json",success:function(M){L.info("Metadata for illustration set ("+n+") successfully loaded");I._metadataLoaded(n,M,f);R(M);},error:function(j,g){if(g!=="abort"){L.error("Metadata from: "+m+" file path could not be loaded");delete s[n];R();}}});});};I._metadataLoaded=function(n,m,f){var g=m.symbols,h=m.requireCustomPatterns;s[n].aSymbols=g;if(h){I.loadAsset(n+a);}if(f){I.loadRestOfTheAssets(n);}s[n].bIsPending=false;};I._removeAssetFromDOMPool=function(i){var D=document.getElementById(S),f;if(D!==null){f=document.getElementById(i);if(f!==null){D.removeChild(f);e.splice(e.indexOf(i),1);}}};I._requireSVG=function(f,i,g){return new Promise(function(R){q.ajax(s[f].sPath+i+".svg",{type:"GET",dataType:"html",success:function(h){if(i.indexOf(a)===-1){o[i]=h;if(g){I._updateDOMPool();}}else{I._addAssetToDOMPool(h);}R(h);},error:function(j,h){if(h!=="abort"){delete A[i];L.error(i+" asset could not be loaded");R();}}});});};I._updateDOMPool=function(){var f=Object.create(null),g=Object.create(null),h,j;for(var k in r){h=r[k];j=e.indexOf(h);if(j===-1){g[h]=true;}else{f[h]=true;}}for(var i=0;i<e.length;i++){h=e[i];if(!f[h]){I._removeAssetFromDOMPool(h);i--;}}for(var m in g){h=o[m];if(h){I._addAssetToDOMPool(h,m);}}};return I;},true);
