/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['./library','sap/ui/core/Core','./NotificationListBase','sap/ui/core/InvisibleText','sap/ui/core/ResizeHandler','sap/ui/core/library','sap/m/Link','sap/m/Avatar',"sap/ui/events/KeyCodes",'./NotificationListItemRenderer'],function(l,C,N,I,R,c,L,A,K,a){'use strict';var b=C.getLibraryResourceBundle('sap.m'),E=b.getText('NOTIFICATION_LIST_ITEM_SHOW_MORE'),d=b.getText('NOTIFICATION_LIST_ITEM_SHOW_LESS'),e=b.getText('NOTIFICATION_LIST_ITEM_READ'),U=b.getText('NOTIFICATION_LIST_ITEM_UNREAD');var m=44;var f=l.AvatarSize;var g=l.AvatarColor;var P=c.Priority;var h=N.extend('sap.m.NotificationListItem',{metadata:{library:'sap.m',properties:{description:{type:'string',group:'Appearance',defaultValue:''},authorInitials:{type:"string",group:"Data",defaultValue:null},truncate:{type:'boolean',group:'Appearance',defaultValue:true},hideShowMoreButton:{type:'boolean',group:'Appearance',defaultValue:false},authorAvatarColor:{type:"sap.m.AvatarColor",group:"Appearance",defaultValue:g.Accent6}},aggregations:{processingMessage:{type:'sap.m.MessageStrip',multiple:false},_showMoreButton:{type:'sap.m.Link',multiple:false,visibility:"hidden"}}}});h.prototype.init=function(){this.setType('Active');this._footerIvisibleText=new I({id:this.getId()+"-invisibleFooterText"});};h.prototype._getAuthorAvatar=function(){if(this.getAuthorInitials()||this.getAuthorPicture()){if(!this._avatar){this._avatar=new A({displaySize:f.XS});}this._avatar.setInitials(this.getAuthorInitials());this._avatar.setSrc(this.getAuthorPicture());this._avatar.setBackgroundColor(this.getAuthorAvatarColor());return this._avatar;}};h.prototype.onBeforeRendering=function(){N.prototype.onBeforeRendering.call(this);if(this._resizeListenerId){R.deregister(this._resizeListenerId);this._resizeListenerId=null;}};h.prototype.onAfterRendering=function(){if(this.getHideShowMoreButton()){return;}this._updateShowMoreButtonVisibility();if(this.getDomRef()){this._resizeListenerId=R.register(this.getDomRef(),this._onResize.bind(this));}};h.prototype.onkeydown=function(i){if(i.target!==this.getDomRef()){return;}var n=this.getParent(),v,j;if(!n||!n.isA('sap.m.NotificationListGroup')){return;}v=n.getVisibleItems();j=v.indexOf(this);switch(i.which){case K.ARROW_UP:if(j===0){return;}var p=j-1;v[p].focus();break;case K.ARROW_DOWN:var k=j+1;if(k===v.length){return;}v[k].focus();break;}};h.prototype.exit=function(){N.prototype.exit.apply(this,arguments);if(this._resizeListenerId){R.deregister(this._resizeListenerId);this._resizeListenerId=null;}if(this._footerIvisibleText){this._footerIvisibleText.destroy();this._footerIvisibleText=null;}if(this._avatar){this._avatar.destroy();this._avatar=null;}};h.prototype._onResize=function(){this._updateShowMoreButtonVisibility();};h.prototype._updateShowMoreButtonVisibility=function(){var $=this.$(),t=$.find('.sapMNLITitleText')[0],i=$.find('.sapMNLIDescription')[0],j;if($.length>0){j=t.scrollHeight>m||i.scrollHeight>m;}this._getShowMoreButton().setVisible(j);};h.prototype._getShowMoreButton=function(){var s=this.getAggregation('_showMoreButton');if(!s){s=new L(this.getId()+'-showMoreButton',{text:this.getTruncate()?E:d,press:function(){var t=!this.getTruncate();this._getShowMoreButton().setText(t?E:d);this.setTruncate(t);}.bind(this)});this.setAggregation("_showMoreButton",s,true);}return s;};h.prototype._getFooterInvisibleText=function(){var r=this.getUnread()?U:e,i=this.getAuthorName(),j=this.getDatetime(),p=this.getPriority(),k=[r];if(i){i=b.getText('NOTIFICATION_LIST_ITEM_CREATED_BY');k.push(i);k.push(this.getAuthorName());}if(j){k.push(b.getText('NOTIFICATION_LIST_ITEM_DATETIME',[j]));}if(p!==P.None){k.push(b.getText('NOTIFICATION_LIST_ITEM_PRIORITY',[p]));}return this._footerIvisibleText.setText(k.join(' '));};return h;});
