/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/core/Renderer','sap/ui/core/IconPool','sap/m/library','sap/ui/Device','sap/ui/core/library'],function(R,I,l,D,c){"use strict";var T=c.TextDirection;var V=c.ValueState;var S=l.SelectType;var a={apiVersion:2};a.CSS_CLASS="sapMSlt";a.render=function(r,s){var t=s.getType(),A=s.getAutoAdjustWidth(),e=s.getEditable(),E=s.getEnabled(),C=s.getWidth(),w=C.indexOf("%")>-1,b=A||C==="auto"||w,d=a.CSS_CLASS,f=E&&e;r.openStart("div",s);this.addClass(r,s);r.class(d);r.class(d+s.getType());if(!E){r.class(d+"Disabled");}else if(!e){r.class(d+"Readonly");}if(b&&(t===S.Default)){r.class(d+"MinWidth");}if(A){r.class(d+"AutoAdjustedWidth");}else{r.style("width",C);}if(s.getIcon()){r.class(d+"WithIcon");}if(f&&D.system.desktop){r.class(d+"Hoverable");}r.class(d+"WithArrow");if(s.getValueState()!==V.None&&f){this.addValueStateClasses(r,s);}r.style("max-width",s.getMaxWidth());if(E){r.attr("tabindex","-1");}r.openEnd();this.renderFocusElement(r,s);this.renderHiddenInput(r,s);this.renderLabel(r,s);switch(t){case S.Default:this.renderArrow(r,s);break;case S.IconOnly:this.renderIcon(r,s);break;}var L=s.getList();if(s._isShadowListRequired()&&L){this.renderShadowList(r,L);}this.renderAccessibilityDomNodes(r,s);r.close("div");};a.renderFocusElement=function(r,s){var o=s.getSelectedItem(),t=s.getTooltip_AsString(),b=s.getType();r.openStart("div",s.getId()+"-hiddenSelect");this.writeAccessibilityState(r,s);r.class("sapUiPseudoInvisibleText");r.class(a.CSS_CLASS+"HiddenSelect");if(s.getEnabled()){r.attr("tabindex","0");}if(t){r.attr("title",t);}else if(b===S.IconOnly){var i=I.getIconInfo(s.getIcon());if(i){r.attr("title",i.text);}}r.openEnd();if(o){r.text(o.getText());}r.close('div');};a.renderHiddenInput=function(r,s){r.voidStart("input",s.getId()+"-hiddenInput");r.attr("name",s.getName());r.attr("value",s.getSelectedKey());r.attr("aria-readonly","true");r.attr("tabindex","-1");r.attr("aria-hidden","true");r.attr("type","hidden");r.class("sapUiPseudoInvisibleText");r.voidEnd();};a.renderLabel=function(r,s){var o=s.getSelectedItem(),t=s.getTextDirection(),b=R.getTextAlign(s.getTextAlign(),t),C=a.CSS_CLASS,e=s.getEnabled()&&s.getEditable(),d=s.getTooltip_AsString();r.openStart("span",s.getId()+"-label");r.attr("aria-hidden",true);r.class(C+"Label");if(d){r.attr("title",d);}if(s.getValueState()!==V.None&&e){r.class(C+"LabelState");r.class(C+"Label"+s.getValueState());}if(s.getType()===S.IconOnly){r.class("sapUiPseudoInvisibleText");}if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.style("text-align",b);r.openEnd();if(s.getType()!==S.IconOnly){r.renderControl(s._getValueIcon());r.openStart("span",s.getId()+"-labelText");r.class("sapMSelectListItemText");r.openEnd();r.text(o&&o.getParent()?o.getText():null);r.close("span");}r.close("span");};a.renderArrow=function(r,s){var C=a.CSS_CLASS,t=s.getTooltip_AsString();r.openStart("span",s.getId()+"-arrow");r.attr("aria-hidden",true);r.class(C+"Arrow");if(s.getValueState()!==V.None){r.class(C+"ArrowState");}if(t){r.attr("title",t);}r.openEnd().close("span");};a.renderIcon=function(r,s){var t=s.getTooltip_AsString(),i=I.getIconInfo(s.getIcon()),b=i&&i.text;r.icon(s.getIcon(),a.CSS_CLASS+"Icon",{id:s.getId()+"-icon",title:t||b||null});};a.renderShadowList=function(r,L){var o=L.getRenderer();o.writeOpenListTag(r,L,{elementData:false});this.renderShadowItems(r,L);o.writeCloseListTag(r,L);};a.renderShadowItems=function(r,L){var o=L.getRenderer(),b=L.getSelectableItems(),s=b.length,d=L.getSelectedItem();for(var i=0;i<s;i++){o.renderItem(r,L,b[i],{selected:d===b[i],setsize:s,posinset:i+1,elementData:false});}};a.addClass=function(r,s){};a.addValueStateClasses=function(r,s){r.class(a.CSS_CLASS+"State");r.class(a.CSS_CLASS+s.getValueState());};a.getAriaRole=function(s){switch(s.getType()){case S.Default:return"combobox";case S.IconOnly:return"button";}};a.writeAccessibilityState=function(r,s){var v=s.getValueState(),o=s.getSelectedItem(),i=s.getType()===S.IconOnly,b=s._getValueIcon(),e=s.getEnabled()&&s.getEditable(),L=[],A=[],d,f,g,h;s.getLabels().forEach(function(k){if(k&&k.getId){L.push(k.getId());}});if(s.isOpen()&&o&&o.getDomRef()){g=o.getId();}if(o&&!o.getText()&&o.getIcon&&o.getIcon()){var j=I.getIconInfo(o.getIcon());if(j){h=j.text||j.name;}}if(v!==V.None&&e){f=s.getValueStateMessageId()+"-sr";}if(h&&b){A.push(b.getId());}if(L.length){A=A.concat(L);}d={value:A.join(" "),append:true};r.accessibilityState(null,{role:this.getAriaRole(s),roledescription:s._sAriaRoleDescription,readonly:i?undefined:s.getEnabled()&&!s.getEditable(),required:s._isRequired()||undefined,disabled:!s.getEnabled()||undefined,expanded:s.isOpen(),invalid:(s.getValueState()===V.Error&&e)?true:undefined,labelledby:(i||d.value==="")?undefined:d,describedby:f,activedescendant:g,haspopup:s.getEditable()?"listbox":undefined});};a.renderAccessibilityDomNodes=function(r,C){var v=C.getValueState(),s,e=C.getEnabled()&&C.getEditable();if(v===V.None||!e){return;}s=C._getValueStateText();r.openStart("div",C.getValueStateMessageId()+"-sr").class("sapUiPseudoInvisibleText").attr("aria-hidden",true).openEnd().text(s).close("div");};return a;},true);
