/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/util/uid","sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/core/Component","sap/ui/fl/util/ManagedObjectModel"],function(u,J,C){"use strict";var a={};var c="$sap.m.flexibility.CombineButtonsModel";function h(b,m,A,M,p,P,v,o,r){var s="";var e="";var O="";var f=[];var i=sap.ui.getCore().getConfiguration().getRTL();var g=[];return b.reduce(function(j,B,k){var I;var l=k;var n;var q;var S=o.content.buttonsIdForSave[l];var t;var w="$sap.m.flexibility.MenuButtonModel"+l;return j.then(m.getProperty.bind(m,B,"text")).then(function(R){t=R;return m.createControl("sap.m.MenuItem",A,v,S);}).then(function(x){n=x;return m.findIndexInParentAggregation(B);}).then(function(x){r.insertIndexes[l]=x;return m.createControl("sap.ui.fl.util.ManagedObjectModel",A,v,Object.assign({},S,{id:S.id+'-managedObjectModel'}),{object:B,name:c});}).then(function(x){q=x;return m.insertAggregation(n,"dependents",q,0,v);}).then(function(){return m.createControl("sap.ui.core.CustomData",A,v,Object.assign({},S,{id:S.id+'-customData'}),{key:"{ path: '"+c+">key' }",value:"{ path: '"+c+">value' }"});}).then(function(x){m.bindProperty(n,"text",c+">/text");m.bindProperty(n,"icon",c+">/icon");m.bindProperty(n,"enabled",c+">/enabled");m.bindProperty(n,"visible",c+">/visible");return m.bindAggregation(n,"customData",{path:c+">/customData",template:x,templateShareable:false},v);}).then(function(){if(t){i?g.unshift(t):g.push(t);}var N=Object.assign({},S,{id:S.id+'-originalButtonId'});return m.createControl("sap.ui.core.CustomData",A,v,N);}).then(function(R){I=R;m.setProperty(I,"key","originalButtonId");m.setProperty(I,"value",m.getId(B));return m.removeAggregation(p,P,B);}).then(function(){return m.insertAggregation(p,"dependents",B,0,v);}).then(function(){m.insertAggregation(B,"customData",I,0,v);}).then(function(){m.insertAggregation(M,"items",n,l,v);}).then(function(){return m.createControl("sap.ui.fl.util.ManagedObjectModel",A,v,Object.assign({},S,{id:S.id+'-managedObjectModelMenuItem'}),{object:n,name:w});}).then(function(x){f[l]=x;s=s+O+"${"+w+">/enabled}";e=e+O+"${"+w+">/visible}";O=" || ";return{menuButtonModels:f,menuButtonName:g,propertyEnabled:s,propertyVisible:e};});},Promise.resolve());}a.applyChange=function(o,b,p){if(p.modifier.targets!=="jsControlTree"){return Promise.reject(new Error("Combine buttons change can't be applied on XML tree"));}var e=o.getDefinition();var m=p.modifier;var v=p.view;var A=p.appComponent;var P;var s;var i;var f;var B;var M;var g;var r={parentAggregation:"",insertIndexes:[]};var j=[];var k=[];return Promise.resolve().then(m.bySelector.bind(m,e.content.combineButtonSelectors[0],A,v)).then(function(R){s=R;P=m.getParent(s);var l=[];e.content.combineButtonSelectors.forEach(function(n){var q=Promise.resolve().then(m.bySelector.bind(m,n,A,v));l.push(q);});return Promise.all(l);}).then(function(l){B=l;return m.getParentAggregationName(B[0],P);}).then(function(R){f=R;r.parentAggregation=f;return m.findIndexInParentAggregation(s);}).then(function(l){i=l;return m.createControl("sap.m.Menu",A,v,e.content.menuIdSelector);}).then(function(l){M=l;return m.attachEvent(M,"itemSelected","sap.m.changeHandler.CombineButtons.pressHandler");}).then(function(){return h(B,m,A,M,P,f,v,e,r);}).then(function(l){j=l.menuButtonModels;k=l.menuButtonName;var n=l.propertyVisible;var q=l.propertyEnabled;return m.createControl("sap.m.MenuButton",A,v,e.content.menuButtonIdSelector,{visible:"{= "+n+"}",enabled:"{= "+q+"}"});}).then(function(l){g=l;return j.reduce(function(n,q){return n.then(m.insertAggregation.bind(m,g,"dependents",q,0,v));},Promise.resolve());}).then(function(){m.setProperty(g,"text",k.join("/"));return Promise.resolve().then(m.insertAggregation.bind(m,g,"menu",M,0,v)).then(m.insertAggregation.bind(m,P,f,g,i,v)).then(function(){o.setRevertData(r);});});};function d(b,m){return b.reduce(function(p,o){return p.then(function(){return m.getProperty(o,"key");}).then(function(k){if(k==="originalButtonId"){return m.destroy(o);}return undefined;});},Promise.resolve());}a.revertChange=function(o,b,p){var m=p.modifier;var v=p.view;var r=o.getRevertData();var e=o.getDefinition();var P=r.parentAggregation;var M,f,B;return Promise.resolve().then(function(){return m.bySelector(e.content.menuButtonIdSelector,p.appComponent,v);}).then(function(R){M=R;f=m.getParent(M);B=e.content.combineButtonSelectors.slice().reverse();return m.removeAggregation(f,P,M);}).then(function(){return m.destroy(M);}).then(function(){var l=B.length;return B.reduce(function(g,i,j){var I=j;var k;return g.then(function(){return m.bySelector(i,p.appComponent,v);}).then(function(R){k=R;return m.getAggregation(k,"customData");}).then(function(n){return d(n,m);}).then(function(){return m.insertAggregation(f,P,k,r.insertIndexes[l-I-1],v);});},Promise.resolve()).then(function(){o.resetRevertData();});});};a.completeChangeContent=function(o,s,p){var m=p.modifier;var A=p.appComponent;var b=o.getDefinition();var e=s.combineElementIds;if(e&&e.length>1){o.addDependentControl(e,"combinedButtons",p);b.content.combineButtonSelectors=e.map(function(f){return m.getSelector(f,A);});b.content.menuButtonIdSelector=m.getSelector(A.createId(u()),A);b.content.menuIdSelector=m.getSelector(A.createId(u()),A);b.content.buttonsIdForSave=e.map(function(){return m.getSelector(A.createId(u()),A);});}else{throw new Error("Combine buttons action cannot be completed: oSpecificChangeInfo.combineElementIds attribute required");}};a.pressHandler=function(e){var b=e.getParameter("item").getModel(c).getObject();b.firePress();};return a;},true);
