/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/base/EventProvider","./Element","./ShortcutHint","./Popup","./InvisibleText","sap/ui/dom/containsOrEquals","sap/ui/events/checkMouseEnterOrLeave","sap/ui/Device"],function(E,a,S,P,I,c,b,D){"use strict";var d=function(C){this.sControlId=C.getId();this._hintConfigs=[];};d.init=function(C){C._shortcutHintsMixin=new d(C);};d.addConfig=function(C,o,i){if(D.system.phone){return;}if(/sap-ui-xx-noshortcuthints=true/.test(document.location.search)){return;}var M=C._shortcutHintsMixin;if(!M){d.init(C);M=C._shortcutHintsMixin;}M._hintConfigs.push(o);M.initHint(o,i);};d.hideAll=function(){var C;for(var s in h.mControls){C=a.registry.get(s);if(C){C._shortcutHintsMixin.hideShortcutHint();}}};d.isDOMIDRegistered=function(s){return h.mDOMNodes[s]&&!!h.mDOMNodes[s].length;};d.isControlRegistered=function(C){return!!h.mControls[C];};d.prototype._attachToEvents=function(){var C;if(!d.isControlRegistered(this.sControlId)){C=a.registry.get(this.sControlId);C.addEventDelegate(H,this);}};d.prototype.register=function(s,C,o){this._attachToEvents();if(!d.isControlRegistered(this.sControlId)){var i=a.registry.get(this.sControlId);i._originalExit=i.exit;i.exit=function(){if(i._originalExit){i._originalExit.apply(i,arguments);}this.deregister();}.bind(this);}h.mControls[this.sControlId]=true;if(!h.mDOMNodes[s]){h.mDOMNodes[s]=[];}h.mDOMNodes[s].push(new S(o,C));};d.prototype.deregister=function(){var n=this.getRegisteredShortcutInfos(),i;delete h.mControls[this.sControlId];for(i=0;i<n.length;i++){delete h.mDOMNodes[n[i].id];}};d.prototype.initHint=function(C,o){var i=this._getShortcutHintInfo(C);if(i.message){this.register(i.id,{message:i.message},o);}else if(i.messageBundleKey){this.register(i.id,{messageBundleKey:i.messageBundleKey},o);}else if(i.event){var n=E.getEventList(o)[i.event],A=[];if(n){A=n.reduce(function(r,L){if(L.fFunction&&L.fFunction._sapui_commandName){r.push(L.fFunction._sapui_commandName);}return r;},[]);}if(A.length){this.register(i.id,{commandName:A[0]},o);}else{o.attachEvent("EventHandlerChange",function(p){var F=p.getParameter("func");if(p.getParameter("type")==="listenerAttached"&&F&&F._sapui_commandName&&p.getParameter("EventId")===i.event){this.register(i.id,{commandName:F._sapui_commandName},o);}},this);}}};d.prototype._getShortcutHintInfos=function(){return this._hintConfigs.map(this._getShortcutHintInfo,this);};d.prototype._getShortcutHintInfo=function(o){var i;if(o.domrefid){i=o.domrefid;}else if(o.domrefid_suffix){i=this.sControlId+o.domrefid_suffix;}else{i=this.sControlId;}return{id:i,event:o.event,position:o.position,messageBundleKey:o.messageBundleKey,message:o.message,addAccessibilityLabel:o.addAccessibilityLabel};};d.prototype.getRegisteredShortcutInfos=function(){return this._getShortcutHintInfos().filter(function(i){return d.isDOMIDRegistered(i.id);},this);};d.prototype.showShortcutHint=function(o){var t,p=o[0].position||"0 8",M=P.Dock.CenterTop,O=P.Dock.CenterBottom,i=e(),s=o[0].ref,n=_(o[0].id),T;if(!k(s)||!j(s)){return;}T=this._getControlTooltips();if(T[o[0].id]){n=T[o[0].id].tooltip+" ("+n+")";}if(!i){i=f(n);}i.oContent.children[0].textContent=n;if(!i.isOpen()){i.open(1000,M,O,s,p,"flipfit",function(q){i.oContent.style.visibility="hidden";if(t){clearTimeout(t);}t=setTimeout(function(){if(!k(s)||!j(s)){return;}i.oContent.style.visibility="visible";},1000);i._applyPosition(i._oLastPosition);});}};d.prototype.hideShortcutHint=function(){var p=e();if(p&&p.isOpen()){p.close();}};d.prototype._findShortcutOptionsForRef=function(n){var o,p=this.getRegisteredShortcutInfos(),i,r=[];for(i=0;i<p.length;i++){o=p[i];o.ref=document.getElementById(o.id);if(c(o.ref,n)){r.push(o);}}return r;};d.prototype._getControlTooltips=function(){var i=this.getRegisteredShortcutInfos(),C=a.registry.get(this.sControlId);return i.reduce(function(r,o){var t=C._getTitleAttribute&&C._getTitleAttribute(o.id);if(!t){t=C.getTooltip();}if(t){r[o.id]={tooltip:t};}return r;},{});};d.prototype._updateShortcutHintAccLabel=function(o){var i,s,C;if(!o.addAccessibilityLabel){return;}C=a.registry.get(this.sControlId);if(!C.getAriaDescribedBy){return;}i=g(C);s=i.getId();i.setText(_(o.id));if(!i.getText()){C.removeAriaDescribedBy(s);}else if(C.getAriaDescribedBy().indexOf(s)===-1){C.addAriaDescribedBy(s);}};var h=Object.create(null);h.mControls={};h.mDOMNodes={};var H={"onfocusin":function(o){var s=this._findShortcutOptionsForRef(o.target);if(!s.length){return;}d.hideAll();this._updateShortcutHintAccLabel(s[0]);this.showShortcutHint(s);},"onfocusout":function(o){var s=this._findShortcutOptionsForRef(o.target);if(!s.length){return;}this.hideShortcutHint();},"onmouseover":function(o){var s=this._findShortcutOptionsForRef(o.target),i;if(!s.length){return;}i=s[0].ref;if(!m(i)){return;}if(b(o,i)){d.hideAll();this.showShortcutHint(s);}},"onmouseout":function(o){var s=this._findShortcutOptionsForRef(o.target);if(!s.length){return;}if(b(o,s[0].ref)){if(c(s[0].ref,document.activeElement)){return;}this.hideShortcutHint();}},"onAfterRendering":function(){var n=this.getRegisteredShortcutInfos(),o,s;for(var i=0;i<n.length;i++){s=n[i].id;o=document.getElementById(s);o.setAttribute("aria-keyshortcuts",_(s));}}};function _(s){var i=h.mDOMNodes[s];if(!i||!i.length){return;}return i.map(function(o){return o._getShortcutText();}).join(", ");}function g(C){if(!C._shortcutInvisibleText){var F=C.exit;C._shortcutInvisibleText=new I();C._shortcutInvisibleText.toStatic();C.exit=function(){this._shortcutInvisibleText.destroy();F.call(this);};}return C._shortcutInvisibleText;}function e(){return d._popup;}function f(t){var p,C,T;C=document.createElement("span");C.classList.add("sapUiHintContainer");T=document.createElement("div");T.classList.add("sapUiHintText");T.textContent=t;C.appendChild(T);p=new P(C,false,false,false);p.setAnimations(function($,i,n){setTimeout(n,i);},function($,i,n){n();});d._popup=p;return p;}function j(o){var r;if(!o){return false;}r=o.getBoundingClientRect();return(r.top>=0&&r.left>=0&&r.bottom<=(window.innerHeight||document.documentElement.clientHeight)&&r.right<=(window.innerWidth||document.documentElement.clientWidth));}function k(i){return i.offsetWidth>0||i.offsetHeight>0||i.getClientRects().length>0;}function l(i){var t=i.tabIndex;return t!=null&&t>=0&&(i.getAttribute("disabled")==null||i.getAttribute("tabindex"));}function m(i){return i.nodeType==1&&k(i)&&l(i);}return d;});
