/*
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['../base/ManagedObject','./Component','sap/ui/core/mvc/ViewType','sap/ui/core/mvc/XMLProcessingMode','./UIComponentMetadata','./mvc/Controller','./mvc/View','sap/base/util/ObjectPath','sap/base/Log','sap/ui/core/Core'],function(M,C,V,X,U,a,b,O,L){"use strict";var c=C.extend("sap.ui.core.UIComponent",{constructor:function(i,s){var d=false;try{if(typeof i!=="string"){s=i;i=undefined;}if(s&&s.hasOwnProperty("_routerHashChanger")){this._oRouterHashChanger=s._routerHashChanger;delete s._routerHashChanger;}if(s&&s.hasOwnProperty("_propagateTitle")){this._bRoutingPropagateTitle=s._propagateTitle;delete s._propagateTitle;}C.apply(this,arguments);d=true;}finally{if(!d){this._destroyCreatedInstances();}}},metadata:{"abstract":true,rootView:null,publicMethods:["render"],aggregations:{"rootControl":{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},designtime:"sap/ui/core/designtime/UIComponent.designtime",routing:{}}},U);c._fnOnInstanceInitialized=null;c._fnOnInstanceDestroy=null;c.prototype.init=function(){var t=this;var p={};var r;if(this.getAutoPrefixId()){p.id=function(i){return t.createId(i);};}function s(r){var F=function(){if(typeof c._fnOnInstanceInitialized==="function"){c._fnOnInstanceInitialized(t);}};var A=function(i){t.setAggregation("rootControl",i);};if(r instanceof Promise){t.pRootControlLoaded=t.pRootControlLoaded.then(function(i){A(i);F();return i;});}else if(r instanceof b&&r.oAsyncState&&r.oAsyncState.promise){A(r);t.pRootControlLoaded=t.pRootControlLoaded.then(function(i){F();return i;});}else{A(r);F();}}function d(r,o){var i;if(r instanceof Promise){i=t.pRootControlLoaded.then(function(j){return(j instanceof b)?j.getId():undefined;});}else if(r instanceof b){i=r.getId();}if(i){if(o.targetParent===undefined){o.targetParent=i;}if(t._oTargets){t._oTargets._setRootViewId(i);}}}var R=this._getManifestEntry("/sap.ui5/routing",true)||{},o=R.config||{},v=R.routes;if(this.isA("sap.ui.core.IAsyncContentCreation")){o.async=true;}if(v){var f;var e=this._getRouterClassName();if(e){f=g(e);}else{f=sap.ui.require("sap/ui/core/routing/Router")||sap.ui.requireSync("sap/ui/core/routing/Router");}this._oRouter=new f(v,o,this,R.targets,this._oRouterHashChanger);this._oTargets=this._oRouter.getTargets();this._oViews=this._oRouter.getViews();}else if(R.targets){var h=sap.ui.require("sap/ui/core/routing/Views")||sap.ui.requireSync("sap/ui/core/routing/Views");this._oViews=new h({component:this});var T;if(o.targetsClass){T=g(o.targetsClass);}else{T=sap.ui.require("sap/ui/core/routing/Targets")||sap.ui.requireSync("sap/ui/core/routing/Targets");}this._oTargets=new T({targets:R.targets,config:o,views:this._oViews});}this.runAsOwner(function(){M.runWithPreprocessors(function(){r=t.createContent();},p);});if(r instanceof Promise){if(this.isA("sap.ui.core.IAsyncContentCreation")){this.pRootControlLoaded=r;}else{throw new Error("Interface 'sap.ui.core.IAsyncContentCreation' must be implemented for component '"+this.getMetadata().getComponentName()+"' when 'createContent' is implemented asynchronously");}}else if(r instanceof b&&r.oAsyncState&&r.oAsyncState.promise){this.pRootControlLoaded=r.loaded();}else{this.pRootControlLoaded=Promise.resolve(r);}d(r,o);s(r);};function g(r){var f;if(typeof r==="string"){f=O.get(r);if(!f){L.error("The specified class for router or targets '"+r+"' is undefined.",this);}}else{f=r;}return f;}c.prototype.rootControlLoaded=function(){if(!this.pRootControlLoaded){L.error("Mandatory init() not called for UIComponent: '"+this.getManifestObject().getComponentName()+"'. This is likely caused by a missing super call in the component's init implementation.",null,"sap.ui.support",function(){return{type:"missingInitInUIComponent"};});}return this.pRootControlLoaded||Promise.resolve(this.getRootControl());};c.prototype.destroy=function(){if(typeof c._fnOnInstanceDestroy==="function"){c._fnOnInstanceDestroy(this);}this._destroyCreatedInstances();return C.prototype.destroy.apply(this,arguments);};c.prototype._destroyCreatedInstances=function(){if(this._oRouter){this._oRouter.destroy();delete this._oRouter;}else{if(this._oTargets){this._oTargets.destroy();this._oTargets=null;}if(this._oViews){this._oViews.destroy();this._oViews=null;}}};c.getRouterFor=function(o){var v=o;if(v instanceof a){v=v.getView();}if(v instanceof b){var d=C.getOwnerComponentFor(v);if(d){return d.getRouter();}else{return undefined;}}};c.prototype.getRouter=function(){return this._oRouter;};c.prototype.hasNativeRouter=function(){return this._oRouter===this.getRouter();};c.prototype.getTargets=function(){return this._oTargets;};c.prototype.getAutoPrefixId=function(){return!!this.getManifestObject().getEntry("/sap.ui5/autoPrefixId");};c.prototype.byId=function(i){return sap.ui.getCore().byId(this.createId(i));};c.prototype.createId=function(i){if(!this.isPrefixedId(i)){i=this.getId()+"---"+i;}return i;};c.prototype.getLocalId=function(i){var p=this.getId()+"---";return(i&&i.indexOf(p)===0)?i.slice(p.length):null;};c.prototype.isPrefixedId=function(i){return!!(i&&i.indexOf(this.getId()+"---")===0);};c.prototype.createContent=function(){var r=this._getManifestEntry("/sap.ui5/rootView",true);if(r&&typeof r==="string"){return b._create({viewName:r,type:V.XML});}else if(r&&typeof r==="object"){if(!r.type&&!b._getModuleName(r)){r.type=V.XML;}if(r.id){r.id=this.createId(r.id);}if(r.async&&r.type===V.XML){r.processingMode=X.Sequential;}if(this.isA("sap.ui.core.IAsyncContentCreation")){return b.create(r);}return b._create(r);}else if(r){throw new Error("Configuration option 'rootView' of component '"+this.getMetadata().getName()+"' is invalid! 'rootView' must be type of string or object!");}return null;};c.prototype.getRootControl=function(){return this.getAggregation("rootControl");};c.prototype.render=function(r){var o=this.getRootControl();if(o&&r){r.renderControl(o);}};c.prototype.getUIArea=function(){return(this.oContainer?this.oContainer.getUIArea():null);};c.prototype.getEventingParent=function(){return this.getUIArea();};c.prototype.setContainer=function(o){this.oContainer=o;if(o){this._applyContextualSettings(o._getContextualSettings());}else{this._oContextualSettings=M._defaultContextualSettings;if(!this._bIsBeingDestroyed){setTimeout(function(){if(!this.oContainer){this._propagateContextualSettings();}}.bind(this),0);}}return this;};c.prototype.onBeforeRendering=function(){};c.prototype.onAfterRendering=function(){};c.prototype._getRouterClassName=function(){var r=this._getManifestEntry("/sap.ui5/routing",true)||{},R=r.config||{};return R.routerClass;};return c;});
