/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/base/util/ObjectPath','sap/base/util/extend','sap/ui/base/EventProvider','sap/ui/base/ManagedObject','sap/ui/core/mvc/ControllerMetadata','sap/ui/core/mvc/ControllerExtension','sap/ui/core/mvc/ControllerExtensionProvider','sap/ui/core/mvc/OverrideExecution',"sap/base/Log"],function(O,e,E,M,C,a,b,c,L){"use strict";var r={};var d=E.extend("sap.ui.core.mvc.Controller",{metadata:{stereotype:"controller",methods:{"byId":{"public":true,"final":true},"getView":{"public":true,"final":true},"getInterface":{"public":false,"final":true},"onInit":{"public":false,"final":false,"overrideExecution":c.After},"onExit":{"public":false,"final":false,"overrideExecution":c.Before},"onBeforeRendering":{"public":false,"final":false,"overrideExecution":c.Before},"onAfterRendering":{"public":false,"final":false,"overrideExecution":c.After}}},constructor:function(n){var t=null;if(typeof(n)=="string"){if(!r[n]){L.warning("Do not call sap.ui.core.mvc.Controller constructor for non typed scenario!");}t=r[n];}E.apply(this,arguments);if(t){e(this,r[n]);}if(this.extension){throw new Error("The keyword 'extension' cannot be used as a member of a controller");}this["_sapui_Extensions"]={};d.extendByMember(this,false);this._sapui_isExtended=false;this._aDestroyables=[];},_isExtended:function(){return this._sapui_isExtended;},getInterface:function(){var i={};var o=this.getMetadata();var p=o.getAllPublicMethods();p.forEach(function(s){var F=this[s];if(typeof F==='function'){i[s]=function(){var t=F.apply(this,arguments);return(t instanceof d)?t.getInterface():t;}.bind(this);}}.bind(this));this.getInterface=function(){return i;};return i;}},C);function f(o,i,l){var n=i.getMetadata().getName();var k=o.getMetadata();var p=o["_sapui_Extensions"];var I=o.getInterface();var q=a.getMetadata().getLifecycleConfiguration();var s={namespace:n,extension:i,reloadNeeded:false};i._setController(I);if(i.getMetadata().hasOverrides()){var t,u,v,w,x=i.getMetadata().getOverrides(),S=i.getMetadata().getStaticOverrides();for(w in S){v=i.getMetadata();if(!v.isMethodFinal(w)){a.overrideMethod(w,i,S,i,v.getOverrideExecution(w));}else{L.error("Method '"+w+"' of extension '"+n+"' is flagged final and cannot be overridden by calling 'override'");}}for(w in x){if(w!=='extension'){if(w in i.base){L.debug("Overriding  member '"+w+"' of original controller.");var y=x[w];var z=o[w];if(typeof z=="object"&&typeof y=="object"){u=p[w];v=u.extension.getMetadata();for(t in y){if(!v.isMethodFinal(t)){a.overrideMethod(t,z,y,i,v.getOverrideExecution(t));}else{L.error("Method '"+t+"' of extension '"+u.namespace+"' is flagged final and cannot be overridden by extension '"+n+"'");}}}else if(!k.isMethodFinal(w)){a.overrideMethod(w,o,x,i,k.getOverrideExecution(w));}else{L.error("Method '"+w+"' of controller '"+o.getMetadata().getName()+"' is flagged final and cannot be overridden by extension '"+n+"'");}}else if(w in q){a.overrideMethod(w,o,x,i,k.getOverrideExecution(w));}else{L.error("Method '"+w+"' does not exist in controller "+o.getMetadata().getName()+" and cannot be overridden");}}s.reloadNeeded=true;}if(x&&x.extension){for(var A in x.extension){v=p[A].extension.getMetadata();var B=O.create(A,o.extension);var D=p[A].extension;var F=x.extension[A];for(t in F){if(!v.isMethodFinal(t)){a.overrideMethod(t,B,F,i,v.getOverrideExecution(t));a.overrideMethod(t,D,F,i,v.getOverrideExecution(t));}else{L.error("Method '"+t+"' of extension '"+A+"' is flagged final and cannot be overridden by extension '"+n+"'");}}}}}var G=i.getInterface();if(l){p[l]=s;s.location=l;o[l]=G;I[l]=G;}else{p[n]=s;s.location="extension."+n;O.set("extension."+n,G,o);O.set("extension."+n,G,I);}}function m(o,i,l){if(i instanceof a){f(o,i,l);}else if(i.getMetadata&&i.getMetadata().getStereotype()=="controllerextension"){var k=new i();f(o,k,l);}else{var n=a.getMetadata().getLifecycleConfiguration();for(var s in i){if(s in n){a.overrideMethod(s,o,i,o,n[s].overrideExecution);}else{a.overrideMethod(s,o,i);}}}}function g(n,A){if(!n){throw new Error("Controller name ('sName' parameter) is required");}var s=n.replace(/\./g,"/")+".controller",i=k(sap.ui.require(s));function k(i){if(i){return i;}else if(r[n]){return d;}else{return O.get(n);}}if(A){return new Promise(function(l,o){if(!i){sap.ui.require([s],function(i){l(k(i));},o);}else{l(i);}});}else if(!i){i=sap.ui.requireSync(s);return k(i);}else{return i;}}function h(i,n){var o;if(r[n]){o=new i(n);}else{o=new i();}if(!o){throw new Error("Controller "+n+" couldn't be instantiated");}return o;}d.extendByMember=function(o,A){var s;for(s in o){if(o[s]&&o[s].getMetadata&&o[s].getMetadata().getStereotype()=="controllerextension"){o[s]=new o[s]();}}for(s in o){if(o[s]&&o[s].getMetadata&&o[s].getMetadata().getStereotype()=="controllerextension"){m(o,o[s],s);}}if(A){return Promise.resolve(o);}else{return o;}};d.applyExtensions=function(o,n,s,v,A){function G(A,t){if(A){return g(t,true).then(function(u){u=r[t]||u;if(u!==undefined){if(u.getMetadata&&u.getMetadata().isA("sap.ui.core.mvc.Controller")){L.warning("Attempt to load Extension Controller "+t+" was not successful","Controller extension should be a plain object.",null,function(){return{type:"ControllerExtension",name:t};});}return u;}},function(u){L.error("Attempt to load Extension Controller "+t+" was not successful - is the Controller correctly defined in its file?");});}else{if(!r[t]&&!sap.ui.require(t)){g(t);}if(r[t]!==undefined){return r[t];}else{L.error("Attempt to load Extension Controller "+t+" was not successful - is the Controller correctly defined in its file?",null,function(){return{type:"ControllerExtension",name:t};});return{};}}}if(A){return b.getControllerExtensions(n,s,v,A).then(function(k){var t=k.customizingControllerNames.map(function(u){return G(true,u);});return Promise.all(t).then(function(p){var q=p.concat(k.providerControllers);for(var i=0,l=q.length;i<l;i++){m(o,q[i]);}return o;});},function(t){L.error("Controller Extension Provider: Error '"+t+"' thrown in "+d._sExtensionProvider+"; extension provider ignored.");return o;});}else{var k=b.getControllerExtensions(n,s,v,A);var p=k.customizingControllerNames.map(G.bind(null,false));var q=p.concat(k.providerControllers);for(var i=0,l=q.length;i<l;i++){m(o,q[i]);}}return o;};d.create=function(o){return j(o.name,undefined,true,o._viewId);};sap.ui.controller=function(n,o,A,v){if(A){L.info("Do not use deprecated factory function 'sap.ui.controller("+n+")'. Use 'sap.ui.core.mvc.Controller.create(...)' instead.","sap.ui.controller",null,function(){return{type:"sap.ui.controller",name:n};});}else{L.warning("Do not use synchronous controller creation for controller '"+n+"'! Use the new asynchronous factory 'sap.ui.core.mvc.Controller.create(...)' instead.","sap.ui.controller",null,function(){return{type:"sap.ui.controller",name:n};});}return j.apply(this,arguments);};function j(n,o,A,v){var i,k,s=M._sOwnerId;if(typeof o==="boolean"){o=undefined;}if(!o){if(A){return g(n,A).then(function(k){return h(k,n);}).then(function(i){return d.applyExtensions(i,n,s,v,A);}).then(function(i){i._sapui_isExtended=true;return i;});}else{k=g(n,A);i=h(k,n);i=d.applyExtensions(i,n,s,v,A);i._sapui_isExtended=true;}return i;}else{r[n]=o;L.info("For defining controllers use Controller.extend instead");}}d.prototype.getPublicMethods=function(){var p={},o=this.getMetadata(),i=o.getAllMethods(),l=o.getLifecycleConfiguration();Object.keys(i).forEach(function(s){if(o.isMethodPublic(s)){p[s]=i[s];p[s].reloadNeeded=!!(s in l);}});delete p.extension;var k=this["_sapui_Extensions"];Object.keys(k).forEach(function(n){var q=k[n];var s=q.extension.getInterface();var A=q.extension.getMetadata().getAllMethods();Object.keys(s).forEach(function(t){delete p[q.location];var u=e({},A[t],{reloadNeeded:q.reloadNeeded});p[q.location+"."+t]=u;});});return p;};d.prototype._getDestroyables=function(){if(!this._aDestroyables){L.error("Mandatory super constructor not called for Controller: '"+this.getMetadata().getName()+"'.",null,"sap.ui.support",function(){return{type:"missingSuperConstructor"};});this._aDestroyables=[];}return this._aDestroyables;};d.prototype.destroyFragments=function(){function D(v){v=Array.isArray(v)?v:[v];for(var i=0;i<v.length;i++){if(!v[i].isDestroyed()){v[i].destroy();}}}var k=this._getDestroyables();for(var i=0;i<k.length;i++){k[i]=k[i].then(D);}};d.prototype.destroy=function(){if(this["_sapui_Extensions"]){Object.keys(this["_sapui_Extensions"]).forEach(function(k){var o=this["_sapui_Extensions"][k];O.set(o.location,null,this);}.bind(this));delete this["_sapui_Extensions"];}E.prototype.destroy.apply(this,arguments);};d.prototype.getView=function(){return this.oView;};d.prototype.byId=function(i){return this.oView?this.oView.byId(i):undefined;};d.prototype.createId=function(i){return this.oView?this.oView.createId(i):undefined;};d.prototype.getOwnerComponent=function(){var i=sap.ui.require("sap/ui/core/Component");if(i){return i.getOwnerComponentFor(this.getView());}else{return undefined;}};d.prototype.connectToView=function(v){this.oView=v;if(this.onInit){v.attachAfterInit(this.onInit,this);}if(this.onExit){v.attachBeforeExit(this.onExit,this);if(v.bControllerIsViewManaged){v.attachBeforeExit(this.destroyFragments,this);}}if(this.onAfterRendering){v.attachAfterRendering(this.onAfterRendering,this);}if(this.onBeforeRendering){v.attachBeforeRendering(this.onBeforeRendering,this);}};d.prototype.loadFragment=function(o){if(!this.getView()){throw new Error("Calling 'loadFragment' without a view attached is not supported!");}else if(!o||!o.name){throw new Error("oOptions must provide at least a fragment name!");}var i=this.getOwnerComponent();var A=o.addToDependents!==false;var k=o.autoPrefixId!==false;var F={name:o.name,type:o.type,id:o.id,controller:this};var D=this._getDestroyables();var p=new Promise(function(l,n){sap.ui.require(["sap/ui/core/Fragment"],function(q){l(q);},n);}).then(function(l){if(!o.id&&k){F.id=this.getView().getId();}else if(k){F.id=this.createId(o.id);}if(i){return i.runAsOwner(function(){return l.load(F);});}else{return l.load(F);}}.bind(this)).then(function(v){if(A){this.getView().applySettings({"dependents":v});}D.splice(D.indexOf(p),1);return v;}.bind(this));D.push(p);return p;};d._sExtensionProvider=null;d.registerExtensionProvider=function(s){d._sExtensionProvider=s;b.registerExtensionProvider(s);};return d;});
