/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/thirdparty/URI','../Element','sap/base/util/UriParameters','sap/base/Log','sap/base/util/extend','sap/ui/core/ThemeCheck','sap/ui/thirdparty/jquery','./ThemeHelper'],function(U,E,a,L,e,T,q,b){"use strict";var c=window["sap-ui-config"]||{};var s=0;if(c['xx-nosync']==='warn'||/(?:\?|&)sap-ui-xx-nosync=(?:warn)/.exec(window.location.search)){s=1;}if(c['xx-nosync']===true||c['xx-nosync']==='true'||/(?:\?|&)sap-ui-xx-nosync=(?:x|X|true)/.exec(window.location.search)){s=2;}var P={};var p=null;var t=null;var d=[];var C=[];var B=new U(sap.ui.require.toUrl(""),document.baseURI).origin();var o={};var r=/url[\s]*\('?"?([^\'")]*)'?"?\)/;var u=a.fromQuery(window.location.search).get("sap-ui-xx-no-inline-theming-parameters")!=="true";function f(i,j){var M=r.exec(i);if(M){var D=new U(M[1]);if(D.is("relative")){var N=D.absoluteTo(j).normalize().toString();i="url('"+N+"')";}}return i;}function m(i,N,j){for(var D in N){if(typeof i[D]==="undefined"){i[D]=f(N[D],j);}}return i;}function g(N,i){if(typeof N["default"]!=="object"){N={"default":N,"scopes":{}};}p=p||{};p["default"]=p["default"]||{};p["scopes"]=p["scopes"]||{};m(p["default"],N["default"],i);if(typeof N["scopes"]==="object"){for(var S in N["scopes"]){p["scopes"][S]=p["scopes"][S]||{};m(p["scopes"][S],N["scopes"][S],i);}}}function h(i){q("link[id^=sap-ui-theme-]").each(function(){i(this.getAttribute("id"));});}function k(i){var j=n(i);var D=T.checkStyle(i);if(!D){L.warning("Parameters have been requested but theme is not applied, yet.","sap.ui.core.theming.Parameters");}if(D&&u){var $=q(document.getElementById(i));var F=$.css("background-image");var G=/\(["']?data:text\/plain;utf-8,(.*?)['"]?\)$/i.exec(F);if(G&&G.length>=2){var H=G[1];if(H.charAt(0)!=="{"&&H.charAt(H.length-1)!=="}"){try{H=decodeURIComponent(H);}catch(I){L.warning("Could not decode theme parameters URI from "+j.styleSheetUrl);}}try{var J=JSON.parse(H);g(J,j.themeBaseUrl);return true;}catch(I){L.warning("Could not parse theme parameters from "+j.styleSheetUrl+". Loading library-parameters.json as fallback solution.");}}}return false;}function l(i){var j=n(i);if(!k(i)){var D=j.styleSheetUrl.replace(/\/(?:css_variables|library)([^\/.]*)\.(?:css|less)($|[?#])/,function($,H,I){return"/library-parameters.json"+(I?I:"");});if(s===2){L.error("[nosync] Loading library-parameters.json ignored",D,"sap.ui.core.theming.Parameters");return;}else if(s===1){L.error("[nosync] Loading library-parameters.json with sync XHR",D,"sap.ui.core.theming.Parameters");}var F=new U(j.themeBaseUrl).origin();var W=o[F];var G=[];if(W===undefined){if(D.startsWith(B)){G=[false,true];}else{G=[true,false];}}else{G=[W];}v(D,j.themeBaseUrl,G);}}function n(i){var j=document.getElementById(i);if(!j){L.warning("Could not find stylesheet element with ID",i,"sap.ui.core.theming.Parameters");return undefined;}var S=j.href;return{themeBaseUrl:new U(S).filename("").query("").toString(),styleSheetUrl:S};}function v(i,D,W){var F=W.shift();var H=F?{"X-Requested-With":"XMLHttpRequest"}:{};q.ajax({url:i,dataType:'json',async:false,xhrFields:{withCredentials:F},headers:H,success:function(G,I,J){var K=new U(D).origin();o[K]=F;if(Array.isArray(G)){for(var j=0;j<G.length;j++){var M=G[j];g(M,D);}}else{g(G,D);}},error:function(j,G,I){L.error("Could not load theme parameters from: "+i,I);if(W.length>0){L.warning("Initial library-parameters.json request failed ('withCredentials="+F+"'; sUrl: '"+i+"').\n"+"Retrying with 'withCredentials="+!F+"'.","sap.ui.core.theming.Parameters");v(i,D,W);}}});}function w(i){if(!p){g({},"");h(function(I){if(i){if(T.checkStyle(I)){k(I);}else{d.push(I);}}else{l(I);}});}return p;}function x(){var i=[];d.forEach(function(I){if(T.checkStyle(I)){k(I);}else{i.push(I);}});d=i;}function y(){d.forEach(l);d=[];}P._addLibraryTheme=function(i){if(p){d.push("sap-ui-theme-"+i);}};function z(O){var i=O.async,j=w(i);if(O.scopeName){j=j["scopes"][O.scopeName];}else{j=j["default"];}var D=j[O.parameterName];if(!D){var I=O.parameterName.indexOf(":");if(I!=-1){var F=O.parameterName.substr(I+1);D=j[F];}}if(O.loadPendingParameters&&typeof D==="undefined"&&!i){y();D=z({parameterName:O.parameterName,scopeName:O.scopeName,loadPendingParameters:false});}return D;}function A(j,D,F){var S=P.getActiveScopesFor(D,F);var G=S.flat().reduce(function(R,J){if(R.indexOf(J)===-1){R.push(J);}return R;},[]);for(var i=0;i<G.length;i++){var H=G[i];var I=z({parameterName:j,scopeName:H,async:F});if(I){return I;}}return z({parameterName:j,async:F});}P._getScopes=function(i,j){if(i&&!p){return;}var D=w(j);var S=Object.keys(D["scopes"]);return S;};P.getActiveScopesFor=function(i,j){var S=[];if(i instanceof E){var D=i.getDomRef();if(j){x();}else{y();}var F=this._getScopes(undefined,j);if(F.length){if(D){var N=function(I){var J=D.classList;return J&&J.contains(I);};while(D){var G=F.filter(N);if(G.length>0){S.push(G);}D=D.parentNode;}}else{var H=function(I){return typeof i.hasStyleClass==="function"&&i.hasStyleClass(I);};while(i){var G=F.filter(H);if(G.length>0){S.push(G);}i=typeof i.getParent==="function"&&i.getParent();}}}}return S;};P.get=function(N,j){var D,F,G,H,I;var J=function(S){return S.callback===F;};if(!sap.ui.getCore().isInitialized()){L.warning("Called sap.ui.core.theming.Parameters.get() before core has been initialized. "+"Consider using the API only when required, e.g. onBeforeRendering.");}if(!t){t=sap.ui.getCore().getConfiguration().getTheme();}if(arguments.length===0){L.warning("Legacy variant usage of sap.ui.core.theming.Parameters.get API detected. Do not use the Parameters.get() API to retrieve ALL theming parameters, "+"as this will lead to unwanted synchronous requests. "+"Use the asynchronous API variant instead and retrieve a fixed set of parameters.","LegacyParametersGet","sap.ui.support",function(){return{type:"LegacyParametersGet"};});y();var K=w();return Object.assign({},K["default"]);}if(!N){return undefined;}if(N instanceof Object&&!Array.isArray(N)){if(!N.name){L.warning("sap.ui.core.theming.Parameters.get was called with an object argument without one or more parameter names.");return undefined;}j=N.scopeElement;F=N.callback;H=typeof N.name==="string"?[N.name]:N.name;G=true;}else{if(typeof N==="string"){H=[N];}else{H=N;}L.warning("Legacy variant usage of sap.ui.core.theming.Parameters.get API detected for parameter(s): '"+H.join(", ")+"'. This could lead to bad performance and additional synchronous XHRs, as parameters might not be available yet. Use asynchronous variant instead.","LegacyParametersGet","sap.ui.support",function(){return{type:"LegacyParametersGet"};});}var M,R;var O=function(S){if(j instanceof E){return A(S,j,G);}else{if(G){x();}return z({parameterName:S,loadPendingParameters:!G,async:G});}};R={};for(var i=0;i<H.length;i++){D=H[i];var Q=O(D);if(!G||Q){R[D]=Q;}}if(G&&F&&Object.keys(R).length!==H.length){if(!sap.ui.getCore().isThemeApplied()){M=function(){sap.ui.getCore().detachThemeChanged(M);var S=this.get({name:N.name,scopeElement:N.scopeElement});if(!S||(typeof S==="object"&&(Object.keys(S).length!==H.length))){L.error("One or more parameters could not be found.","sap.ui.core.theming.Parameters");}F(S);C.splice(C.findIndex(J),1);}.bind(this);I=C.findIndex(J);if(I>=0){sap.ui.getCore().detachThemeChanged(C[I].eventHandler);C[I].eventHandler=M;}else{C.push({callback:F,eventHandler:M});}sap.ui.getCore().attachThemeChanged(M);return undefined;}else{L.error("One or more parameters could not be found.","sap.ui.core.theming.Parameters");}}return H.length===1?R[H[0]]:R;};P._setOrLoadParameters=function(i){p={"default":{},"scopes":{}};t=sap.ui.getCore().getConfiguration().getTheme();h(function(I){var j=I.substr(13);if(i[j]){e(p["default"],i[j]);}else{l(I);}});};P.reset=function(){var O=arguments[0]===true;if(!O||sap.ui.getCore().getConfiguration().getTheme()!==t){t=sap.ui.getCore().getConfiguration().getTheme();d=[];p=null;b.reset();}};P._getThemeImage=function(i,F){i=i||"sapUiGlobalLogo";var j=P.get(i);if(j){var D=r.exec(j);if(D){j=D[1];}else if(j==="''"||j==="none"){j=null;}}if(F&&!j){return sap.ui.resource('sap.ui.core','themes/base/img/1x1.gif');}return j;};return P;},true);
