/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/base/ManagedObject','sap/ui/base/BindingParser','sap/ui/core/Control','sap/ui/core/RenderManager','sap/base/util/ObjectPath','sap/base/Log','sap/base/assert','sap/ui/thirdparty/jquery','sap/ui/core/tmpl/TemplateControl','./_parsePath'],function(M,B,C,R,O,L,a,q,T,p){"use strict";var b=M.extend("sap.ui.core.tmpl.Template",{constructor:function(i,s){M.apply(this,arguments);},metadata:{stereotype:"template","abstract":true,library:"sap.ui.core",properties:{"content":{type:"string",group:"Data",defaultValue:null}},publicMethods:["declareControl","createControl","placeAt","createMetadata","createRenderer"]}});var t={};b.prototype.register=function(){var i=this.getId(),o=t[i],m;if(o&&this!==o){m="adding template with duplicate id '"+i+"'";L.error(m);throw new Error("Error: "+m);}t[i]=this;};b.prototype.deregister=function(){delete t[this.getId()];};b.byId=function(i){return t[i];};b.prototype.getInterface=function(){return this;};b._mSupportedTypes={};b.registerType=function(s,c){b._mSupportedTypes[s]=c;};b.unregisterType=function(s){delete b._mSupportedTypes[s];};b.parsePath=p;b.prototype.init=function(s,S){if(this.getMetadata().getName()==="sap.ui.core.tmpl.Template"){throw new Error("The class 'sap.ui.core.tmpl.Template' is abstract and must not be instantiated!");}if(M.bindingParser===B.complexParser){b.prototype.extractBindingInfo=function(v,i,S){M.bindingParser=B.simpleParser;var r=C.prototype.extractBindingInfo.apply(this,arguments);M.bindingParser=B.complexParser;return r;};}};b.prototype.declareControl=function(c){a(!!c,"A fully qualified name must be specified!");if(c){var m=this.createMetadata(),r=this.createRenderer(),d=this;T.extend(c,{metadata:m,init:function(){T.prototype.init.apply(this,arguments);this.setTemplate(d);},renderer:{renderTemplate:r,hasControlData:m._hasControlData}});return O.get(c||"");}};b.prototype.createControl=function(i,c,v){var o=new T({id:i,template:this,context:c});o.setTemplateRenderer(this.createRenderer(v));return o;};b.prototype.placeAt=function(r,c,P,i){if(typeof c==="string"||typeof c==="number"){P=c;c=undefined;}var I;if(!(r instanceof C)&&i){var $=typeof r==="string"?q(document.getElementById(r)):q(r);if($.length>0){I=$.attr("id");r=$.get(0);var s=$.attr("data-context");c=c||s&&JSON.parse(s);R.markInlineTemplate($);}}var o=this.createControl(I,c);o.placeAt(r,P);return o;};b.prototype.createMetadata=function(){L.error("The function createMetadata is an abstract function which needs to be implemented by subclasses.");};b.prototype.createRenderer=function(){L.error("The function createRenderer is an abstract function which needs to be implemented by subclasses.");};sap.ui.template=function(o){var l=function(N){L.warning("The usage of Template Views is deprecated since 1.56. Please make use of the asynchronous create functions of the different view classes, e.g. XMLView.create()","Deprecation",null,function(){return{type:"sap.ui.template",name:N};});};if(!o){var c=[];q.each(b._mSupportedTypes,function(s,k){q("script[type='"+s+"'], [data-type='"+s+"']").each(function(r,E){c.push(sap.ui.template({id:E.id,domref:E,type:s,_class:k}));});});return c;}else{if(typeof o==="string"){return sap.ui.template({id:o});}else if(o&&o.tagName&&o.nodeName&&o.ownerDocument&&o.nodeType===1){return sap.ui.template({id:o.id,domref:o});}o=q.extend({type:b.DEFAULT_TEMPLATE},o);l(o.id);var i,s,d,e,f=false,g=typeof o.src==="string",I=false;if(g){q.ajax({url:o.src,dataType:"text",async:false,success:function(r){i=o.id;s=o.type;d=o.control;e=r;var u=/^<!--\sUI5:Template\stype=([a-z\/\-]*)\s(?:controller=([A-Za-z.]*)\s)?-->/,v=e.match(u);if(v){s=v[1];if(v.length==3){f=v[2];}e=e.substr(v[0].length);}},error:function(){throw new Error("The template could not be loaded from "+o.src+"!");}});}else{var E=o.domref||((o.id?window.document.getElementById(o.id):null)),$=q(E);I=false;i=o.id||E&&E.id;s=$.attr("type")||o.type;d=$.attr("data-control")||o.control;if(i){var h=sap.ui.getCore().getTemplate(i);if(!h instanceof b){throw new Error("Object for id \""+i+"\" is no sap.ui.core.tmpl.Template!");}else{if(h){return h;}}}if($.length===0){throw new Error("DOM element for the Template with the id \""+i+"\" not found!");}e=$.html();var j=E.tagName.toLowerCase();if(j!=="script"){I=$.parents("body").length===1;}}var k=o._class;if(!k){k=b._mSupportedTypes[s];if(!k){throw new Error("The type \""+s+"\" is not supported.");}}var m=sap.ui.requireSync(k.replace(/\./g,"/"));m=m||O.get(k||"");var n=new m({id:i,content:e});if(d){n.declareControl(d);}if(f){n._sControllerName=f;}if(I){n.placeAt(i,o.context,undefined,true);}return n;}};b.DEFAULT_TEMPLATE="text/x-handlebars-template";b.registerType(b.DEFAULT_TEMPLATE,"sap.ui.core.tmpl.HandlebarsTemplate");return b;});
