/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/Log","sap/base/util/merge","sap/base/util/restricted/_pick","sap/ui/fl/Utils","sap/ui/core/util/reflection/JsControlTreeModifier"],function(L,m,_,f,J){"use strict";var D={};D._mDefaultDelegateItems={};D.types={READONLY:"readonly",WRITEONLY:"writeonly",COMPLETE:"complete"};function g(C,M){if(M){return M;}if(C.getModel){var i=C.getModel();if(!i){return undefined;}return i.getMetadata().getName();}}function a(C,M){M=g(C,M);var i=D._mDefaultDelegateItems[M];return(i||[]).map(function(r){r.payload={};return r;});}function l(M,C,i){if(!i.length){return Promise.resolve([]);}var P=[];i.forEach(function(r){P.push(function(s){return f.requireAsync(r.name).then(function(t){r.instance=t||{};s.push(r);return s;}).catch(function(E){L.error("Failed to load the delegate for the control "+M.getId(C)+"\n"+E.message);return s;});});});return P.reduce(function(r,s){return r.then(s);},Promise.resolve([]));}function b(i){return i&&typeof i==="function";}function c(i){return i.delegateType===D.types.COMPLETE||(b(i.instance.getPropertyInfo)&&(b(i.instance.createLabel)||b(i.instance.createLayout)));}function d(i){return i.delegateType===D.types.READONLY||b(i.instance.getPropertyInfo);}function e(i){return i.delegateType===D.types.WRITEONLY||b(i.instance.createLabel)||b(i.instance.createLayout);}function h(t,i){t.names.push(i.name);if(i.requiredLibraries){t.requiredLibraries=Object.assign(t.requiredLibraries||{},i.requiredLibraries);}if(i.payload&&!t.payload){t.payload=i.payload;}return t;}function j(t,i){t=h(t,i);return m(t,{instance:_(i.instance,["getPropertyInfo","getRepresentedProperties"])});}function k(t,i){t=h(t,i);return m(t,{instance:_(i.instance,["createLabel","createControlForProperty","createLayout"])});}function n(t,i){t=h(t,i);return m(t,_(i,"instance"));}function o(r){var R={names:[],instance:{},modelType:r.length&&r[0].modelType};var s=true;var w=true;for(var i=(r.length-1);i>=0;i--){var t=r[i];if(c(t)){if(s&&w){R=n(R,t);}else if(s){R=j(R,t);}else if(w){R=k(R,t);}break;}else if(d(t)&&s){R=j(R,t);s=false;}else if(e(t)&&w){R=k(R,t);w=false;}}return r.length?R:undefined;}function v(C,M){return new Promise(function(r,i){if(!C){i(new Error("The control parameter is missing"));}if(!M){i(new Error("The modifier parameter is missing"));}if(!C){i(new Error("The input control should be available"));}if(M===J&&(!C.isA||!C.isA("sap.ui.base.ManagedObject"))){i(new Error("The input control should be a managed object"));}r();});}function p(P){return Object.values(D.types).some(function(s){return s===P.delegateType;});}function q(P){var i=D._mDefaultDelegateItems[P.modelType]||[];var r=i.map(function(s){return s.delegateType;});return r.indexOf(D.types.COMPLETE)>-1||r.indexOf(P.delegateType)>-1||(P.delegateType===D.types.COMPLETE&&r.length);}D.getKnownDefaultDelegateLibraries=function(){return["sap.ui.comp"];};D.getRequiredLibrariesForDefaultDelegate=function(i,C,M){M=g(C,M);var r=D._mDefaultDelegateItems[M]||[];return r.reduce(function(R,s){var I=i.indexOf(s.name)>-1;return R.concat(Object.keys((I&&s.requiredLibraries)||{}));},[]);};D.isDelegateRegistered=function(M){return!!D._mDefaultDelegateItems[M];};D.registerDefaultDelegate=function(P){if(!(P.modelType&&P.delegate)){throw new Error("'modelType' and 'delegate' properties are required for registration!");}P.delegateType=P.delegateType||D.types.COMPLETE;if(P.delegateType&&!p(P)){throw new Error("default 'delegateType': "+P.delegateType+" is invalid!");}if(q(P)){throw new Error("modelType "+P.modelType+"is already defined!");}if(!D._mDefaultDelegateItems[P.modelType]){D._mDefaultDelegateItems[P.modelType]=[];}D._mDefaultDelegateItems[P.modelType].push({name:P.delegate,requiredLibraries:P.requiredLibraries,delegateType:P.delegateType,modelType:P.modelType});};D.getDelegateForControl=function(C,M,s,S){return v(C,M).then(function(){return M.getFlexDelegate(C);}).then(function(i){var r=(S&&a(C,s))||[];if(i){r.push(i);}return l(M,C,r);}).then(o.bind(this));};D.clear=function(){D._mDefaultDelegateItems={};};return D;});
