//@ui5-bundle sap/ui/fl/library-preload-apply.js
/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/ui/fl/apply/_internal/ChangesController',["sap/ui/fl/FlexControllerFactory","sap/ui/fl/Utils"],function(O,F){"use strict";var C={getFlexControllerInstance:function(s){if(typeof s==="string"){return O.create(s);}var m=s.appComponent||s;return O.createForControl(m);},getDescriptorFlexControllerInstance:function(s){if(typeof s.appId==="string"){return O.create(s.appId);}var a=s.appComponent||s;var A=F.getAppDescriptorComponentObjectForControl(a);return O.create(A.name);},getAppComponentForSelector:function(s){if(typeof s.appId==="string"){return s;}return s.appComponent||F.getAppComponentForControl(s);}};return C;});
sap.ui.predefine('sap/ui/fl/apply/_internal/connectors/ObjectStorageConnector',["sap/ui/fl/apply/_internal/connectors/ObjectStorageUtils","sap/ui/fl/initial/_internal/StorageUtils"],function(O,S){"use strict";
function l(p){var f=[];return O.forEachObjectInStorage(p,function(F){f.push(F.changeDefinition);}).then(function(){return f;});}
var a={oStorage:undefined,layers:["ALL"],loadFlexData:function(p){return l({storage:this.oStorage,reference:p.reference}).then(function(f){var g=S.getGroupedFlexObjects(f);return S.filterAndSortResponses(g);});}};a.storage=a.oStorage;return a;});
sap.ui.predefine('sap/ui/fl/apply/_internal/connectors/ObjectStorageUtils',[],function(){"use strict";var F="sap.ui.fl";return{forEachObjectInStorage:function(p,P){var r=p.storage.getItems&&p.storage.getItems()||p.storage;return Promise.resolve(r).then(function(r){var a=Object.keys(r).map(function(k){var i=k.includes(F);if(!i){return;}var s=r[k];var f=p.storage._itemsStoredAsObjects?s:JSON.parse(s);var S=true;if(p.reference){S=f.reference===p.reference||f.reference+".Component"===p.reference;}var b=true;if(p.layer){b=f.layer===p.layer;}if(!S||!b){return;}return P({changeDefinition:f,key:k});});return Promise.all(a);});},getAllFlexObjects:function(p){var f=[];return this.forEachObjectInStorage(p,function(m){f.push(m);}).then(function(){return f;});},createFlexKey:function(i){if(i){return F+"."+i;}},createFlexObjectKey:function(f){return this.createFlexKey(f.fileName);}};});
sap.ui.predefine('sap/ui/fl/apply/_internal/flexState/UI2Personalization/UI2PersonalizationState',["sap/ui/fl/apply/_internal/flexState/FlexState","sap/ui/fl/write/_internal/connectors/LrepConnector"],function(F,L){"use strict";var U={};
U.getPersonalization=function(r,c,i){var u=F.getUI2Personalization(r);if(!u||!u[c]){return i?undefined:[];}if(!i){return u[c];}return u[c].filter(function(e){return e.itemName===i;})[0];};
U.setPersonalization=function(p){if(!p||!p.reference||!p.containerKey||!p.itemName||!p.content){return Promise.reject("not all mandatory properties were provided for the storage of the personalization");}return L.ui2Personalization.create({flexObjects:p}).then(function(P){var o=F.getUI2Personalization(P.response.reference);o[P.response.containerKey]=o[P.response.containerKey]||[];o[P.response.containerKey].push(P.response);});};
U.deletePersonalization=function(r,c,i){if(!r||!c||!i){return Promise.reject("not all mandatory properties were provided for the storage of the personalization");}return L.ui2Personalization.remove({reference:r,containerKey:c,itemName:i}).then(function(){var I=U.getPersonalization(r,c);var t=U.getPersonalization(r,c,i);var n=I.indexOf(t);I.splice(n,1);});};
return U;});
sap.ui.predefine('sap/ui/fl/apply/_internal/flexState/changes/ExtensionPointState',["sap/ui/fl/write/api/ChangesWriteAPI","sap/ui/fl/ChangePersistenceFactory","sap/base/util/restricted/_omit","sap/base/util/merge","sap/base/Log"],function(C,a,_,m,L){"use strict";var E={};
function i(c,p,o){if(o.getSelector().name!==p.extensionPointName){return false;}return c.changesHavingCorrectViewPrefix(p,o);}
function b(c,e){if(e.fragmentId){var o=c.getExtensionPointInfo&&c.getExtensionPointInfo();if(o){return e.fragmentId!==o.fragmentId;}return true;}return false;}
function r(c,e,o){var s=c.getSelector();if(e.closestAggregationBindingCarrier&&e.closestAggregationBinding){s=m(s,{id:e.closestAggregationBindingCarrier,idIsLocal:false});var d=c.getDefinition();var O={id:e.targetControl.getId(),idIsLocal:false};if(!d.dependentSelector){d.dependentSelector={};}if(o){c.originalSelectorToBeAdjusted=O;}else{d.dependentSelector.originalSelector=O;}d.content.boundAggregation=e.closestAggregationBinding;}else{s=m(s,{id:e.targetControl.getId(),idIsLocal:false});}c.setSelector(s);}
E.getChangesForExtensionPoint=function(c,p){if(!p.extensionPointName){L.error("Missing name from extension point info!");return Promise.resolve([]);}return c.getChangesForComponent().then(function(d){return d.filter(i.bind(this,c,p));});};
E.enhanceExtensionPointChanges=function(p,e){p.extensionPointName=e.name;var c=a.getChangePersistenceForControl(e.targetControl);return E.getChangesForExtensionPoint(c,p).then(function(d){var P=[];d.forEach(function(o){if(o.isInInitialState()&&!(o.getExtensionPointInfo&&o.getExtensionPointInfo())){o.setExtensionPointInfo(e);r(o,e,false);if(c.isChangeMapCreated()){c.addChangeAndUpdateDependencies(p.appComponent,o);}}else if(b(o,e)){var f=o.getDefinition();var g=_(f,["dependentSelector","fileName","selector","content"]);Object.keys(f.content).forEach(function(k){g[k]=f.content[k];});g.support.sourceChangeFileName=f.fileName||"";P.push(C.create({changeSpecificData:g,selector:{view:e.view,name:e.name}}).then(function(R){r(R,e,true);R.setExtensionPointInfo(e);R.setModuleName(f.moduleName);R.getDefinition().creation=f.creation;c.addChangeAndUpdateDependencies(p.appComponent,R,o);}));}});return Promise.all(P).then(function(){return d;});});};
return E;});
sap.ui.predefine('sap/ui/fl/apply/_internal/flexState/compVariants/Utils',[],function(){"use strict";var U={};
U.getPersistencyKey=function(c){if(c){var v=c.getVariantManagement&&c.getVariantManagement()||c;if(v.getPersonalizableControlPersistencyKey){return v.getPersonalizableControlPersistencyKey();}return v.getPersistencyKey&&v.getPersistencyKey();}};
return U;});
sap.ui.predefine('sap/ui/fl/apply/api/ControlVariantApplyAPI',["sap/base/Log","sap/ui/core/Component","sap/ui/core/Core","sap/ui/core/Element","sap/ui/fl/apply/_internal/controlVariants/URLHandler","sap/ui/fl/variants/VariantManagement","sap/ui/fl/Utils"],function(L,C,a,E,U,V,b){"use strict";var c={clearVariantParameterInURL:function(p){var u;var A=b.getAppComponentForControl(p.control);var v=A&&A.getModel(b.VARIANT_MODEL_NAME);if(!v){L.error("Variant model could not be found on the provided control");return;}if(p.control instanceof V){var s=v.getLocalId(p.control.getId(),A);var m=U.removeURLParameterForVariantManagement({model:v,vmReference:s});u=m.parameters;}U.update({parameters:u||[],updateURL:true,updateHashEntry:!!v,model:v||{},silent:!v});},activateVariant:function(p){function l(o){L.error(o);return Promise.reject(o);}var e;if(typeof p.element==="string"){e=C.get(p.element);if(!(e instanceof C)){e=a.byId(p.element);if(!(e instanceof E)){return l(Error("No valid component or control found for the provided ID"));}}}else if(p.element instanceof C||p.element instanceof E){e=p.element;}var A=b.getAppComponentForControl(e);if(!A){return l(Error("A valid variant management control or component (instance or ID) should be passed as parameter"));}var v=A.getModel(b.VARIANT_MODEL_NAME);if(!v){return l(Error("No variant management model found for the passed control or application component"));}var s=v.getVariantManagementReference(p.variantReference).variantManagementReference;if(!s){return l(Error("A valid control or component, and a valid variant/ID combination are required"));}return v.waitForVMControlInit(s).then(function(){return v.updateCurrentVariant({variantManagementReference:s,newVariantReference:p.variantReference,appComponent:A});}).catch(function(o){L.error(o);throw o;});},attachVariantApplied:function(p){var o=p.selector.id&&sap.ui.getCore().byId(p.selector.id)||p.selector;var A=b.getAppComponentForControl(o);var v=A.getModel(b.VARIANT_MODEL_NAME);v.attachVariantApplied({vmControlId:p.vmControlId,control:o,callback:p.callback,callAfterInitialVariant:p.callAfterInitialVariant});},detachVariantApplied:function(p){var o=p.selector.id&&sap.ui.getCore().byId(p.selector.id)||p.selector;var A=b.getAppComponentForControl(o);var v=A.getModel(b.VARIANT_MODEL_NAME);v.detachVariantApplied(p.vmControlId,o.getId());}};return c;});
sap.ui.predefine('sap/ui/fl/apply/api/FlexRuntimeInfoAPI',["sap/base/util/includes","sap/base/Log","sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/fl/apply/_internal/controlVariants/Utils","sap/ui/fl/apply/_internal/flexState/ManifestUtils","sap/ui/fl/apply/_internal/ChangesController","sap/ui/fl/FlexControllerFactory","sap/ui/fl/Layer","sap/ui/fl/Utils"],function(i,L,J,V,M,C,F,a,U){"use strict";var b={isPersonalized:function(p){function l(m){L.error(m);return Promise.reject(m);}function c(e){return e.getFileType()==="change";}function f(A,e,g){var I=e.map(function(j){return j.id||j.getId();});var s=g.getSelector();var h=J.getControlIdBySelector(s,A);return i(I,h);}function d(e,g){return(Array.isArray(e)&&e.length>0)?i(e,g.getChangeType()):true;}if(!p.selectors||p.selectors.length===0){return l("At least one control ID has to be provided as a parameter");}var A=p.selectors[0].appComponent||U.getAppComponentForControl(p.selectors[0]);if(!A){return l("App Component could not be determined");}var o=F.createForControl(A);return o.getComponentChanges({currentLayer:a.USER,includeCtrlVariants:true}).then(function(e){return e.filter(f.bind(this,A,p.selectors)).filter(d.bind(this,p.changeTypes)).some(c);}.bind(this));},waitForChanges:function(p){var c;var f;if(p.element){c=[{selector:p.element}];f=p.element;}else if(p.selectors){c=p.selectors.map(function(s){return{selector:s};});f=p.selectors[0];}else if(p.complexSelectors){c=p.complexSelectors;f=p.complexSelectors[0].selector;}return C.getFlexControllerInstance(f).waitForChangesToBeApplied(c);},isFlexSupported:function(p){return!!U.getAppComponentForControl(p.element);},hasVariantManagement:function(p){return V.belongsToVariantManagement(p.element);},getFlexReference:function(p){return M.getFlexReferenceForControl(p.element);}};return b;});
sap.ui.predefine('sap/ui/fl/apply/api/SmartVariantManagementApplyAPI',["sap/ui/fl/apply/_internal/flexState/compVariants/CompVariantMerger","sap/ui/fl/apply/_internal/flexState/compVariants/Utils","sap/ui/fl/apply/_internal/flexState/FlexState","sap/ui/fl/apply/_internal/flexState/ManifestUtils","sap/ui/fl/Utils","sap/ui/fl/LayerUtils"],function(C,a,F,M,U,L){"use strict";
function g(o){var r=M.getFlexReferenceForControl(o);var p=a.getPersistencyKey(o);var m=F.getCompVariantsMap(r);return m._getOrCreate(p);}
function b(p){var o=p.control;var r=M.getFlexReferenceForControl(o);return F.initialize({reference:r,componentData:{},manifest:U.getAppDescriptor(o),componentId:U.getAppComponentForControl(o).getId()}).then(function(){var P=a.getPersistencyKey(o);var m=F.getCompVariantsMap(r);F.setInitialNonFlCompVariantData(r,P,p.standardVariant,p.variants);return m._initialize(P,p.variants);});}
function c(s){if(s.length>0&&s.indexOf(".Component")<0){s+=".Component";}return s;}
var S={loadVariants:function(p){return b(p).then(function(m){var P=a.getPersistencyKey(p.control);return C.merge(P,m,p.standardVariant);});},isApplicationVariant:function(p){var o=p.control;var A=U.getAppComponentForControl(o);var f=M.getFlexReferenceForControl(A);var s=c(U.getAppIdFromManifest(A.getManifest()));if(f!==s){return true;}var d=U.getComponentForControl(o);if(d&&d.getAppComponent){d=d.getAppComponent();if(d){return true;}}return false;},isVendorLayer:function(){return L.isVendorLayer();},isVariantDownport:function(){return S.isVendorLayer()&&U.isHotfixMode();},getDefaultVariantId:function(p){var d=g(p.control).defaultVariants;var o=d[d.length-1];return o?o.getContent().defaultVariantName:"";}};return S;});
sap.ui.predefine('sap/ui/fl/apply/api/UI2PersonalizationApplyAPI',["sap/ui/fl/apply/_internal/flexState/UI2Personalization/UI2PersonalizationState","sap/ui/fl/apply/_internal/flexState/FlexState","sap/ui/fl/apply/_internal/ChangesController"],function(U,F,C){"use strict";var a={load:function(p){var f=C.getFlexControllerInstance(p.selector);p.reference=f.getComponentName();if(!p.reference||!p.containerKey){return Promise.reject(new Error("not all mandatory properties were provided for the loading of the personalization"));}return F.initialize({componentId:p.selector.getId()}).then(function(){return U.getPersonalization(p.reference,p.containerKey,p.itemName);});}};return a;});
sap.ui.predefine('sap/ui/fl/initial/_internal/connectors/LrepConnector',["sap/ui/fl/initial/_internal/connectors/Utils","sap/ui/fl/Utils","sap/ui/dom/includeScript","sap/base/util/restricted/_pick"],function(U,F,i,_){"use strict";var R={DATA:"/flex/data/",MODULES:"/flex/modules/"};return{layers:["ALL"],xsrfToken:undefined,settings:undefined,_loadModules:function(f){return new Promise(function(r,a){i(f,undefined,r,a);});},_addClientInfo:function(p){var c=F.getUrlParameter("sap-client");if(!p&&c){p={};}if(c){p["sap-client"]=c;}},loadFlexData:function(p){if(p.cacheKey==="<NO CHANGES>"){return Promise.resolve();}var P=_(p,["version","allContexts"]);this._addClientInfo(P);U.addLanguageInfo(P);var a;if(p.appDescriptor&&p.appDescriptor["sap.app"]){a=p.appDescriptor["sap.app"].id;}if(p.preview){p.reference=p.preview.reference;P.upToLayerType=p.preview.maxLayer;}var d=U.getUrl(R.DATA,p,P);return U.sendRequest(d,"GET",{xsrfToken:this.xsrfToken,siteId:p.siteId,sAppDescriptorId:a}).then(function(r){var o=r.response;if(r.xsrfToken){this.xsrfToken=r.xsrfToken;}if(r.etag){o.cacheKey=r.etag;}else if(p.cacheKey){o.cacheKey=p.cacheKey;}o.changes=o.changes.concat(o.compVariants||[]);if(o.settings){this.settings=o.settings;this.settings.isVariantAdaptationEnabled=!!this.settings.isPublicLayerAvailable;}if(!o.loadModules){return o;}var m=U.getUrl(R.MODULES,p,P);return this._loadModules(m).then(function(){return o;});}.bind(this));}};});
sap.ui.predefine('sap/ui/fl/initial/_internal/connectors/Utils',["sap/base/security/encodeURLParameters"],function(a){"use strict";var T=0;var _=function(r,u){var e=new Error(r.statusText);e.status=r.status;e.userMessage=u;return e;};var b=function(t){return sap.ui.getCore().getLibraryResourceBundle("sap.ui.fl").getText(t);};return{addLanguageInfo:function(p){if(!p){p={};}p["sap-language"]=sap.ui.getCore().getConfiguration().getLanguage();},getUrl:function(r,p,P){if(!r||!p.url){throw new Error("Not all necessary parameters were passed");}var u=p.url+r;if(p.cacheKey){u+="~"+p.cacheKey+"~/";}if(p.reference){u+=p.reference;}else if(p.fileName){u+=p.fileName;}if(P){Object.keys(P).forEach(function(k){if(P[k]===undefined){delete P[k];}});var q=a(P);if(q.length>0){u+="?"+q;}}return u;},sendRequest:function(u,m,p){m=m||"GET";m=m.toUpperCase();return new Promise(function(r,c){var x=new XMLHttpRequest();x.open(m,u);x.timeout=T;if((m==="GET"||m==="HEAD")&&(!p||!p.xsrfToken)){x.setRequestHeader("X-CSRF-Token","fetch");}if((m==="POST"||m==="PUT"||m==="DELETE")&&p&&p.xsrfToken){x.setRequestHeader("X-CSRF-Token",p.xsrfToken);}if(p&&p.contentType){x.setRequestHeader("Content-Type",p.contentType);}if(p&&p.siteId){x.setRequestHeader("X-LRep-Site-Id",p.siteId);}if(p&&p.sAppDescriptorId){x.setRequestHeader("X-LRep-AppDescriptor-Id",p.sAppDescriptorId);}if(p&&p.dataType){x.responseType=p.dataType;}x.onload=function(){if(x.status>=200&&x.status<400){try{var R={};if(x.status!==204&&x.status!==205){if(!x.response&&x.responseText){x.response=x.responseText;}R.response=x.response;if(typeof R.response==="string"&&x.getResponseHeader("content-type")&&(x.getResponseHeader("content-type").indexOf("json")>0)){R.response=JSON.parse(R.response);}}R.status=x.status;if(x.getResponseHeader("X-CSRF-Token")){R.xsrfToken=x.getResponseHeader("X-CSRF-Token");}if(x.getResponseHeader("Etag")){R.etag=x.getResponseHeader("Etag");}r(R);}catch(E){E.userMessage=b("MSG_LOADING_SERVER_RESPONSE_ERROR");c(E);}}else{var s="";try{var o=typeof x.response==="string"?JSON.parse(x.response):x.response;if(Array.isArray(o.messages)&&o.messages.length){s=o.messages.reduce(function(C,d){return C.concat(d.severity==="Error"?d.text+"\n":"");},s);}}catch(e){}c(_(x,s));}};x.ontimeout=function(){c(_(x,b("MSG_CONNECTION_TIMEOUT_ERROR")));};x.onerror=function(){c(_(x,b("MSG_NETWORK_ERROR")));};if(p&&p.payload){x.send(p.payload);}else{x.send();}});}};});
sap.ui.predefine('sap/ui/fl/variants/VariantManagement',["sap/ui/model/Context","sap/ui/model/PropertyBinding","sap/ui/model/json/JSONModel","sap/ui/model/Filter","sap/ui/model/FilterOperator","sap/ui/Device","sap/ui/core/InvisibleText","sap/ui/core/Control","sap/ui/core/Icon","sap/ui/layout/HorizontalLayout","sap/ui/layout/Grid",'sap/base/Log',"sap/m/SearchField","sap/m/RadioButton","sap/m/ColumnListItem","sap/m/Column","sap/m/Text","sap/m/Bar","sap/m/Table","sap/m/Page","sap/m/Toolbar","sap/m/ToolbarSpacer","sap/m/Button","sap/m/ToggleButton","sap/m/CheckBox","sap/m/Dialog","sap/m/Input","sap/m/Label","sap/m/Title","sap/m/ResponsivePopover","sap/m/SelectList","sap/m/ObjectIdentifier","sap/m/OverflowToolbar","sap/m/OverflowToolbarLayoutData","sap/m/VBox",'sap/m/HBox',"sap/ui/events/KeyCodes","sap/ui/core/library","sap/m/library","sap/ui/fl/Utils","sap/ui/fl/registry/Settings"],function(C,P,J,F,a,D,I,b,c,H,G,L,S,R,d,f,T,B,g,h,i,j,k,l,m,n,o,p,q,r,s,O,t,u,V,v,K,w,x,y,z){"use strict";var A=x.OverflowToolbarPriority;var E=x.ButtonType;var M=x.PlacementType;var N=x.PopinDisplay;var Q=x.ScreenSize;var U=w.ValueState;var W=w.TextAlign;
var X=b.extend("sap.ui.fl.variants.VariantManagement",{
metadata:{interfaces:["sap.m.IOverflowToolbarContent"],library:"sap.ui.fl",designtime:"sap/ui/fl/designtime/variants/VariantManagement.designtime",properties:{showSetAsDefault:{type:"boolean",group:"Misc",defaultValue:true},manualVariantKey:{type:"boolean",group:"Misc",defaultValue:false},inErrorState:{type:"boolean",group:"Misc",defaultValue:false},editable:{type:"boolean",group:"Misc",defaultValue:true},modelName:{type:"string",group:"Misc",defaultValue:null},updateVariantInURL:{type:"boolean",group:"Misc",defaultValue:false},resetOnContextChange:{type:"boolean",group:"Misc",defaultValue:true},executeOnSelectionForStandardDefault:{type:"boolean",group:"Misc",defaultValue:false},displayTextForExecuteOnSelectionForStandardVariant:{type:"string",group:"Misc",defaultValue:""}},associations:{"for":{type:"sap.ui.core.Control",multiple:true}},events:{save:{parameters:{name:{type:"string"},overwrite:{type:"boolean"},key:{type:"string"},execute:{type:"boolean"},def:{type:"boolean"}}},cancel:{},manage:{},initialized:{},select:{parameters:{key:{type:"string"}}}}},
renderer:{apiVersion:2,render:function(e,Y){e.openStart("div",Y).class("sapUiFlVarMngmt").openEnd();e.renderControl(Y.oVariantLayout);e.close("div");}}
});
X.INNER_MODEL_NAME="$sapUiFlVariants";X.MAX_NAME_LEN=100;X.COLUMN_FAV_IDX=0;X.COLUMN_NAME_IDX=1;
X.prototype.init=function(){this._sModelName=y.VARIANT_MODEL_NAME;this.attachModelContextChange(this._setModel,this);this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.ui.fl");this._createInnerModel();this.oVariantInvisibleText=new I();this.oVariantText=new q(this.getId()+"-text",{text:{path:'currentVariant',model:this._sModelName,formatter:function(Y){var Z="";if(Y){Z=this.getSelectedVariantText(Y);this._setInvisibleText(Z,this.getModified());}return Z;}.bind(this)}});this.oVariantText.addStyleClass("sapUiFlVarMngmtClickable");this.oVariantText.addStyleClass("sapUiFlVarMngmtTitle");this.oVariantText.addStyleClass("sapMTitleStyleH4");if(D.system.phone){this.oVariantText.addStyleClass("sapUiFlVarMngmtTextPhoneMaxWidth");}else{this.oVariantText.addStyleClass("sapUiFlVarMngmtTextMaxWidth");}var e=new T(this.getId()+"-modified",{text:"*",visible:{path:"modified",model:this._sModelName,formatter:function(Y){var Z=this.getCurrentVariantKey();if(Z){this._setInvisibleText(this.getSelectedVariantText(Z),Y);}return((Y===null)||(Y===undefined))?false:Y;}.bind(this)}});e.setVisible(false);e.addStyleClass("sapUiFlVarMngmtModified");e.addStyleClass("sapUiFlVarMngmtClickable");this.oVariantPopoverTrigger=new l(this.getId()+"-trigger",{icon:"sap-icon://slim-arrow-down",type:E.Transparent,tooltip:this._oRb.getText("VARIANT_MANAGEMENT_TRIGGER_TT")});this.oVariantPopoverTrigger.addAriaLabelledBy(this.oVariantInvisibleText);this.oVariantPopoverTrigger.addStyleClass("sapUiFlVarMngmtTriggerBtn");this.oVariantLayout=new H({content:[this.oVariantText,e,this.oVariantPopoverTrigger]});this.oVariantLayout.addStyleClass("sapUiFlVarMngmtLayout");e.setVisible(false);this.oVariantModifiedText=e;this.oVariantInvisibleText.toStatic();this.addDependent(this.oVariantLayout);this._fRegisteredApplyAutomaticallyOnStandardVariant=null;};
X.prototype.registerApplyAutomaticallyOnStandardVariant=function(e){this._fRegisteredApplyAutomaticallyOnStandardVariant=e;return this;};
X.prototype.getApplyAutomaticallyOnVariant=function(e){var Y=e.executeOnSelect;if(this._fRegisteredApplyAutomaticallyOnStandardVariant&&this.getDisplayTextForExecuteOnSelectionForStandardVariant()&&(e.key===this.getStandardVariantKey())){try{Y=this._fRegisteredApplyAutomaticallyOnStandardVariant(e);}catch(Z){L.error("callback for determination of apply automatically on standard variant failed");}}return Y;};
X.prototype.getOverflowToolbarConfig=function(){return{canOverflow:false,invalidationEvents:["save","manage","select"]};};
X.prototype.getTitle=function(){return this.oVariantText;};
X.prototype._setInvisibleText=function(e,Y){var Z;if(e){if(Y){Z="VARIANT_MANAGEMENT_SEL_VARIANT_MOD";}else{Z="VARIANT_MANAGEMENT_SEL_VARIANT";}this.oVariantInvisibleText.setText(this._oRb.getText(Z,[e]));}};
X.prototype._createInnerModel=function(){var e=new J({showExecuteOnSelection:false,showSetAsDefault:true,showPublic:false,showContexts:false,editable:true,popoverTitle:this._oRb.getText("VARIANT_MANAGEMENT_VARIANTS")});this.setModel(e,X.INNER_MODEL_NAME);this._bindProperties();this._updateInnerModelWithSettingsInfo();};
X.prototype._bindProperties=function(){this.bindProperty("showSetAsDefault",{path:"/showSetAsDefault",model:X.INNER_MODEL_NAME});this.bindProperty("editable",{path:"/editable",model:X.INNER_MODEL_NAME});};
X.prototype._updateInnerModelWithSettingsInfo=function(){z.getInstance().then(function(e){this.getModel(X.INNER_MODEL_NAME).setProperty("/showSaveAs",e.isVariantPersonalizationEnabled());this.getModel(X.INNER_MODEL_NAME).setProperty("/showPublic",e.isPublicFlVariantEnabled());}.bind(this));};
X.prototype._getShowPublic=function(){var e=this.getModel(X.INNER_MODEL_NAME);if(e){return e.getProperty("/showPublic");}return false;};
X.prototype._setShowPublic=function(e){var Y=this.getModel(X.INNER_MODEL_NAME);if(Y){Y.setProperty("/showPublic",e);}};
X.prototype._getShowContexts=function(){var e=this.getModel(X.INNER_MODEL_NAME);if(e){return e.getProperty("/showContexts");}return false;};
X.prototype._setShowContexts=function(e){var Y=this.getModel(X.INNER_MODEL_NAME);if(Y){Y.setProperty("/showContexts",e);}};
X.prototype._getShowExecuteOnSelection=function(){var e=this.getModel(X.INNER_MODEL_NAME);if(e){return e.getProperty("/showExecuteOnSelection");}return false;};
X.prototype._setShowExecuteOnSelection=function(e){var Y=this.getModel(X.INNER_MODEL_NAME);if(Y){Y.setProperty("/showExecuteOnSelection",e);}};
X.prototype.setExecuteOnSelection=function(e){var Y=this.getModel(this._sModelName);if(Y&&this.oContext){Y.setProperty(this.oContext+"/executeOnSelection",e);}};
X.prototype.getOriginalDefaultVariantKey=function(){var e=this.getModel(this._sModelName);if(e&&this.oContext){return e.getProperty(this.oContext+"/originalDefaultVariant");}return null;};
X.prototype.setDefaultVariantKey=function(e){var Y=this.getModel(this._sModelName);if(Y&&this.oContext){Y.setProperty(this.oContext+"/defaultVariant",e);}};
X.prototype.getDefaultVariantKey=function(){var e=this.getModel(this._sModelName);if(e&&this.oContext){return e.getProperty(this.oContext+"/defaultVariant");}return null;};
X.prototype.setCurrentVariantKey=function(e){var Y=this.getModel(this._sModelName);if(Y&&this.oContext){Y.setProperty(this.oContext+"/currentVariant",e);}return this;};
X.prototype.getCurrentVariantKey=function(){var e=this.getModel(this._sModelName);if(e&&this.oContext){return e.getProperty(this.oContext+"/currentVariant");}return null;};
X.prototype._assignPopoverTitle=function(){var e;var Y;var Z=this.getModel(this._sModelName);if(Z&&this.oContext){e=Z.getProperty(this.oContext+"/popoverTitle");}if(e!==undefined){Y=this.getModel(X.INNER_MODEL_NAME);if(Y){Y.setProperty("/popoverTitle",e);}}};
X.prototype.getVariants=function(){return this._getItems();};
X.prototype.setModified=function(e){var Y=this.getModel(this._sModelName);if(Y&&this.oContext){Y.setProperty(this.oContext+"/modified",e);}};
X.prototype.getModified=function(){var e=this.getModel(this._sModelName);if(e&&this.oContext){return e.getProperty(this.oContext+"/modified");}return false;};
X.prototype.getSelectedVariantText=function(e){var Y=this._getItemByKey(e);if(Y){return Y.title;}return"";};
X.prototype.getStandardVariantKey=function(){var e=this._getItems();if(e&&e[0]){return e[0].key;}return null;};
X.prototype.getShowFavorites=function(){var e=this.getModel(this._sModelName);if(e&&this.oContext){return e.getProperty(this.oContext+"/showFavorites");}return false;};
X.prototype._clearDeletedItems=function(){this._aDeletedItems=[];};
X.prototype._addDeletedItem=function(e){this._aDeletedItems.push(e);};
X.prototype._getDeletedItems=function(){return this._aDeletedItems;};
X.prototype._getItems=function(){var e=[];if(this.oContext&&this.oContext.getObject()){e=this.oContext.getObject().variants.filter(function(Y){if(!Y.hasOwnProperty("visible")){return true;}return Y.visible;});}return e;};
X.prototype._getItemByKey=function(e){var Y=null;var Z=this._getItems();Z.some(function($){if($.key===e){Y=$;}return(Y!==null);});return Y;};
X.prototype._rebindControl=function(){this.oVariantText.unbindProperty("text");this.oVariantText.bindProperty("text",{path:'currentVariant',model:this._sModelName,formatter:function(e){var Y="";if(e){Y=this.getSelectedVariantText(e);this._setInvisibleText(Y,this.getModified());}return Y;}.bind(this)});this.oVariantModifiedText.unbindProperty("visible");this.oVariantModifiedText.bindProperty("visible",{path:"modified",model:this._sModelName,formatter:function(e){var Y=this.getCurrentVariantKey();if(Y){this._setInvisibleText(this.getSelectedVariantText(Y),e);}return((e===null)||(e===undefined))?false:e;}.bind(this)});};
X.prototype.setModelName=function(e){if(this.getModelName()){this.oContext=null;}this.setProperty("modelName",e);this._sModelName=e;this._rebindControl();return this;};
X.prototype._setBindingContext=function(){var e;var Y;if(!this.oContext){e=this.getModel(this._sModelName);if(e){Y=this._getLocalId(e);if(Y){this.oContext=new C(e,"/"+Y);this.setBindingContext(this.oContext,this._sModelName);if(!this.getModelName()&&e.registerToModel){e.registerToModel(this);}this._assignPopoverTitle();this._registerPropertyChanges(e);this.fireInitialized();}}}};
X.prototype._getLocalId=function(e){if(this.getModelName()&&(this._sModelName!==y.VARIANT_MODEL_NAME)){return this.getId();}return e.getVariantManagementReferenceForControl(this);};
X.prototype._setModel=function(){this._setBindingContext();};
X.prototype._registerPropertyChanges=function(e){var Y=new P(e,this.oContext+"/showExecuteOnSelection");Y.attachChange(function(Z){if(Z&&Z.oSource&&Z.oSource.oModel&&Z.oSource.sPath){var $=Z.oSource.oModel.getProperty(Z.oSource.sPath);if($!==undefined){this._setShowExecuteOnSelection($);}}}.bind(this));Y=new P(e,this.oContext+"/variantsEditable");Y.attachChange(function(Z){if(Z&&Z.oSource&&Z.oSource.oModel&&Z.oSource.sPath){var $;var _=Z.oSource.oModel.getProperty(Z.oSource.sPath);$=this.getModel(X.INNER_MODEL_NAME);if($&&(_!==undefined)){$.setProperty("/editable",_);}}}.bind(this));};
X.prototype._obtainControl=function(e){if(e&&e.target&&e.target.id){var Y=e.target.id;var Z=Y.indexOf("-inner");if(Z>0){Y=Y.substring(0,Z);}return sap.ui.getCore().byId(Y);}return null;};
X.prototype.handleOpenCloseVariantPopover=function(e){if(!this.bPopoverOpen){this._oCtrlRef=this._obtainControl(e);this._openVariantList();}else if(this.oVariantPopOver&&this.oVariantPopOver.isOpen()){this.oVariantPopOver.close();}else if(this.getInErrorState()&&this.oErrorVariantPopOver&&this.oErrorVariantPopOver.isOpen()){this.oErrorVariantPopOver.close();}};
X.prototype.getFocusDomRef=function(){return this.oVariantPopoverTrigger.getFocusDomRef();};
X.prototype.onclick=function(e){if(this.oVariantPopoverTrigger&&!this.bPopoverOpen){this.oVariantPopoverTrigger.focus();}this.handleOpenCloseVariantPopover(e);};
X.prototype.onkeyup=function(e){if(e.which===K.F4||e.which===K.SPACE||e.altKey===true&&e.which===K.ARROW_UP||e.altKey===true&&e.which===K.ARROW_DOWN){this._oCtrlRef=this._obtainControl(e);this._openVariantList();}};
X.prototype.onAfterRendering=function(){this.oVariantText.$().off("mouseover").on("mouseover",function(){this.oVariantPopoverTrigger.addStyleClass("sapUiFlVarMngmtTriggerBtnHover");}.bind(this));this.oVariantText.$().off("mouseout").on("mouseout",function(){this.oVariantPopoverTrigger.removeStyleClass("sapUiFlVarMngmtTriggerBtnHover");}.bind(this));};
X.prototype._openInErrorState=function(){var Y;if(!this.oErrorVariantPopOver){Y=new V({fitContainer:true,alignItems:sap.m.FlexAlignItems.Center,items:[new c({size:"4rem",color:"lightgray",src:"sap-icon://message-error"}),new q({titleStyle:sap.ui.core.TitleLevel.H2,text:this._oRb.getText("VARIANT_MANAGEMENT_ERROR_TEXT1")}),new T({textAlign:sap.ui.core.TextAlign.Center,text:this._oRb.getText("VARIANT_MANAGEMENT_ERROR_TEXT2")})]});Y.addStyleClass("sapUiFlVarMngmtErrorPopover");this.oErrorVariantPopOver=new r(this.getId()+"-errorpopover",{title:{path:"/popoverTitle",model:X.INNER_MODEL_NAME},contentWidth:"400px",placement:M.VerticalPreferredBottom,content:[new h(this.getId()+"-errorselpage",{showSubHeader:false,showNavButton:false,showHeader:false,content:[Y]})],afterOpen:function(){this.bPopoverOpen=true;}.bind(this),afterClose:function(){if(this.bPopoverOpen){setTimeout(function(){this.bPopoverOpen=false;}.bind(this),200);}}.bind(this),contentHeight:"300px"});this.oErrorVariantPopOver.attachBrowserEvent("keyup",function(e){if(e.which===32){this.oErrorVariantPopOver.close();}}.bind(this));}if(this.bPopoverOpen){return;}this.oErrorVariantPopOver.openBy(this.oVariantLayout);};
X.prototype._createVariantList=function(){if(this.oVariantPopOver){return;}this.oVariantManageBtn=new k(this.getId()+"-manage",{text:this._oRb.getText("VARIANT_MANAGEMENT_MANAGE"),enabled:true,press:function(){this._openManagementDialog();}.bind(this),layoutData:new u({priority:A.Low})});this.oVariantSaveBtn=new k(this.getId()+"-mainsave",{text:this._oRb.getText("VARIANT_MANAGEMENT_SAVE"),press:function(){this._handleVariantSave();}.bind(this),visible:{path:"modified",model:this._sModelName,formatter:function(Y){return Y;}},type:E.Emphasized,layoutData:new u({priority:A.Low})});this.oVariantSaveAsBtn=new k(this.getId()+"-saveas",{text:this._oRb.getText("VARIANT_MANAGEMENT_SAVEAS"),press:function(){this._openSaveAsDialog();}.bind(this),layoutData:new u({priority:A.Low}),visible:{path:"/showSaveAs",model:X.INNER_MODEL_NAME}});this._oVariantList=new s(this.getId()+"-list",{selectedKey:{path:"currentVariant",model:this._sModelName},itemPress:function(Y){var Z=null;if(Y&&Y.getParameters()){var $=Y.getParameters().item;if($){Z=$.getKey();}}if(Z){this.setCurrentVariantKey(Z);this.fireEvent("select",{key:Z});this.oVariantPopOver.close();}}.bind(this)});this._oVariantList.setNoDataText(this._oRb.getText("VARIANT_MANAGEMENT_NODATA"));var e=new sap.ui.core.Item({key:'{'+this._sModelName+">key}",text:'{'+this._sModelName+">title}"});this._oVariantList.bindAggregation("items",{path:"variants",model:this._sModelName,template:e});this._oSearchField=new S(this.getId()+"-search");this._oSearchField.attachLiveChange(function(Y){this._triggerSearch(Y,this._oVariantList);}.bind(this));this.oVariantSelectionPage=new h(this.getId()+"-selpage",{subHeader:new i({content:[this._oSearchField]}),content:[this._oVariantList],footer:new t({content:[new j(this.getId()+"-spacer"),this.oVariantSaveBtn,this.oVariantSaveAsBtn,this.oVariantManageBtn]}),showNavButton:false,showHeader:false,showFooter:{path:"/editable",model:X.INNER_MODEL_NAME}});this.oVariantPopOver=new r(this.getId()+"-popover",{title:{path:"/popoverTitle",model:X.INNER_MODEL_NAME},titleAlignment:"Auto",contentWidth:"400px",placement:M.VerticalPreferredBottom,content:[this.oVariantSelectionPage],afterOpen:function(){this.bPopoverOpen=true;this.oVariantPopoverTrigger.setPressed(true);}.bind(this),afterClose:function(){this.oVariantPopoverTrigger.setPressed(false);if(this.bPopoverOpen){setTimeout(function(){this.bPopoverOpen=false;}.bind(this),200);}}.bind(this),contentHeight:"300px"});this.oVariantPopOver.addStyleClass("sapUiFlVarMngmtPopover");if(this.oVariantLayout.$().closest(".sapUiSizeCompact").length>0){this.oVariantPopOver.addStyleClass("sapUiSizeCompact");}this.addDependent(this.oVariantPopOver);};
X.prototype.showSaveButton=function(e){if(e===false){this.oVariantSaveAsBtn.setType(E.Emphasized);this.oVariantSaveBtn.setVisible(false);}else{this.oVariantSaveAsBtn.setType(E.Default);this.oVariantSaveBtn.setVisible(true);}};
X.prototype._openVariantList=function(){var e;if(this.getInErrorState()){this._openInErrorState();return;}if(this.bPopoverOpen){return;}if(!this.oContext){return;}this._createVariantList();this._oSearchField.setValue("");this._oVariantList.getBinding("items").filter(this._getFilters());this.oVariantSelectionPage.setShowSubHeader(this._oVariantList.getItems().length>9);this.showSaveButton(false);if(this.getModified()){e=this._getItemByKey(this.getCurrentVariantKey());if(e&&e.change){this.showSaveButton(true);}}var Y=this._oCtrlRef?this._oCtrlRef:this.oVariantLayout;this._oCtrlRef=null;this.oVariantPopOver.openBy(Y);};
X.prototype._triggerSearch=function(e,Y){if(!e){return;}var Z=e.getParameters();if(!Z){return;}var $=Z.newValue?Z.newValue:"";var _=new F({path:"title",operator:a.Contains,value1:$});Y.getBinding("items").filter(this._getFilters(_));};
X.prototype._createSaveAsDialog=function(){if(!this.oSaveAsDialog){this.oInputName=new o(this.getId()+"-name",{liveChange:function(){this._checkVariantNameConstraints(this.oInputName);}.bind(this)});var e=new p(this.getId()+"-namelabel",{text:this._oRb.getText("VARIANT_MANAGEMENT_NAME")});e.setLabelFor(this.oInputName);e.addStyleClass("sapUiFlVarMngmtSaveDialogLabel");this.oDefault=new m(this.getId()+"-default",{text:this._oRb.getText("VARIANT_MANAGEMENT_SETASDEFAULT"),visible:{path:"/showSetAsDefault",model:X.INNER_MODEL_NAME},width:"100%"});this.oPublic=new m(this.getId()+"-public",{text:this._oRb.getText("VARIANT_MANAGEMENT_SETASPUBLIC"),visible:{path:"/showPublic",model:X.INNER_MODEL_NAME},width:"100%"});this.oExecuteOnSelect=new m(this.getId()+"-execute",{text:this._oRb.getText("VARIANT_MANAGEMENT_EXECUTEONSELECT"),visible:{path:"/showExecuteOnSelection",model:X.INNER_MODEL_NAME},width:"100%"});this.oInputManualKey=new o(this.getId()+"-key",{liveChange:function(){this._checkVariantNameConstraints(this.oInputManualKey);}.bind(this)});this.oLabelKey=new p(this.getId()+"-keylabel",{text:this._oRb.getText("VARIANT_MANAGEMENT_KEY"),required:true});this.oLabelKey.setLabelFor(this.oInputManualKey);this.oSaveSave=new k(this.getId()+"-variantsave",{text:this._oRb.getText("VARIANT_MANAGEMENT_SAVE"),type:E.Emphasized,press:function(){if(!this._bSaveOngoing){this._checkVariantNameConstraints(this.oInputName);if(this.oInputName.getValueState()==="Error"){this.oInputName.focus();return;}this._bSaveOngoing=true;this._bSaveCanceled=false;this._handleVariantSaveAs(this.oInputName.getValue());}}.bind(this),enabled:true});var Y=new G({defaultSpan:"L12 M12 S12"});if(this.getShowSetAsDefault()){Y.addContent(this.oDefault);}Y.addContent(this.oPublic);if(this._getShowExecuteOnSelection()){Y.addContent(this.oExecuteOnSelect);}this.oSaveAsDialog=new n(this.getId()+"-savedialog",{title:this._oRb.getText("VARIANT_MANAGEMENT_SAVEDIALOG"),afterClose:function(){this._bSaveOngoing=false;if(this._sStyleClass){this._setShowPublic(this._bShowPublic);this.oSaveAsDialog.removeStyleClass(this._sStyleClass);if(this._oRolesComponentContainer){this.oSaveAsDialog.removeContent(this._oRolesComponentContainer);}this._sStyleClass=undefined;this._oRolesComponentContainer=null;}}.bind(this),beginButton:this.oSaveSave,endButton:new k(this.getId()+"-variantcancel",{text:this._oRb.getText("VARIANT_MANAGEMENT_CANCEL"),press:this._cancelPressed.bind(this)}),content:[e,this.oInputName,this.oLabelKey,this.oInputManualKey,Y],stretch:D.system.phone});this.oSaveAsDialog.isPopupAdaptationAllowed=function(){return false;};this.oSaveAsDialog.addStyleClass("sapUiContentPadding");this.oSaveAsDialog.addStyleClass("sapUiFlVarMngmtSaveDialog");if(this.oVariantLayout.$().closest(".sapUiSizeCompact").length>0){this.oSaveAsDialog.addStyleClass("sapUiSizeCompact");}this.addDependent(this.oSaveAsDialog);}};
X.prototype._cancelPressed=function(){this._bSaveCanceled=true;this.fireCancel();this.oSaveAsDialog.close();};
X.prototype._getSelectedContexts=function(){return this._oRolesComponentContainer.getComponentInstance().getSelectedContexts();};
X.prototype._setSelectedContexts=function(e){if(!e){e={role:[]};}this._oRolesComponentContainer.getComponentInstance().setSelectedContexts(e);};
X.prototype._isInErrorContexts=function(){return this._oRolesComponentContainer.getComponentInstance().hasErrorsAndShowErrorMessage();};
X.prototype._determineRolesSpecificText=function(e,Y){if(!e){e={role:[]};}if(e&&Y){Y.setText(this._oRb.getText((e.role&&e.role.length>0)?"VARIANT_MANAGEMENT_VISIBILITY_RESTRICTED":"VARIANT_MANAGEMENT_VISIBILITY_NON_RESTRICTED"));}};
X.prototype._checkAndAddRolesContainerToManageDialog=function(){if(this._oRolesComponentContainer&&this._oRolesDialog){var e=null;this._oRolesDialog.getContent().some(function(Y){if(Y===this._oRolesComponentContainer){e=Y;return true;}return false;}.bind(this));if(!e){this._oRolesDialog.addContent(this._oRolesComponentContainer);}}};
X.prototype._createRolesDialog=function(){if(!this._oRolesDialog){this._oRolesDialog=new n(this.getId()+"-roledialog",{draggable:true,resizable:true,contentWidth:"40%",title:this._oRb.getText("VARIANT_MANAGEMENT_SELECTROLES_DIALOG"),beginButton:new k(this.getId()+"-rolesave",{text:this._oRb.getText("VARIANT_MANAGEMENT_SAVE"),type:E.Emphasized,press:function(){if(!this._checkAndCreateContextInfoChanges(this._oCurrentContextsKey,this._oTextControl)){return;}this._oRolesDialog.close();}.bind(this)}),endButton:new k(this.getId()+"-rolecancel",{text:this._oRb.getText("VARIANT_MANAGEMENT_CANCEL"),press:function(){this._oRolesDialog.close();}.bind(this)}),content:[this._oRolesComponentContainer],stretch:D.system.phone});this._oRolesDialog.setParent(this);this._oRolesDialog.addStyleClass("sapUiContentPadding");this._oRolesDialog.addStyleClass(this._sStyleClass);this._oRolesDialog.isPopupAdaptationAllowed=function(){return false;};}this._checkAndAddRolesContainerToManageDialog();};
X.prototype._openRolesDialog=function(e,Y){this._createRolesDialog();this._oCurrentContextsKey=e.key;this._oTextControl=Y;this._setSelectedContexts(e.contexts);this._oRolesDialog.open();};
X.prototype._checkAndCreateContextInfoChanges=function(e,Y){if(e){if(this._oRolesComponentContainer){try{if(!this._isInErrorContexts()){var Z=this._getSelectedContexts();var $=this._getItemByKey(e);if($){$.contexts=Z;this._determineRolesSpecificText(Z,Y);}}else{return false;}}catch(_){return false;}}return true;}return false;};
X.prototype._checkAndAddRolesContainerToSaveAsDialog=function(){if(this._oRolesComponentContainer&&this.oSaveAsDialog){var e=null;this.oSaveAsDialog.getContent().some(function(Y){if(Y===this._oRolesComponentContainer){e=Y;return true;}return false;}.bind(this));this._setSelectedContexts({role:[]});if(!e){this.oSaveAsDialog.addContent(this._oRolesComponentContainer);}}};
X.prototype.openSaveAsDialogForKeyUser=function(e,Y){this._openSaveAsDialog(true);this.oSaveAsDialog.addStyleClass(e);this._sStyleClass=e;this._bShowPublic=this._getShowPublic();this._setShowPublic(false);if(Y){Promise.all([Y]).then(function(Z){this._oRolesComponentContainer=Z[0];this._checkAndAddRolesContainerToSaveAsDialog();this.oSaveAsDialog.open();}.bind(this));}else{this.oSaveAsDialog.open();}};
X.prototype._openSaveAsDialog=function(e){this._createSaveAsDialog();this.oInputName.setValue(this.getSelectedVariantText(this.getCurrentVariantKey()));this.oInputName.setEnabled(true);this.oInputName.setValueState(U.None);this.oInputName.setValueStateText(null);this.oDefault.setSelected(false);this.oPublic.setSelected(false);this.oExecuteOnSelect.setSelected(false);if(this.oVariantPopOver){this.oVariantPopOver.close();}if(this.getManualVariantKey()){this.oInputManualKey.setVisible(true);this.oInputManualKey.setEnabled(true);this.oInputManualKey.setValueState(U.None);this.oInputManualKey.setValueStateText(null);this.oLabelKey.setVisible(true);}else{this.oInputManualKey.setVisible(false);this.oLabelKey.setVisible(false);}if(!e){this.oSaveAsDialog.open();}};
X.prototype._handleVariantSaveAs=function(e){var Y=null;var Z=e.trim();var $=this.oInputManualKey.getValue().trim();if(Z===""){this.oInputName.setValueState(U.Error);this.oInputName.setValueStateText(this._oRb.getText("VARIANT_MANAGEMENT_ERROR_EMPTY"));return;}if(this.getManualVariantKey()){if($===""){this.oInputManualKey.setValueState(U.Error);this.oInputManualKey.setValueStateText(this._oRb.getText("VARIANT_MANAGEMENT_ERROR_EMPTY"));return;}Y=$;}if(this.oSaveAsDialog){this.oSaveAsDialog.close();}if(this.oDefault.getSelected()){this.setDefaultVariantKey(Y);}this.setModified(false);this.fireSave({key:Y,name:Z,overwrite:false,def:this.oDefault.getSelected(),execute:this.oExecuteOnSelect.getSelected(),"public":this._sStyleClass?undefined:this.oPublic.getSelected(),contexts:this._sStyleClass?this._getContextInfoChanges():undefined});};
X.prototype._getContextInfoChanges=function(){if(this._oRolesComponentContainer){try{if(!this._isInErrorContexts()){return this._getSelectedContexts();}}catch(e){return null;}}return null;};
X.prototype._handleVariantSave=function(){var e=this._getItemByKey(this.getCurrentVariantKey());var Y=false;if(this.getDefaultVariantKey()===e.key){Y=true;}if(this.oVariantPopOver){this.oVariantPopOver.close();}this.fireSave({name:e.title,overwrite:true,key:e.key,def:Y});this.setModified(false);};
X.prototype.openManagementDialog=function(e,Y,Z){if(e&&this.oManagementDialog){this.oManagementDialog.destroy();this.oManagementDialog=undefined;}if(Y){this._sStyleClass=Y;this._bShowPublic=this._getShowPublic();this._setShowPublic(false);}if(Z){Promise.all([Z]).then(function($){this._oRolesComponentContainer=$[0];this._setShowContexts(!!this._oRolesComponentContainer);this._openManagementDialog();if(this._sStyleClass){this.oManagementDialog.addStyleClass(this._sStyleClass);}}.bind(this));}else{this._setShowContexts(false);this._openManagementDialog();if(this._sStyleClass){this.oManagementDialog.addStyleClass(this._sStyleClass);}}};
X.prototype._triggerSearchInManageDialog=function(e,Y){if(!e){return;}var Z=e.getParameters();if(!Z){return;}var $=Z.newValue?Z.newValue:"";var _=[this._getVisibleFilter(),new F({filters:[new F({path:"title",operator:a.Contains,value1:$}),new F({path:"author",operator:a.Contains,value1:$})],and:false})];Y.getBinding("items").filter(_);this._bDeleteOccured=true;};
X.prototype.getManageDialog=function(){return this.oManagementDialog;};
X.prototype._createManagementDialog=function(){if(!this.oManagementDialog||this.oManagementDialog.bIsDestroyed){this.oManagementTable=new g(this.getId()+"-managementTable",{contextualWidth:"Auto",fixedLayout:false,growing:true,columns:[new f({width:"3rem",visible:{path:"showFavorites",model:this._sModelName}}),new f({header:new T({text:this._oRb.getText("VARIANT_MANAGEMENT_NAME")}),width:"16rem"}),new f({header:new T({text:this._oRb.getText("VARIANT_MANAGEMENT_VARIANTTYPE"),wrappingType:"Hyphenated"}),visible:{path:"/showPublic",model:X.INNER_MODEL_NAME},demandPopin:true,popinDisplay:N.Inline,minScreenWidth:Q.Tablet}),new f({header:new T({text:this._oRb.getText("VARIANT_MANAGEMENT_DEFAULT"),wrappingType:"Hyphenated"}),hAlign:W.Center,demandPopin:true,popinDisplay:N.Block,minScreenWidth:Q.Tablet,visible:{path:"/showSetAsDefault",model:X.INNER_MODEL_NAME}}),new f({header:new T({text:this._oRb.getText("VARIANT_MANAGEMENT_EXECUTEONSELECT"),wrappingType:"Hyphenated"}),hAlign:this.getDisplayTextForExecuteOnSelectionForStandardVariant()?W.Begin:W.Center,demandPopin:true,popinDisplay:N.Block,minScreenWidth:Q.Tablet,visible:{path:"/showExecuteOnSelection",model:X.INNER_MODEL_NAME}}),new f({header:new T({text:this._oRb.getText("VARIANT_MANAGEMENT_VISIBILITY"),wrappingType:"Hyphenated"}),width:"8rem",demandPopin:true,popinDisplay:N.Inline,minScreenWidth:Q.Tablet,visible:{path:"/showContexts",model:X.INNER_MODEL_NAME}}),new f({header:new T({text:this._oRb.getText("VARIANT_MANAGEMENT_AUTHOR")}),demandPopin:true,popinDisplay:N.Block,minScreenWidth:Q.Tablet}),new f({hAlign:W.Center}),new f({visible:false})]});this.oManagementSave=new k(this.getId()+"-managementsave",{text:this._oRb.getText("VARIANT_MANAGEMENT_SAVE"),enabled:true,type:E.Emphasized,press:function(){this._handleManageSavePressed();}.bind(this)});this.oManagementCancel=new k(this.getId()+"-managementcancel",{text:this._oRb.getText("VARIANT_MANAGEMENT_CANCEL"),press:function(){this._resumeManagementTableBinding();this.oManagementDialog.close();this._handleManageCancelPressed();}.bind(this)});this.oManagementDialog=new n(this.getId()+"-managementdialog",{contentWidth:"64%",resizable:true,draggable:true,title:this._oRb.getText("VARIANT_MANAGEMENT_MANAGEDIALOG"),beginButton:this.oManagementSave,endButton:this.oManagementCancel,afterClose:function(){if(this._sStyleClass){this._setShowPublic(this._bShowPublic);this.oManagementDialog.removeStyleClass(this._sStyleClass);this._sStyleClass=undefined;this._oRolesComponentContainer=null;}}.bind(this),content:[this.oManagementTable],stretch:D.system.phone});this.oManagementDialog.isPopupAdaptationAllowed=function(){return false;};this._oSearchFieldOnMgmtDialog=new S();this._oSearchFieldOnMgmtDialog.attachLiveChange(function(Y){this._triggerSearchInManageDialog(Y,this.oManagementTable);}.bind(this));var e=new B(this.getId()+"-mgmHeaderSearch",{contentMiddle:[this._oSearchFieldOnMgmtDialog]});this.oManagementDialog.setSubHeader(e);if(this.oVariantLayout.$().closest(".sapUiSizeCompact").length>0){this.oManagementDialog.addStyleClass("sapUiSizeCompact");}this.addDependent(this.oManagementDialog);this.oManagementTable.bindAggregation("items",{path:"variants",model:this._sModelName,factory:this._templateFactoryManagementDialog.bind(this),filters:this._getVisibleFilter()});this._bDeleteOccured=false;}};
X.prototype._setFavoriteIcon=function(e,Y){if(e){e.setSrc(Y?"sap-icon://favorite":"sap-icon://unfavorite");e.setTooltip(this._oRb.getText(Y?"VARIANT_MANAGEMENT_FAV_DEL_TOOLTIP":"VARIANT_MANAGEMENT_FAV_ADD_TOOLTIP"));e.setAlt(this._oRb.getText(Y?"VARIANT_MANAGEMENT_FAV_DEL_ACC":"VARIANT_MANAGEMENT_FAV_ADD_ACC"));}};
X.prototype._templateFactoryManagementDialog=function(e,Y){var Z=null;var $;var _;var a1;var b1;var c1;var d1=Y.getObject();if(!d1){return undefined;}var e1=function(o1){this._checkVariantNameConstraints(o1.oSource,o1.oSource.getBindingContext(this._sModelName).getObject().key);}.bind(this);var f1=function(o1){this._handleManageTitleChanged(o1.oSource.getBindingContext(this._sModelName).getObject());}.bind(this);var g1=function(o1){this._handleManageDefaultVariantChange(o1.oSource,o1.oSource.getBindingContext(this._sModelName).getObject(),o1.getParameters().selected);}.bind(this);var h1=function(o1){this._handleManageExecuteOnSelectionChanged(o1.oSource.getBindingContext(this._sModelName).getObject());}.bind(this);var i1=function(o1){this._handleManageDeletePressed(o1.oSource.getBindingContext(this._sModelName).getObject());var p1=o1.oSource.getParent();if(p1){p1.setVisible(false);}this._reCheckVariantNameConstraints();}.bind(this);var j1=function(o1){this._handleManageFavoriteChanged(o1.oSource,o1.oSource.getBindingContext(this._sModelName).getObject());}.bind(this);var k1=function(o1){var d1=o1.oSource.getBindingContext(this._sModelName).getObject();this._openRolesDialog(d1,o1.oSource.getParent().getItems()[0]);}.bind(this);if(d1.rename){a1=new o({liveChange:e1,change:f1,value:'{'+this._sModelName+">title}"});}else{a1=new O({title:'{'+this._sModelName+">title}"});if(Z){a1.setTooltip(Z);}}$=new k({icon:"sap-icon://decline",enabled:true,type:E.Transparent,press:i1,tooltip:this._oRb.getText("VARIANT_MANAGEMENT_DELETE"),visible:d1.remove});this._assignColumnInfoForDeleteButton($);_=this.oContext.getPath();var l1=new c({src:{path:"favorite",model:this._sModelName,formatter:function(o1){return o1?"sap-icon://favorite":"sap-icon://unfavorite";}},tooltip:{path:'favorite',model:this._sModelName,formatter:function(o1){return this._oRb.getText(o1?"VARIANT_MANAGEMENT_FAV_DEL_TOOLTIP":"VARIANT_MANAGEMENT_FAV_ADD_TOOLTIP");}.bind(this)},press:j1});if((this.getStandardVariantKey()===d1.key)||(this.getDefaultVariantKey()===d1.key)){l1.addStyleClass("sapUiFlVarMngmtFavNonInteractiveColor");}else{l1.addStyleClass("sapUiFlVarMngmtFavColor");}if(this.getDisplayTextForExecuteOnSelectionForStandardVariant()&&(this.getStandardVariantKey()===d1.key)){b1=new m({wrapping:true,text:this.getDisplayTextForExecuteOnSelectionForStandardVariant(),select:h1,selected:'{'+this._sModelName+">executeOnSelect}"});}else{b1=new m({text:"",select:h1,selected:'{'+this._sModelName+">executeOnSelect}"});}if(this._sStyleClass&&(d1.key!==this.getStandardVariantKey())){var m1=new T({wrapping:false});this._determineRolesSpecificText(d1.contexts,m1);var n1=new c({src:"sap-icon://edit",press:k1});n1.addStyleClass("sapUiFlVarMngmtRolesEdit");n1.setTooltip(this._oRb.getText("VARIANT_MANAGEMENT_VISIBILITY_ICON_TT"));c1=new v({items:[m1,n1]});}else{c1=new T();}return new d({cells:[l1,a1,new T({text:{path:"sharing",model:this._sModelName,formatter:function(o1){return this._oRb.getText(o1==="private"?"VARIANT_MANAGEMENT_PRIVATE":"VARIANT_MANAGEMENT_PUBLIC");}.bind(this)},textAlign:"Center"}),new R({groupName:this.getId(),select:g1,selected:{path:_+"/defaultVariant",model:this._sModelName,formatter:function(o1){return d1.key===o1;}}}),b1,c1,new T({text:'{'+this._sModelName+">author}",textAlign:"Begin"}),$,new T({text:'{'+this._sModelName+">key}"})]});};
X.prototype._openManagementDialog=function(){this._createManagementDialog();if(this.oVariantPopOver){this.oVariantPopOver.close();}this._suspendManagementTableBinding();this._clearDeletedItems();this._oSearchFieldOnMgmtDialog.setValue("");if(this._bDeleteOccured){this._bDeleteOccured=false;this.oManagementTable.bindAggregation("items",{path:"variants",model:this._sModelName,factory:this._templateFactoryManagementDialog.bind(this),filters:this._getVisibleFilter()});}this.oManagementDialog.open();};
X.prototype._assignColumnInfoForDeleteButton=function(e){if(!this._oInvisibleDeleteColumnName){this._oInvisibleDeleteColumnName=new I({text:this._oRb.getText("VARIANT_MANAGEMENT_ACTION_COLUMN")});this.oManagementDialog.addContent(this._oInvisibleDeleteColumnName);}if(this._oInvisibleDeleteColumnName){e.addAriaLabelledBy(this._oInvisibleDeleteColumnName);}};
X.prototype._toggleIconActivityState=function(e,Y,Z){if(!e){return;}if(Y.key===this.getStandardVariantKey()){return;}if(Z&&e.hasStyleClass("sapUiFlVarMngmtFavColor")){e.removeStyleClass("sapUiFlVarMngmtFavColor");e.addStyleClass("sapUiFlVarMngmtFavNonInteractiveColor");}else if(e.hasStyleClass("sapUiFlVarMngmtFavNonInteractiveColor")){e.removeStyleClass("sapUiFlVarMngmtFavNonInteractiveColor");e.addStyleClass("sapUiFlVarMngmtFavColor");}};
X.prototype._handleManageDefaultVariantChange=function(e,Y,Z){var $=Y.key;if(e){var _=e.getParent().getCells()[X.COLUMN_FAV_IDX];if(Z){if(this.getShowFavorites()&&!Y.favorite){Y.favorite=true;this._setFavoriteIcon(_,true);}this.setDefaultVariantKey($);}this._toggleIconActivityState(_,Y,Z);}};
X.prototype._handleManageCancelPressed=function(){var e;var Y;this._getDeletedItems().forEach(function(Z){Z.visible=true;});this._getItems().forEach(function(Z){Z.title=Z.originalTitle;Z.favorite=Z.originalFavorite;Z.executeOnSelection=Z.originalExecuteOnSelection;Z.contexts=Z.originalContexts;});e=this.getOriginalDefaultVariantKey();if(e!==this.getDefaultVariantKey()){this.setDefaultVariantKey(e);}Y=this.getModel(this._sModelName);if(Y){Y.checkUpdate();}};
X.prototype._handleManageFavoriteChanged=function(e,Y){if(this.getStandardVariantKey()===Y.key){return;}if((this.getDefaultVariantKey()===Y.key)&&Y.favorite){return;}Y.favorite=!Y.favorite;this._setFavoriteIcon(e,Y.favorite);};
X.prototype._getRowForKey=function(e){var Y=null;if(this.oManagementTable){this.oManagementTable.getItems().some(function(Z){if(e===Z.getCells()[0].getBindingContext(this._sModelName).getObject().key){Y=Z;}return Y!==null;}.bind(this));}return Y;};
X.prototype._handleManageDeletePressed=function(e){var Y;var Z=e.key;if(this.getStandardVariantKey()===Z){return;}e.visible=false;this._addDeletedItem(e);if((Z===this.getDefaultVariantKey())){this.setDefaultVariantKey(this.getStandardVariantKey());if(this.getShowFavorites()){var $=this._getItemByKey(this.getStandardVariantKey());if($&&!$.favorite){var _=this._getRowForKey(this.getStandardVariantKey());if(_){$.favorite=true;this._setFavoriteIcon(_.getCells()[X.COLUMN_FAV_IDX],true);}}}}Y=this.getModel(this._sModelName);if(Y){Y.checkUpdate();}this.oManagementCancel.focus();};
X.prototype._handleManageExecuteOnSelectionChanged=function(){};
X.prototype._handleManageTitleChanged=function(){};
X.prototype._handleManageSavePressed=function(){if(this._anyInErrorState(this.oManagementTable)){return;}this._getDeletedItems().some(function(e){if(e.key===this.getCurrentVariantKey()){var Y=this.getStandardVariantKey();this.setModified(false);this.setCurrentVariantKey(Y);this.fireEvent("select",{key:Y});return true;}return false;}.bind(this));this.fireManage();this._resumeManagementTableBinding();this.oManagementDialog.close();};
X.prototype._resumeManagementTableBinding=function(){if(this.oManagementTable){var e=this.oManagementTable.getBinding("items");if(e){e.resume();}}};
X.prototype._suspendManagementTableBinding=function(){if(this.oManagementTable){var e=this.oManagementTable.getBinding("items");if(e){e.suspend();}}};
X.prototype._anyInErrorState=function(e){var Y;var Z;var $=false;if(e){Y=e.getItems();Y.some(function(_){Z=_.getCells()[X.COLUMN_NAME_IDX];if(Z&&Z.getValueState&&(Z.getValueState()===U.Error)){$=true;}return $;});}return $;};
X.prototype._getFilters=function(e){var Y=[];if(e){Y.push(e);}Y.push(this._getVisibleFilter());if(this.getShowFavorites()){Y.push(this._getFilterFavorites());}return Y;};
X.prototype._getVisibleFilter=function(){return new F({path:"visible",operator:a.EQ,value1:true});};
X.prototype._getFilterFavorites=function(){return new F({path:"favorite",operator:a.EQ,value1:true});};
X.prototype._verifyVariantNameConstraints=function(e,Y){if(!e){return;}var Z=e.getValue();Z=Z.trim();if(!this._checkIsDuplicate(Z,Y)){if(Z===""){e.setValueState(U.Error);e.setValueStateText(this._oRb.getText("VARIANT_MANAGEMENT_ERROR_EMPTY"));}else if(Z.indexOf('{')>-1){e.setValueState(U.Error);e.setValueStateText(this._oRb.getText("VARIANT_MANAGEMENT_NOT_ALLOWED_CHAR",["{"]));}else if(Z.length>X.MAX_NAME_LEN){e.setValueState(U.Error);e.setValueStateText(this._oRb.getText("VARIANT_MANAGEMENT_MAX_LEN",[X.MAX_NAME_LEN]));}else{e.setValueState(U.None);e.setValueStateText(null);}}else{e.setValueState(U.Error);e.setValueStateText(this._oRb.getText("VARIANT_MANAGEMENT_ERROR_DUPLICATE"));}};
X.prototype._checkVariantNameConstraints=function(e,Y){this._verifyVariantNameConstraints(e,Y);if(this.oManagementDialog&&this.oManagementDialog.isOpen()){this._reCheckVariantNameConstraints();}};
X.prototype._reCheckVariantNameConstraints=function(){var e;var Y=false;if(this.oManagementTable){e=this.oManagementTable.getItems();e.some(function(Z){var $=Z.getBindingContext(this._sModelName).getObject();if($&&$.visible){var _=Z.getCells()[X.COLUMN_NAME_IDX];if(_&&_.getValueState&&(_.getValueState()===U.Error)){this._verifyVariantNameConstraints(_,$.key);if(_.getValueState()===U.Error){Y=true;}}}return Y;}.bind(this));}return Y;};
X.prototype._checkIsDuplicate=function(e,Y){if(this.oManagementDialog&&this.oManagementDialog.isOpen()){return this._checkIsDuplicateInManageTable(e,Y);}return this._checkIsDuplicateInModel(e,Y);};
X.prototype._checkIsDuplicateInModel=function(e,Y){var Z=false;var $=this._getItems();var _=e.toLowerCase();$.some(function(a1){if(a1.title.toLowerCase()===_){if(Y&&(Y===a1.key)){return false;}Z=true;}return Z;});return Z;};
X.prototype._checkIsDuplicateInManageTable=function(e,Y){var Z;var $=false;var _=e.toLowerCase();if(this.oManagementTable){Z=this.oManagementTable.getItems();Z.some(function(a1){var b1;var c1=a1.getBindingContext(this._sModelName).getObject();if(c1&&c1.visible){var d1=a1.getCells()[X.COLUMN_NAME_IDX];if(d1&&(c1.key!==Y)){if(d1.isA("sap.m.Input")){b1=d1.getValue().toLowerCase();}else{b1=d1.getTitle().toLowerCase();}if(b1===_){$=true;}}}return $;}.bind(this));}return $;};
X.prototype.exit=function(){var e;if(this.oVariantInvisibleText){this.oVariantInvisibleText.destroy(true);this.oVariantInvisibleText=undefined;}if(this.oDefault&&!this.oDefault._bIsBeingDestroyed){this.oDefault.destroy();}this.oDefault=undefined;if(this.oPublic&&!this.oPublic._bIsBeingDestroyed){this.oPublic.destroy();}this.oPublic=undefined;if(this.oExecuteOnSelect&&!this.oExecuteOnSelect._bIsBeingDestroyed){this.oExecuteOnSelect.destroy();}this.oExecuteOnSelect=undefined;this._oRb=undefined;this.oContext=undefined;this._oVariantList=undefined;this.oVariantSelectionPage=undefined;this.oVariantLayout=undefined;this.oVariantText=undefined;this.oVariantModifiedText=undefined;this.oVariantPopoverTrigger=undefined;this._oSearchField=undefined;this._oSearchFieldOnMgmtDialog=undefined;e=this.getModel(X.INNER_MODEL_NAME);if(e){e.destroy();}this._oRolesComponentContainer=null;this._sStyleClass=null;this._fRegisteredApplyAutomaticallyOnStandardVariant=null;};
return X;});
sap.ui.predefine('sap/ui/fl/write/_internal/appVariant/AppVariantInlineChange',["sap/ui/thirdparty/jquery","sap/ui/base/ManagedObject","sap/ui/fl/descriptorRelated/internal/Utils","sap/base/Log"],function(q,M,U,L){"use strict";
var A=M.extend("sap.ui.fl.write._internal.appVariant.AppVariantInlineChange",{
metadata:{library:"sap.ui.fl"},
constructor:function(p){M.apply(this);if(!q.isPlainObject(p)){L.error("Constructor : sap.ui.fl.write._internal.appVariant.AppVariantInlineChange: mPropertyBag is not defined");}U.checkTexts(p.texts);this._oDefinition=p;return this;}
});
A.prototype._getChangeType=function(){return this._oDefinition.changeType;};
A.prototype.getMap=function(){return this._oDefinition;};
A.prototype.getContent=function(){return this._oDefinition.content;};
A.prototype.getTexts=function(){return this._oDefinition.texts;};
A.prototype.getHostingIdSuffix=function(){return this._sHostingIdSuffix;};
A.prototype.setHostingIdSuffix=function(h){this._sHostingIdSuffix=h;};
A.prototype.replaceHostingIdForTextKey=function(n,o,c,t){var C=JSON.stringify(c);if(t){Object.keys(t).forEach(function(T){var s;if(T.indexOf(o)===0){s=n+T.substring(o.length);this._oDefinition.texts[s]=this._oDefinition.texts[T];delete this._oDefinition.texts[T];C=C.split("{{"+T+"}}").join("{{"+s+"}}");}},this);this._oDefinition.content=JSON.parse(C);}};
A.prototype.setHostingIdForTextKey=function(h){if(this.getHostingIdSuffix()){var t=h+this.getHostingIdSuffix();if(this._oDefinition.texts){this._oDefinition.texts[t]=this._oDefinition.texts[""];delete this._oDefinition.texts[""];}}};
return A;});
sap.ui.predefine('sap/ui/fl/write/_internal/connectors/LrepConnector',["sap/base/util/merge","sap/ui/fl/write/connectors/BaseConnector","sap/ui/fl/initial/_internal/connectors/LrepConnector","sap/ui/fl/initial/_internal/connectors/Utils","sap/ui/fl/write/_internal/connectors/Utils","sap/ui/fl/write/_internal/transport/TransportSelection","sap/ui/fl/registry/Settings","sap/ui/fl/Layer","sap/ui/fl/LayerUtils","sap/ui/fl/Utils","sap/ui/fl/Change","sap/ui/core/Component","sap/ui/core/BusyIndicator","sap/base/Log","sap/m/MessageBox","sap/base/util/restricted/_pick"],function(m,B,I,a,W,T,S,L,b,U,C,c,d,e,M,_){"use strict";var R={FLEX_INFO:"/flex/info/",PUBLISH:"/actions/make_changes_transportable/",CHANGES:"/changes/",CONDENSE:"/actions/condense/",VARIANTS:"/variants/",SETTINGS:"/flex/settings",TOKEN:"/actions/getcsrftoken/",APPVARIANTS:"/appdescr_variants/",APPVARIANTS_OVERVIEW:"/app_variant_overview/",UI2PERSONALIZATION:"/ui2personalization/",CONTEXTS:"/flex/contexts/",VERSIONS:{GET:"/flex/versions/",ACTIVATE:"/flex/versions/activate/",DISCARD:"/flex/versions/draft/"}};var f=function(p){var s;if(p.isLegacyVariant){s=R.VARIANTS;}else if(p.isAppVariant){s=R.APPVARIANTS;}else if(p.isContextSharing){s=R.CONTEXTS;}else if(p.isCondensingEnabled){s=R.CONDENSE;}else{s=R.CHANGES;}var P=p.transport?{changelist:p.transport}:{};if(p.skipIam){P.skipIam=p.skipIam;}if(p.parentVersion){P.parentVersion=p.parentVersion;}a.addLanguageInfo(P);I._addClientInfo(P);if(p.flexObject&&!p.isAppVariant){p.fileName=p.flexObject.fileName;}var w=a.getUrl(s,p,P);delete p.reference;delete p.fileName;var t=a.getUrl(R.TOKEN,p);var o=W.getRequestOptions(I,t,p.flexObjects||p.flexObject,"application/json; charset=utf-8","json");return W.sendRequest(w,p.method,o);};var g=function(A){var p=A.getDefinition().layer===L.VENDOR?A.getPackage():"";return new C({fileName:A.getDefinition().fileName,fileType:A.getDefinition().fileType,packageName:p,namespace:A.getNamespace()});};var h=function(p){var t;if(p.transport){t=Promise.resolve({transport:p.transport});}else if(p.isForSmartBusiness){return Promise.resolve();}else{var o=g(p.appVariant);t=new T().openTransportSelection(o);}return t.then(function(i){if(i==="cancel"){return Promise.reject("cancel");}if(i&&i.transport!==undefined){return i.transport;}return Promise.reject(new Error("Transport information could not be determined"));});};
function r(v){v.version=v.versionId;delete v.versionId;return v;}
return m({},B,{initialConnector:I,layers:I.layers,reset:function(p){d.show(0);var i=[];var t=Promise.resolve();if(p.layer!==L.USER){i=p.changes;t=S.getInstance().then(function(s){if(!s.isProductiveSystem()){return new T().setTransports(i,c.get(p.reference)).then(function(){i.some(function(o){if(o.getRequest()){p.changelist=o.getRequest();return true;}return false;});});}});}return t.then(function(){d.show(0);var P=["reference","layer","changelist","generator"];var j=_(p,P);I._addClientInfo(j);if(p.selectorIds){j.selector=p.selectorIds;}if(p.changeTypes){j.changeType=p.changeTypes;}delete p.reference;var s=a.getUrl(R.CHANGES,p,j);var k=a.getUrl(R.TOKEN,p);var o=W.getRequestOptions(I,k);return W.sendRequest(s,"DELETE",o).then(function(l){if(l&&l.response){l.response.forEach(function(n){n.fileName=n.name;delete n.name;});}d.hide();return l;}).catch(function(E){d.hide();return Promise.reject(E);});});},publish:function(p){var o=sap.ui.getCore().getLibraryResourceBundle("sap.ui.fl");var H=function(E){d.hide();var s=o.getText("MSG_TRANSPORT_ERROR",E?[E.message||E]:undefined);var i=o.getText("HEADER_TRANSPORT_ERROR");e.error("transport error"+E);M.show(s,{icon:M.Icon.ERROR,title:i,styleClass:p.transportDialogSettings.styleClass});return"Error";};var t=new T();return t.openTransportSelection(null,p.transportDialogSettings.rootControl,p.transportDialogSettings.styleClass).then(function(i){if(t.checkTransportInfo(i)){d.show(0);var j={reference:p.reference,layer:p.layer};return t._prepareChangesForTransport(i,p.localChanges,p.appVariantDescriptors,j).then(function(){d.hide();if(i.transport==="ATO_NOTIFICATION"){return o.getText("MSG_ATO_NOTIFICATION");}return o.getText("MSG_TRANSPORT_SUCCESS");});}return"Cancel";})['catch'](H);},getFlexInfo:function(p){var P=["layer"];var i=_(p,P);I._addClientInfo(i);var D=a.getUrl(R.FLEX_INFO,p,i);return a.sendRequest(D).then(function(o){return o.response;});},getContexts:function(p){var P=["type","$skip","$filter"];var i=_(p,P);I._addClientInfo(i);var s=a.getUrl(R.CONTEXTS,p,i);return a.sendRequest(s).then(function(o){return o.response;});},loadContextDescriptions:function(p){p.method="POST";p.isContextSharing=true;return f(p).then(function(o){return o.response;});},isContextSharingEnabled:function(){return Promise.resolve(true);},loadFeatures:function(p){if(I.settings){I.settings.isVersioningEnabled=false;return Promise.resolve(I.settings);}var P={};I._addClientInfo(P);var F=a.getUrl(R.SETTINGS,p,P);return a.sendRequest(F).then(function(o){o.response.isVersioningEnabled=false;o.response.isVariantAdaptationEnabled=!!o.response.isPublicLayerAvailable;return o.response;});},write:function(p){p.method="POST";return f(p);},condense:function(p){p.method="POST";p.isCondensingEnabled=true;return f(p);},update:function(p){if(p.flexObject.fileType==="variant"){p.isLegacyVariant=true;}p.method="PUT";return f(p);},remove:function(p){var P={namespace:p.flexObject.namespace,layer:p.flexObject.layer};if(p.transport){P.changelist=p.transport;}I._addClientInfo(P);p.fileName=p.flexObject.fileName;var s=p.flexObject.fileType==="variant"?R.VARIANTS:R.CHANGES;var D=a.getUrl(s,p,P);D=decodeURIComponent(D);delete p.fileName;var t=a.getUrl(R.TOKEN,p);var o=W.getRequestOptions(I,t,undefined,"application/json; charset=utf-8","json");return W.sendRequest(D,"DELETE",o);},appVariant:{getManifest:function(p){var A=p.appVarUrl;var o=W.getRequestOptions(I,U.getLrepUrl()+R.TOKEN,undefined,"application/json; charset=utf-8","json");return W.sendRequest(A,"GET",o);},load:function(p){var A=a.getUrl(R.APPVARIANTS,p);var o=W.getRequestOptions(I,U.getLrepUrl()+R.TOKEN,undefined,"application/json; charset=utf-8","json");return W.sendRequest(A,"GET",o);},create:function(p){p.method="POST";p.isAppVariant=true;return f(p);},assignCatalogs:function(p){var P={};P.action=p.action;delete p.action;P.assignFromAppId=p.assignFromAppId;delete p.assignFromAppId;var s=a.getUrl(R.APPVARIANTS,p,P);delete p.reference;var t=a.getUrl(R.TOKEN,p);var o=W.getRequestOptions(I,t,undefined,"application/json; charset=utf-8","json");return W.sendRequest(s,"POST",o);},unassignCatalogs:function(p){var P={};P.action=p.action;delete p.action;var s=a.getUrl(R.APPVARIANTS,p,P);delete p.reference;var t=a.getUrl(R.TOKEN,p);var o=W.getRequestOptions(I,t,undefined,"application/json; charset=utf-8","json");return W.sendRequest(s,"POST",o);},update:function(p){return h(p).then(function(t){if(t){p.transport=t;}delete p.isForSmartBusiness;p.method="PUT";p.isAppVariant=true;return f(p);});},remove:function(p){return h(p).then(function(t){var P={};if(t){P.changelist=t;}delete p.isForSmartBusiness;var D=a.getUrl(R.APPVARIANTS,p,P);delete p.reference;var s=a.getUrl(R.TOKEN,p);var o=W.getRequestOptions(I,s,undefined,"application/json; charset=utf-8","json");return W.sendRequest(D,"DELETE",o);});},list:function(p){var P={};P.layer=p.layer;P["sap.app/id"]=p.reference;delete p.layer;delete p.reference;var A=a.getUrl(R.APPVARIANTS_OVERVIEW,p,P);var o=W.getRequestOptions(I,undefined,undefined,"application/json; charset=utf-8","json");return W.sendRequest(A,"GET",o);}},ui2Personalization:{create:function(p){p.initialConnector=this.initialConnector;var P=U.getLrepUrl();var o=W.getRequestOptions(I,P+R.TOKEN,p.flexObjects||p.flexObject,"application/json; charset=utf-8","json");var u=P+R.UI2PERSONALIZATION;return W.sendRequest(u,"PUT",o);},remove:function(p){p.initialConnector=this.initialConnector;var u=a.getUrl(R.UI2PERSONALIZATION,{url:U.getLrepUrl()},{reference:p.reference,containerkey:p.containerKey,itemname:p.itemName});return W.sendRequest(u,"DELETE");}},versions:{load:function(p){var o=W.getRequestOptions(I,R.TOKEN);var P={};a.addLanguageInfo(P);P.limit=p.limit;var v=a.getUrl(R.VERSIONS.GET,p,P);return W.sendRequest(v,"GET",o).then(function(i){return i.response.versions.map(function(V){return r(V);});});},activate:function(p){var o=W.getRequestOptions(I,R.TOKEN,{title:p.title},"application/json; charset=utf-8","json");var P={version:p.version};a.addLanguageInfo(P);var v=a.getUrl(R.VERSIONS.ACTIVATE,p,P);return W.sendRequest(v,"POST",o).then(function(i){var V=i.response;return r(V);});},discardDraft:function(p){var o=W.getRequestOptions(I,R.TOKEN);var v=a.getUrl(R.VERSIONS.DISCARD,p);return W.sendRequest(v,"DELETE",o);}}});});
sap.ui.predefine('sap/ui/fl/write/_internal/connectors/Utils',["sap/ui/fl/initial/_internal/connectors/Utils"],function(U){"use strict";
function u(p){return U.sendRequest(p.tokenUrl,"HEAD").then(function(r){if(r&&r.xsrfToken){if(p.initialConnector){p.initialConnector.xsrfToken=r.xsrfToken;}p.xsrfToken=r.xsrfToken;return p;}});}
function a(p,s,m){return u(p).then(U.sendRequest.bind(undefined,s,m));}
function b(s,t,k){if(!t[k]){t[k]=s[k];return;}if(Array.isArray(t[k])){t[k]=t[k].concat(s[k]);return;}if(typeof t[k]==='object'){Object.keys(s[k]).forEach(function(i){b(s[k],t[k],i);});}t[k]=s[k];}
return{getRequestOptions:function(i,t,f,c,d){var o={xsrfToken:i.xsrfToken,tokenUrl:t,initialConnector:i};if(f){o.payload=JSON.stringify(f);}if(c){o.contentType=c;}if(d){o.dataType=d;}return o;},sendRequest:function(s,m,p){if(!p.initialConnector||(!p.initialConnector.xsrfToken&&!(m==='GET')&&!(m==='HEAD'))){return a(p,s,m);}return U.sendRequest(s,m,p).then(function(r){return r;}).catch(function(f){if(f.status===403){return a(p,s,m);}throw f;});},mergeResults:function(r){var R={};r.forEach(function(o){Object.keys(o).forEach(function(k){b(o,R,k);});});return R;}};});
sap.ui.predefine('sap/ui/fl/write/api/ChangesWriteAPI',["sap/ui/fl/apply/_internal/changes/Applier","sap/ui/fl/apply/_internal/changes/Reverter","sap/ui/fl/apply/_internal/ChangesController","sap/ui/fl/apply/_internal/appVariant/DescriptorChangeTypes","sap/ui/fl/descriptorRelated/api/DescriptorChangeFactory","sap/ui/fl/initial/_internal/changeHandlers/ChangeHandlerStorage","sap/ui/fl/write/_internal/appVariant/AppVariantInlineChangeFactory","sap/base/Log","sap/ui/core/Component","sap/ui/core/Element","sap/ui/core/util/reflection/JsControlTreeModifier","sap/base/util/includes","sap/base/util/restricted/_omit"],function(A,R,C,D,a,b,c,L,d,E,J,i,_){"use strict";var e={create:function(p){var f;if(i(D.getChangeTypes(),p.changeSpecificData.changeType)){f=C.getDescriptorFlexControllerInstance(p.selector);var r=f.getComponentName();var l;if(p.changeSpecificData.layer){l=p.changeSpecificData.layer;delete p.changeSpecificData.layer;}var I={changeType:p.changeSpecificData.changeType,content:p.changeSpecificData.content};if(p.changeSpecificData.texts){I.texts=p.changeSpecificData.texts;}return c.createDescriptorInlineChange(I).then(function(o){return new a().createNew(r,o,l,p.selector);}).catch(function(o){L.error("the change could not be created.",o.message);throw o;});}if(p.selector.name&&p.selector.view){f=C.getFlexControllerInstance(p.selector.view);}else{f=C.getFlexControllerInstance(p.selector);}if(p.selector instanceof d){return f.createBaseChange(p.changeSpecificData,p.selector);}if(p.selector.name&&p.selector.view){return f.createChangeWithExtensionPointSelector(p.changeSpecificData,p.selector);}return f.createChangeWithControlSelector(p.changeSpecificData,p.selector);},apply:function(p){if(!(p.element instanceof E)){return Promise.reject("Please provide an Element");}var f=C.getFlexControllerInstance(p.element);p.appComponent=C.getAppComponentForSelector(p.element);if(!p.modifier){p.modifier=J;}return A.applyChangeOnControl(p.change,p.element,_(p,["element","change"])).then(function(r){var g=f.checkForOpenDependenciesForControl(p.change.getSelector(),p.appComponent);if(g){return e.revert({change:p.change,element:p.element}).then(function(){throw Error("The following Change cannot be applied because of a dependency: "+p.change.getId());});}return r;});},revert:function(p){var o;if(p.element instanceof E){o=C.getAppComponentForSelector(p.element);}var r={modifier:J,appComponent:o};return R.revertChangeOnControl(p.change,p.element,r);},getChangeHandler:function(p){var s=p.controlType||p.modifier.getControlType(p.element);return b.getChangeHandler(p.changeType,s,p.element,p.modifier,p.layer);}};return e;});
sap.ui.predefine('sap/ui/fl/write/connectors/BaseConnector',[],function(){"use strict";var B={layers:[],write:function(){return Promise.reject("write is not implemented");},condense:function(){return Promise.reject("condense is not implemented");},update:function(){return Promise.reject("write is not implemented");},remove:function(){return Promise.reject("remove is not implemented");},reset:function(){return Promise.reject("reset is not implemented");},publish:function(){return Promise.reject("publish is not implemented");},getFlexInfo:function(){return Promise.resolve({});},getContexts:function(){return Promise.reject("getContexts is not implemented");},loadContextDescriptions:function(){return Promise.reject("loadContextDescriptions is not implemented");},isContextSharingEnabled:function(){return Promise.resolve(false);},loadFeatures:function(){return Promise.reject("loadFeatures is not implemented");},versions:{load:function(){return Promise.reject("versions.load is not implemented");},activate:function(){return Promise.reject("versions.activate is not implemented");},discardDraft:function(){return Promise.reject("versions.discardDraft is not implemented");}},translation:{getSourceLanguages:function(){return Promise.reject("translation.getSourceLanguages is not implemented");},getTexts:function(){return Promise.reject("translation.getTexts is not implemented");}}};return B;});
/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/ApplyUtil',["sap/ui/thirdparty/URI"],function(U){"use strict";var A={formatBundleName:function(i,b){if(b.startsWith("/")){throw Error("Absolute paths are not supported");}var n=new U(i+"/"+b).normalize().path();return n.replace(/\//g,".").replace("..",".").replace(/.properties$/g,"");}};return A;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/Registration',["sap/ui/fl/requireAsync"],function(r){"use strict";var R={appdescr_ui5_addLibraries:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/ui5/AddLibrary"),appdescr_app_setTitle:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/app/SetTitle"),appdescr_ovp_changeCard:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/ovp/ChangeCard"),appdescr_ovp_addNewCard:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/ovp/AddNewCard"),appdescr_ovp_removeCard:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/ovp/DeleteCard"),appdescr_ui_generic_app_addNewObjectPage:r.bind(this,"sap/suite/ui/generic/template/manifestMerger/AddNewObjectPage"),appdescr_ui_generic_app_changePageConfiguration:r.bind(this,"sap/suite/ui/generic/template/manifestMerger/ChangePageConfiguration"),appdescr_fe_changePageConfiguration:r.bind(this,"sap/fe/core/manifestMerger/ChangePageConfiguration")};return R;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/RegistrationBuild',["sap/ui/fl/requireAsync","sap/ui/fl/apply/_internal/changes/descriptor/Registration"],function(r,R){"use strict";var a={appdescr_app_changeDataSource:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/app/ChangeDataSource"),appdescr_ui5_addNewModelEnhanceWith:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/ui5/AddNewModelEnhanceWith"),appdescr_ui5_addComponentUsages:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/ui5/AddComponentUsages"),appdescr_ui5_setMinUI5Version:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/ui5/SetMinUI5Version"),appdescr_fiori_setRegistrationIds:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/fiori/SetRegistrationIds"),appdescr_ui5_setFlexExtensionPointEnabled:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/ui5/SetFlexExtensionPointEnabled"),appdescr_ui5_addNewModel:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/ui5/AddNewModel"),appdescr_app_addAnnotationsToOData:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/app/AddAnnotationsToOData"),appdescr_app_changeInbound:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/app/ChangeInbound"),appdescr_fiori_setAbstract:r.bind(this,"sap/ui/fl/apply/_internal/changes/descriptor/fiori/SetAbstract")};var b=Object.assign({},R);return Object.assign(b,a);});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/app/AddAnnotationsToOData',["sap/ui/fl/util/DescriptorChangeCheck"],function(D){"use strict";var S=["BEGINNING","END"];
function i(M,s){return Object.keys(M).indexOf(s)>=0;}
function a(M,s){return!M[s].type||M[s].type==="OData";}
function b(M,C,s){return((M[s]&&M[s].type==="ODataAnnotation")||C[s]);}
function c(C,s){return C[s].type&&C[s].type==="ODataAnnotation";}
function d(C,s){return C.indexOf(s)>=0;}
function e(M,C){if(C){if(Object.keys(M).length>0){if(!i(M,C)){throw new Error("There is no dataSource '"+C+"' existing in the manifest. You can only add annotations to already existing dataSources in the manifest");}if(!a(M,C)){throw new Error("The dataSource '"+C+"' is existing in the manifest but is not type of 'OData'. The type of the dataSource in the manifest is '"+M[C].type+"'");}}else{throw new Error("There are no dataSources in the manifest at all");}}else{throw new Error("Invalid change format: The mandatory 'dataSourceId' is not defined. Please define the mandatory property 'dataSourceId' and refer it to an existing OData");}}
function f(C){if(C){if(C.length===0){throw new Error("Invalid change format: The 'annotations' array property is empty");}}else{throw new Error("Invalid change format: The mandatory 'annotations' array property is not defined. Please define the 'annotations' array property");}}
function g(C){if(!(S.indexOf(C)>=0)&&!(C===undefined)){throw new Error("The defined insert position '"+C+"' is not supported. The supported insert positions are: "+S.join("|"));}}
function h(C,l,o){if(C){if(Object.keys(C).length===0){throw new Error("The 'dataSource' object is empty");}Object.keys(C).forEach(function(s){D.checkIdNamespaceCompliance(s,o);if(!c(C,s)){throw new Error("The dataSource annotation '"+s+"' is type of '"+C[s].type+"'. Only dataSource annotations of type 'ODataAnnotation' is supported");}if(!d(l,s)){throw new Error("The annotation '"+s+"' is not part of 'annotations' array property. Please add the annotation '"+s+"' in the 'annotations' array property");}});}else{throw new Error("Invalid change format: The mandatory 'dataSource' object is not defined. Please define the mandatory 'dataSource' object");}}
function m(M,C,l,s,o){j(M[C],l,s);k(M,o);}
function j(M,C,s){if(!M["settings"]){M["settings"]={};}if(!M["settings"].annotations){M["settings"].annotations=[];}var n=M["settings"].annotations.filter(function(l){return(C.indexOf(l)<0);});M["settings"].annotations=n;if(s==="END"){M["settings"].annotations=M["settings"].annotations.concat(C);}else{M["settings"].annotations=C.concat(M["settings"].annotations);}}
function k(M,C){Object.assign(M,C);}
function p(M,C,l){l.forEach(function(s){if(!b(M,C,s)){throw new Error("The annotation '"+s+"' is part of 'annotations' array property but does not exists in the change property 'dataSource' and in the manifest (or it is not type of 'ODataAnnotation' in the manifest)");}});}
var A={applyChange:function(M,C){var s=C.getContent().dataSourceId;var l=C.getContent().annotations;var n=C.getContent().annotationsInsertPosition;var o=C.getContent().dataSource;e(M["sap.app"].dataSources,s);f(l);g(n);h(o,l,C);p(M["sap.app"]["dataSources"],o,l);m(M["sap.app"]["dataSources"],s,l,n,o);return M;}};return A;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/app/ChangeDataSource',["sap/ui/fl/util/changePropertyValueByPath","sap/ui/fl/util/DescriptorChangeCheck"],function(c,D){"use strict";var S=["UPDATE","UPSERT"];var a=["uri","settings/maxAge"];var C={applyChange:function(m,o){var d=m["sap.app"].dataSources;var b=o.getContent();D.checkEntityPropertyChange(b,a,S);if(d){var e=d[b.dataSourceId];if(e){c(b.entityPropertyChange,e);}else{throw new Error("Nothing to update. DataSource with ID \""+b.dataSourceId+"\" does not exist.");}}else{throw Error("No sap.app/dataSource found in manifest.json");}return m;}};return C;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/app/ChangeInbound',["sap/ui/fl/util/changePropertyValueByPath","sap/ui/fl/util/DescriptorChangeCheck"],function(c,D){"use strict";var S=["UPDATE","UPSERT"];var a=["title","subTitle","icon"];var C={applyChange:function(m,o){var b=m["sap.app"].crossNavigation;var d=o.getContent();D.checkEntityPropertyChange(d,a,S);if(b&&b.inbounds){var i=b.inbounds[d.inboundId];if(i){c(d.entityPropertyChange,i);}else{throw new Error("Nothing to update. Inbound with ID \""+d.inboundId+"\" does not exist.");}}else{throw new Error("sap.app/crossNavigation or sap.app/crossNavigation/inbounds sections have not been found in manifest.json");}return m;}};return C;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/app/SetTitle',[],function(){"use strict";var S={applyChange:function(m){m["sap.app"].title="{{"+m["sap.app"].id+"_sap.app.title}}";return m;}};return S;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/fiori/SetAbstract',["sap/base/util/ObjectPath"],function(O){"use strict";var S={applyChange:function(m,c){if(!c.getContent().hasOwnProperty("abstract")){throw new Error("No abstract in change content provided");}if(c.getContent().abstract!==false){throw new Error("The current change value of property abstract is '"+c.getContent().abstract+"'. Only allowed value for property abstract is boolean 'false'");}O.set(["sap.fiori","abstract"],c.getContent().abstract,m);return m;}};return S;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/fiori/SetRegistrationIds',["sap/base/util/ObjectPath"],function(O){"use strict";var S={applyChange:function(m,c){O.set(["sap.fiori","registrationIds"],c.getContent().registrationIds,m);return m;}};return S;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/ovp/AddNewCard',[],function(){"use strict";var A={applyChange:function(m,c){var n=c.getContent();var o=m["sap.ovp"].cards;if("card"in n&&Object.keys(n.card).length>0&&!(Object.keys(n.card)in o)){Object.assign(o,n.card);}else{throw Error("No new card found");}return m;}};return A;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/ovp/ChangeCard',["sap/base/util/ObjectPath"],function(O){"use strict";var C={applyChange:function(m,c){var o=c.getContent();var i=o.entityPropertyChange.operation==="UPSERT";var a=m["sap.ovp"].cards;var p=o.entityPropertyChange;if(Array.isArray(p)){throw Error("Expected value for oPropertyChange was an object");}if(!i){throw Error("This Operation is not supported");}if(o.cardId in a&&"propertyPath"in p){O.set([o.cardId,p.propertyPath],p.propertyValue,a);}else{throw Error("Change card settings was not found");}return m;}};return C;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/ovp/DeleteCard',[],function(){"use strict";var D={applyChange:function(m,c){var d=c.getContent();var o=m["sap.ovp"].cards;if(d.cardId in o){delete o[d.cardId];}else{throw Error("The card to be deleted was not found");}return m;}};return D;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/ui5/AddComponentUsages',[],function(){"use strict";var A={applyChange:function(m,c){var C=c.getContent().componentUsages;if(!m["sap.ui5"]["componentUsages"]){m["sap.ui5"]["componentUsages"]={};}var M=m["sap.ui5"].componentUsages;Object.keys(C).forEach(function(s){if(M[s]){throw new Error("Component usage '"+s+"' already exists");}else{M[s]=C[s];}});return m;}};return A;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/ui5/AddLibrary',["sap/base/util/Version"],function(V){"use strict";
function _(m,c){var u={};if(c.minVersion){var M=new V(m.minVersion);u.minVersion=M.compareTo(c.minVersion)>=0?m.minVersion:c.minVersion;}if(c.lazy){u.lazy=m.lazy===c.lazy===true;}return u;}
var A={applyChange:function(m,c){if(!m["sap.ui5"]["dependencies"]["libs"]){m["sap.ui5"]["dependencies"]["libs"]={};}var M=m["sap.ui5"]["dependencies"]["libs"];var C=c.getContent().libraries;Object.keys(C).forEach(function(l){if(M[l]){M[l]=_(M[l],C[l]);}else{M[l]=C[l];}});return m;}};return A;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/ui5/AddNewModel',[],function(){"use strict";var S=["OData","INA","XML","JSON","FHIR","http","WebSocket"];var a=S.concat(["ODataAnnotation"]);
function i(C,D,s){return!C[D].type||s.indexOf(C[D]["type"])>=0;}
function b(C,o){return k(C).some(function(D){return(!D.type||D["type"]==="OData")&&D["settings"]["annotations"].indexOf(o)>=0;});}
function c(M,C,D){return d(C,D,S)||e(M,D);}
function d(D,s,l){return h(D,s)&&i(D,s,l);}
function e(D,s){if(h(D,s)){if(D[s].type&&D[s]["type"]==="ODataAnnotation"){throw new Error("The already existing dataSource '"+s+"' in the manifest is type of 'ODataAnnotation'. A model must not reference to a dataSource which is of type 'ODataAnnotation'");}return true;}return false;}
function h(t,s){return t&&Object.keys(t).indexOf(s)>=0;}
function m(M,C,E){if(C){Object.keys(C).forEach(function(n){if(M[n]){throw new Error("The "+E+" '"+n+"' already exists");}M[n]=C[n];});}}
function f(M,C,r,s,l){if(!M[r][s]){M[r][s]={};}m(M[r][s],C.getContent()[l],l);return M[r][s];}
function g(C,o,D){if(C[D].type==="ODataAnnotation"){return true;}return k(o).some(function(M){return M.dataSource&&M["dataSource"]===D;});}
function j(C,M){return C[M].type||C[M].dataSource;}
function k(o){return Object.keys(o).map(function(O){return o[O];});}
var A={applyChange:function(M,C){var o=C.getContent().model;var l=C.getContent().dataSource;if(o){if(Object.keys(o).length!==1){throw new Error("There are currently '"+Object.keys(o).length+"' models in the change. Currently it is only allowed to add '1' model");}Object.keys(o).forEach(function(s){if(!j(o,s)){throw new Error("There is no 'dataSource' or 'type' in the change model defined. Please define either 'type' or 'dataSource' in property '"+s+"'");}if(o[s].dataSource){if(!c(M["sap.app"]["dataSources"],l,o[s]["dataSource"])){throw new Error("The defined dataSource '"+o[s]["dataSource"]+"' in the model does not exists as dataSource or must be allowed type of "+S.join("|"));}}});}else{throw new Error("No model defined");}if(l){Object.keys(l).forEach(function(D){if(!i(l,D,a)){throw new Error("The dataSource '"+D+"' has the type '"+l[D]["type"]+"', but only dataSources with the follwing types are supported: "+a.join("|"));}if(!g(l,o,D)){throw new Error("The dataSource in the change '"+D+"' is not used by any model in the change. A dataSource in the change must be used by model in the change");}if(l[D]["type"]==="ODataAnnotation"){if(!b(l,D)){throw new Error("There is no dataSource with type 'OData' defined which includes the annotation '"+D+"'");}}});}f(M,C,"sap.ui5","models","model");f(M,C,"sap.app","dataSources","dataSource");return M;}};return A;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/ui5/AddNewModelEnhanceWith',["sap/ui/fl/apply/_internal/changes/descriptor/ApplyUtil","sap/base/util/ObjectPath"],function(A,O){"use strict";var a={applyChange:function(m,c){var M=c.getContent().modelId;var i=A.formatBundleName(m["sap.app"].id,c.getTexts().i18n);var o=m["sap.ui5"].models[M];if(o){if(o.type&&o.type==="sap.ui.model.resource.ResourceModel"){if(!(o.settings&&o.settings.enhanceWith)){O.set("settings.enhanceWith",[],o);}var e=o.settings.enhanceWith;e.push({bundleName:i});}}return m;},skipPostprocessing:true};return a;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/ui5/SetFlexExtensionPointEnabled',["sap/base/util/ObjectPath"],function(O){"use strict";var S={applyChange:function(m,c){if(!c.getContent().flexExtensionPointEnabled){throw new Error("No flexExtensionPointEnabled in change content provided");}O.set(["sap.ui5","flexExtensionPointEnabled"],c.getContent().flexExtensionPointEnabled,m);return m;}};return S;});
sap.ui.predefine('sap/ui/fl/apply/_internal/changes/descriptor/ui5/SetMinUI5Version',["sap/base/util/Version"],function(V){"use strict";var S={applyChange:function(m,c){var C=new V(m["sap.ui5"].dependencies.minUI5Version);if(C.compareTo(c.getContent().minUI5Version)<=0){m["sap.ui5"].dependencies.minUI5Version=c.getContent().minUI5Version;}return m;}};return S;});
sap.ui.predefine('sap/ui/fl/apply/_internal/extensionPoint/Processor',["sap/ui/fl/apply/_internal/changes/Applier","sap/ui/fl/apply/_internal/flexState/FlexState","sap/ui/fl/apply/_internal/flexState/changes/ExtensionPointState","sap/ui/fl/Utils","sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/base/SyncPromise","sap/base/util/merge"],function(A,F,E,U,J,S,m){"use strict";var P;
function e(C,r,i,n,N){return N(C,true).then(function(b){b.forEach(function(o,d){r.splice(i+d+n,0,o);});C.index+=n;return b.length-1;});}
function c(o,n,C){var N=[];var r=[];var i=0;var l;C.forEach(function(b,d){if(b._isExtensionPoint){b.targetControl=o.targetControl;b.aggregationName=o.aggregationName;b.fragmentId=o.fragmentId;b.index=d;if(l){l._nextSibling=b;}l=b;b.referencedExtensionPoint=o;N.push(function(){return e(b,r,d,i,n).then(function(f){i+=f;});});}else{r.push(b);}});if(N.length>0){return N.reduce(function(p,b){return p.then(b);},S.resolve()).then(function(){return r;});}return S.resolve(r);}
function a(o,s){var b=U.getAppComponentForControl(o.targetControl);var p={};var d=m({defaultContent:[]},o);p.appComponent=b;p.modifier=J;p.viewId=o.view.getId();p.componentId=b.getId();return P.registerExtensionPoint(d).then(F.initialize.bind(F,p)).then(E.enhanceExtensionPointChanges.bind(E,p,o)).then(P.createDefaultContent.bind(this,o,s,a)).then(P.addDefaultContentToExtensionPointInfo.bind(this,d,s));}
P={oExtensionPointRegistry:undefined,oRegistryPromise:Promise.resolve(),registerExtensionPoint:function(b){if(sap.ui.getCore().getConfiguration().getDesignMode()){if(P.oExtensionPointRegistry){P.oExtensionPointRegistry.registerExtensionPoint(b);return S.resolve();}P.oRegistryPromise=P.oRegistryPromise.then(function(){return new Promise(function(r,d){sap.ui.require(["sap/ui/fl/write/_internal/extensionPoint/Registry"],function(f){P.oExtensionPointRegistry=f;f.registerExtensionPoint(b);r();},function(o){d(o);});});});return P.oRegistryPromise;}return S.resolve();},createDefaultContent:function(o,s,n,C){if(C.length===0){return o.createDefault().then(c.bind(undefined,o,n)).then(function(b){if(!s){b.forEach(function(N,i){J.insertAggregation(o.targetControl,o.aggregationName,N,o.index+i,o.view);});o.ready(b);}return b;});}return S.resolve([]);},addDefaultContentToExtensionPointInfo:function(r,s,C){if(!s){r.defaultContent=r.defaultContent.concat(C);}return C;},applyExtensionPoint:function(o){var p=a(o,false);A.addPreConditionForInitialChangeApplying(p);return p;}};return P;});
sap.ui.predefine('sap/ui/fl/apply/_internal/flexObjects/CompVariantRevertData',["sap/ui/fl/apply/_internal/flexObjects/RevertData"],function(R){"use strict";return R.extend("sap.ui.fl.apply._internal.flexObjects.CompVariantRevertData",{metadata:{properties:{change:{type:"sap.ui.fl.Change"}}}});});
sap.ui.predefine('sap/ui/fl/apply/_internal/flexObjects/RevertData',["sap/ui/base/ManagedObject"],function(M){"use strict";return M.extend("sap.ui.fl.apply._internal.flexObjects.RevertData",{metadata:{properties:{type:{type:"string"},content:{type:"object"}}}});});
sap.ui.predefine('sap/ui/fl/descriptorRelated/api/DescriptorChangeFactory',["sap/ui/fl/ChangePersistenceFactory","sap/ui/fl/Change","sap/ui/fl/Utils","sap/base/util/merge"],function(C,a,F,b){"use strict";var D=function(m,i){this._mChangeFile=m;this._mChangeFile.packageName='';this._oInlineChange=i;};
D.prototype.submit=function(){this.store();var o=this._getChangePersistence(this._mChangeFile.reference);return o.saveDirtyChanges();};
D.prototype.store=function(){var s=this._mChangeFile.reference;var o=this._getChangePersistence(s);var d=this._getChangeToSubmit();o.addChange(d);return d;};
D.prototype._getChangePersistence=function(s){return C.getChangePersistenceForComponent(s);};
D.prototype._getChangeToSubmit=function(){var o=new a(this._getMap());return o;};
D.prototype._getMap=function(){var i=this._oInlineChange.getMap();this._mChangeFile.content=i.content;this._mChangeFile.texts=i.texts;return this._mChangeFile;};
D.prototype.getJson=function(){return b({},this._getMap());};
var c=function(){};
c.prototype.createNew=function(r,i,l,A,t){var s=function(_,I){if(_["setHostingIdForTextKey"]){_.setHostingIdForTextKey(I);}};s(i,r);var p={};p.changeType=i._getChangeType();p.componentName=r;p.reference=r;p.generator=t;p.support=i.getMap().support;p.layer=l||'CUSTOMER';var m=a.createInitialFileContent(p);return Promise.resolve(new D(m,i));};
return c;});
sap.ui.predefine('sap/ui/fl/descriptorRelated/internal/Utils',[],function(){"use strict";var U=function(){};
U.prototype.getNameAndNameSpace=function(i,r){return{fileName:"manifest",namespace:"apps/"+r+"/appVariants/"+i+"/"};};
U.prototype.checkEntityPropertyChange=function(p){this.checkParameterAndType(p,"entityPropertyChange","object");if(p.entityPropertyChange instanceof Array){for(var i=0;i<p.entityPropertyChange.length;i++){var c=p.entityPropertyChange[i];this.checkEntityPropertyChangeContent(c);}}else if(p.entityPropertyChange instanceof Object){this.checkEntityPropertyChangeContent(p.entityPropertyChange);}};
U.prototype.checkEntityPropertyChangeContent=function(c){this.checkParameterAndType(c,"propertyPath","string");this.checkParameterAndType(c,"operation","string");if(['INSERT','UPDATE','UPSERT','DELETE'].indexOf(c.operation)===-1){throw new Error("Parameter \"entityPropertyChange.operation\" needs to be one of 'INSERT', 'UPDATE', 'UPSERT', 'DELETE'");}if(c.propertyValue===undefined&&c.operation!=='DELETE'){throw new Error("No parameter \"entityPropertyChange.propertyValue\" provided");}};
U.prototype.checkParameterAndType=function(p,P,t){if(t==="array"){if(p===undefined||p[P]===undefined||!Array.isArray(p[P])){throw new Error("No parameter \""+P+"\" of type "+t+" provided");}}else if(p===undefined||p[P]===undefined||typeof p[P]!==t){throw new Error("No parameter \""+P+"\" of type "+t+" provided");}};
U.prototype.checkTexts=function(t){if(t!==undefined&&typeof t!=="object"){throw new Error("Wrong format for provided \"texts\" parameter");}};
U.prototype.checkTransportRequest=function(t){if(!/^[A-Z0-9]{1,20}$/.test(t)&&t!=='ATO_NOTIFICATION'){throw new Error("Wrong format for provided \"sTransportRequest\" parameter");}};
U.prototype.checkPackage=function(p){if(!/^[A-Z0-9/_]{1,30}$/.test(p)&&p!=="$TMP"){throw new Error("Wrong format for provided \"sPackage\" parameter");}};
return new U();},true);
sap.ui.predefine('sap/ui/fl/transport/TransportDialog',["sap/ui/fl/write/_internal/transport/TransportDialog"],function(I){"use strict";
var T=I.extend("sap.ui.fl.transport.TransportDialog",{
metadata:{library:"sap.ui.fl",deprecated:true},
renderer:{apiVersion:2}
});
return T;});
sap.ui.predefine('sap/ui/fl/transport/TransportSelection',["sap/ui/fl/write/_internal/transport/TransportSelection"],function(T){"use strict";return T;},true);
sap.ui.predefine('sap/ui/fl/util/DescriptorChangeCheck',["sap/base/util/includes","sap/ui/fl/Layer"],function(i,L){"use strict";
function c(e,s,S){if(Array.isArray(e)){e.forEach(function(d){f(d,s,S);});}else{f(e,s,S);}}
function f(C,s,S){if(!C.propertyPath){throw new Error("Invalid change format: The mandatory 'propertyPath' is not defined. Please define the mandatory property 'propertyPath'");}if(!C.operation){throw new Error("Invalid change format: The mandatory 'operation' is not defined. Please define the mandatory property 'operation'");}if(!C.propertyValue){throw new Error("Invalid change format: The mandatory 'propertyValue' is not defined. Please define the mandatory property 'propertyValue'");}if(!i(s,C.propertyPath)){throw new Error("Changing "+C.propertyPath+" is not supported. The supported 'propertyPath' is: "+s.join("|"));}if(!i(S,C.operation)){throw new Error("Operation "+C.operation+" is not supported. The supported 'operation' is "+S.join("|"));}}
function a(C,s,S){var d=Object.keys(C).filter(function(k){return k.endsWith("Id");}).shift();if(!C[d]){throw new Error("Mandatory \""+d+"\" parameter is not provided.");}if(!C.entityPropertyChange){throw new Error("Changes for \""+C[d]+"\" are not provided.");}c(C.entityPropertyChange,s,S);}
var l={};l[L.CUSTOMER]="customer.";l[L.CUSTOMER_BASE]="customer.";l[L.PARTNER]="partner.";l[L.VENDOR]=null;
function b(I,C){var s=C.getLayer();if(!s){throw new Error("Mandatory layer parameter is not provided.");}var p=g(s);if(p===null){Object.keys(l).forEach(function(k){if(l[k]&&I.startsWith(l[k])){throw new Error("Id "+I+" must not start with reserved "+l[k]);}});}else if(!I.startsWith(p)){throw new Error("Id "+I+" must start with "+p);}}
function g(s){var p=l[s];if(p===undefined){throw new Error("Layer "+s+" not supported.");}return p;}
return{checkEntityPropertyChange:a,checkIdNamespaceCompliance:b,getNamespacePrefixForLayer:g};});
sap.ui.predefine('sap/ui/fl/util/IFrame.flexibility',["sap/ui/fl/changeHandler/UpdateIFrame"],function(U){"use strict";return{updateIFrame:U,hideControl:"default",unhideControl:"default"};});
sap.ui.predefine('sap/ui/fl/util/changePropertyValueByPath',["sap/base/util/ObjectPath"],function(O){"use strict";
function s(e,r){var p=e.propertyPath.split("/");var v=O.get(p,r);if(v&&e.operation==="INSERT"){throw new Error("Path has already a value. 'INSERT' operation is not appropriate.");}if(!v&&e.operation==="UPDATE"){throw new Error("Path does not contain a value. 'UPDATE' operation is not appropriate.");}O.set(p,e.propertyValue,r);}
return function(c,r){if(Array.isArray(c)){c.forEach(function(e){s(e,r);});}else{s(c,r);}};});
sap.ui.predefine('sap/ui/fl/write/_internal/appVariant/AppVariantInlineChangeFactory',["sap/ui/fl/descriptorRelated/internal/Utils","sap/ui/fl/write/_internal/appVariant/AppVariantInlineChange"],function(U,A){"use strict";
function _(p){if(!p.texts){p.texts={"":p.content};p.content={};}}
function a(p){var o=new A(p);return Promise.resolve(o);}
var b={};
b.createNew=function(p){var o=new A(p);return Promise.resolve(o);};
b.createDescriptorInlineChange=function(p){var t=p.changeType.replace("appdescr","create");return this[t](p);};
b.create_ovp_addNewCard=function(p){U.checkParameterAndType(p.content,"card","object");return a(p);};
b.create_ovp_removeCard=function(p){U.checkParameterAndType(p.content,"cardId","string");return a(p);};
b.create_ovp_changeCard=function(p){U.checkParameterAndType(p.content,"cardId","string");U.checkEntityPropertyChange(p.content);return a(p);};
b.create_app_addNewInbound=function(p){U.checkParameterAndType(p.content,"inbound","object");return a(p);};
b.create_app_removeInbound=function(p){U.checkParameterAndType(p.content,"inboundId","string");return a(p);};
b.create_app_removeAllInboundsExceptOne=function(p){U.checkParameterAndType(p.content,"inboundId","string");return a(p);};
b.create_app_changeInbound=function(p){U.checkParameterAndType(p.content,"inboundId","string");U.checkEntityPropertyChange(p.content);return a(p);};
b.create_app_addNewOutbound=function(p){U.checkParameterAndType(p.content,"outbound","object");return a(p);};
b.create_app_removeOutbound=function(p){U.checkParameterAndType(p.content,"outboundId","string");return a(p);};
b.create_app_changeOutbound=function(p){U.checkParameterAndType(p.content,"outboundId","string");U.checkEntityPropertyChange(p.content);return a(p);};
b.create_app_addNewDataSource=function(p){U.checkParameterAndType(p.content,"dataSource","object");return a(p);};
b.create_app_removeDataSource=function(p){U.checkParameterAndType(p.content,"dataSourceId","string");return a(p);};
b.create_app_changeDataSource=function(p){U.checkParameterAndType(p.content,"dataSourceId","string");U.checkEntityPropertyChange(p.content);return a(p);};
var T={BEGINNING:"BEGINNING",END:"END"};
b.create_app_addAnnotationsToOData=function(p){U.checkParameterAndType(p.content,"dataSourceId","string");U.checkParameterAndType(p.content,"annotations","array");U.checkParameterAndType(p.content,"dataSource","object");return a(p);};
b.create_app_setTitle=function(p){_(p);return a(p).then(function(d){d.setHostingIdSuffix("_sap.app.title");return d;});};
b.create_app_setSubTitle=function(p){_(p);return a(p).then(function(d){d.setHostingIdSuffix("_sap.app.subTitle");return d;});};
b.create_app_setShortTitle=function(p){_(p);return a(p).then(function(d){d.setHostingIdSuffix("_sap.app.shortTitle");return d;});};
b.create_app_setDescription=function(p){_(p);return a(p).then(function(d){d.setHostingIdSuffix("_sap.app.description");return d;});};
b.create_app_setInfo=function(p){_(p);return a(p).then(function(d){d.setHostingIdSuffix("_sap.app.info");return d;});};
b.create_app_setAch=function(p){U.checkParameterAndType(p.content,"ach","string");return a(p);};
b.create_app_setDestination=function(p){U.checkParameterAndType(p.content,"destination","object");return a(p);};
b.create_app_setKeywords=function(p){U.checkParameterAndType(p.content,"keywords","array");return a(p);};
b.create_app_addTechnicalAttributes=function(p){U.checkParameterAndType(p.content,"technicalAttributes","array");return a(p);};
b.create_app_removeTechnicalAttributes=function(p){U.checkParameterAndType(p.content,"technicalAttributes","array");return a(p);};
b.create_app_addCdsViews=function(p){U.checkParameterAndType(p.content,"cdsViews","array");return a(p);};
b.create_app_removeCdsViews=function(p){U.checkParameterAndType(p.content,"cdsViews","array");return a(p);};
b.create_flp_setConfig=function(p){U.checkParameterAndType(p.content,"config","object");return a(p);};
b.create_ui5_addNewModel=function(p){U.checkParameterAndType(p.content,"model","object");return a(p);};
b.create_ui5_removeModel=function(p){U.checkParameterAndType(p.content,"modelId","string");return a(p);};
b.create_ui5_addNewModelEnhanceWith=function(p){U.checkParameterAndType(p.content,"modelId","string");return a(p);};
b.create_ui5_replaceComponentUsage=function(p){U.checkParameterAndType(p.content,"componentUsageId","string");U.checkParameterAndType(p.content,"componentUsage","object");return a(p);};
b.create_ui5_addLibraries=function(p){U.checkParameterAndType(p.content,"libraries","object");return a(p);};
b.create_ui5_addComponentUsages=function(p){U.checkParameterAndType(p.content,"componentUsages","object");return a(p);};
b.create_ui5_setMinUI5Version=function(p){U.checkParameterAndType(p.content,"minUI5Version","string");return a(p);};
b.create_smb_addNamespace=function(p){U.checkParameterAndType(p.content,"smartBusinessApp","object");return a(p);};
b.create_smb_changeNamespace=function(p){U.checkParameterAndType(p.content,"smartBusinessApp","object");return a(p);};
b.create_ui_generic_app_setMainPage=function(p){U.checkParameterAndType(p.content,"page","object");return a(p);};
b.create_ui_setIcon=function(p){U.checkParameterAndType(p.content,"icon","string");return a(p);};
b.create_ui_setDeviceTypes=function(p){U.checkParameterAndType(p.content,"deviceTypes","object");return a(p);};
b.create_url_setUri=function(p){U.checkParameterAndType(p.content,"uri","string");return a(p);};
b.create_fiori_setRegistrationIds=function(p){U.checkParameterAndType(p.content,"registrationIds","array");return a(p);};
b.create_ui5_setFlexExtensionPointEnabled=function(p){U.checkParameterAndType(p.content,"flexExtensionPointEnabled","boolean");U.checkParameterAndType(p,"changeType","string");return a(p);};
b.create_ui5_changeModel=function(p){U.checkParameterAndType(p.content,"modelId","string");U.checkEntityPropertyChange(p.content);return a(p);};
b.create_fiori_setAbstract=function(p){U.checkParameterAndType(p.content,"abstract","boolean");U.checkParameterAndType(p,"changeType","string");return a(p);};
return b;});
sap.ui.predefine('sap/ui/fl/write/_internal/transport/TransportDialog',["sap/m/List","sap/m/InputListItem","sap/m/Button","sap/m/ComboBox","sap/m/Dialog","sap/m/Input","sap/m/MessageToast","sap/ui/core/ListItem","sap/ui/fl/write/_internal/transport/Transports"],function(L,I,B,C,D,a,M,b,T){"use strict";
var c=D.extend("sap.ui.fl.write._internal.transport.TransportDialog",{
metadata:{library:"sap.ui.fl",properties:{pkg:{type:"string",group:"Misc",defaultValue:null},transports:{type:"any",group:"Misc",defaultValue:null},lrepObject:{type:"any",group:"Misc",defaultValue:null},hidePackage:{type:"boolean",group:"Misc",defaultValue:null}},events:{ok:{},cancel:{}}},
renderer:{apiVersion:2}
});
c.prototype.init=function(){D.prototype.init.apply(this);this._oResources=sap.ui.getCore().getLibraryResourceBundle("sap.ui.fl");this.setTitle(this._oResources.getText("TRANSPORT_DIALOG_TITLE"));this._oPackageLabel=null;this._oPackage=this._createPackageField();this._oTransport=this._createTransportCombo();this.addContent(this._createContentList());this._createButtons();this.setEscapeHandler(function(p){this.fireCancel();p.resolve();}.bind(this));};
c.prototype._createContentList=function(){this._oPackageListItem=new I({label:this._oResources.getText("TRANSPORT_DIALOG_PACKAGE"),content:[this._oPackage]});this._oTransportListItem=new I({label:this._oResources.getText("TRANSPORT_DIALOG_TRANSPORT"),content:[this._oTransport]});return new L({items:[this._oPackageListItem,this._oTransportListItem]});};
c.prototype._createButtons=function(){var t=this;this.addButton(new B({text:this._oResources.getText("TRANSPORT_DIALOG_LOCAL_OBJECT"),tooltip:this._oResources.getText("TRANSPORT_DIALOG_LOCAL_OBJECT"),press:function(){t._onLocal();}}));this.addButton(new B({text:this._oResources.getText("TRANSPORT_DIALOG_OK"),tooltip:this._oResources.getText("TRANSPORT_DIALOG_OK"),enabled:false,press:function(){t._onOkay();}}));this.addButton(new B({text:this._oResources.getText("TRANSPORT_DIALOG_CANCEL"),tooltip:this._oResources.getText("TRANSPORT_DIALOG_CANCEL"),press:function(){t.fireCancel();t.close();t.destroy();}}));};
c.prototype._onLocal=function(){this.fireOk({selectedTransport:"",selectedPackage:this.getPkg()||"$TMP",dialog:true});this.close();this.destroy();};
c.prototype._onOkay=function(){var t=this._oTransport.getSelectedKey();if(this._checkOkay(t)){this.fireOk({selectedTransport:t,selectedPackage:this.getPkg()||this._oPackage.getValue(),dialog:true});this.close();this.destroy();}else{this.getButtons()[1].setEnabled(false);this._oTransport.setValueState(sap.ui.core.ValueState.Error);this._oTransport.setValueStateText(this.getTitle());}};
c.prototype._checkOkay=function(t){if(t){return true;}return false;};
c.prototype._createTransportCombo=function(){var t=this;return new C({showSecondaryValues:true,enabled:false,tooltip:this._oResources.getText("TRANSPORT_DIALOG_TRANSPORT_TT"),width:"100%",selectionChange:function(){if(t._oPackageListItem.getVisible()&&!t._oPackage.getValue()){return;}t.getButtons()[1].setEnabled(true);t._oTransport.setValueState(sap.ui.core.ValueState.None);},change:function(e){var f=function(i){if((i&&e.mParameters.newValue!==i.getText())||!i){return true;}return false;};if(e&&e.mParameters&&e.mParameters.newValue){if(f(t._oTransport.getSelectedItem())){t.getButtons()[1].setEnabled(false);t._oTransport.setValueState(sap.ui.core.ValueState.Error);t._oTransport.setValueStateText(t._oResources.getText("TRANSPORT_DIALOG_TRANSPORT_TT"));}}}});};
c.prototype._createPackageField=function(){var t=this;return new a({tooltip:this._oResources.getText("TRANSPORT_DIALOG_PACKAGE_TT"),width:"100%",change:function(){var p;var o;o=t._createObjectInfo();p=T.getTransports(o);p.then(function(r){t._onPackageChangeSuccess(r);},function(r){t._onPackageChangeError(r);});},liveChange:function(e){if(e.mParameters.liveValue&&e.mParameters.liveValue.length>3){t._oTransport.setEnabled(true);}}});};
c.prototype._createObjectInfo=function(){var o;var r={"package":this._oPackage.getValue()||""};o=this.getProperty("lrepObject");if(o){if(o.name){r.name=o.name;}if(o.type){r.type=o.type;}if(o.namespace){r.namespace=o.namespace;}}return r;};
c.prototype._onPackageChangeSuccess=function(t){if(t){if(t.localonly){this._oTransport.setEnabled(false);this.getButtons()[1].setEnabled(true);}else if(t.transports&&t.transports.length>0){this._oTransport.setEnabled(true);this._setTransports(t);}else if(t.errorCode){this.getButtons()[1].setEnabled(false);this._oPackage.setValueState(sap.ui.core.ValueState.Error);this._oPackage.setValueStateText(this._oResources.getText("TRANSPORT_DIALOG_"+t.errorCode));this._setTransports(t);}else{M.show(this._oResources.getText("TRANSPORT_DIALOG_NO_TRANSPORTS"));}}};
c.prototype._setTransports=function(t){var l;var d;l=this._hasLock(t.transports);if(l){d=[l];}else{d=t.transports;}this.setTransports(d);if(d&&d.length===1){this._oTransport.setValue(d[0].description,true);this.getButtons()[1].setEnabled(true);}if(!d||d.length===0){this._oTransport.setSelectedKey(null);this._oTransport.setValueState(sap.ui.core.ValueState.None);this.getButtons()[1].setEnabled(false);}};
c.prototype._onPackageChangeError=function(r){M.show(r);this.setTransports([]);};
c.prototype._hasLock=function(t){var o;var l=t.length;while(l--){o=t[l];if(o.locked){return o;}}return null;};
c.prototype.setPkg=function(p){if(p&&!this.getProperty("pkg")){this.setProperty("pkg",p);this._oPackage.setValue(p);this._oPackage.setEnabled(false);this._oTransport.setEnabled(true);this.setTitle(this._oResources.getText("TRANSPORT_DIALOG_TITLE_SIMPLE"));this.getButtons()[0].setVisible(false);}return this;};
c.prototype.setTransports=function(s){var i;var l=0;var o;if(s){this.setProperty("transports",s);this._oTransport.removeAllItems();l=s.length;for(i=0;i<l;i++){o=s[i];this._oTransport.addItem(new b({key:o.transportId,text:o.transportId,additionalText:o.description}));}if(l===1){this._oTransport.setSelectedKey(s[0].transportId);this.getButtons()[1].setEnabled(true);}if(l>0){this._oTransport.setEnabled(true);}}return this;};
c.prototype.setLrepObject=function(o){if(o&&!this.getProperty("lrepObject")){this.setProperty("lrepObject",o);}return this;};
c.prototype.setHidePackage=function(h){this.setProperty("hidePackage",h);this._oPackageListItem.setVisible(!h);if(h){this.getButtons()[0].setEnabled(h);this.setTitle(this._oResources.getText("TRANSPORT_DIALOG_TITLE_SIMPLE"));}return this;};
return c;},true);
sap.ui.predefine('sap/ui/fl/write/_internal/transport/TransportSelection',["sap/ui/fl/Utils","sap/ui/fl/LayerUtils","sap/ui/fl/Layer","sap/ui/fl/write/_internal/transport/Transports","sap/ui/fl/write/_internal/transport/TransportDialog","sap/ui/fl/registry/Settings","sap/ui/core/BusyIndicator"],function(F,L,a,T,b,c,B){"use strict";var d=function(){};
d.prototype.selectTransport=function(o,O,e,C,f,s){if(!F.getLrepUrl()){O(this._createEventObject(o,{transportId:""}));return;}var r=function(o,O,e,C,s,A){T.getTransports(o).then(function(g){if(this._checkDialog(g,A)){this._openDialog({hidePackage:!L.doesCurrentLayerRequirePackage(),pkg:o.package,transports:g.transports,lrepObject:this._toLREPObject(o)},O,e,C,s);}else{var t=(!g.localonly&&A)?{transportId:"ATO_NOTIFICATION"}:this._getTransport(g);O(this._createEventObject(o,t));}}.bind(this),function(R){e(R);});};var l=L.getCurrentLayer();if(l&&((l===a.CUSTOMER)||(l===a.CUSTOMER_BASE))){c.getInstance().then(function(S){if(S.isAtoEnabled()){if(!(o&&o.name&&o.namespace&&o.type)){var t={transportId:"ATO_NOTIFICATION"};O(this._createEventObject(o,t));}else{r.apply(this,[o,O,e,C,s,true]);}}else{r.apply(this,[o,O,e,C,s,false]);}}.bind(this));}else{r.apply(this,[o,O,e,C,s,false]);}};
d.prototype._createEventObject=function(o,t){return{mParameters:{selectedTransport:t.transportId,selectedPackage:o["package"],dialog:false},getParameters:function(){return this.mParameters;},getParameter:function(n){return this.mParameters[n];}};};
d.prototype._toLREPObject=function(o){var O={};if(o.namespace){O.namespace=o.namespace;}if(o.name){O.name=o.name;}if(o.type){O.type=o.type;}return O;};
d.prototype._openDialog=function(C,o,e,f,s){var D=new b(C);D.attachOk(o);D.attachCancel(e);D.addStyleClass(s);if(f){D.addStyleClass("sapUiSizeCompact");}else{D.removeStyleClass("sapUiSizeCompact");}D.open();B.hide();return D;};
d.prototype._getTransport=function(t){var o;if(!t.localonly){o=this._hasLock(t.transports);}else{o={transportId:""};}return o;};
d.prototype._checkDialog=function(t,A){if(t){if(t.localonly||this._hasLock(t.transports)||(!t.localonly&&A)){return false;}}return true;};
d.prototype._hasLock=function(t){var l=t.length;while(l--){var o=t[l];if(o.locked){return o;}}return false;};
d.prototype.setTransports=function(C,o){var i=C.length-1;var t=this;var s=function(C,i,o,e,f){if(i>=0){var g=C[i];if(f===true){if(g.getDefinition().packageName!=="$TMP"){g.setRequest(e);}i--;return s(C,i,o,e,f);}if(g.getDefinition().packageName!=="$TMP"){return t.openTransportSelection(g,o).then(function(h){if(h==="cancel"){return Promise.reject("cancel");}g.setRequest(h.transport);if(h.fromDialog===true){e=h.transport;f=true;}i--;return s(C,i,o,e,f);},function(){return null;});}i--;return s(C,i,o,e,f);}return Promise.resolve();};return s(C,i,o);};
d.prototype.openTransportSelection=function(C,o,s){var t=this;return new Promise(function(r,e){var O=function(R){if(R&&R.getParameters){var g=R.getParameters().selectedTransport;var p=R.getParameters().selectedPackage;var h=R.getParameters().dialog;var i={transport:g,packageName:p,fromDialog:h};r(i);}else{r({});}};var E=function(g){if(g.sId==='cancel'){r(g.sId);}else{e(g);}};var f={};if(C){f["package"]=C.getPackage();f.namespace=C.getNamespace();f.name=C.getId();f.type=C.getDefinition().fileType;}t.selectTransport(f,O,E,false,o,s);});};
d.prototype.checkTransportInfo=function(t){return t&&t.transport&&t.packageName!=="$TMP";};
d.prototype._prepareChangesForTransport=function(t,A,e,C){var f=T.convertToChangeTransportData(A,e);var o={};o.package=t.packageName;o.transportId=t.transport;o.changeIds=f;o.reference=C.reference;o.layer=C.layer;return T.makeChangesTransportable(o).then(function(){A.forEach(function(g){if(g.getPackage()==='$TMP'){var D=g.getDefinition();D.packageName=t.packageName;g.setResponse(D);}});});};
return d;});
sap.ui.predefine('sap/ui/fl/write/_internal/transport/Transports',["sap/ui/fl/initial/_internal/connectors/LrepConnector","sap/ui/fl/Utils","sap/ui/fl/initial/_internal/connectors/Utils","sap/ui/fl/write/_internal/connectors/Utils"],function(A,F,I,W){"use strict";var R={ACTION_GET_TRANSPORTS:"/actions/gettransports/",ACTION_MAKE_CHANGE_TRANSPORTABLE:"/actions/make_changes_transportable/",ACTION_GET_TOKEN:"/actions/getcsrftoken/"};return{getTransports:function(p){if(F.getClient()){p["sap-client"]=F.getClient();}var g=I.getUrl(R.ACTION_GET_TRANSPORTS,{url:F.getLrepUrl()},p);g=decodeURIComponent(g);return I.sendRequest(g,"GET").then(function(r){if(r.response){if(!r.response.localonly){r.response.localonly=false;}if(!r.response.errorCode){r.response.errorCode="";}return Promise.resolve(r.response);}return Promise.reject('response is empty');});},makeChangesTransportable:function(p){if(!p.transportId){return Promise.reject(new Error("no transportId provided as attribute of mParameters"));}if(!p.changeIds){return Promise.reject(new Error("no changeIds provided as attribute of mParameters"));}if(!p.reference){return Promise.reject(new Error("no reference provided as attribute of mParameters"));}var u=F.getClient()?{"sap-client":F.getClient()}:{};var m=I.getUrl(R.ACTION_MAKE_CHANGE_TRANSPORTABLE,{url:F.getLrepUrl()},u);var t=I.getUrl(R.ACTION_GET_TOKEN,{url:F.getLrepUrl()});var r=W.getRequestOptions(A,t,p,"application/json; charset=utf-8","json");return W.sendRequest(m,"POST",r);},convertToChangeTransportData:function(l,a){var t=[];var i;if(a&&a.length){for(i=0;i<a.length;i++){var o=a[i];var p={};p.namespace=o.getNamespace();p.fileName=o.getDefinition().fileName;p.fileType=o.getDefinition().fileType;t.push(p);}}var b=l.length;for(i=0;i<b;i++){var c=l[i];var d={};d.namespace=c.getNamespace();d.fileName=c.getId();d.fileType=c.getDefinition().fileType;t.push(d);}return t;}};},true);
//# sourceMappingURL=library-preload-apply.js.map