/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/util/restricted/_CancelablePromise","sap/base/util/restricted/_isEqual","sap/base/util/restricted/_omit","sap/base/util/merge","sap/base/util/deepClone","sap/base/util/deepEqual","sap/base/util/ObjectPath","./CardEditor","sap/ui/integration/designtime/baseEditor/BaseEditor","sap/ui/integration/Designtime","sap/ui/integration/util/CardMerger","sap/base/util/LoaderExtensions","sap/base/Log"],function(C,_,a,m,d,b,O,c,B,D,e,L,f){"use strict";var g="";g=L.loadResource("sap/ui/integration/designtime/cardEditor/ConfigurationTemplate.js",{dataType:"text",failOnError:false,async:false});var h=c.extend("sap.ui.integration.designtime.cardEditor.BASEditor",{metadata:{library:"sap.ui.integration",events:{configurationChange:{},createConfiguration:{},error:{},designtimeInited:{}}},renderer:c.getMetadata().getRenderer()});h.prototype.getManifest=function(){return this._oCurrent.manifest;};h.prototype.getConfigurationClass=function(){return this._oCurrent.configurationclass;};h.prototype.getConfiguration=function(){return this._oCurrent.configuration;};h.prototype.getConfigurationString=function(){return this._oCurrent.configurationstring;};h.prototype._generateDesigntimeJSConfig=function(){var M=this._formatExportedDesigntimeMetadata(this.getDesigntimeMetadata());var J=this.getJson();if(this._eventTimeout){clearTimeout(this._eventTimeout);this._eventTimeout=null;}this._eventTimeout=setTimeout(function(){var E={form:{items:{}}};var l=m(E,this._oDesigntimeJSConfig);var N={};var I=[];var p;if(!O.get(["sap.card","configuration"],J)){O.set(["sap.card","configuration"],{"parameters":{}},J);}else if(!O.get(["sap.card","configuration","parameters"],J)){O.set(["sap.card","configuration","parameters"],{},J);}var P=O.get(["sap.card","configuration","parameters"],J);if(J){var q=O.get(["sap.card","configuration","parameters"],this._oDesigntimeMetadataModel.getData());if(b(P,{})&&!q){this._oDesigntimeJSConfig.form.items={};this._oCurrent={configuration:this._cleanConfig(this._oDesigntimeJSConfig),manifest:this._cleanJson(),configurationclass:this._fnDesigntime,configurationstring:this._cleanConfig(this._oDesigntimeJSConfig,true)};this.fireConfigurationChange(this._oCurrent);return;}var r=Object.keys(P);for(var n in l.form.items){p=m({},l.form.items[n]);if(!P[n]){if(q[n]){if(p.type==="group"||p.type==="separater"){P[n]={};}else if(p.manifestpath&&!p.manifestpath.startsWith("/sap.card/configuration/parameters")){var s=p.manifestpath;if(s.startsWith("/")){s=s.substring(1);}var v=O.get(s.split("/"),J)||"";P[n]={value:v};}}else{delete l.form.items[n];continue;}}else if(p.manifestpath&&!p.manifestpath.startsWith("/sap.card/configuration/parameters")){var s=p.manifestpath;if(s.startsWith("/")){s=s.substring(1);}var u=s.split("/");var v=O.get(u,J);var w=O.get(u,this._oInitialJson);if(!_(v,w)){P[n].value=v;}else{O.set(u,P[n].value,J);}}var x=r.indexOf(n);if(x>-1){r.splice(x,1);}var V;if(P[n].visualization){V=P[n].visualization;}var y;if(P[n].values){y=P[n].values;}l.form.items[n]=m(p,P[n]);if(!q[n].__value.visualization){delete l.form.items[n].visualization;}else if(V){l.form.items[n].visualization=V;V=null;}if(!q[n].__value.values){delete l.form.items[n].values;}else if(y){l.form.items[n].values=y;y=null;}if(p.type==="group"||p.type==="separator"){delete l.form.items[n].manifestpath;}else if(!l.form.items[n].manifestpath){q[n].manifestpath="/sap.card/configuration/parameters/"+n+"/value";q[n].__value.manifestpath="/sap.card/configuration/parameters/"+n+"/value";l.form.items[n].manifestpath="/sap.card/configuration/parameters/"+n+"/value";}}if(r.length>0){for(var i=0;i<r.length;i++){var z=r[i];var A=P[z];var F="string";if(A.type){F=A.type;}else if(q[z]&&q[z].__value){F=q[z].__value.type;}l.form.items[z]={manifestpath:"/sap.card/configuration/parameters/"+z+"/value",type:F,label:A.label,translatable:false,editable:A.editable,visible:A.visible};}P[z]=m(l.form.items[z],P[z]);}}if(M){if(l){for(var n in M){var G=M[n];var K=n.substring(n.lastIndexOf("/")+1);if(!n.startsWith("sap.card/configuration/parameters")){continue;}var H=l.form.items[K]||{};var V;if(H.visualization){V=H.visualization;}var y;if(H.values){y=H.values;}p=m(H,P[K]);if(G.hasOwnProperty("label")){p.label=G.label;}if(G.hasOwnProperty("position")){p.position=G.position;}if(p.editable==="false"){p.editable=false;}else if(p.editable==="true"){p.editable=false;}if(p.visible==="false"){p.visible=false;}else if(p.visible==="true"){p.visible=false;}if(p.type==="group"||p.type==="separator"){delete p.manifestpath;}if(V){p.visualization=V;V=null;}if(y){p.values=y;y=null;}p.__key=K;I[p.position]=p;}for(var i=0;i<I.length;i++){p=I[i];if(!p){continue;}N[p.__key]=p;delete p.__key;delete p.position;}l.form.items=N;}}this._oDesigntimeJSConfig=l;var Q=this._cleanConfig(this._oDesigntimeJSConfig);this._fnDesigntime=function(o){return new D(o);}.bind(this,Q);this._oCurrent={configuration:Q,manifest:this._cleanJson(J),configurationclass:this._fnDesigntime,configurationstring:this._cleanConfig(this._oDesigntimeJSConfig,true)};this._oDataModel.setData(this._prepareData(J));this.fireConfigurationChange(this._oCurrent);this._oInitialJson=J;}.bind(this),500);};h.prototype.init=function(){c.prototype.init.apply(this,arguments);this._oCurrent={configuration:null,manifest:null,configurationclass:null};};h.prototype._applyDefaultValue=function(i){if(i.value===undefined||i.value===null){switch(i.type){case"boolean":i.value=false;break;case"integer":case"number":i.value=0;break;case"string[]":i.value=[];break;default:i.value="";}}};h.prototype.getJson=function(i){if(i===true){return this._cleanJson();}else{return B.prototype.getJson.apply(this,arguments);}};h.prototype._cleanJson=function(J,i){J=J||this.getJson();var s=k(O.get(["sap.card","configuration","editor"],J)||"");if(s===""){s=k(O.get(["sap.card","designtime"],J)||"");}if(!s){O.set(["sap.card","designtime"],"sap/ui/integration/designtime/cardEditor/ConfigurationTemplate",J);}J=d(J);var i=i!==false;if(i){var p=O.get(["sap.card","configuration","parameters"],J);for(var n in p){var P=p[n];if(P&&(P.type==="group"||P.type==="separator")){delete p[n];continue;}if(this._oDesigntimeJSConfig&&this._oDesigntimeJSConfig.form&&this._oDesigntimeJSConfig.form.items){var o=this._oDesigntimeJSConfig.form.items[n]||{};if(o.type==="group"||o.type==="separator"){delete p[n];continue;}if(o.manifestpath&&!o.manifestpath.startsWith("/sap.card/configuration/parameters")){var l=o.manifestpath;if(l.startsWith("/")){l=l.substring(1);}if(o.type==="simpleicon"){o.type="string";}if(o.type==="string[]"){o.type="array";}O.set(l.split("/"),o.value,J);delete p[n];continue;}}p[n]={value:p[n].value};}}if(this._i18n){O.set(["sap.app","i18n"],this._i18n,J);}return J;};h.prototype._cleanConfig=function(o,S){var o=m({},o);for(var n in o.form.items){var i=o.form.items[n];if(i.type==="simpleicon"){if(!i.visualization){i.visualization={"type":"IconSelect","settings":{"value":"{currentSettings>value}","editable":"{currentSettings>editable}"}};}i.type="string";}if(i.type==="array"){i.type="string[]";}if(i.type!=="string[]"&&i.type!="string"){delete i.values;}delete i.value;}if(S){var l=JSON.stringify(o,null,"\t");l=l.replace(/\"\$\$([a-zA-Z]*)\$\$\"/g,function(s){return s.substring(3,s.length-3);});return l;}return o;};h.prototype._generateMetadataFromJSConfig=function(o){var M={};if(o){this._oDesigntimeJSConfig=m(this._oDesigntimeJSConfig,o);}if(this._oDesigntimeJSConfig){var I=this._oDesigntimeJSConfig.form.items;var i=0;for(var n in I){var p="sap.card/configuration/parameters/"+n,P=p.split("/"),l;M[p]=m({},I[n]);l=M[p];l.position=i++;if(l.visualization){if(l.visualization.type==="IconSelect"){l.type="simpleicon";}}if(l.type==="string[]"){l.type="array";}if(l.manifestpath&&(!l.manifestpath.startsWith("/sap.card/configuration/parameters/")||!O.get(P,this._oInitialJson))){O.set(P,l,this._oInitialJson);}if(!l.hasOwnProperty("type")){this.fireError({"name":"Designtime Error","detail":{"message":"Type of parameter "+n+" not exist"}});}else if(l.type===""){this.fireError({"name":"Designtime Error","detail":{"message":"Type of parameter "+n+" is Invalid"}});}if(l.type!=="group"&&l.type!=="separator"){if(!l.hasOwnProperty("value")){var q=l.manifestpath.substring(1).split("/"),v=O.get(q,this._oInitialJson);if(v!==undefined){l.value=v;}else{this._applyDefaultValue(l);}}else{this._applyDefaultValue(l);}if(O.get(P,this._oInitialJson)){if(O.get(P,this._oInitialJson).value===undefined){O.get(P,this._oInitialJson).value=l.value;}}}}}return M;};h.prototype.setJson=function(J){if(!this._i18n){this._i18n=O.get(["sap.app","i18n"],J);}B.prototype.setJson.apply(this,arguments);if(!this.__generateDesigntimeJSConfigAttached){this.attachDesigntimeMetadataChange(this._generateDesigntimeJSConfig.bind(this));this.attachJsonChange(this._generateDesigntimeJSConfig.bind(this));this.__generateDesigntimeJSConfigAttached=true;}var J=this.getJson();var s=O.get(["sap.app","id"],J);if(this._bDesigntimeInit&&this._bCardId!==s){if(this._oDesigntimePromise){this._oDesigntimePromise.cancel();}delete this._bCardId;delete this._bDesigntimeInit;}if(!this._bDesigntimeInit){this.setPreventInitialization(true);this._bCardId=s;var T;var i=k(O.get(["sap.card","configuration","editor"],J)||"");if(i===""){i=k(O.get(["sap.card","designtime"],J)||"");}if(!i){var l=g;O.set(["sap.card","designtime"],"sap/ui/integration/designtime/cardEditor/ConfigurationTemplate",J);T="sap/ui/integration/designtime/cardEditor/ConfigurationTemplate";this.fireCreateConfiguration({file:"sap/ui/integration/designtime/cardEditor/ConfigurationTemplate.js",content:l,manifest:this._cleanJson(J,false)});return;}var n=k(this.getBaseUrl()||""),p={},S=null,q=null,N=null,F=null;if(i&&i.indexOf("cardEditor/ConfigurationTemplate")>0){T=i;q=t(i);N=s.replace(/\./g,"/")+"/"+q;p[N]=q;p[N+"js"]=q.substring(0,q.lastIndexOf("/"));F=q.replace(p[N+"js"]+"/","");}else if(n&&i){S=k(n);q=t(i);var r=S+"/"+q;N=s.replace(/\./g,"/")+"/"+q;p[N]=r;p[N+"js"]=r.substring(0,r.lastIndexOf("/"));F=r.replace(p[N+"js"]+"/","");}if(n&&i){sap.ui.loader.config({paths:p});var u=this;this._oDesigntimePromise=new C(function(R){var U=N+"js"+"/"+F+".js";if(T){U=T+".js";}sap.ui.loader._.loadJSResourceAsync(U).then(function(o){if(!o){u.fireError({"name":"Designtime Error","detail":{"message":"Invalid file format"}});}else if(o){var v=new o();u._oDesigntimeJSConfig=v.getSettings();u._fnDesigntime=o;var M=u._generateMetadataFromJSConfig();o=v.getMetadata().getClass();R(M);}}).catch(function(o){f.error(o);u.fireError({"name":"Designtime Error","detail":o});});});this._oDesigntimePromise.then(function(M){this.setPreventInitialization(false);var o=M;o=e.mergeCardDesigntimeMetadata(o,this.getDesigntimeChanges());this._oInitialDesigntimeMetadata=o;this.setDesigntimeMetadata(j(o),true);this._bDesigntimeInit=true;this.fireDesigntimeInited();}.bind(this));}else{this.setPreventInitialization(false);}}};h.prototype.initialize=function(){if(!this._bDesigntimeInit){this.attachEventOnce("designtimeInited",this.initialize);return;}if(!this._bPreventInitialization){this._initialize();}};h.prototype.getConfigurationTemplate=function(){return g;};h.prototype.updateDesigntimeMetadata=function(o,i){var l=this._generateMetadataFromJSConfig(o);this._oInitialDesigntimeMetadata=l;this.setDesigntimeMetadata(j(l),i);};h.prototype.setDestinations=function(o){if(Array.isArray(o)&&o.length>0){var i=this.getConfig();if(!i.properties){i.properties={destinations:{}};}else if(!i.properties.destinations){i.properties.destinations={};}i.properties.destinations.allowedValues=o;this.setConfig(i);}};function j(F){var o={};Object.keys(F).forEach(function(p){O.set(p.split("/"),{__value:d(F[p])},o);});return o;}function k(p){return p.trim().replace(/\/*$/,"");}function t(p){return p.replace(/^\.\//,"");}return h;});
