/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/util/restricted/_CancelablePromise","sap/base/util/restricted/_isEqual","sap/base/util/restricted/_omit","sap/base/util/restricted/_castArray","sap/base/util/deepEqual","sap/base/util/each","sap/base/util/merge","sap/base/util/deepClone","sap/base/util/ObjectPath","sap/base/util/isEmptyObject","sap/ui/integration/designtime/baseEditor/BaseEditor","sap/ui/integration/util/CardMerger","sap/ui/thirdparty/jquery","./config/index"],function(C,_,a,b,d,e,m,c,O,i,B,f,q,D){"use strict";var g=B.extend("sap.ui.integration.designtime.cardEditor.CardEditor",{metadata:{library:"sap.ui.integration",properties:{layout:{type:"string",defaultValue:"form"},designtimeChanges:{type:"array",defaultValue:[]},baseUrl:{type:"sap.ui.core.URI",defaultValue:null},"config":{type:"object",defaultValue:{"i18n":[].concat(B.getMetadata().getProperty("config").getDefaultValue().i18n,"sap/ui/integration/designtime/cardEditor/i18n/i18n.properties")}}}},constructor:function(p){p=p||{};B.prototype.constructor.apply(this,arguments);this.setPreventInitialization(true);if(!p["config"]){this.addConfig(D,true);}},renderer:B.getMetadata().getRenderer()});function h(o,n,N,K,v){if(!o[n]){o[n]={};}if(!o[n][N]){o[n][N]={};}o[n][N][K]=v;}function j(J,I){var n="sap.card";var o=O.get([n,"configuration"],J);var p=O.get([n,"configuration"],I);if(d(o,p)){return undefined;}var r={};e(o,function(u,v){e(v,function(N,S){if(!p[u][N]){r[u]=r[u]||{};r[u][N]=S;}else{e(S,function(K,V){if(p[u][N][K]!==V){h(r,u,N,K,V);}});}});});return{configuration:r};}g.prototype.init=function(){B.prototype.init.apply(this,arguments);this.attachJsonChange(function(E){if(!this._oInitialJson){this._oInitialJson=E.getParameter("json");}},this);};g.prototype.setJson=function(){B.prototype.setJson.apply(this,arguments);var J=this.getJson();var n=O.get(["sap.app","id"],J);if(this._bDesigntimeInit&&this._bCardId!==n){if(this._oDesigntimePromise){this._oDesigntimePromise.cancel();}delete this._bCardId;delete this._bDesigntimeInit;}if(!this._bDesigntimeInit){this.setPreventInitialization(true);this._bDesigntimeInit=true;this._bCardId=n;var o=s(O.get(["sap.card","configuration","editor"],J)||"");if(o===""){o=s(O.get(["sap.card","designtime"],J)||"");}var p=s(this.getBaseUrl()||"");if(p&&o){var P={};var S=s(p);var r=t(o);var u=S+"/"+r;var N=n.replace(/\./g,"/")+"/"+r;P[N]=u;sap.ui.loader.config({paths:P});var E=N+"/editor.config";var I=N+"/i18n/i18n.properties";var v=u+"/metadata.json";this._oDesigntimePromise=new C(function(R){Promise.all([new Promise(function(w){sap.ui.require([E],w,function(){w({});});}),new Promise(function(w){q.getJSON(v).done(w).fail(function(){w({});});})]).then(R);});this._oDesigntimePromise.then(function(w){this.setPreventInitialization(false);var x=w[1];x=f.mergeCardDesigntimeMetadata(x,this.getDesigntimeChanges());this._oInitialDesigntimeMetadata=x;this.setDesigntimeMetadata(k(x),true);var y=w[0];if(i(y)){this.addConfig({"i18n":I});}else{y=m({},y);y.i18n=y.i18n?b(y.i18n):[];y.i18n.push(I);this._addSpecificConfig(y);}}.bind(this));}else{this.setPreventInitialization(false);this.addConfig({});}}};g.prototype.setDesigntimeChanges=function(n){if(this._oInitialDesigntimeMetadata){throw Error("Designtime Changes can only be set initially");}this.setProperty("designtimeChanges",n);};function k(F){var o={};Object.keys(F).forEach(function(p){O.set(p.split("/"),{__value:c(F[p])},o);});return o;}function s(p){return p.trim().replace(/\/*$/,"");}function t(p){return p.replace(/^\.\//,"");}g.prototype.getChanges=function(p){return Promise.all([this.getDeltaChangeDefinition(p).catch(function(){return;}),this.getDesigntimeChangeDefinition(p).catch(function(){return;})]).then(function(n){if(n[0]===undefined&&n[1]===undefined){return Promise.reject("No changes");}return{runtimeChange:n[0],designtimeChange:n[1]};});};function l(p){return new Promise(function(r){sap.ui.require(["sap/ui/fl/Change"],function(n){var o=n.createInitialFileContent(p);o.creation=new Date().toISOString();r(o);});});}g.prototype.getDesigntimeChangeDefinition=function(p){var n=[];var o=Object.assign({},this._oInitialDesigntimeMetadata);var N=this._formatExportedDesigntimeMetadata(this.getDesigntimeMetadata());e(N,function(K,v){if(o.hasOwnProperty(K)){if(!_(o[K],v)){n.push({propertyPath:K,operation:"UPDATE",propertyValue:v});}delete o[K];}else{n.push({propertyPath:K,operation:"INSERT",propertyValue:v});}});e(o,function(K){n.push({propertyPath:K,operation:"DELETE"});});if(!n.length){return Promise.reject("No Change");}this._oInitialDesigntimeMetadata=N;var r=this.getJson();var P=m({},a(p,["oldValue","newValue"]));P.content={entityPropertyChange:n};P.changeType="appdescr_card_designtime";P.generator="CardEditor";P.selector={};P.reference=O.get(["sap.app","id"],r);return l(P);};g.prototype.getDeltaChangeDefinition=function(p){var o=this.getJson();var P=m({},p);P.content=j(o,this._oInitialJson);if(!P.content){return Promise.reject("No Change");}this._oInitialJson=o;P.changeType="appdescr_card";P.generator="CardEditor";P.selector={};P.reference=O.get(["sap.app","id"],o);return l(P);};return g;});
