/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/core/util/reflection/JsControlTreeModifier","sap/base/util/uid","sap/base/Log"],function(J,u,L){"use strict";var M={};M.CHANGE_TYPE_MOVE_FIELD="moveSimpleFormField";M.CHANGE_TYPE_MOVE_GROUP="moveSimpleFormGroup";M.sTypeTitle="sap.ui.core.Title";M.sTypeMTitle="sap.m.Title";M.sTypeToolBar="sap.m.Toolbar";M.sTypeOverflowToolBar="sap.m.OverflowToolbar";M.sTypeLabel="sap.m.Label";M.sTypeSmartLabel="sap.ui.comp.smartfield.SmartLabel";M.CONTENT_AGGREGATION="content";function f(o,s,C){return C.reduce(function(p,i){return p.then(function(R){if(R!==undefined){return R;}var t=o.getControlType(i);if(s.indexOf(t)===-1){return Promise.resolve().then(o.getVisible.bind(o,i)).then(function(v){return v||undefined;});}else{return false;}});},Promise.resolve());}function a(C,o,i,s,p,S,G){return f(o,S,i).then(function(F){if(F){var v=p.view;var A=p.appComponent;var t;return Promise.resolve().then(o.createControl.bind(o,"sap.ui.core.Title",A,v,G)).then(function(l){t=l;o.setProperty(t,"text","");return o.insertAggregation(s,"content",t,0,v);}).then(function(){var n=C.getRevertData();n.createdTitleSelector=p.modifier.getSelector(t,p.appComponent);C.setRevertData(n);});}return Promise.resolve();}).then(function(){return o.getAggregation(s,"content");});}function m(o,s,C,G){var R;var l=-1;return f(o,s,C).then(function(F){if(F){l++;}for(var i=0;i<C.length;i++){var t=o.getControlType(C[i]);if(s.indexOf(t)>-1){l++;if(l===G){R=C[i];break;}}}return C.indexOf(R);});}function b(E,i,o){if(i>=E.length||i===-1){return true;}var t=o.getControlType(E[i]);return(M.sTypeTitle===t||M.sTypeToolBar===t||M.sTypeMTitle===t||M.sTypeOverflowToolBar===t);}function c(o,l,C,s){var i=0;for(i=l+1;i<C.length;++i){var t=o.getControlType(C[i]);if(s.indexOf(t)>-1){break;}}return i-l;}function g(o,E,i){return c(o,i,E,[M.sTypeTitle,M.sTypeMTitle,M.sTypeToolBar,M.sTypeOverflowToolBar,M.sTypeLabel,M.sTypeSmartLabel]);}function d(o,C,G,F,U){if(!b(C,G,o)){L.error("Illegal argument. iIndex has to point to a Label.");}else{F=U?F+1:F;var i=0;var A=G;var l;while(A<C.length&&i<F){++i;l=g(o,C,A);A+=l;}return A;}}function e(s,S,t,T,l){var R=t;for(var i=0;i<l;i++){R.splice(T+i,0,s[S+i]);}return R;}function h(H){var R=H.getTitle();if(!R){R=H.getToolbar();}return R;}function j(s,i,p){var o=h(i.element);var S=p.modifier.getSelector(s,p.appComponent);var l={elementSelector:p.modifier.getSelector(o,p.appComponent),source:{groupIndex:i.sourceIndex},target:{groupIndex:i.targetIndex}};return{changeType:M.CHANGE_TYPE_MOVE_GROUP,targetSelector:S,movedControl:o,movedElements:[l]};}function k(s,i,S,t,p){var o=p.modifier.getSelector(s,p.appComponent);var l=i.element.getLabel();var n=p.modifier.getSelector(l,p.appComponent);var T=h(t.parent);var q=h(S.parent);var v=p.modifier.getSelector(T,p.appComponent);var w=p.modifier.getSelector(q,p.appComponent);var x={elementSelector:n,source:{groupSelector:w,fieldIndex:i.sourceIndex},target:{groupSelector:v,fieldIndex:i.targetIndex}};return{changeType:M.CHANGE_TYPE_MOVE_FIELD,targetSelector:o,target:T,source:q,movedControl:l,movedElements:[x]};}function r(o,s,M,C,v){return Promise.resolve().then(o.removeAllAggregation.bind(o,s,M.CONTENT_AGGREGATION)).then(function(){return C.reduce(function(p,i,I){return p.then(o.insertAggregation.bind(o,s,M.CONTENT_AGGREGATION,i,I,v));},Promise.resolve());});}M.applyChange=function(C,s,p){var o=p.modifier;var v=p.view;var A=p.appComponent;var t;var i;var l;var n=C.getContent();var q=n.movedElements[0];return Promise.resolve().then(function(){return o.getAggregation(s,M.CONTENT_AGGREGATION);}).then(function(w){var x=w.map(function(R){return o.getSelector(R,A);});var S={content:x};C.setRevertData(S);if(C.getChangeType()===M.CHANGE_TYPE_MOVE_FIELD){var y=o.bySelector(q.elementSelector||q.element,A,v);var z=w.indexOf(y);var B=g(o,w,z);t=o.bySelector(q.target.groupSelector||q.target.groupId,A,v);var T=w.indexOf(t);var D=o.bySelector(q.source.groupSelector||q.source.groupId,A,v);var E=w.indexOf(D);var F=d(o,w,T,q.target.fieldIndex,(E===T)&&(q.source.fieldIndex<q.target.fieldIndex));var G=g(o,w,F);i=w.slice();var H=i.slice(z,z+B);var I,K,N,O;if(z<F){I=i.slice(0,z);N=i.slice(z+B,F+G);O=i.slice(F+G,i.length);i=I.concat(N.concat(H.concat(O)));}else if(z>F){K=i.slice(0,F+G);N=i.slice(F+G,z);O=i.slice(z+B,i.length);i=K.concat(H.concat(N.concat(O)));}if(z!=F){return r(o,s,M,i,v);}}else if(C.getChangeType()===M.CHANGE_TYPE_MOVE_GROUP){var P=[M.sTypeTitle,M.sTypeToolBar,M.sTypeMTitle,M.sTypeOverflowToolBar];var Q=o.bySelector(q.elementSelector||q.element,A,v);return Promise.resolve().then(function(){if(q.target.groupIndex===0||!Q){return a(C,o,w,s,p,P,n.newControlId).then(function(R){w=R;});}return undefined;}).then(function(){l=Q?w.indexOf(Q):0;return m(o,P,w,q.target.groupIndex);}).then(function(R){t=w[R];var U=c(o,R,w,P);var V=c(o,l,w,P);i=w.slice();i.splice(l,V);R=i.indexOf(t);var W=q.source.groupIndex<q.target.groupIndex?U:0;i=e(w,l,i,R+W,V);return r(o,s,M,i,v);});}else{L.warning("Unknown change type detected. Cannot apply to SimpleForm");}});};M.completeChangeContent=function(C,s,p){var S;var o=p.modifier;var v=p.view;var A=p.appComponent;var i=o.bySelector(s.selector,A,v);var l=s.movedElements;if(l.length>1){L.warning("Moving more than 1 Formelement is not yet supported.");}var n=l[0];n.element=sap.ui.getCore().byId(n.id);var q=Object.assign({},s.source);var t=Object.assign({},s.target);if(!t.parent){t.parent=sap.ui.getCore().byId(t.id);}if(!q.parent){q.parent=sap.ui.getCore().byId(q.id);}if(i&&n.element&&t.parent){if(s.changeType==="moveSimpleFormGroup"){S=j(i,n,p);}else if(s.changeType==="moveSimpleFormField"){S=k(i,n,q,t,p);}}else{L.error("Element not found. This may be caused by an unstable id!");}var w=C.getDefinition();w.content.targetSelector=S.targetSelector;w.content.movedElements=S.movedElements;w.content.newControlId=o.getSelector(v.createId(u()),A);if(S.source&&S.target){C.addDependentControl(S.source,"sourceParent",p);C.addDependentControl(S.target,"targetParent",p);}C.addDependentControl([S.movedControl],"movedElements",p);};M.revertChange=function(C,s,p){var o=p.modifier;var A=p.appComponent;var v=p.view;var R=C.getRevertData();var i=R.content;var l=i.map(function(S){return o.bySelector(S,A,v);});return r(o,s,M,l,v).then(function(){var n=R.createdTitleSelector;var q=p.modifier.bySelector(n,p.appComponent);if(q){q.destroy();}C.resetRevertData();return true;});};M.getChangeVisualizationInfo=function(C,A){var o=C.getContent().movedElements[0];var G=o.source.groupSelector;var i=J.bySelector(o.elementSelector,A).getParent().getId();return{affectedControls:[i],dependentControls:[G&&G.id?G:C.getContent().targetSelector]};};return M;},true);
