/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/Device','sap/ui/core/ResizeHandler','sap/ui/layout/library','./FormLayout','./ColumnLayoutRenderer',"sap/ui/thirdparty/jquery"],function(D,R,l,F,C,q){"use strict";var a=F.extend("sap.ui.layout.form.ColumnLayout",{metadata:{library:"sap.ui.layout",properties:{columnsXL:{type:"sap.ui.layout.form.ColumnsXL",group:"Appearance",defaultValue:2},columnsL:{type:"sap.ui.layout.form.ColumnsL",group:"Appearance",defaultValue:2},columnsM:{type:"sap.ui.layout.form.ColumnsM",group:"Appearance",defaultValue:1},labelCellsLarge:{type:"sap.ui.layout.form.ColumnCells",group:"Appearance",defaultValue:4},emptyCellsLarge:{type:"sap.ui.layout.form.EmptyCells",group:"Appearance",defaultValue:0}}}});a.prototype.init=function(){F.prototype.init.apply(this,arguments);this._iBreakPointTablet=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD_EXTENDED].points[0];this._iBreakPointDesktop=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD_EXTENDED].points[1];this._iBreakPointLargeDesktop=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD_EXTENDED].points[2];this._resizeProxy=q.proxy(b,this);if(typeof ResizeObserver==="function"){this._oResizeObserver=new ResizeObserver(this._resizeProxy);}};a.prototype.exit=function(){_.call(this);this._oResizeObserver=undefined;};a.prototype.onBeforeRendering=function(e){F.prototype.onBeforeRendering.apply(this,arguments);if(this.getColumnsM()>this.getColumnsL()||this.getColumnsL()>this.getColumnsXL()){throw new Error("Column size not correct defined for "+this);}_.call(this);};a.prototype.onAfterRendering=function(e){if(this._oResizeObserver){var d=this.getDomRef();this._oResizeObserver.observe(d);}else{this._sResizeListener=R.register(this,this._resizeProxy);}c.call(this);};a.prototype.toggleContainerExpanded=function(o){o.$().toggleClass("sapUiFormCLContainerColl",!o.getExpanded());};a.prototype.onLayoutDataChange=function(e){this.invalidate();};a.prototype.onsapup=function(e){this.onsapleft(e);};a.prototype.onsapdown=function(e){this.onsapright(e);};a.prototype.getContainerRenderedDomRef=function(o){return o.getDomRef();};a.prototype.getElementRenderedDomRef=function(e){return e.getDomRef();};a.prototype._getContainerSize=function(o){var f=this.getParent();var L=this.getLayoutDataForElement(o,"sap.ui.layout.form.ColumnContainerData");var d=f.getVisibleFormContainers();var e=d.length;var g=this.getColumnsM();var h=this.getColumnsL();var j=this.getColumnsXL();var O={S:{Size:1,Break:false,FirstRow:false},M:{Size:1,Break:false,FirstRow:false},L:{Size:1,Break:false,FirstRow:false},XL:{Size:1,Break:false,FirstRow:false}};var k=function(x,O,e,I,y){if(e<x){O.Size=Math.floor(x/e);if(y&&O.Size*e<x){O.Size=O.Size+x-O.Size*e;}}O.Break=x>1&&I>0&&(I%x)===0;O.FirstRow=e>1&&I<x;};if(L){O.M.Size=L.getColumnsM();O.L.Size=L.getColumnsL();O.XL.Size=L.getColumnsXL();if(O.M.Size>g||O.L.Size>h||O.XL.Size>j){throw new Error("More cells defined for FormContainer "+o.getId()+" than columns on "+this);}}if(e===1){if(!L){O.M.Size=g;O.L.Size=h;O.XL.Size=j;}O.S.FirstRow=true;O.M.FirstRow=true;O.L.FirstRow=true;O.XL.FirstRow=true;}else{var m=0;var M=0;var n=0;var p;var r=false;var s=0;var t=g;var u=h;var v=j;var i=0;for(i=0;i<e;i++){if(o===d[i]){m=i;p=L;}else{p=this.getLayoutDataForElement(d[i],"sap.ui.layout.form.ColumnContainerData");}if(!p){var E=d[i].getVisibleFormElements();if(M<E.length){M=E.length;n=i;}s++;}else{r=true;t=t-p.getColumnsM();u=u-p.getColumnsL();v=v-p.getColumnsXL();}}O.S.FirstRow=e>1&&m===0;O.S.Break=m>0;if(!r){k(g,O.M,e,m,m===n);k(h,O.L,e,m,m===n);k(j,O.XL,e,m,m===n);}else{if(!L){if(s<t){k(t,O.M,s,m,m===n);}if(s<u){k(u,O.L,s,m,m===n);}if(s<v){k(v,O.XL,s,m,m===n);}}var S={M:{rowColumns:0,lineBreak:false,first:true},L:{rowColumns:0,lineBreak:false,first:true},XL:{rowColumns:0,lineBreak:false,first:true}};var w=function(x,y,U){if(U){if(x.rowColumns+U<=y){x.rowColumns=x.rowColumns+U;x.lineBreak=false;}else{x.rowColumns=U;if(y>1){x.lineBreak=true;}x.first=false;}}else{if(x.rowColumns<y){x.rowColumns++;x.lineBreak=false;}else{x.rowColumns=1;if(y>1){x.lineBreak=true;}x.first=false;}}};for(i=0;i<e;i++){if(o===d[i]){p=L;}else{p=this.getLayoutDataForElement(d[i],"sap.ui.layout.form.ColumnContainerData");}w(S.M,g,(p?p.getColumnsM():0));w(S.L,h,(p?p.getColumnsL():0));w(S.XL,j,(p?p.getColumnsXL():0));if(o===d[i]){O.M.Break=S.M.lineBreak;O.L.Break=S.L.lineBreak;O.XL.Break=S.XL.lineBreak;O.M.FirstRow=S.M.first;O.L.FirstRow=S.L.first;O.XL.FirstRow=S.XL.first;break;}}}}return O;};a.prototype._getFieldSize=function(f){var d=12;var L=this.getLayoutDataForElement(f,"sap.ui.layout.form.ColumnElementData");var o={S:{Size:d,Break:false,Space:0},L:{Size:d,Break:false,Space:0}};var e=d;var g=this.getLabelCellsLarge();if(L){o.S.Size=L.getCellsSmall()===-1?d:L.getCellsSmall();o.L.Size=L.getCellsLarge()===-1?d:L.getCellsLarge();}var E=f.getParent();var h=E.getLabelControl();if(h===f){if(!L||L.getCellsSmall()===-1){o.S.Size=e;}if(!L||L.getCellsLarge()===-1){o.L.Size=g;}}else{var j=E.getFieldsForRendering();var k=j.length;var m=d;var n=d-this.getEmptyCellsLarge();if(h){var p=this.getLayoutDataForElement(h,"sap.ui.layout.form.ColumnElementData");if(p){e=p.getCellsSmall()===-1?e:p.getCellsSmall();g=p.getCellsLarge()===-1?g:p.getCellsLarge();}if(e<d){m=m-e;}if(g<d){n=n-g;}}else{e=0;g=0;}if(k===1){if(!L||L.getCellsSmall()===-1){o.S.Size=m;}else if(h){if(o.S.Size>m){o.S.Break=true;}}if(!L||L.getCellsLarge()===-1){o.L.Size=n;}else if(h){if(o.L.Size>n){o.L.Break=true;}}}else{var i=0;var r=[];var s=[];var t={availableCells:m,first:0,last:999,firstDefault:-1,defaultFields:0};var u=0;var v=0;var w=0;var O;r.push(q.extend({},t));t.availableCells=n;s.push(q.extend({},t));var x=function(B,G,I,d){B[G].last=I-1;B.push(q.extend({},t));G++;B[G].first=I;B[G].availableCells=d;return G;};var y=function(B,G,H,U,I){if(B[G].availableCells-B[G].defaultFields<H){if(H<=U){G=x(B,G,I,U);}else{G=x(B,G,I,d);}}B[G].availableCells=B[G].availableCells-H;return G;};var z=function(B,G,d,I){if(B[G].availableCells===B[G].defaultFields){G=x(B,G,I,d);}if(B[G].firstDefault<0){B[G].firstDefault=I;}B[G].defaultFields++;return G;};for(i=0;i<k;i++){if(f!==j[i]){O=this.getLayoutDataForElement(j[i],"sap.ui.layout.form.ColumnElementData");}else{O=L;w=i;}if(O&&O.getCellsSmall()>0){u=y(r,u,O.getCellsSmall(),m,i);}else{u=z(r,u,m,i);}if(O&&O.getCellsLarge()>0){v=y(s,v,O.getCellsLarge(),n,i);}else{v=z(s,v,n,i);}}var A=function(B,w,G,o,H){var I=0;var t;for(i=0;i<B.length;i++){if(w>=B[i].first&&w<=B[i].last){t=B[i];break;}}if(G<=0){o.Size=Math.floor(t.availableCells/t.defaultFields);}if(w===t.first&&w>0){o.Break=true;if(H>0&&H<d&&o.Size<=d-H){o.Space=H;}}if(w===t.firstDefault){I=t.availableCells-t.defaultFields*o.Size;if(I>0){o.Size=o.Size+I;}}};A(r,w,L?L.getCellsSmall():-1,o.S,e);A(s,w,L?L.getCellsLarge():-1,o.L,g);}}return o;};function _(){if(this._oResizeObserver){this._oResizeObserver.disconnect();}if(this._sResizeListener){R.deregister(this._sResizeListener);this._sResizeListener=undefined;}}function b(e,n){window.requestAnimationFrame(function(){c.call(this,e,n);}.bind(this));}function c(e,n){var d=this.getDomRef();if(!d){_.call(this);return;}var $=this.$();if(!$.is(":visible")){return;}if(R.isSuspended(d,this._resizeProxy)){return;}var w=d.clientWidth;var i=1;if(w<=this._iBreakPointTablet){$.toggleClass("sapUiFormCLMedia-Std-Phone",true);$.toggleClass("sapUiFormCLMedia-Std-Desktop",false).toggleClass("sapUiFormCLMedia-Std-Tablet",false).toggleClass("sapUiFormCLMedia-Std-LargeDesktop",false);}else if((w>this._iBreakPointTablet)&&(w<=this._iBreakPointDesktop)){$.toggleClass("sapUiFormCLMedia-Std-Tablet",true);$.toggleClass("sapUiFormCLMedia-Std-Desktop",false).toggleClass("sapUiFormCLMedia-Std-Phone",false).toggleClass("sapUiFormCLMedia-Std-LargeDesktop",false);i=this.getColumnsM();}else if((w>this._iBreakPointDesktop)&&(w<=this._iBreakPointLargeDesktop)){$.toggleClass("sapUiFormCLMedia-Std-Desktop",true);$.toggleClass("sapUiFormCLMedia-Std-Phone",false).toggleClass("sapUiFormCLMedia-Std-Tablet",false).toggleClass("sapUiFormCLMedia-Std-LargeDesktop",false);i=this.getColumnsL();}else{$.toggleClass("sapUiFormCLMedia-Std-LargeDesktop",true);$.toggleClass("sapUiFormCLMedia-Std-Desktop",false).toggleClass("sapUiFormCLMedia-Std-Phone",false).toggleClass("sapUiFormCLMedia-Std-Tablet",false);i=this.getColumnsXL();}var W=this.getLabelCellsLarge()<12&&w/i>this._iBreakPointTablet;$.toggleClass("sapUiFormCLWideColumns",W);$.toggleClass("sapUiFormCLSmallColumns",!W);}a.prototype.getLayoutDataForDelimiter=function(){var d=sap.ui.require("sap/ui/layout/form/ColumnElementData");if(!d){var r;sap.ui.require(["sap/ui/layout/form/ColumnElementData"],function(d){r(new d({cellsLarge:1,cellsSmall:1}));});return new Promise(function(f){r=f;});}else{return new d({cellsLarge:1,cellsSmall:1});}};a.prototype.getLayoutDataForSemanticField=function(f,i,L){if(L){if(L.isA("sap.ui.layout.form.ColumnElementData")){L.setCellsLarge(-1).setCellsSmall(11);return L;}else{L.destroy();}}var d=sap.ui.require("sap/ui/layout/form/ColumnElementData");if(!d){var r;sap.ui.require(["sap/ui/layout/form/ColumnElementData"],function(d){r(new d({cellsLarge:-1,cellsSmall:11}));});return new Promise(function(e){r=e;});}else{return new d({cellsLarge:-1,cellsSmall:11});}};return a;});
