/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/mdc/Element','sap/ui/mdc/mixin/PromiseMixin','sap/ui/mdc/condition/Condition','sap/ui/mdc/condition/FilterOperatorUtil','sap/ui/mdc/condition/FilterConverter','sap/ui/mdc/enum/SelectType','sap/ui/mdc/enum/OutParameterMode','sap/ui/mdc/enum/ConditionValidated','sap/ui/model/Context','sap/ui/model/FormatException','sap/ui/model/ParseException','sap/ui/model/base/ManagedObjectModel','sap/ui/base/ManagedObjectObserver','sap/base/util/merge','sap/base/util/deepEqual'],function(E,P,C,F,a,S,O,b,c,d,e,M,f,m,g){"use strict";var V=E.extend("sap.ui.mdc.ValueHelp",{metadata:{library:"sap.ui.mdc",properties:{conditions:{type:"object[]",defaultValue:[],byValue:true},delegate:{type:"object",group:"Data",defaultValue:{name:"sap/ui/mdc/ValueHelpDelegate"}},filterValue:{type:"string",defaultValue:""},validateInput:{type:"boolean",defaultValue:true},_config:{type:"object",defaultValue:{},visibility:"hidden"},_valid:{type:"boolean",group:"Appearance",defaultValue:true,visibility:"hidden"},_inConditions:{type:"object",defaultValue:{},byValue:true,visibility:"hidden"},_outParameters:{type:"string[]",defaultValue:[],byValue:true,visibility:"hidden"}},aggregations:{dialog:{type:"sap.ui.mdc.valuehelp.IDialogContainer",multiple:false},typeahead:{type:"sap.ui.mdc.valuehelp.ITypeaheadContainer",multiple:false},inParameters:{type:"sap.ui.mdc.field.InParameter",group:"Data",multiple:true},outParameters:{type:"sap.ui.mdc.field.OutParameter",group:"Data",multiple:true}},events:{select:{parameters:{conditions:{type:"object[]"},add:{type:"boolean"},close:{type:"boolean"}}},disconnect:{},closed:{},navigated:{parameters:{bLeaveFocus:{type:"boolean"},condition:{type:"object"},itemId:{type:"string"}}},switchToValueHelp:{}},defaultProperty:"filterValue"}});V.prototype.init=function(){E.prototype.init.apply(this,arguments);this._oObserver=new f(r.bind(this));this._oObserver.observe(this,{aggregations:["inParameters","outParameters","typeahead","dialog"]});this.setBindingContext(null);this._oConditions={};};V.prototype.exit=function(){if(this._oManagedObjectModel){this._oManagedObjectModel.destroy();delete this._oManagedObjectModel;}};V.prototype.invalidate=function(i){return;};V.prototype.connect=function(i,j){if(this._oControl&&this._oControl!==i){this.close();this.setFilterValue("");this.setConditions([]);this.fireDisconnect();}this._oControl=i;this.setProperty("_config",j,true);A.call(this);return this;};V.prototype.getControl=function(){return this._oControl;};V.prototype.getDomRef=function(){var T=this.getTypeahead();var i=this.getDialog();if(T&&(T.isOpen()||T.isOpening())){return T.getDomRef();}else if(i&&(i.isOpen()||i.isOpening())){return i.getDomRef();}};V.prototype.getAriaAttributes=function(i){var T=this.getTypeahead();var j=this.getDialog();if(!j&&T&&T.getUseAsValueHelp()){j=T;}var K=T&&T.isOpen();var L=j&&j.isOpen();var N=T&&T.getAriaAttributes(i);var Q=j&&j.getAriaAttributes(i);var R;var U;var W;var X;if(K){R=N.contentId;}else if(L){R=Q.contentId;}U=(T&&N.ariaHasPopup)||(j&&Q.ariaHasPopup);W=(T&&N.role)||(j&&Q.role);X=(T&&N.roleDescription)||(j&&Q.roleDescription);return{contentId:R,ariaHasPopup:U,role:W,roleDescription:X,valueHelpEnabled:!!j||!!T&&!!T.getUseAsValueHelp()};};V.prototype._retrieveDelegateContent=function(i){return this._retrievePromise("delegateContent--"+i.getId(),function(){var j=this._getControlDelegatePromise();return j.then(function(K){return K.retrieveContent(this.getPayload(),i);}.bind(this));}.bind(this));};V.prototype._getControlDelegatePromise=function(i){return this._retrievePromise("delegate",this.initControlDelegate.bind(this));};V.prototype.open=function(T){var i=T?this.getTypeahead():J.call(this);var j=T?this.getDialog():this.getTypeahead();if(j&&i!==j&&(j.isOpen()||j.isOpening())){j.close();}if(i&&!i.isOpen()&&!i.isOpening()){this._removePromise("delegateContent"+"--"+i.getId());i.open(this._retrieveDelegateContent(i,true));}};function _(i){var j=i.getParameter("container");this._removePromise("delegateContent"+"--"+j.getId());this._retrieveDelegateContent(j);}function h(i){this.fireSwitchToValueHelp();}V.prototype.close=function(){var T=this.getTypeahead();var i=this.getDialog();if(T&&T.isOpen()){T.close();}if(i&&i.isOpen()){i.close();}};V.prototype.toggleOpen=function(T){var i=this.getTypeahead();var j=this.getDialog();if(!T&&!j&&i&&i.getUseAsValueHelp()){j=i;}var K=i&&i.isOpen();var L=j&&j.isOpen();if((T&&K)||(!T&&L)){this.close();}else if((T&&i)||(!T&&j)){this.open(T);}};V.prototype.isOpen=function(){var T=this.getTypeahead();var i=this.getDialog();return(T&&T.isOpen())||(i&&i.isOpen());};V.prototype.skipOpening=function(){var T=this.getTypeahead();var i=this.getDialog();if(T&&T.isOpening()){T.close();}if(i&&i.isOpening()){i.close();}};V.prototype.initBeforeOpen=function(T){};V.prototype.isTypeaheadSupported=function(){var T=this.getTypeahead();if(T){return this._retrieveDelegateContent(T).then(function(){return!!T&&T.isTypeaheadSupported();});}else{return Promise.resolve(false);}};V.prototype.shouldOpenOnClick=function(){var i=J.call(this);if(i){return i.shouldOpenOnClick();}return false;};V.prototype.isFocusInHelp=function(){var i=J.call(this);return i&&i.isFocusInHelp();};V.prototype.removeFocus=function(){var T=this.getTypeahead();if(T){T.removeFocus();}};V.prototype.navigate=function(i){var T=this.getTypeahead();if(T){var j=function(){if(T.shouldOpenOnNavigate()&&!T.isOpening()&&!T.isOpen()){return T.open(true).then(function(){T.navigate(i);});}return T.navigate(i);};var N=this._retrievePromise("navigate");var K=N&&!N.isSettled()&&N.getInternalPromise();this._addPromise("navigate",K?K.then(j):this._retrieveDelegateContent(T).then(j));}};V.prototype.getTextForKey=function(K,i,j,L,N,Q){return this.getItemForValue({parsedValue:K,value:K,inParameters:i,outParameters:j,bindingContext:L,conditionModel:N,conditionModelName:Q,checkKey:true,exception:d,caseSensitive:true});};V.prototype.getKeyForText=function(T,i){return this.getItemForValue({value:T,inParameters:i,checkDescription:true,exception:e,caseSensitive:true});};V.prototype.getItemForValue=function(i){var T=this.getTypeahead();if(T){var j=["getItemForValue",i.parsedValue||i.value,JSON.stringify(i.oInParameters),i.oBindingContext&&i.oBindingContext.getPath()];var K=j.join("_");return this._retrievePromise(K,function(){return this._retrieveDelegateContent(T).then(function(){var L=B.call(this,this.getInParameters(),i.bindingContext,i.conditionModel,i.conditionModelName);return G.call(this,L).then(function(){i.inParameters=H.call(this,i.inParameters,this.getInParameters(),L,i.bindingContext);i.outParameters=null;i.caseSensitive=i.hasOwnProperty("caseSensitive")?i.caseSensitive:false;return T.getItemForValue(i).then(function(N){D.call(this,L);if(N){if(N.inParameters){N.inParameters=y.call(this,N.inParameters,this.getInParameters());}if(N.outParameters){N.outParameters=y.call(this,N.outParameters,this.getOutParameters());}}return N;}.bind(this));}.bind(this));}.bind(this));}.bind(this));}else{return Promise.reject("No Typeahead");}};V.prototype.isValidationSupported=function(){var T=this.getTypeahead();return T&&T.isValidationSupported();};V.prototype.onControlChange=function(){if(this.bIsDestroyed){return;}var K=this.getOutParameters();A.call(this);var L=B.call(this,K);G.call(this,L).then(function(){var N=this.getConditions();for(var j=0;j<K.length;j++){var Q=K[j];var R=Q.getValue();var U=Q.getUseConditions();var T=true;if(Q.getMode()===O.WhenEmpty){if(U){T=!R||(Array.isArray(R)&&R.length===0);}else{T=!R;}}if(T){var W;var X;if(U){if(!Array.isArray(R)){throw new Error("Value on OutParameter must be an array "+Q);}W=m([],R);}else{W=R;}if(!Q.getHelpPath()){if(U){X=C.createCondition("EQ",[Q.getFixedValue()],undefined,undefined,b.Validated);if(F.indexOfCondition(X,W)<0){W.push(X);}}else{W=Q.getFixedValue();}}else{for(var i=0;i<N.length;i++){var Y=N[i];if(Y.outParameters){for(var Z in Y.outParameters){if(Q.getFieldPath()===Z){if(U){X=C.createCondition("EQ",[Y.outParameters[Z]],undefined,undefined,b.Validated);if(F.indexOfCondition(X,W)<0){W.push(X);}}else{W=Y.outParameters[Z];}}}}}}if(U){F.checkConditionsEmpty(W);}Q.setValue(W);}}}.bind(this));};V.prototype.getIcon=function(){var T=this.getTypeahead();var i=this.getDialog();if(i){return i.getValueHelpIcon();}else if(T){return T.getValueHelpIcon();}};V.prototype.getMaxConditions=function(){var i=this.getProperty("_config");return(i&&i.maxConditions)||-1;};V.prototype.getDisplay=function(){};V.prototype.getDataType=function(){};V.prototype.valueHelpEnabled=function(){var T=this.getTypeahead();var i=this.getDialog();if(i){return true;}else{return T&&T.getUseAsValueHelp();}};function k(i){var j=z.call(this,i.getParameter("condition"));this.fireNavigated({condition:j,itemId:i.getParameter("itemId"),leaveFocus:i.getParameter("leaveFocus")});}function l(K){var L=this.getMaxConditions()===1;var T=K.getParameter("type");var N=K.getParameter("conditions")||[];var Q;if(L){N=N.slice(0,1);}if(T===S.Set||T===S.Add){Q=T===S.Set||L?[]:this.getConditions();for(var i=0;i<N.length;i++){var R=z.call(this,N[i]);Q.push(R);}}else if(T===S.Remove){Q=L?[]:this.getConditions();for(var j=0;j<N.length;j++){var U=z.call(this,N[j]);var W=F.indexOfCondition(U,Q);if(W>=0){Q.splice(W,1);}}}if(Q){this.setProperty("conditions",Q,true);}}function n(i){if(this.getProperty("_valid")){var j=this.getMaxConditions()===1;var K=i.getParameter("close");var L=typeof K!=='undefined'?K:j;var N=this.getConditions();var Q=!j&&!i.getSource().isMultiSelect();if(L){this.close();}N=C._removeEmptyConditions(N);N=C._removeInitialFlags(N);F.updateConditionsValues(N);this.fireSelect({conditions:N,add:Q,close:L});}}function o(i){this.close();}function p(i){}function q(i){var j=i.getSource();this._removePromise("delegateContent--"+j.getId());this._removePromise("navigate");this.fireClosed();}function r(i){if(["typeahead","dialog"].indexOf(i.name)!==-1){var j=i.child;var K=i.mutation==="insert";var L=K?j.attachEvent.bind(j):j.detachEvent.bind(j);L("select",l,this);L("requestDelegateContent",_,this);L("confirm",n,this);L("cancel",o,this);L("opened",p,this);L("closed",q,this);if(j.attachRequestSwitchToDialog){L("requestSwitchToDialog",h,this);}if(j.attachNavigated){L("navigated",k,this);}if(K){if(!this._oManagedObjectModel){this._oManagedObjectModel=new M(this);}j.setModel(this._oManagedObjectModel,"$valueHelp");}}if(i.object==this){if(i.name==="inParameters"){s.call(this,i.child,i.mutation);}if(i.name==="outParameters"){v.call(this,i.child,i.mutation);}}else if(i.object.isA("sap.ui.mdc.field.OutParameter")){if(i.name==="helpPath"){w.call(this,i.current,i.old);}}else if(i.object.isA("sap.ui.mdc.field.InParameter")){if(i.name==="value"){t.call(this,i.object.getHelpPath(),i.current,i.object.getUseConditions(),i.object.getInitialValueFilterEmpty());}if(i.name==="helpPath"){u.call(this,i.current,i.old,i.object.getValue(),i.object.getUseConditions(),i.object.getInitialValueFilterEmpty());}}}function s(i,j){var K=i.getHelpPath();if(j==="remove"){this._oObserver.unobserve(i);var L=this.getProperty("_inConditions");delete L[K];this.setProperty("_inConditions",L,true);}else{this._oObserver.observe(i,{properties:["value","helpPath"]});t.call(this,K,i.getValue(),i.getUseConditions(),i.getInitialValueFilterEmpty());}}function t(j,K,U,L){var N=this.getProperty("_inConditions");var Q;N[j]=[];if(U){if(Array.isArray(K)){for(var i=0;i<K.length;i++){Q=m({},K[i]);if(Q.inParameters){Q.inParameters=x.call(this,Q.inParameters,this.getInParameters());}if(Q.outParameters){Q.outParameters=x.call(this,Q.outParameters,this.getOutParameters());}N[j].push(Q);}}}else{if(!K&&L){Q=C.createCondition("Empty",[]);Q.isEmpty=false;}else if(K!==null){Q=C.createItemCondition(K);Q.validated=b.Validated;}if(Q){N[j].push(Q);}}this.setProperty("_inConditions",N,true);}function u(i,j,K,U,L){var N=this.getProperty("_inConditions");delete N[j];this.setProperty("_inConditions",N,true);t.call(this,i,K,U,L);}function v(i,j){var K=i.getHelpPath();var L=this.getProperty("_outParameters");var N=L.indexOf(K);if(j==="remove"){this._oObserver.unobserve(i);if(N>-1){L.splice(N,1);}}else{this._oObserver.observe(i,{properties:["helpPath"]});if(N===-1){L.push(K);}}this.setProperty("_outParameters",L,true);}function w(i,j){var K=this.getProperty("_outParameters");var L=K.indexOf(j);if(L>-1){K[L]=i;}this.setProperty("_outParameters",K,true);}function x(j,K){var L;if(K.length>0){for(var N in j){for(var i=0;i<K.length;i++){var Q=K[i];var R="conditions/"+Q.getHelpPath();var T=Q.getFieldPath();if(T&&(T===N||T==="conditions/"+N)&&R){if(!L){L={};}L[R]=j[N];}}}}return L;}function y(j,K){if(!j||K.length===0){return null;}var L={};for(var i=0;i<K.length;i++){var N=K[i];var Q=N.getHelpPath();var R=N.getFieldPath();if(Q&&R){for(var T in j){if([Q,R].indexOf(T)>=0){L[R]=j[T];break;}}}else if(!Q&&R&&N.getFixedValue){L[R]=N.getFixedValue();}}return L;}function z(i){i=m({},i);if(i.inParameters){i.inParameters=y.call(this,i.inParameters,this.getInParameters());}if(i.outParameters){i.outParameters=y.call(this,i.outParameters,this.getOutParameters());}return i;}function A(){var i=this._oControl?this._oControl.getBindingContext():null;this.setBindingContext(i);var j=this.getProperty("_config");if(j&&j.conditionModel&&this.getModel(j.conditionModelName)!==j.conditionModel){this.setModel(j.conditionModel,j.conditionModelName);}}function B(j,K,L,N){var Q=[];var R=false;var T;if(K){T=this.oBindingContexts[undefined];if(K&&c.hasChanged(T,K)){R=true;}}for(var i=0;i<j.length;i++){var U=j[i];var W=U.getBinding("value");if(U.getUseConditions()&&L){var X=this.getModel(N);if(X!==L){W=L.bindProperty("/"+U.getFieldPath());W._bValueHelp=true;Q.push(W);}}else if(W){var Y=W.getPath();var Z=W.getContext();if(R&&W.isRelative()&&(Z===T||(!Z&&T))){if(K.getProperty(Y)===undefined){var $=W.getModel();W=$.bindProperty(Y,K);W._bValueHelp=true;Q.push(W);}}else if((!Z&&W.isRelative())||(Z&&Z.getProperty(Y)===undefined)||W.getValue()===undefined||(Z&&!g(U.validateProperty("value",Z.getProperty(Y)),U.getValue()))){Q.push(W);}}}return Q;}function D(j){for(var i=0;i<j.length;i++){if(j[i]._bValueHelp){j[i].destroy();}}}function G(i){var j=this._getControlDelegatePromise();return j.then(function(K){if(i.length===0){return null;}return K.checkBindingsPending(this.getPayload(),i);}.bind(this));}function H(K,L,N,Q){if(L.length===0){return null;}var R={};var T;var U;var W;var X;var i=0;if(K){for(var Y in K){for(i=0;i<L.length;i++){U=L[i];W=U.getHelpPath();X=U.getFieldPath();if(X&&W&&(X===Y||X==="conditions/"+Y)){R[W]=[];T=C.createItemCondition(K[Y]);T.validated=b.Validated;R[W].push(T);}}}}else{var Z=this.getBindingContext();for(i=0;i<L.length;i++){U=L[i];W=U.getHelpPath();if(W){var $=U.getValue();var a1=U.getUseConditions();var b1=U.getInitialValueFilterEmpty();var j=0;if((N&&N.length>0)||Q){var c1=U.getBinding("value");var d1=false;if(c1||a1){X=U.getFieldPath();for(j=0;j<N.length;j++){if((c1&&c1.getPath()===N[j].getPath())||(a1&&N[j].getPath()==="/"+X)){$=N[j].getValue();d1=true;break;}}if(!d1&&!a1&&Q&&c1&&c1.isRelative()&&(!c1.getContext()||(c1.getContext()!==Q&&c1.getContext()===Z))){$=Q.getProperty(c1.getPath());}}}R[W]=[];if(a1){for(j=0;j<$.length;j++){T=m({},$[j]);if(T.inParameters){T.inParameters=x.call(this,T.inParameters,this.getInParameters());}if(T.outParameters){T.outParameters=x.call(this,T.outParameters,this.getOutParameters());}R[W].push(T);}}else{if(!$&&b1){T=C.createCondition("Empty",[]);T.isEmpty=false;}else if($){T=C.createItemCondition($);T.validated=b.Validated;}if(T){R[W].push(T);}}T=undefined;}}}var e1=I.call(this,R);var f1=a.createFilters(R,e1);return f1;}function I(j){var K=this.getInParameters();var L={};var N;for(N in j){var T;for(var i=0;i<K.length;i++){var Q=K[i];if(Q.getHelpPath()===N){T=Q.getDataType();break;}}L[N]={type:T};}return L;}function J(){var i=this.getDialog();if(!i){var T=this.getTypeahead();if(T&&T.getUseAsValueHelp()){i=T;}}return i;}P.call(V.prototype);return V;});
