/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/m/OverflowToolbarButton","sap/m/ButtonRenderer","sap/ui/base/ManagedObjectObserver","sap/ui/core/library","sap/m/PlacementType"],function(O,B,M,C,P){"use strict";var H=C.aria.HasPopup;var R,L,a,S,b,I,D,r;var c=O.extend("sap.ui.mdc.chart.ChartTypeButton",{metadata:{library:"sap.ui.mdc"},constructor:function(m){if(!m){O.apply(this);return;}this.oMDCChartModel=m.getManagedObjectModel();var s={type:"Transparent",press:function(e){this.displayChartTypes(e.getSource(),m);}.bind(this),id:m.getId()+"-btnChartType",icon:'{$chart>/getChartTypeInfo/icon}',tooltip:'{$chart>/getChartTypeInfo/text}',text:'{$chart>/getChartTypeInfo/text}',ariaHasPopup:H.ListBox};this.oMDCChart=m;O.apply(this,[s]);this.setModel(this.oMDCChartModel,"$chart");this._oObserver=new M(function(){this.oMDCChartModel.checkUpdate(true);}.bind(this));this._oObserver.observe(this.oMDCChart,{aggregations:["items"],properties:["chartType"]});},renderer:B});c.mMatchingIcon={"bar":"sap-icon://horizontal-bar-chart","bullet":"sap-icon://horizontal-bullet-chart","bubble":"sap-icon://bubble-chart","column":"sap-icon://vertical-bar-chart","combination":"sap-icon://business-objects-experience","dual_bar":"sap-icon://horizontal-bar-chart","dual_column":"sap-icon://vertical-bar-chart","dual_combination":"sap-icon://business-objects-experience","dual_horizontal_combination":"sap-icon://business-objects-experience","dual_horizontal_stacked_combination":"sap-icon://business-objects-experience","dual_line":"sap-icon://line-chart","dual_stacked_bar":"sap-icon://full-stacked-chart","dual_stacked_column":"sap-icon://vertical-stacked-chart","dual_stacked_combination":"sap-icon://business-objects-experience","donut":"sap-icon://donut-chart","heatmap":"sap-icon://heatmap-chart","horizontal_stacked_combination":"sap-icon://business-objects-experience","line":"sap-icon://line-chart","pie":"sap-icon://pie-chart","scatter":"sap-icon://scatter-chart","stacked_bar":"sap-icon://full-stacked-chart","stacked_column":"sap-icon://vertical-stacked-chart","stacked_combination":"sap-icon://business-objects-experience","treemap":"sap-icon://Chart-Tree-Map","vertical_bullet":"sap-icon://vertical-bullet-chart","100_dual_stacked_bar":"sap-icon://full-stacked-chart","100_dual_stacked_column":"sap-icon://vertical-stacked-chart","100_stacked_bar":"sap-icon://full-stacked-chart","100_stacked_column":"sap-icon://full-stacked-column-chart","waterfall":"sap-icon://vertical-waterfall-chart","horizontal_waterfall":"sap-icon://horizontal-waterfall-chart"};c.prototype.displayChartTypes=function(o,m){if(!m||!o){return;}if(!this.oReadyPromise){this.oReadyPromise=new Promise(function(d){if(R){d(true);}else{sap.ui.require(["sap/m/ResponsivePopover","sap/m/List","sap/m/Bar","sap/m/SearchField","sap/m/StandardListItem","sap/ui/core/InvisibleText","sap/ui/Device"],function(e,f,g,h,i,j,k){R=e;L=f;a=g;S=h;b=i;I=j;D=k;if(!r){sap.ui.getCore().getLibraryResourceBundle("sap.ui.mdc",true).then(function(l){r=l;d(true);});}else{d(true);}});}});}this.oReadyPromise.then(function(){this.oPopover=this._createPopover(o,m);this.oPopover.attachAfterClose(function(){this.oPopover.destroy();}.bind(this));return this.oPopover.openBy(o);}.bind(this));};c.prototype._createPopover=function(o,m){var i=new b({title:"{$chart>text}",icon:"{$chart>icon}",selected:"{$chart>selected}"});var l=new L({mode:"SingleSelectMaster",items:{path:"$chart>/getAvailableChartTypes",template:i},selectionChange:function(E){if(E&&E.mParameters&&E.mParameters.listItem){var f=E.mParameters.listItem.getBinding("title");if(f){var g=f.getContext();if(g){var h=g.getObject();if(h&&h.key){sap.ui.require(["sap/ui/mdc/p13n/FlexUtil","sap/ui/mdc/flexibility/Chart.flexibility"],function(F,j){var k=[];k.push(j["setChartType"].changeHandler.createChange({control:m,chartType:h.key}));F.handleChanges(k);});}}}}p.close();}});var s=new a();var d=new S({placeholder:r.getText("chart.CHART_TYPE_SEARCH")});d.attachLiveChange(function(E){if(m){this._triggerSearchInPopover(E,l);}}.bind(this));s.addContentRight(d);var p=new R({id:m.getId()+"-btnChartTypePopover",placement:P.VerticalPreferredBottom,subHeader:s,contentWidth:"25rem"});p.setModel(this.oMDCChartModel,"$chart");if(D.system.desktop){var e=new I({text:r.getText("chart.CHART_TYPELIST_TEXT")});p.setShowHeader(false);p.addContent(e);p.addAriaLabelledBy(e);}else{p.setTitle(r.getText("chart.CHART_TYPELIST_TEXT"));}p.addContent(l);if(l.getItems().length<7){s.setVisible(false);}return p;};c.prototype._triggerSearchInPopover=function(e,l){var p,i,t,T,v,d;if(!e||!l){return;}p=e.getParameters();if(!p){return;}v=p.newValue?p.newValue.toLowerCase():"";d=l.getItems();for(i=0;i<d.length;i++){T=d[i].getTooltip();t=d[i].getTitle();if((t&&(t.toLowerCase().indexOf(v)>-1))||(T&&(T.toLowerCase().indexOf(v)>-1))){d[i].setVisible(true);}else{d[i].setVisible(false);}}};c.prototype.exit=function(){O.prototype.exit.apply(this,arguments);if(this.oPopover){this.oPopover.destroy();this.oPopover=null;}};return c;});
