/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/mdc/field/FieldValueHelpContentWrapperBase','sap/ui/model/ChangeReason','sap/ui/model/Filter','sap/ui/model/FormatException','sap/ui/model/ParseException','sap/ui/model/FilterType','sap/ui/model/FilterOperator','sap/ui/model/FilterProcessor','sap/ui/base/ManagedObjectObserver','sap/base/strings/capitalize','sap/m/library','sap/base/util/deepEqual','sap/base/Log','sap/ui/base/SyncPromise'],function(F,C,a,b,P,c,d,e,M,f,l,g,L,S){"use strict";var h=F.extend("sap.ui.mdc.field.FieldValueHelpTableWrapperBase",{metadata:{library:"sap.ui.mdc",aggregations:{table:{type:"sap.ui.core.Control",multiple:false}},defaultAggregation:"table"}});h.prototype.init=function(){F.prototype.init.apply(this,arguments);this._oObserver=new M(this._observeChanges.bind(this));this._oObserver.observe(this,{properties:["selectedItems"],aggregations:["table"]});this._bTableResolved=false;this._oTablePromise=new Promise(function(r){this._oTablePromiseResolve=r;}.bind(this));this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.ui.mdc");this._oPromises={};this._oTableDelegate={onsapprevious:this._handleTableEvent,onsapnext:this._handleTableEvent,cellClick:this._handleTableEvent};};h.prototype.exit=function(){this._sTableWidth=null;this._oObserver.disconnect();this._oObserver=undefined;if(this._oTableModificationPromise){this._oTableModificationPromise=null;}delete this._oTablePromise;delete this._oTablePromiseResolve;delete this._bTableResolved;F.prototype.exit.apply(this,arguments);};h.prototype.invalidate=function(O){if(O){var t=this._getWrappedTable();if(t&&O===t){if(O.bOutput&&!this._bIsBeingDestroyed){var i=this.getParent();if(i){i.invalidate(this);}}return;}}F.prototype.invalidate.apply(this,arguments);};h.prototype.getDialogContent=function(){return this._getWrappedTable();};h.prototype.getSuggestionContent=function(){return this._getWrappedTable();};h.prototype.fieldHelpOpen=function(s){F.prototype.fieldHelpOpen.apply(this,arguments);var t=this._getWrappedTable();if(t){this._adjustTable(s);this._updateSelectedItems();}return this;};h.prototype.fieldHelpClose=function(){F.prototype.fieldHelpClose.apply(this,arguments);var t=this._getWrappedTable();if(t){t.removeStyleClass("sapMListFocus");}return this;};h.prototype.removeFocus=function(){F.prototype.removeFocus.apply(this,arguments);var t=this._getWrappedTable();if(t){t.removeStyleClass("sapMListFocus");}return this;};h.prototype.navigate=function(s,i){var t=this._getWrappedTable();if(!this._isTableReady(t)){if(t&&!this._bTableResolved&&!this._bNavigationDelayed){this._bNavigationDelayed=true;this._oTablePromise.then(function(){this.fireNavigate({disableFocus:true});this._bNavigationDelayed=false;}.bind(this));}this._bNavigate=true;this._iStep=s;return;}var j=this.getSelectedItems();var k=j&&j[0];var T=k&&this._getTableItemByKey(k.key);if(this._getMaxConditions()!==1){this._bShouldRebind=false;this.fireNavigate();t.focus();return;}t.addStyleClass("sapMListFocus");var I=this._getTableItems();var q=I.length;var r=0;var u=false;if(T){r=I.indexOf(T);r=r+s;}else if(s>=0){r=s-1;}else{r=q+s;}var v;if(r<0){r=0;v=true;u=true;}else if(r>=q-1){r=q-1;v=false;}else{v=s>=0;}while(I[r]&&I[r].isA("sap.m.GroupHeaderListItem")){if(v){r++;}else{r--;}}var w=I[r];if(w){var V=this._getDataFromItem(w);var x=w===T;if(!x){this._modifyTableSelection(I,w,true,undefined,true);}S.resolve(this._handleScrolling(w)).then(function(y){var R=w.getId&&w.getId();if(x){if(!this.getParent().isOpen()){this.fireNavigate({key:V.key,description:V.description,inParameters:V.inParameters,outParameters:V.outParameters,itemId:R,leave:u});}else if(u){this.fireNavigate({key:undefined,value:undefined,condition:undefined,itemId:undefined,leave:u});}return;}this._bNoTableUpdate=true;this.setSelectedItems([{key:V.key,description:V.description,inParameters:V.inParameters,outParameters:V.outParameters}]);this._bNoTableUpdate=false;if(!R&&w.isA("sap.ui.model.Context")){var z=this._getTableItems(false,true).find(function(A){return A.getBindingContext()===w;});R=z&&z.getId();}if(R){this.fireNavigate({key:V.key,description:V.description,inParameters:V.inParameters,outParameters:V.outParameters,itemId:R,leave:u});}else{this.fireNavigate({disableFocus:true});}}.bind(this));}};h.prototype.getTextForKey=function(k,i,O,N,j){return _.call(this,[k],["key"],i,O,N,j);};h.prototype.getKeyForText=function(t,i,N,j){return _.call(this,[t],["description"],i,undefined,N,j);};h.prototype.getKeyAndText=function(k,t,i,O,j){return _.call(this,[k,t],["key","description"],i,O,false,j);};function _(v,i,I,O,N,j){if((v[0]===null||v[0]===undefined||(i[0]==="description"&&v[0]===""))&&(v.length===1||!v[1])){return null;}return p.call(this).then(function(r){var E=i.length>1||i[0]==="description"?P:b;var G=[i[0]==="description"?this._getDescriptionPath:this._getKeyPath];if(i.length>1){G.push(i[1]==="description"?this._getDescriptionPath:this._getKeyPath);}if(r&&this._getKeyPath()){var k=this._getTableItems();var R=m.call(this,v,k,G,I,O,E,j);if(R){return R;}}if(N){throw new E(this._oResourceBundle.getText("valuehelp.VALUE_NOT_EXIST",[v[0]]));}else{return this.loadData(G,v,I,O,E,j);}}.bind(this)).unwrap();}function m(v,I,G,j,O,E,k){var i=0;var q=[];for(i=0;i<G.length;i++){q.push(G[i].call(this));if(!q[i]){throw new Error("path for filter missing");}}var r=function(w,x){var B=w.isA("sap.ui.model.Context")?w:w.getBindingContext();return B.getProperty(x);};var s;var t=[];for(i=0;i<v.length;i++){t.push(new a({path:q[i],operator:d.EQ,value1:v[i],caseSensitive:k}));}if(t.length===1){s=t[0];}else{s=new a({filters:t,and:false});}if(j||O){t=[s];if(j){t.push(j);}if(O){t.push(O);}s=new a({filters:t,and:true});}var u=e.apply(I,s,r);if(u.length===1){var V=this._getDataFromItem(u[0]);return{key:V.key,description:V.description,inParameters:V.inParameters,outParameters:V.outParameters};}else if(u.length>1){if(!k){return m.call(this,v,I,G,j,O,E,true);}throw n.call(this,E,true,v[0]);}}h.prototype.loadData=function(G,v,I,O,E,k){var s="";var i=0;for(i=0;i<G.length;i++){s=s+G[i].call(this);}if(this._oPromises[s]&&this._oPromises[s][v[0]]){return this._oPromises[s][v[0]];}if(!this._oPromises[s]){this._oPromises[s]={};}this._oPromises[s][v[0]]=new Promise(function(r,R){this._oTablePromise.then(function(t){var q=s;s="";for(i=0;i<G.length;i++){s=s+G[i].call(this);}if(!s){R(new Error("missing FieldPath"));return;}if(s!==q){if(!this._oPromises[s]){this._oPromises[s]={};}this._oPromises[s][v[0]]=this._oPromises[q][v[0]];delete this._oPromises[q][v[0]];}var u=this.getListBinding();var w=u.getModel();var x=u.getPath();var y;var B=u.getContext();var z=[];for(i=0;i<G.length;i++){z.push(new a({path:G[i].call(this),operator:d.EQ,value1:v[i],caseSensitive:k}));}if(z.length===1){y=z[0];}else{y=new a({filters:z,and:false});}z=[];if(I){z.push(I);}if(O){if(I){var A=O.aFilters?O.aFilters:[O];var D=I.aFilters?I.aFilters:[I];for(i=0;i<A.length;i++){var H=A[i];var J=false;for(var j=0;j<D.length;j++){var K=D[j];if(K.sPath===H.sPath&&K.oValue1===H.oValue1&&K.oValue2===H.oValue2){J=true;break;}}if(!J){z.push(H);}}}else{z.push(O);}}if(z.length>0){z.push(y);y=new a({filters:z,and:true});}try{var N=w.bindList(x,B);var Q=function(){var V=N.getContexts();if(V.length===1){var W=this._getDataFromContext(V[0]);var X={key:W.key,description:W.description,inParameters:W.inParameters,outParameters:W.outParameters};r(X);}else if(v[0]===""&&V.length===0){r(null);}else{var Y=n.call(this,E,V.length>1,v[0]);R(Y);}setTimeout(function(){N.destroy();},0);delete this._oPromises[s][v[0]];};var T=this._getDelegate();if(T.delegate){T.delegate.executeFilter(T.payload,N,y,Q.bind(this),2);}}catch(U){R(U);}}.bind(this));}.bind(this));return this._oPromises[s][v[0]];};function n(E,N,v){var s;if(N){s=this._oResourceBundle.getText("valuehelp.VALUE_NOT_UNIQUE",[v]);}else{s=this._oResourceBundle.getText("valuehelp.VALUE_NOT_EXIST",[v]);}var i=new E(s);i._bNotUnique=N;return i;}h.prototype.getAsyncKeyText=function(){return true;};h.prototype.applyFilters=function(i,s,j){var k=this.getListBinding();var D=this._getDelegate();if(!k){this._oTablePromise.then(function(t){if(!this._bIsBeingDestroyed){this.applyFilters(i,s,j);}}.bind(this));return;}var u=true;var q;try{q=k.getFilterInfo();}catch(r){L.info("ValueHelp-Filter: getFilterInfo threw error");}if(!i){i=[];}if(i.length===0&&!q){u=false;}if(D.delegate&&D.delegate.isSearchSupported(D.payload,k)){if(!k.isSuspended()&&u){k.suspend();}s=D.delegate.adjustSearch(D.payload,this._bSuggestion,s);D.delegate.executeSearch(D.payload,k,s);L.info("ValueHelp-Search: "+s);}if(u){k.filter(i,c.Application);L.info("ValueHelp-Filter: "+o.call(this,i));}if(k.isSuspended()){k.resume();}};h.prototype.isSuspended=function(){var i=this.getListBinding();if(!i){return true;}return i.isSuspended();};function o(i){var r;if(!i){return"";}if(Array.isArray(i)){r="";i.forEach(function(i,I,j){r+=o.call(this,i);if(j.length-1!=I){r+=" or ";}},this);return"("+r+")";}else if(i._bMultiFilter){r="";var A=i.bAnd;i.aFilters.forEach(function(i,I,j){r+=o.call(this,i);if(j.length-1!=I){r+=A?" and ":" or ";}},this);return"("+r+")";}else{r=i.sPath+" "+i.sOperator+" '"+i.oValue1+"'";if(i.sOperator==="BT"){r+="...'"+i.oValue2+"'";}return r;}}h.prototype.clone=function(i,j){this._handleEvents();var k=F.prototype.clone.apply(this,arguments);this._handleEvents(true);return k;};h.prototype._observeChanges=function(i){if(i.name==="table"){this._handleTableChanged.call(this,i.mutation,i.child);}if(i.name==="selectedItems"){this._updateSelectedItems.call(this);}};h.prototype._handleTableChanged=function(s,t){if(s==="remove"){this._handleEvents();t.removeDelegate(this._oTableDelegate);t.removeStyleClass("sapMComboBoxList");t=undefined;this._oTablePromise=new Promise(function(r){this._oTablePromiseResolve=function(){r();this._bTableResolved=true;};}.bind(this));}else{this._handleEvents(true);t.addDelegate(this._oTableDelegate,true,this);this._updateSelectedItems();if(this._bNavigate){this._bNavigate=false;this.navigate(this._iStep);}t.addStyleClass("sapMComboBoxList");}this.fireDataUpdate({contentChange:true});};h.prototype._handleModelContextChange=function(E){var t=this._getWrappedTable();if(this.getListBinding()){this._oTablePromiseResolve(t);}};h.prototype._adjustTable=function(s){var t=this.getTable();if(t&&this.getParent()){if(s){if(this._sTableWidth){t.setWidth(this._sTableWidth);}}else if(t.getWidth()!=="100%"){this._sTableWidth=t.getWidth();t.setWidth("100%");}}};h.prototype._fireSelectionChange=function(I){var q=[];var t=this._getWrappedTable();if(t){var s=this.getSelectedItems();var T;var v;if(s.length>0){var r=this._getTableItems();for(var k in r){T=r[k];v=this._getDataFromItem(T);if(!v){throw new Error("Key of item cannot be determined"+this);}for(var j=s.length-1;j>=0;j--){var u=s[j];if(u.key===v.key&&(!v.inParameters||!u.inParameters||g(u.inParameters,v.inParameters))&&(!v.outParameters||!u.outParameters||g(u.outParameters,v.outParameters))){s.splice(j,1);break;}}if(!s.length){break;}}}if(s.length>0){q=s;}s=this._getTableItems(true);for(var i=0;i<s.length;i++){T=s[i];v=this._getDataFromItem(T);if(!v){throw new Error("Key of item cannot be determined"+this);}q.push({key:v.key,description:v.description,inParameters:v.inParameters,outParameters:v.outParameters});}}this._bNoTableUpdate=true;this.setSelectedItems(q);this._bNoTableUpdate=false;this.fireSelectionChange({selectedItems:q,itemPress:I});};h.prototype._handleUpdateFinished=function(E){if(!this.getParent()){return;}this._updateSelectedItems.call(this);if(this._bNavigate){this._bNavigate=false;this.navigate(this._iStep);}if(E.getParameter("reason")!==f(C.Filter)){this.fireDataUpdate({contentChange:false});}};h.prototype._handleBusyStateChanged=function(E){this._bBusy=E.getParameter("busy");};h.prototype._updateSelectedItems=function(){if(this._bNoTableUpdate){return;}var t=[];var T=this._getWrappedTable();if(this._isTableReady(T)&&this._getKeyPath()){var s=this.getSelectedItems();var k=this._getTableItems();var u=false;this._bIsModifyingTableSelection=true;for(var j=0;j<k.length;j++){var q=k[j];if(q){var r=false;if(s.length>0){var v=this._getDataFromItem(q);for(var i=0;i<s.length;i++){var w=s[i];if(v.key===w.key&&(!v.inParameters||!w.inParameters||g(w.inParameters,v.inParameters))&&(!v.outParameters||!w.outParameters||g(w.outParameters,v.outParameters))){r=true;if(v.description!==w.description){w.description=v.description;u=true;}break;}}}t.push(this._modifyTableSelection(k,q,r,j));}}if(u){this._bNoTableUpdate=true;this.setSelectedItems(s);this._bNoTableUpdate=false;}this._oTableModificationPromise=Promise.all(t).then(function(){this._bIsModifyingTableSelection=false;}.bind(this));}};h.prototype._getDataFromItem=function(i,I,O){var B=i.isA("sap.ui.model.Context")?i:i.getBindingContext();return B&&this._getDataFromContext.call(this,B,I,O);};h.prototype._getDataFromContext=function(B,I,O){var k=this._getKeyPath();var D=this._getDescriptionPath();var K;var s;if(!k){throw new Error("KeyPath missing");}if(!I){I=this._getInParameters();}if(!O){O=this._getOutParameters();}var j=I.length>0?{}:null;var q=O.length>0?{}:null;var r;if(B){K=k?B.getProperty(k):undefined;s=D?B.getProperty(D):undefined;var i=0;for(i=0;i<I.length;i++){r=I[i];j[r]=B.getProperty(r);}for(i=0;i<O.length;i++){r=O[i];q[r]=B.getProperty(r);}}if(K===null||K===undefined){return false;}return{key:K,description:s,inParameters:j,outParameters:q};};h.prototype._isTableReady=function(){var t=this._getWrappedTable();var i=t&&this.getListBinding();if(!t||!i){return false;}if(i&&(i.isSuspended()||i.getLength()===0)){return false;}return true;};function p(){return S.resolve().then(function(){var i=this.getListBinding();var j=this._getListBindingInfo();var D=this._getDelegate();if(i&&D.delegate){return D.delegate.checkListBindingPending(D.payload,i,j);}else{return false;}}.bind(this)).catch(function(E){throw E;});}h.prototype._handleItemPress=function(E){};h.prototype._handleSelectionChange=function(E,i){};h.prototype._getTableItems=function(s,N){return[];};h.prototype._getTableItemByKey=function(k,N){var i=this._getTableItems(undefined,N);return i&&i.find(function(I){var D=this._getDataFromItem(I);return D.key===k;}.bind(this));};h.prototype._handleTableEvent=function(E){};h.prototype._modifyTableSelection=function(i,I,s,j,k){};h.prototype._getWrappedTable=function(){return this.getTable();};h.prototype._handleEvents=function(A){};h.prototype._handleScrolling=function(i){};h.prototype.getListBinding=function(){};h.prototype._getListBindingInfo=function(){};return h;});
