/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/mdc/field/FieldHelpBase','sap/ui/mdc/condition/Condition','sap/ui/mdc/enum/ConditionValidated','sap/ui/model/FormatException','sap/ui/model/ParseException','sap/ui/model/base/ManagedObjectModel','sap/ui/base/ManagedObjectObserver','sap/ui/mdc/library'],function(F,C,a,b,P,M,c,l){"use strict";var L;var D;var m;var d;var S;var e=F.extend("sap.ui.mdc.field.ListFieldHelp",{metadata:{library:"sap.ui.mdc",properties:{filterList:{type:"boolean",group:"Appearance",defaultValue:true},useFirstMatch:{type:"boolean",group:"Behavior",defaultValue:false}},aggregations:{items:{type:"sap.ui.core.ListItem",multiple:true,singularName:"item"}},defaultAggregation:"items"}});e._init=function(){F._init.apply(this,arguments);L=undefined;D=undefined;m=undefined;d=undefined;};e.prototype.init=function(){F.prototype.init.apply(this,arguments);this._oManagedObjectModel=new M(this);this._oObserver=new c(h.bind(this));this._oObserver.observe(this,{properties:["filterValue","conditions"],aggregations:["items"],bindings:["items"]});this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.ui.mdc");};e.prototype.exit=function(){F.prototype.exit.apply(this,arguments);this._oManagedObjectModel.destroy();delete this._oManagedObjectModel;this._oObserver.disconnect();this._oObserver=undefined;if(this._iDataUpdateTimer){clearTimeout(this._iDataUpdateTimer);this._iDataUpdateTimer=null;}};e.prototype._createPopover=function(){var i=F.prototype._createPopover.apply(this,arguments);if((!L||!D||!m)&&!this._bListRequested){L=sap.ui.require("sap/m/List");D=sap.ui.require("sap/m/DisplayListItem");m=sap.ui.require("sap/m/library");d=sap.ui.require("sap/ui/model/Filter");S=sap.ui.require("sap/ui/model/Sorter");if(!L||!D||!m){sap.ui.require(["sap/m/List","sap/m/DisplayListItem","sap/m/library","sap/ui/model/Filter","sap/ui/model/Sorter"],g.bind(this));this._bListRequested=true;}}if(i){_.call(this);}return i;};function _(){if(!this._oList&&L&&D&&m&&!this._bListRequested){var B=this.getBindingInfo("items");this._oList=new L(this.getId()+"-List",{width:"100%",showNoData:false,mode:m.ListMode.SingleSelectMaster,rememberSelections:false,itemPress:k.bind(this)}).addStyleClass("sapMComboBoxBaseList").addStyleClass("sapMComboBoxList");this._oList.setModel(this._oManagedObjectModel,"$field");this._oList.bindElement({path:"/",model:"$field"});f.call(this,B);this._setContent(this._oList);if(this._bNavigate){this._bNavigate=false;this.navigate(this._iStep);this._iStep=null;}}}function f(B){if(this._oList){this._oList.unbindAggregation("items");var i=new D(this.getId()+"-item",{type:m.ListType.Active,label:"{$field>text}",value:"{$field>additionalText}",valueTextDirection:"{$field>textDirection}"}).addStyleClass("sapMComboBoxNonInteractiveItem");var v=new d("text",p.bind(this));var U=false;if(B&&B.template&&B.template.isA("sap.ui.mdc.field.ListFieldHelpItem")){U=true;}else{var I=this.getItems();if(I.length>0&&I[0].isA("sap.ui.mdc.field.ListFieldHelpItem")){U=true;}}var w=U&&new S("groupKey",false,r.bind(this));this._oList.bindAggregation("items",{path:"$field>items",template:i,filters:v,sorter:w,templateShareable:false});s.call(this);}}function g(i,v,w,x,y){L=i;D=v;m=w;d=x;S=y;this._bListRequested=false;if(!this._bIsBeingDestroyed){_.call(this);}}e.prototype.open=function(i){F.prototype.open.apply(this,arguments);var v=this._getPopover();var w=this._getControlForSuggestion();if(v&&w){var W=(w.$().outerWidth()/parseFloat(m.BaseFontSize))+"rem";v.setContentMinWidth(W);}};e.prototype._handleAfterClose=function(E){if(this._bUpdateFilterAfterClose){this._bUpdateFilterAfterClose=false;o.call(this);}this._oList.removeStyleClass("sapMListFocus");F.prototype._handleAfterClose.apply(this,arguments);};function h(i){if(i.object===this){if(i.name==="items"){if(i.type==="binding"){if(i.mutation==="prepare"){f.call(this,i.bindingInfo);}}else{if(i.mutation==="insert"){this._oObserver.observe(i.child,{properties:true});}else{this._oObserver.unobserve(i.child);}j.call(this);}}if(i.name==="conditions"){if(!this._bConditionUpdate){s.call(this);}}if(i.name==="filterValue"){if(this._oList){if(this._bClosing){this._bUpdateFilterAfterClose=true;}else{o.call(this);}}}}else{j.call(this);}}function j(){if(!this._iDataUpdateTimer){this._iDataUpdateTimer=setTimeout(function(){this._iDataUpdateTimer=null;this.fireDataUpdate();}.bind(this),0);}}e.prototype.openByTyping=function(){return true;};e.prototype.openByClick=function(){return!this.getFilterList();};e.prototype.getValueHelpEnabled=function(){return false;};e.prototype.removeFocus=function(){if(this._oList){this._oList.removeStyleClass("sapMListFocus");}};e.prototype.navigate=function(v){var w=this._getPopover();if(!w||!this._oList){this._bNavigate=true;this._iStep=v;return;}this._oList.addStyleClass("sapMListFocus");var x=this._oList.getSelectedItem();var I=this._oList.getItems();var y=I.length;var z=0;var A=this.getFilterList();var B=this.getFilterValue();var E=false;if(!A&&!x){var i=0;if(v>=0){for(i=0;i<I.length;i++){if(I[i].getLabel&&q.call(this,I[i].getLabel(),B)){z=i;break;}}}else{for(i=I.length-1;i>=0;i--){if(I[i].getLabel&&q.call(this,I[i].getLabel(),B)){z=i;break;}}}}else if(x){z=this._oList.indexOfItem(x);z=z+v;}else if(v>=0){z=v-1;}else{z=y+v;}var G;if(z<0){z=0;G=true;E=true;}else if(z>=y-1){z=y-1;G=false;}else{G=v>=0;}while(I[z]&&I[z].isA("sap.m.GroupHeaderListItem")){if(G){z++;}else{z--;}}var H=I[z];if(H){if(H!==x){var O=n.call(this,H);var K=t.call(this,O);H.setSelected(true);var J=u.call(this,K,H.getLabel());if(!w.isOpen()){this.open();}this._oList.scrollToIndex(z);this.fireNavigate({key:K,value:H.getLabel(),condition:J,itemId:H.getId(),leaveFocus:false});}else if(E){this.fireNavigate({key:undefined,value:undefined,condition:undefined,itemId:undefined,leaveFocus:E});}}};e.prototype._getTextOrKey=function(v,K,B,I,O,N,w,x,y,z){if(v===null||v===undefined){return null;}else if(!v&&!K){return null;}var A=this.getItems();var E;var i=0;for(i=0;i<A.length;i++){E=A[i];if(z){if(t.call(this,E)===y||E.getText()===v){return{key:t.call(this,E),description:E.getText()};}}else if(K){if(t.call(this,E)===v){return E.getText();}}else if(E.getText()===v){return t.call(this,E);}}if(K&&v===""){return null;}if((!K||z)&&this.getUseFirstMatch()){for(i=0;i<A.length;i++){E=A[i];var T=E.getText();if(q.call(this,T,v)){return{key:t.call(this,E),description:T};}}}var G=this._oResourceBundle.getText("valuehelp.VALUE_NOT_EXIST",[v]);if(K&&!z){throw new b(G);}else{throw new P(G);}};function k(E){var i=E.getParameter("listItem");var v=i.getSelected();if(v){var O=n.call(this,i);var K=t.call(this,O);u.call(this,K,i.getLabel());this.close();this.fireSelect({conditions:this.getConditions(),add:true,close:true});}}function n(i){var v=i.getBindingContextPath();return this._oManagedObjectModel.getProperty(v);}function o(){var B=this._oList.getBinding("items");B.update();this._oList.updateItems();this._oList.invalidate();s.call(this);}function p(T){var i=this.getFilterList();return!i||q.call(this,T,this.getFilterValue());}function q(T,i){return!i||(typeof i==="string"&&T.toLowerCase().startsWith(i.toLowerCase()));}function r(i){var K=i.getProperty('groupKey');var T=i.getProperty('groupText');return{key:K,text:T};}function s(){if(this._oList){var v=this.getConditions();var w;var x=this.getFilterValue();var U=this.getUseFirstMatch();var y=false;var O=this._getOperator();if(v.length>0&&(v[0].validated===a.Validated||v[0].operator===O.name)){w=v[0].values[0];}var I=this._oList.getItems();for(var i=0;i<I.length;i++){var z=I[i];if(z.isA("sap.m.DisplayListItem")){var A=n.call(this,z);if(v.length>0&&t.call(this,A)===w){z.setSelected(true);}else if(v.length===0&&U&&x&&!y&&q.call(this,z.getLabel(),x)){z.setSelected(true);y=true;}else{z.setSelected(false);}}}}}function t(i){var B=i.getBinding("key");if(B){return B.getInternalValue();}else{return i.getKey();}}function u(K,v){this._bConditionUpdate=true;var i=this._createCondition(K,v);this.setProperty("conditions",[i],true);this._bConditionUpdate=false;return i;}return e;});
