/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/base/Object","sap/ui/mdc/p13n/P13nBuilder","sap/m/p13n/Container","sap/m/p13n/AbstractContainerItem","sap/base/util/UriParameters","sap/base/Log"],function(B,P,a,A,S,L){"use strict";var E="UIManager: This class is a singleton and should not be used without an AdaptationProvider. Please use 'sap.ui.mdc.p13n.Engine.getInstance().uimanager' instead";var u;var U=new S(window.location.search);var b=B.extend("sap.ui.mdc.p13n.UIManager",{constructor:function(o){if(u){throw Error(E);}this.oAdaptationProvider=o;B.call(this);}});b.prototype.show=function(c,k,s){this.bLiveMode=false;if(U.getAll("sap-ui-xx-p13nLiveMode")[0]==="true"){this.bLiveMode=true;L.warning("Please note that the p13n liveMode is experimental");}if(!this.hasActiveP13n(c)){this.setActiveP13n(c,k);return this.create(c,k).then(function(p){this._openP13nControl(c,k,p,s);return p;}.bind(this),function(e){this.setActiveP13n(c,null);L.error("Engine UI failure:"+e.stack);}.bind(this));}else{return Promise.resolve();}};b.prototype.create=function(c,k,C){var K=k instanceof Array?k:[k];var o=typeof c=="string"?sap.ui.getCore().byId(c):c;return this.oAdaptationProvider.initAdaptation(c,K,C).then(function(){return this._retrieveP13nContainer(o,K).then(function(d){o.addDependent(d);return d;});}.bind(this));};b.prototype._openP13nControl=function(c,k,p,s){var K=k instanceof Array?k:[k];if(this.bLiveMode){p.openBy(s);delete this.bLiveMode;}else{p.open();}if(this.oAdaptationProvider&&this.oAdaptationProvider.validateP13n instanceof Function){K.forEach(function(d){var w=K.length>1;var o;var C=p.getContent()[0];if(w&&C.isA("sap.m.p13n.Container")&&C.getView(d)){o=C.getView(d).getContent();}else{o=C;}this.oAdaptationProvider.validateP13n(c,d,o);}.bind(this));}};b.prototype._retrieveP13nContainer=function(c,k){var p=[];var d=k instanceof Array&&k.length>1;var o=this.oAdaptationProvider.getUISettings(c,k);k.forEach(function(r){if(!o[r]){k.splice(k.indexOf(r),1);return;}});k.forEach(function(r){var e=o[r].adaptationUI;e._key=r;var f=e.then(function(g){if(this.bLiveMode&&g&&g.attachChange){g.attachChange(function(){this.oAdaptationProvider.handleP13n(c,k);}.bind(this));}if(g&&g.attachChange){g.attachChange(function(h){var K=d?h.getSource().getParent().getParent().getCurrentViewKey():k[0];this.oAdaptationProvider.validateP13n(c,K,g);}.bind(this));}var s=o[e._key];return{key:e._key,tab:s.containerSettings&&s.containerSettings.tabText?s.containerSettings.tabText:e._key,panel:g};}.bind(this));p.push(f);}.bind(this));return Promise.all(p).then(function(e){var f=d?new a():e[0].panel;if(d){e.forEach(function(m){if(m.panel){f.addView(new A({key:m.key,text:m.tab,content:m.panel}));}});f.switchView(e[0].key);}return this._createUIContainer(c,k,f,o).then(function(D){return D;});}.bind(this));};b.prototype._createUIContainer=function(c,k,p,o){var C;var m=k.length>1?this._getDefaultContainerConfig(o):o[k[0]];if(this.bLiveMode){C=this._createPopover(c,k,p,m);}else{C=this._createModalDialog(c,k,p,m);}return C.then(function(d){d.addStyleClass("sapUiMdcPersonalizationDialog");d.isPopupAdaptationAllowed=function(){return false;};if(this.bLiveMode===false){d.setEscapeHandler(function(D){this.setActiveP13n(c,null);k.forEach(function(K){if(o[K].containerSettings&&o[K].containerSettings.afterClose instanceof Function){o[K].containerSettings.afterClose({getSource:function(){return d;}});}});d.close();d.destroy();D.resolve();}.bind(this));}d.toggleStyleClass("sapUiSizeCompact",!!jQuery(c).closest(".sapUiSizeCompact").length);return d;}.bind(this));};b.prototype._createPopover=function(c,k,p,m){var f=function(e){var o=e.getSource();this.setActiveP13n(c,null);o.destroy();}.bind(this);var s=Object.assign({verticalScrolling:true,reset:m.reset,afterClose:f},m.containerSettings);if(m.resetEnabled){s.reset={onExecute:function(){k.forEach(function(K){this.oAdaptationProvider.reset(c,K);}.bind(this));}};}return P.createP13nPopover(p,s);};b.prototype._createModalDialog=function(c,k,p,m){var d=function(e){var o=e.getSource().getParent();var f=this._confirmContainer(c,k,p);f.then(function(){this.setActiveP13n(c,null);o.close();}.bind(this));}.bind(this);var D=function(e){var C=e.getSource().getParent();this.setActiveP13n(c,null);C.close();}.bind(this);var s=Object.assign({verticalScrolling:true,reset:m.reset||{},afterClose:function(e){var o=e.getSource();if(o){o.destroy();}},cancel:D},m.containerSettings);if(m.resetEnabled){s.reset.onExecute=function(){this.oAdaptationProvider.reset(c,k);}.bind(this);}s.confirm={handler:function(e){d(e);}};return P.createP13nDialog(p,s);};b.prototype.setActiveP13n=function(c,k){if(this.oAdaptationProvider.setActiveP13n instanceof Function){this.oAdaptationProvider.setActiveP13n(c,k);}};b.prototype.hasActiveP13n=function(c){var d=false;if(this.oAdaptationProvider.hasActiveP13n instanceof Function){d=this.oAdaptationProvider.hasActiveP13n(c);}return d;};b.prototype._getDefaultContainerConfig=function(o){var r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.mdc");var k=Object.keys(o);var c={containerSettings:{title:r.getText("p13nDialog.VIEW_SETTINGS"),verticalScrolling:false,contentHeight:o.contentHeight,contentWidth:o.contentWidth,afterClose:function(e){k.forEach(function(K){if(o[K]&&o[K].containerSettings&&o[K].containerSettings.afterClose instanceof Function){o[K].containerSettings.afterClose(e);}});e.getSource().destroy();}}};if(o.resetEnabled!==false){c.reset={onExecute:function(C){this.oAdaptationProvider.reset(C,k);}.bind(this),warningText:r.getText("p13nDialog.RESET_WARNING_TEXT")};}return c;};b.prototype._confirmContainer=function(c,k){return this.oAdaptationProvider.handleP13n(c,k);};b._checkValidInterface=function(o){if(!o||!o.isA("sap.ui.mdc.p13n.AdaptationProvider")){throw Error("The UIManager singleton must not be accessed without an AdaptationProvider interface!");}};b.getInstance=function(o){if(!u){this._checkValidInterface(o);u=new b(o);}return u;};b.prototype.destroy=function(){B.prototype.destroy.apply(this,arguments);u=null;};return b;});
