/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/mdc/valuehelp/base/FilterableListContent','sap/ui/mdc/util/loadModules','sap/base/util/deepEqual','sap/ui/mdc/enum/SelectType','sap/ui/mdc/library','sap/m/library',"sap/ui/table/library","sap/ui/mdc/p13n/Engine","sap/ui/mdc/enum/PersistenceMode"],function(F,l,d,S,a,L,u,E,P){"use strict";var b=L.ListMode;var c=L.Sticky;var M=a.SelectionMode;var U=u.VisibleRowCountMode;var e=u.SelectionMode;var f=u.SelectionBehavior;var _=function(t){var T,i=T=t&&t.getType();if(!i){T="Table";}else if(typeof i==="object"){if(i.isA("sap.ui.mdc.table.ResponsiveTableType")){T="ResponsiveTable";}else{T="Table";}}return T;};var g=function(){var t=this._getTable();var I=t&&t._oTable;var r=t.getRowBinding();var s=function(){return this._oUITableSelectionPlugin||I;}.bind(this);var v=function(i,x){var V=this._getItemFromContext(i.getBindingContext());var C=V&&this._createCondition(V.key,V.description,V.inParameters,V.outParameters);var A=x?S.Add:S.Remove;this.fireSelect({type:this._isSingleSelect()?S.Set:A,conditions:[C]});};var w={"ResponsiveTable":{getListBindingInfo:function(){return I&&I.getBindingInfo("items");},getItems:function(){return I.getItems();},getSelectedItems:function(){return I.getSelectedItems();},modifySelection:function(i,x){if(i.getSelected()!==x){i.setSelected(x);}},handleItemPress:function(i){var x=i.getParameter("listItem");if(!this.isTypeahead()||!this._isSingleSelect()){x.setSelected(!x.getSelected());}v.call(this,x,x.getSelected());},handleSelectionChange:function(i){if(!this.isTypeahead()||!this._isSingleSelect()){var x=i.getParameters();var y=x.listItems||x.listItem&&[x.listItem];var C=y.map(function(z){var V=this._getItemFromContext(z.getBindingContext());return V&&this._createCondition(V.key,V.description,V.inParameters,V.outParameters);}.bind(this));this.fireSelect({type:x.selected?S.Add:S.Remove,conditions:C});}},adjustTable:function(){var i=I.getSticky();if(!i||i.length===0){I.setSticky([c.ColumnHeaders]);}if(this._isSingleSelect()){I.setMode(b.SingleSelectLeft);}else{I.setMode(b.MultiSelect);}},handleScrolling:function(i){var x=this.getScrollDelegate();if(x){I.scrollToIndex(i).catch(function(y){});return true;}},handleListBinding:function(){}},"Table":{getListBindingInfo:function(){return I&&I.getBindingInfo("rows");},getItems:function(){return I.getRows().filter(function(R){var i=R.getBindingContext();return i&&i.getObject();});},getSelectedItems:function(){var i=s().getSelectedIndices();var x=i.reduce(function(R,C){var y=I.getContextByIndex(C);return y?R.concat(y):R;},[]);return w["Table"].getItems().filter(function(R){return x.indexOf(R.getBindingContext())>=0;});},modifySelection:function(i,x){var C=i.getBindingContext();var y=w["Table"].getContexts().indexOf(C);var z=s().getSelectedIndices().indexOf(y)>=0;if(x&&!z){return this._isSingleSelect()?s().setSelectedIndex(y):s().addSelectionInterval(y,y);}else if(!x&&z){return s().removeSelectionInterval(y,y);}},handleItemPress:function(i){},handleSelectionChange:function(x){if(this._bScrolling||this._bBusy){return;}var R=x.getParameter("rowIndices");var C=w["Table"].getContexts().filter(function(i,H){return R.indexOf(H)>=0;});var y=w["Table"].getItems().filter(function(i,H){return C.indexOf(i.getBindingContext())>=0;});var A=[],z=[];var B=w["Table"].getSelectedItems();var D=this.getConditions();y.forEach(function(H,i){var J=this._isItemSelected(H,D);var K=B.indexOf(H)!==-1;if(J!==K){var N=B.indexOf(H)!==-1?A:z;var V=this._getItemFromContext(H.getBindingContext());var O=V&&this._createCondition(V.key,V.description,V.inParameters,V.outParameters);N.push(O);}}.bind(this));var G=this._isSingleSelect();if(A.length){this.fireSelect({type:this._isSingleSelect()?S.Set:S.Add,conditions:A});if(G){return;}}if(z.length){this.fireSelect({type:this._isSingleSelect()?S.Set:S.Remove,conditions:z});}},adjustTable:function(){var R=I.getRowMode();if(!R){I.setVisibleRowCountMode(U.Auto);I.setMinAutoRowCount(3);}else if(R.isA("sap.ui.table.rowmodes.AutoRowMode")){R.setMinRowCount(3);}var i=this._isSingleSelect()?e.Single:e.MultiToggle;var x=this._isSingleSelect()?f.RowOnly:f.Row;I.setSelectionBehavior(x);s().setSelectionMode(i);},handleScrolling:function(i){var x=I.getFirstVisibleRow();if(typeof i==="undefined"||i<0){i=x-1;}if(i>=0&&i!=x){I.setFirstVisibleRow(i);return Promise.resolve();}return false;},getContexts:function(){return r&&(r.aContexts||(r.aIndices&&r.aIndices.map(function(i){return I.getContextByIndex(i);}))||r.getContexts());},handleListBinding:function(){r.attachEvent("change",this._handleUpdateFinished.bind(this));}}};return w[this._sTableType];};function h(){if(this._oTableHelper){this._bSelectionIsUpdating=true;var i=this._oTableHelper.getItems();var C=this.getConditions();var r=[];for(var I in i){var s=i[I];var t=this._isItemSelected(s,C);r.push(this._oTableHelper.modifySelection.call(this,s,t));}Promise.all(r).then(function(){this._bSelectionIsUpdating=false;}.bind(this));}}var j=F.extend("sap.ui.mdc.valuehelp.content.MDCTable",{metadata:{library:"sap.ui.mdc",interfaces:["sap.ui.mdc.valuehelp.IDialogContent"],properties:{},aggregations:{table:{type:"sap.ui.mdc.Table",multiple:false}},events:{},defaultAggregation:"table"}});j.prototype.init=function(){F.prototype.init.apply(this,arguments);this._oObserver.observe(this,{aggregations:["table"]});this._addPromise("listBinding");};var k=function(){var i=this._getTable().getRowBinding();if(i){this._oTableHelper=g.call(this);this._oTableHelper.handleListBinding.call(this);q.call(this);this._resolvePromise("listBinding",i);}};var m=function(){if(this._oTable&&!this._oTable.getHeader()){this._oTable.setHeader(this._oResourceBundle.getText("valuehelp.TABLETITLENONUMBER"));}};j.prototype._handleConditionsUpdate=function(){h.call(this);};j.prototype._handleUpdateFinished=function(i){this._bScrolling=false;this._bSearchTriggered=false;h.call(this);};j.prototype._handleFirstVisibleRowChanged=function(i){this._bScrolling=true;};j.prototype._handleBusyStateChanged=function(i){this._bBusy=i.getParameter("busy");};var n=function(i,s){if(!i){return;}if(s==="remove"){if(this._sTableType==="Table"){i.detachEvent("cellClick",this._handleItemPress,this);i.detachEvent("rowSelectionChange",this._handleSelectionChange,this);i.detachEvent("rowsUpdated",this._handleUpdateFinished,this);i.detachEvent("firstVisibleRowChanged",this._handleFirstVisibleRowChanged,this);i.detachEvent("busyStateChanged",this._handleBusyStateChanged,this);if(this._oUITableSelectionPlugin){this._oUITableSelectionPlugin.detachEvent("selectionChange",this._handleSelectionChange,this);}this._oUITableSelectionPlugin=undefined;}else if(this._sTableType==="ResponsiveTable"){i.detachEvent("itemPress",this._handleItemPress,this);i.detachEvent("selectionChange",this._handleSelectionChange,this);i.detachEvent("updateFinished",this._handleUpdateFinished,this);}this._oObserver.unobserve(i);}else{if(this._sTableType==="Table"){this._oObserver.observe(i,{bindings:["rows"],aggregations:["plugins"]});i.attachEvent("cellClick",this._handleItemPress,this);i.attachEvent("rowSelectionChange",this._handleSelectionChange,this);i.attachEvent("rowsUpdated",this._handleUpdateFinished,this);i.attachEvent("firstVisibleRowChanged",this._handleFirstVisibleRowChanged,this);i.attachEvent("busyStateChanged",this._handleBusyStateChanged,this);this._oUITableSelectionPlugin=i.getPlugins().find(function(r){return r.isA("sap.ui.table.plugins.SelectionPlugin");});if(this._oUITableSelectionPlugin){this._oUITableSelectionPlugin.attachEvent("selectionChange",this._handleSelectionChange,this);}}else if(this._sTableType==="ResponsiveTable"){this._oObserver.observe(i,{bindings:["items"]});i.attachEvent("itemPress",this._handleItemPress,this);i.attachEvent("selectionChange",this._handleSelectionChange,this);i.attachEvent("updateFinished",this._handleUpdateFinished,this);}}};var o=function(i){var s=this.getFilterFields();var r=i.getSource();var C=r.getInternalConditions();var t=s&&C[s]&&C[s][0];var v=t&&t.values[0];this.setFilterValue(v);};j.prototype._observeChanges=function(C){var i,D;if(C.name==="_defaultFilterBar"){D=C.child;if(C.mutation==="insert"){i=this.getFilterBar();if(!i){D.attachSearch(o,this);}}else{D.detachSearch(o,this);}p.call(this);}if(C.name==="filterBar"){i=C.child;D=this.getAggregation("_defaultFilterBar");if(C.mutation==="insert"){if(D){D.detachSearch(o,this);}i.attachSearch(o,this);}else{if(D){D.attachSearch(o,this);}i.detachSearch(o,this);}p.call(this);}if(C.name==="table"){var t=C.child;if(C.mutation==="remove"){E.getInstance().defaultProviderRegistry.detach(t);this._oObserver.unobserve(t);this._oTable=null;this._oTableHelper=null;this._addPromise("listBinding");}else{this._oTable=t;E.getInstance().defaultProviderRegistry.attach(t,P.Transient);this._oObserver.observe(t,{aggregations:["_content"]});this._sTableType=_(t);t.addDelegate({onmouseover:function(r){var I=jQuery(r.target).control(0);if(I&&I.isA("sap.m.ColumnListItem")){I.setType("Active");}}});n.call(this,this._oTable._oTable,"insert");k.call(this);m.call(this);p.call(this);}return;}if(C.name==="_content"){n.call(this,C.child,C.mutation);return;}if(["rows","items"].indexOf(C.name)!==-1&&C.mutation==="ready"){k.call(this);return;}if(C.name==="config"){q.call(this);}if(C.name==="plugins"){this._oUITableSelectionPlugin=C.mutation==="remove"||!C.child.isA("sap.ui.table.plugins.SelectionPlugin")?undefined:C.child;if(this._oUITableSelectionPlugin){this._oUITableSelectionPlugin.attachEvent("selectionChange",this._handleSelectionChange,this);}}F.prototype._observeChanges.apply(this,arguments);};j.prototype._getTable=function(){return this._oTable;};function p(){var i=this._getPriorityFilterBar();if(this._oTable&&i&&this._oTable.getFilter()!==i.getId()){this._oTable.setFilter(i);}}function q(){if(this._oTableHelper){this._oTableHelper.adjustTable.call(this);}}j.prototype.getContent=function(){return this._retrievePromise("wrappedContent",function(){return l(["sap/ui/layout/FixFlex","sap/m/VBox","sap/m/ScrollContainer"]).then(function(i){var r=i[0];var V=i[1];var s=i[2];if(!this._oContentLayout){this._oFilterBarVBox=new V(this.getId()+"-FilterBarBox",{visible:"{$this>/_filterBarVisible}"});this._oFilterBarVBox.addStyleClass("sapMdcValueHelpPanelFilterbar");this._oFilterBarVBox._oWrapper=this;this._oFilterBarVBox.getItems=function(){return[this._oWrapper._getPriorityFilterBar.call(this._oWrapper)];};this._oTableBox=new V(this.getId()+"-TB",{height:"100%"});this._oTableBox.addStyleClass("sapMdcValueHelpPanelTableBox");this._oTableBox._oWrapper=this;this._oTableBox.getItems=function(){return[this._oWrapper._sTableType==="ResponsiveTable"?this._oWrapper._oScrollContainer:this._oWrapper._oTable];};this._oContentLayout=new r(this.getId()+"-FF",{minFlexSize:200,fixContent:this._oFilterBarVBox,flexContent:this._oTableBox});this._oScrollContainer=new s(this.getId()+"-SC",{height:"calc(100% - 0.5rem)",width:"100%",vertical:true});this._oScrollContainer._oWrapper=this;this._oScrollContainer.getContent=function(){var C=[];var t=this._oWrapper&&this._oWrapper._oTable;if(t){C.push(t);}return C;};}this.setAggregation("displayContent",this._oContentLayout);if(!this._getPriorityFilterBar()){return this._createDefaultFilterBar().then(function(){return this._oContentLayout;}.bind(this));}return this._oContentLayout;}.bind(this));}.bind(this));};j.prototype._getListBinding=function(){var t=this.getTable();return t&&t.getRowBinding();};j.prototype._getListBindingInfo=function(){return this._oTableHelper&&this._oTableHelper.getListBindingInfo();};j.prototype.onShow=function(){if(this._oTable){var s=F.prototype._isSingleSelect.apply(this)?M.Single:M.Multi;if(this._oTable.getSelectionMode()===M.None){this._oTable.setSelectionMode(s);}if(this._oTable.getSelectionMode()!==s){throw new Error("Table selectionMode needs to be "+s);}}F.prototype.onShow.apply(this,arguments);};j.prototype.applyFilters=function(s){var t=this.getTable();var i=this._getPriorityFilterBar();if(t&&i){var r=this._getListBinding();var v=r&&r.isSuspended();if(r&&!v&&!this._bSearchTriggered){var w=i.getSearch()||"";var B=r.mParameters.$search||"";var x=this._getFiltersForFilterBar();var y=r.aApplicationFilters.reduce(function(R,C){return R.concat(C._bMultiFilter?C.aFilters:C);},[]);var z=!d(x,y);var A=w!==B;var T=t._oTable&&t._oTable.getShowOverlay&&t._oTable.getShowOverlay();if(z||A||T){this._handleScrolling();i.triggerSearch();this._bSearchTriggered=true;}}if(v){r.resume();}if(!r&&t.getAutoBindOnInit()){this._retrievePromise("listBinding").then(function(){this.applyFilters(s);}.bind(this));}}};j.prototype._handleScrolling=function(i){return this._oTableHelper&&this._oTableHelper.handleScrolling.call(this,i);};j.prototype.getScrollDelegate=function(){if(!this.isTypeahead()&&this._oScrollContainer){return this._oScrollContainer.getScrollDelegate();}return F.prototype.getScrollDelegate.apply(this,arguments);};j.prototype._handleItemPress=function(i){this._oTableHelper.handleItemPress.call(this,i);};j.prototype._handleSelectionChange=function(i){if(!this._bSelectionIsUpdating){this._oTableHelper.handleSelectionChange.call(this,i);}};j.prototype.isQuickSelectSupported=function(){return true;};j.prototype.setParent=function(i){F.prototype.setParent.apply(this,arguments);q.call(this);};j.prototype._isSingleSelect=function(){if(this._oTable){if(this._oTable.getSelectionMode()===M.Multi){return false;}else{return true;}}else{return F.prototype._isSingleSelect.apply(this,arguments);}};return j;});
