/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/mdc/valuehelp/base/FilterableListContent','sap/ui/mdc/condition/Condition','sap/ui/mdc/condition/FilterConverter','sap/ui/mdc/enum/ConditionValidated','sap/ui/mdc/util/loadModules','sap/m/library','sap/ui/model/FilterType','sap/ui/model/Filter','sap/ui/model/FilterOperator','sap/ui/model/FilterProcessor','sap/ui/mdc/util/Common','sap/base/strings/formatMessage','sap/base/util/merge','sap/ui/mdc/enum/SelectType','sap/base/Log'],function(F,C,a,b,l,c,d,e,f,g,h,k,m,S,L){"use strict";var n=c.ListMode;var o=c.Sticky;var M=F.extend("sap.ui.mdc.valuehelp.content.MTable",{metadata:{library:"sap.ui.mdc",interfaces:["sap.ui.mdc.valuehelp.ITypeaheadContent","sap.ui.mdc.valuehelp.IDialogContent"],properties:{},aggregations:{table:{type:"sap.m.Table",multiple:false}},events:{contentUpdated:{}},defaultAggregation:"table"}});M.prototype.init=function(){F.prototype.init.apply(this,arguments);this._oObserver.observe(this,{aggregations:["table"]});this._addPromise("listBinding");this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.ui.mdc");this._oMResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");};M.prototype.getValueHelpIcon=function(){if(this.getUseAsValueHelp()){return"sap-icon://slim-arrow-down";}else{return null;}};function _(){if(this._oTable){var i=this._oTable.getItems();var j=this.getConditions();var H=this._isSingleSelect()&&!F.prototype._isSingleSelect.apply(this);for(var I in i){var u=i[I];var v=H?false:this._isItemSelected(u,j);u.setSelected(v);}}}M.prototype.applyFilters=function(i){var j=this._getListBinding();var v=this._isValueHelpDelegateInitialized();if((!j||!v)&&(this.isContainerOpening()||this.isTypeahead())){Promise.all([this._retrievePromise("listBinding"),this._awaitValueHelpDelegate()]).then(function(){if(!this.bIsDestroyed){this.applyFilters(i);}}.bind(this));return;}if(!v||(!this.isTypeahead()&&!this.isContainerOpen()&&j.isSuspended())){return;}var D=this._getValueHelpDelegate();var u=this._getValueHelpDelegatePayload();var w=this.getFilterFields();var x=this._getPriorityFilterBar();var y=x?x.getInternalConditions():this.getProperty("inConditions");if(!x&&i&&w&&w!=="$search"){var z=C.createCondition("Contains",[i],undefined,undefined,b.NotValidated);y[w]=[z];}var A=y&&this._getTypesForConditions(y);var B=y&&a.createFilters(y,A,undefined,this.getCaseSensitive());var E=B&&[B];var G=this.isTypeahead()?i:x&&x.getSearch();var U=true;var H;try{H=j.getFilterInfo();}catch(I){L.info("ValueHelp-Filter: getFilterInfo threw error");}if(!E){E=[];}if(E.length===0&&!H){U=false;}if(w==="$search"&&D&&D.isSearchSupported(u,j)){if(!j.isSuspended()&&U){j.suspend();}G=D.adjustSearch(u,this.isTypeahead(),G);D.executeSearch(u,j,G);L.info("ValueHelp-Search: "+G);}if(U){j.filter(E,d.Application);L.info("ValueHelp-Filter: "+this._prettyPrintFilters.call(this,E));}if(j.isSuspended()){j.resume();}};M.prototype._handleSelectionChange=function(E){var i=this.isTypeahead();if(!i||!this._isSingleSelect()){var P=E.getParameters();var j=P.listItems||P.listItem&&[P.listItem];var u=j.map(function(I){var v=this._getItemFromContext(I.getBindingContext());return v&&this._createCondition(v.key,v.description,v.inParameters,v.outParameters);}.bind(this));this.fireSelect({type:P.selected?S.Add:S.Remove,conditions:u});if(i){this.fireConfirm();}}};M.prototype._handleItemPress=function(E){var i=E.getParameter("listItem");var v=this._getItemFromContext(i.getBindingContext());var I=this._isSingleSelect();var j=I?true:!i.getSelected();var u=S.Set;if(!I){i.setSelected(j);u=j?S.Add:S.Remove;}var w=this._createCondition(v.key,v.description,v.inParameters,v.outParameters);this.fireSelect({type:u,conditions:[w]});if(this.isTypeahead()){this.fireConfirm({close:true});}};M.prototype._handleUpdateFinished=function(){_.apply(this);this.fireContentUpdated();};M.prototype._getTable=function(){return this._oTable;};M.prototype.onShow=function(){var T=this._getTable();if(T){if(!T.hasStyleClass("sapMComboBoxList")){T.addStyleClass("sapMComboBoxList");}var i=this.isTypeahead()?n.SingleSelectMaster:n.SingleSelectLeft;if(!F.prototype._isSingleSelect.apply(this)&&T.getMode()!==i){i=n.MultiSelect;}if(T.getMode()===n.None){T.setMode(i);}if(T.getMode()!==i){throw new Error("Table selection mode needs to be "+i);}}F.prototype.onShow.apply(this,arguments);};M.prototype.onHide=function(){F.prototype.onHide.apply(this,arguments);var T=this.getTable();if(T){this.removeFocus();if(T.hasStyleClass("sapMComboBoxList")){T.removeStyleClass("sapMComboBoxList");}}};M.prototype._handleConditionsUpdate=function(i){_.call(this);};M.prototype.getContent=function(){if(!this.isTypeahead()){return this._retrievePromise("wrappedContent",function(){return l(["sap/ui/layout/FixFlex","sap/m/VBox","sap/m/Panel","sap/m/ScrollContainer","sap/ui/model/resource/ResourceModel"]).then(function(i){var j=i[0];var V=i[1];var P=i[2];var u=i[3];var R=i[4];if(!this._oContentLayout){this._oFilterBarVBox=new V(this.getId()+"-FilterBarBox");this._oFilterBarVBox.addStyleClass("sapMdcValueHelpPanelFilterbar");this._oFilterBarVBox._oWrapper=this;this._oFilterBarVBox.getItems=function(){return[this._oWrapper._getPriorityFilterBar.call(this._oWrapper)];};this.setModel(new R({bundleName:"sap/ui/mdc/messagebundle",async:false}),"$i18n");var v=function(T){var I=0;if(I===0){T=this.getModel("$i18n").getResourceBundle().getText("valuehelp.TABLETITLENONUMBER");}return k(T,I);};this._oTablePanel=new P(this.getId()+"-TablePanel",{expanded:true,height:"100%",headerText:{parts:['$i18n>valuehelp.TABLETITLE'],formatter:v}});this._oTablePanel.addStyleClass("sapMdcTablePanel");this._oContentLayout=new j(this.getId()+"-FF",{minFlexSize:200,fixContent:this._oFilterBarVBox,flexContent:this._oTablePanel});this._oScrollContainer=new u(this.getId()+"-SC",{height:"100%",width:"100%",vertical:true});this._oScrollContainer._oWrapper=this;this._oScrollContainer.getContent=function(){var x=[];var T=this._oWrapper&&this._oWrapper._oTable;if(T){x.push(T);}return x;};this._oTablePanel.addContent(this._oScrollContainer);}this.setAggregation("displayContent",this._oContentLayout);var w=this._getPriorityFilterBar();if(!w){return this._createDefaultFilterBar().then(function(){return this._oContentLayout;}.bind(this));}return this._oContentLayout;}.bind(this));}.bind(this));}return this._oTable;};M.prototype.getItemForValue=function(i){if(!i.checkKey&&i.parsedValue&&!i.checkDescription){return null;}i.caseSensitive=i.caseSensitive||this.getCaseSensitive();return p.call(this).then(function(P){var R;if(!P){var T=this.getTable();R=q.call(this,i,T.getItems());}if(!R){R=this._loadItemForValue(i);}return R;}.bind(this));};function p(){return this._retrievePromise("listBinding").then(function(i){var D=this._getValueHelpDelegate();var j=this._getValueHelpDelegatePayload();var u=this._getListBindingInfo();if(i&&D){return D.checkListBindingPending(j,i,u);}else{return true;}}.bind(this));}function q(j,I){if(I.length===0){return;}var u=[];if(j.checkKey&&j.hasOwnProperty("parsedValue")){u.push({path:this.getKeyPath(),value:j.parsedValue});}if(j.checkDescription&&j.value){u.push({path:this.getDescriptionPath(),value:j.value});}var v=function(A,P){var B=A.isA("sap.ui.model.Context")?A:A.getBindingContext();return B.getProperty(P);};var w;var x=[];var y;var O;var i=0;for(i=0;i<u.length;i++){if(!u[i].path){throw new Error("path for filter missing");}x.push(new e({path:u[i].path,operator:f.EQ,value1:u[i].value,caseSensitive:j.caseSensitive}));}if(x.length===1){w=x[0];}else{w=new e({filters:x,and:false});}if(j.inParameters){x=[w];if(j.inParameters){x.push(j.inParameters);y=[];if(!j.inParameters.aFilters){y.push(j.inParameters.sPath);}else{for(i=0;i<j.inParameters.aFilters.length;i++){if(y.indexOf(j.inParameters.aFilters[i].sPath)<0){y.push(j.inParameters.aFilters[i].sPath);}}}}w=new e({filters:x,and:true});}var z=g.apply(I,w,v);if(z.length===1){var V=this._getItemFromContext(z[0].getBindingContext(),{inParameters:y,outParameters:O});return{key:V.key,description:V.description,inParameters:V.inParameters,outParameters:V.outParameters};}else if(z.length>1){if(!j.caseSensitive){var N=m({},j);N.caseSensitive=true;return q.call(this,N,I);}throw r.call(this,j.exception,true,u[0].value);}}M.prototype._getListBinding=function(){var T=this._getTable();return T&&T.getBinding("items");};M.prototype._getListBindingInfo=function(){var T=this._getTable();return T&&T.getBindingInfo("items");};M.prototype._loadItemForValue=function(u){if(!u.checkKey&&u.parsedValue&&!u.checkDescription){return null;}var K=this.getKeyPath();var D=this.getDescriptionPath();var U=this.getUseFirstMatch();var v=u.caseSensitive;var T=this._getTable();var w=T&&T.getBinding("items");var B=w&&w.getContext();var x=w&&w.getModel();var P=w&&w.getPath();var y=this._getValueHelpDelegate();var z=this._getValueHelpDelegatePayload();var A=["loadItemForValue",P,K,u.parsedValue||u.value].join("_");return this._retrievePromise(A,function(){var E=[];if(u.checkKey&&u.hasOwnProperty("parsedValue")){E.push(new e({path:K,operator:f.EQ,value1:u.parsedValue,caseSensitive:v}));}if(u.checkDescription&&u.value){E.push(new e({path:D,operator:f.EQ,value1:u.value,caseSensitive:v}));}var G=E.length>1?new e({filters:E,and:false}):E[0];E=[G];var I;if(u.inParameters){E.push(u.inParameters);I=[];if(!u.inParameters.aFilters){I.push(u.inParameters.sPath);}else{for(var i=0;i<u.inParameters.aFilters.length;i++){var H=u.inParameters.aFilters[i];if(H.aFilters){for(var j=0;j<H.aFilters.length;j++){if(H.aFilters[j].sPath&&I.indexOf(H.aFilters[j].sPath)<0){I.push(H.aFilters[j].sPath);}}}else if(H.sPath&&I.indexOf(H.sPath)<0){I.push(H.sPath);}}}}G=E.length>1?new e({filters:E,and:true}):E[0];var J=x.bindList(P,B);return y.executeFilter(z,J,G,2).then(function(N){var O=N.getContexts();setTimeout(function(){J.destroy();},0);if(O.length&&(O.length<2||U)){return this._getItemFromContext(O[0],{keyPath:K,descriptionPath:D,inParameters:I});}else if(u.checkKey&&u.parsedValue===""&&O.length===0){return null;}else{var Q=r.call(this,u.exception,O.length>1,u.value);throw Q;}}.bind(this));}.bind(this));};function r(E,N,v){var i;if(N){i=this._oResourceBundle.getText("valuehelp.VALUE_NOT_UNIQUE",[v]);}else{i=this._oResourceBundle.getText("valuehelp.VALUE_NOT_EXIST",[v]);}var j=new E(i);j._bNotUnique=N;return j;}M.prototype.isValidationSupported=function(i){return true;};M.prototype.navigate=function(i){var j=this._getListBinding();if(!j||!j.getLength()){return p.call(this).then(function(P){if(!P&&j.getLength()!==0){return this.navigate(i);}return false;}.bind(this));}var T=this._getTable();T.addStyleClass("sapMListFocus");var I=this._oTable.getItems();var u=T.getSelectedItem();var v=I.length;var w=0;var x=false;if(u){w=I.indexOf(u);w=w+i;}else if(i>=0){w=i-1;}else{w=v+i;}if(this._getMaxConditions()!==1){if(this.getParent().isOpen()){T.focus();return;}}var y;if(w<0){w=0;y=true;x=true;}else if(w>=v-1){w=v-1;y=false;}else{y=i>=0;}while(I[w]&&I[w].isA("sap.m.GroupHeaderListItem")){if(y){w++;}else{w--;}}if(w<0||w>v-1){y=!y;x=w<0;w=w<0?0:v-1;while(I[w]&&I[w].isA("sap.m.GroupHeaderListItem")){if(y){w++;}else{w--;}}}var z=I[w];if(z){var A;if(z!==u){z.setSelected(true);var V=this._getItemFromContext(z.getBindingContext());A=V&&this._createCondition(V.key,V.description,V.inParameters,V.outParameters);this.setProperty("conditions",[A],true);if(this._bVisible){this._handleScrolling(z);}this.fireNavigated({condition:A,itemId:z.getId(),leaveFocus:false});}else if(x){this.fireNavigated({condition:undefined,itemId:undefined,leaveFocus:x});}}};M.prototype._handleScrolling=function(i){var j=this.getScrollDelegate();if(j){var T=this._getTable();var I=!isNaN(i)?i:T.indexOfItem(i);T.scrollToIndex(I).catch(function(E){});return true;}return false;};M.prototype.getScrollDelegate=function(){if(this._oScrollContainer){return this._oScrollContainer.getScrollDelegate();}return F.prototype.getScrollDelegate.apply(this,arguments);};M.prototype.removeFocus=function(){var T=this.getTable();if(T){T.removeStyleClass("sapMListFocus");}};M.prototype.getAriaAttributes=function(i){var T=this.getTable();return{contentId:T&&T.getId(),ariaHasPopup:"listbox",roleDescription:null};};M.prototype.getContainerConfig=function(){return{'sap.ui.mdc.valuehelp.Popover':{getContentHeight:function(){var T=this._getTable();var D=T&&T.getDomRef();return D&&Math.round(D.getBoundingClientRect().height);}.bind(this),getFooter:function(){return this._retrievePromise("footer",function(){return this._retrievePromise("listBinding").then(function(i){var B=this._getListBindingInfo();if(B&&B.length){return l(["sap/m/Button","sap/m/Toolbar","sap/m/ToolbarSpacer"]).then(function(j){var u=j[0];var T=j[1];var v=j[2];var w=new u(this.getId()+"-showAllItems",{text:this._oMResourceBundle.getText("INPUT_SUGGESTIONS_SHOW_ALL"),press:function(){this.fireRequestSwitchToDialog();}.bind(this)});var x=[new v(this.getId()+"-Spacer")].concat(w);var y=new T(this.getId()+"-TB",{content:x});return y;}.bind(this));}}.bind(this));}.bind(this));}.bind(this)}};};function s(){if(this._oTable&&this.getParent()){var i=this._oTable.getSticky();if(!i||i.length===0){this._oTable.setSticky([o.ColumnHeaders]);}}}M.prototype.setParent=function(P){F.prototype.setParent.apply(this,arguments);s.call(this);};var t=function(){return this.applyFilters(this.getFilterValue());};M.prototype._observeChanges=function(i){var j,D;if(i.name==="_defaultFilterBar"){D=i.child;if(i.mutation==="insert"){j=this.getFilterBar();if(!j){D.attachSearch(t,this);}}else{D.detachSearch(t,this);}}if(i.name==="filterBar"){j=i.child;D=this.getAggregation("_defaultFilterBar");if(i.mutation==="insert"){if(D){D.detachSearch(t,this);}j.attachSearch(t,this);}else{if(D){D.attachSearch(t,this);}j.detachSearch(t,this);}}if(i.name==="config"){s.call(this);}if(i.name==="items"&&i.mutation==="ready"){this._resolvePromise("listBinding",i.bindingInfo.binding);}if(i.name==="table"){var T=i.child;if(i.mutation==="remove"){this._oObserver.unobserve(T);T.removeDelegate(this._oTableDelegate);this._oTable.detachItemPress(this._handleItemPress,this);this._oTable.detachSelectionChange(this._handleSelectionChange,this);this._oTable.detachUpdateFinished(this._handleUpdateFinished,this);this._oTable=null;this._removePromise("footer");this._addPromise("listBinding");}else{this._oTable=T;s.call(this);this._oTable.attachItemPress(this._handleItemPress,this);this._oTable.attachSelectionChange(this._handleSelectionChange,this);this._oTable.attachUpdateFinished(this._handleUpdateFinished,this);this._oTableDelegate=this._oTableDelegate||{onsapprevious:this._handleTableEvent,onsapnext:this._handleTableEvent,cellClick:this._handleTableEvent};T.addDelegate(this._oTableDelegate,true,this);var u=T.getBinding("items");if(u){this._resolvePromise("listBinding",u);}else{this._oObserver.observe(i.child,{bindings:["items"]});}}}F.prototype._observeChanges.apply(this,arguments);};M.prototype._handleTableEvent=function(E){if(!this.isTypeahead()){return;}var T=this._getTable();var i=jQuery(E.target).control(0);switch(E.type){case"sapprevious":if(i.isA("sap.m.ListItemBase")){if(T.indexOfItem(i)===0){this.fireNavigated({condition:undefined,itemId:undefined,leaveFocus:true});E.preventDefault();E.stopPropagation();E.stopImmediatePropagation(true);}}break;default:break;}};M.prototype.isQuickSelectSupported=function(){return true;};M.prototype.shouldOpenOnNavigate=function(){return true;};M.prototype._isSingleSelect=function(){var T=this._getTable();if(T){if(T.getMode()===n.MultiSelect){return false;}else{return true;}}else{return F.prototype._isSingleSelect.apply(this,arguments);}};M.prototype.exit=function(){h.cleanup(this,["_sTableWidth","_oTable","_oScrollContainer","_oContentLayout","_oTablePanel","_oFilterBarVBox","_oMResourceBundle","_oResourceBundle"]);F.prototype.exit.apply(this,arguments);};return M;});
