/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/assert","sap/base/Log","sap/base/util/isEmptyObject"],function(a,L,b){"use strict";var A={EnumMember:true,Path:true,PropertyPath:true,NavigationPropertyPath:true,AnnotationPath:true};var t={Binary:true,Bool:true,Date:true,DateTimeOffset:true,Decimal:true,Duration:true,Float:true,Guid:true,Int:true,String:true,TimeOfDay:true,LabelElementReference:true,EnumMember:true,Path:true,PropertyPath:true,NavigationPropertyPath:true,AnnotationPath:true};var M={And:true,Or:true,Eq:true,Ne:true,Gt:true,Ge:true,Lt:true,Le:true,If:true,Collection:true};function g(o){return o.getAttribute("Qualifier")||o.parentNode.nodeName==="Annotations"&&o.parentNode.getAttribute("Qualifier");}var c={merge:function(T,s){var d,e;var S=["annotationsAtArrays","propertyAnnotations","EntityContainer","annotationReferences"];for(d in s){if(S.indexOf(d)!==-1){continue;}c._mergeAnnotation(d,s,T);}for(var i=1;i<S.length;++i){var f=S[i];T[f]=T[f]||{};for(d in s[f]){for(e in s[f][d]){T[f][d]=T[f][d]||{};c._mergeAnnotation(e,s[f][d],T[f][d]);}}}if(s.annotationsAtArrays){T.annotationsAtArrays=(T.annotationsAtArrays||[]).concat(s.annotationsAtArrays);}},_mergeAnnotation:function(n,m,T){if(Array.isArray(m[n])){T[n]=m[n].slice(0);}else{T[n]=T[n]||{};for(var k in m[n]){T[n][k]=m[n][k];}}},parse:function(m,x,s){try{c._parserData={};c._oXPath=c.getXPath();return c._parse(m,x,s);}finally{delete c._parserData;delete c._oXPath;}},_parse:function(m,x,s){var d={},e,f,h,T,l,n,p,q,r,u,v,w,y,z,B,C,D,E,F,G,H,i,I,J=[];c._parserData.metadataInstance=m;c._parserData.serviceMetadata=m.getServiceMetadata();c._parserData.xmlDocument=c._oXPath.setNameSpace(x);c._parserData.schema={};c._parserData.aliases={};c._parserData.url=s?s:"metadata document";c._parserData.annotationsAtArrays=J;e=c._oXPath.selectNodes("//d:Schema",c._parserData.xmlDocument);for(i=0;i<e.length;i+=1){f=c._oXPath.nextNode(e,i);c._parserData.schema.Alias=f.getAttribute("Alias");c._parserData.schema.Namespace=f.getAttribute("Namespace");}var K={};var N=c._parseReferences(K);if(N){d.annotationReferences=K;d.aliasDefinitions=c._parserData.aliases;}h=c._oXPath.selectNodes("//d:Term",c._parserData.xmlDocument);if(h.length>0){T={};for(I=0;I<h.length;I+=1){l=c._oXPath.nextNode(h,I);n=c.replaceWithAlias(l.getAttribute("Type"));T["@"+c._parserData.schema.Alias+"."+l.getAttribute("Name")]=n;}d.termDefinitions=T;}c._parserData.metadataProperties=c.getAllPropertiesMetadata(c._parserData.serviceMetadata);if(c._parserData.metadataProperties.extensions){d.propertyExtensions=c._parserData.metadataProperties.extensions;}p=c._oXPath.selectNodes("//d:Annotations ",c._parserData.xmlDocument);for(I=0;I<p.length;I+=1){q=c._oXPath.nextNode(p,I);if(q.hasChildNodes()===false){continue;}r=q.getAttribute("Target");u=r.split(".")[0];if(u&&c._parserData.aliases[u]){r=r.replace(new RegExp(u,""),c._parserData.aliases[u]);}v=r;w=null;var O=null;if(r.indexOf("/")>0){v=r.split("/")[0];var S=c._parserData.serviceMetadata.dataServices&&c._parserData.serviceMetadata.dataServices.schema&&c._parserData.serviceMetadata.dataServices.schema.length;if(S){for(var j=c._parserData.serviceMetadata.dataServices.schema.length-1;j>=0;j--){var P=c._parserData.serviceMetadata.dataServices.schema[j];if(P.entityContainer){var Q=v.split('.');for(var k=P.entityContainer.length-1;k>=0;k--){if(P.entityContainer[k].name===Q[Q.length-1]){O=r.replace(v+"/","");break;}}}}}if(!O){w=r.replace(v+"/","");}}if(w){if(!d.propertyAnnotations){d.propertyAnnotations={};}if(!d.propertyAnnotations[v]){d.propertyAnnotations[v]={};}if(!d.propertyAnnotations[v][w]){d.propertyAnnotations[v][w]={};}y=c._oXPath.selectNodes("./d:Annotation",q);for(var R=0;R<y.length;R+=1){z=c._oXPath.nextNode(y,R);B=c.replaceWithAlias(z.getAttribute("Term"));var U=g(z);if(U){B+="#"+U;}if(z.hasChildNodes()===false){var o={};c.enrichFromPropertyValueAttributes(o,z);if(b(o)){o.Bool="true";}d.propertyAnnotations[v][w][B]=o;}else{d.propertyAnnotations[v][w][B]=c.getPropertyValue(z);}}}else{var V;if(O){if(!d["EntityContainer"]){d["EntityContainer"]={};}if(!d["EntityContainer"][v]){d["EntityContainer"][v]={};}V=d["EntityContainer"][v];}else{if(!d[v]){d[v]={};}V=d[v];}C=v.replace(c._parserData.aliases[u],u);y=c._oXPath.selectNodes("./d:Annotation",q);for(var W=0;W<y.length;W+=1){z=c._oXPath.nextNode(y,W);var X=V;if(O){if(!V[O]){V[O]={};}X=V[O];}c._parseAnnotation(v,z,X);}D=c._oXPath.selectNodes("//d:Annotations[contains(@Target, '"+C+"')]//d:PropertyValue[contains(@Path, '/')]//@Path",c._parserData.xmlDocument);for(i=0;i<D.length;i+=1){E=c._oXPath.nextNode(D,i);F=E.value;if(d.propertyAnnotations){if(d.propertyAnnotations[v]){if(d.propertyAnnotations[v][F]){continue;}}}G=F.split('/');if(c.findNavProperty(v,G[0])){if(!d.expand){d.expand={};}if(!d.expand[v]){d.expand[v]={};}d.expand[v][G[0]]=G[0];}}H=c._oXPath.selectNodes("//d:Annotations[contains(@Target, '"+C+"')]//d:Path[contains(., '/')]",c._parserData.xmlDocument);for(i=0;i<H.length;i+=1){E=c._oXPath.nextNode(H,i);F=c._oXPath.getNodeText(E);if(d.propertyAnnotations&&d.propertyAnnotations[v]&&d.propertyAnnotations[v][F]){continue;}if(!d.expand){d.expand={};}if(!d.expand[v]){d.expand[v]={};}G=F.split('/');if(c.findNavProperty(v,G[0])){if(!d.expand){d.expand={};}if(!d.expand[v]){d.expand[v]={};}d.expand[v][G[0]]=G[0];}}}}if(J.length){d.annotationsAtArrays=J.map(function(Y){return c.backupAnnotationAtArray(Y,d);});}return d;},backupAnnotationAtArray:function(e,m){var q,s=[];function i(){return Array.prototype.filter.call(e.parentNode.childNodes,function(n){return n.nodeType===1;}).indexOf(e);}while(e.nodeName!=="Annotations"){switch(e.nodeName){case"Annotation":q=g(e);s.unshift(e.getAttribute("Term")+(q?"#"+q:""));break;case"Collection":break;case"PropertyValue":s.unshift(e.getAttribute("Property"));break;case"Record":if(e.parentNode.nodeName==="Collection"){s.unshift(i());}break;default:if(e.parentNode.nodeName==="Apply"){s.unshift("Value");s.unshift(i());s.unshift("Parameters");}else{s.unshift(e.nodeName);}break;}e=e.parentNode;}s.unshift(e.getAttribute("Target"));s=s.map(function(S){return typeof S==="string"?c.replaceWithAlias(S):S;});c.syncAnnotationsAtArrays(m,s,true);return s;},restoreAnnotationsAtArrays:function(m){if(m.annotationsAtArrays){m.annotationsAtArrays.forEach(function(s){c.syncAnnotationsAtArrays(m,s);});}},syncAnnotationsAtArrays:function(m,s,w){var i,n=s.length-2,d=s[n+1],p=m,P=s[n],S=P+"@"+d;for(i=0;i<n;i+=1){p=p&&p[s[i]];}if(p&&Array.isArray(p[P])){if(!(S in p)){p[S]=p[P][d];}if(!(d in p[P])){p[P][d]=p[S];}}else if(w){L.warning("Wrong path to annotation at array",s,"sap.ui.model.odata.AnnotationParser");}},_parseAnnotation:function(s,o,d){var q=g(o);var T=c.replaceWithAlias(o.getAttribute("Term"));if(q){T+="#"+q;}var v=c.getPropertyValue(o,s);v=c.setEdmTypes(v,c._parserData.metadataProperties.types,s,c._parserData.schema);d[T]=v;if(Array.isArray(d)){c._parserData.annotationsAtArrays.push(o);}},_parseReferences:function(m){var f=false;var n,i;var x=c._oXPath;var s="//edmx:Reference/edmx:Include[@Namespace and @Alias]";var o=x.selectNodes(s,c._parserData.xmlDocument);for(i=0;i<o.length;++i){f=true;n=x.nextNode(o,i);c._parserData.aliases[n.getAttribute("Alias")]=n.getAttribute("Namespace");}c._parserData.aliasesByLength=Object.keys(c._parserData.aliases).sort(function(h,j){return j.length-h.length;});var r="//edmx:Reference[@Uri]/edmx:IncludeAnnotations[@TermNamespace]";var R=x.selectNodes(r,c._parserData.xmlDocument);for(i=0;i<R.length;++i){f=true;n=x.nextNode(R,i);var T=n.getAttribute("TermNamespace");var d=n.getAttribute("TargetNamespace");var e=n.parentNode.getAttribute("Uri");if(d){if(!m[d]){m[d]={};}m[d][T]=e;}else{m[T]=e;}}return f;},getAllPropertiesMetadata:function(o){var d={},P={},e={},f=false,n,E,C,h={},q={},r={},s=false,u,v,w,T,x,R={types:P};if(!o.dataServices.schema){return R;}for(var i=o.dataServices.schema.length-1;i>=0;i-=1){d=o.dataServices.schema[i];if(d.entityType){n=d.namespace;E=d.entityType;C=d.complexType;for(var j=0;j<E.length;j+=1){h=E[j];r={};q={};if(h.property){for(var k=0;k<h.property.length;k+=1){u=h.property[k];if(u.type.substring(0,n.length)===n){if(C){for(var l=0;l<C.length;l+=1){if(C[l].name===u.type.substring(n.length+1)){if(C[l].property){for(var m=0;m<C[l].property.length;m+=1){v=C[l].property[m];q[C[l].name+"/"+v.name]=v.type;}}}}}}else{w=u.name;T=u.type;if(u.extensions){for(var p=0;p<u.extensions.length;p+=1){x=u.extensions[p];if((x.name==="display-format")&&(x.value==="Date")){T="Edm.Date";}else{s=true;if(!r[w]){r[w]={};}if(x.namespace&&!r[w][x.namespace]){r[w][x.namespace]={};}r[w][x.namespace][x.name]=x.value;}}}q[w]=T;}}}if(!P[n+"."+h.name]){P[n+"."+h.name]={};}P[n+"."+h.name]=q;if(s){if(!e[n+"."+h.name]){f=true;}e[n+"."+h.name]={};e[n+"."+h.name]=r;}}}}if(f){R={types:P,extensions:e};}return R;},setEdmTypes:function(p,P,T,s){function d(e){var o,E='';if(p[e]){o=p[e];if(o.Value&&o.Value.Path){E=c.getEdmType(o.Value.Path,P,T,s);if(E){p[e].EdmType=E;}}else if(o.Path){E=c.getEdmType(o.Path,P,T,s);if(E){p[e].EdmType=E;}}else if(o.Facets){p[e].Facets=c.setEdmTypes(o.Facets,P,T,s);}else if(o.Data){p[e].Data=c.setEdmTypes(o.Data,P,T,s);}else if(e==="Data"){p.Data=c.setEdmTypes(o,P,T,s);}else if(o.Value&&o.Value.Apply){p[e].Value.Apply.Parameters=c.setEdmTypes(o.Value.Apply.Parameters,P,T,s);}else if(o.Value&&o.Type&&(o.Type==="Path")){E=c.getEdmType(o.Value,P,T,s);if(E){p[e].EdmType=E;}}}}if(Array.isArray(p)){for(var v=0;v<p.length;v+=1){d(v);}}else{for(var V in p){d(V);}}return p;},getEdmType:function(p,P,T,s){var i=p.indexOf("/");if(i>-1){var d=p.substr(0,i);var n=c.findNavProperty(T,d);if(n){var m=c._parserData.metadataInstance._getEntityTypeByNavPropertyObject(n);if(m){T=m.entityType;p=p.substr(i+1);}}}if((p.charAt(0)==="@")&&(p.indexOf(s.Alias)===1)){p=p.slice(s.Alias.length+2);}if(p.indexOf("/")>=0){if(P[p.slice(0,p.indexOf("/"))]){T=p.slice(0,p.indexOf("/"));p=p.slice(p.indexOf("/")+1);}}return P[T]&&P[T][p];},enrichFromPropertyValueAttributes:function(m,n){var I={"Property":true,"Qualifier":true,"Term":true,"xmlns":true};for(var i=0;i<n.attributes.length;i+=1){var N=n.attributes[i].name;if(!I[N]&&(N.indexOf("xmlns:")!==0)){var v=n.attributes[i].value;if(N==="EnumMember"&&v.indexOf(" ")>-1){var V=v.split(" ");m[N]=V.map(c.replaceWithAlias).join(" ");}else{m[N]=c.replaceWithAlias(v);}}}return m;},_getRecordValues:function(n){var N=[];var x=c._oXPath;for(var i=0;i<n.length;++i){var o=x.nextNode(n,i);var v=c.getPropertyValues(o);var T=o.getAttribute("Type");if(T){v["RecordType"]=c.replaceWithAlias(T);}N.push(v);}return N;},_getTextValues:function(n){var N=[];var x=c._oXPath;for(var i=0;i<n.length;i+=1){var o=x.nextNode(n,i);var v={};var T=x.getNodeText(o);v[o.nodeName]=c._parserData.aliases?c.replaceWithAlias(T):T;N.push(v);}return N;},_getTextValue:function(n){var x=c._oXPath;var v="";if(n.nodeName in A){v=c.replaceWithAlias(x.getNodeText(n));}else{v=x.getNodeText(n);}if(n.nodeName!=="String"){v=v.trim();}return v;},getPropertyValue:function(d,s){var i;var x=c._oXPath;var p=d.nodeName==="Collection"?[]:{};if(d.hasChildNodes()){var r=x.selectNodes("./d:Record",d);var R=c._getRecordValues(r);var C=x.selectNodes("./d:Collection/d:Record | ./d:Collection/d:If/d:Record",d);var e=c._getRecordValues(C);var P=R.concat(e);if(P.length>0){if(C.length===0&&r.length>0){p=P[0];}else{p=P;}}else{var o=x.selectNodes("./d:Collection/d:AnnotationPath | ./d:Collection/d:NavigationPropertyPath | ./d:Collection/d:PropertyPath",d);if(o.length>0){p=c._getTextValues(o);}else{var f=x.selectNodes("./d:*[not(local-name() = \"Annotation\")]",d);if(f.length>0){for(i=0;i<f.length;i++){var h=x.nextNode(f,i);var v;var n=h.nodeName;var j=h.parentNode.nodeName;if(n==="Apply"){v=c.getApplyFunctions(h);}else{v=c.getPropertyValue(h);}if(M[j]){if(!Array.isArray(p)){p=[];}var V={};V[n]=v;p.push(V);}else if(n==="Collection"){p=v;}else{if(p[n]){L.warning("Annotation contained multiple "+n+" values. Only the last "+"one will be stored: "+x.getPath(h));}p[n]=v;}}c.enrichFromPropertyValueAttributes(p,d);}else if(d.nodeName in t){p=c._getTextValue(d);}else{c.enrichFromPropertyValueAttributes(p,d);}}}var N=x.selectNodes("./d:Annotation",d);if(N.length>0){for(i=0;i<N.length;i++){var k=x.nextNode(N,i);c._parseAnnotation(s,k,p);}}}else if(d.nodeName in t){p=c._getTextValue(d);}else if(d.nodeName.toLowerCase()==="null"){p=null;}else{c.enrichFromPropertyValueAttributes(p,d);}return p;},getPropertyValues:function(p){var P={},i;var x=c._oXPath;var o=x.selectNodes("./d:Annotation",p);var d=x.selectNodes("./d:PropertyValue",p);function e(p,w,N){var l,m=p;while(m.nodeName!=="Annotation"){m=m.parentNode;}l=m.parentNode;return(w+" '"+N+"' is defined twice; "+"Source = "+c._parserData.url+", Annotation Target = "+l.getAttribute("Target")+", Term = "+m.getAttribute("Term"));}if(o.length===0&&d.length===0){P=c.getPropertyValue(p);}else{for(i=0;i<o.length;i++){var f=x.nextNode(o,i);var T=c.replaceWithAlias(f.getAttribute("Term"));a(!P[T],function(){return e(p,"Annotation",T);});P[T]=c.getPropertyValue(f);}for(i=0;i<d.length;i++){var h=x.nextNode(d,i);var s=h.getAttribute("Property");a(!P[s],function(){return e(p,"Property",s);});P[s]=c.getPropertyValue(h);var j=x.selectNodes("./d:Apply",h);for(var n=0;n<j.length;n+=1){var k=x.nextNode(j,n);P[s]={};P[s]['Apply']=c.getApplyFunctions(k);}}}return P;},getApplyFunctions:function(d){var x=c._oXPath;var m={Name:d.getAttribute('Function'),Parameters:[]};var p=x.selectNodes("./d:*",d);for(var i=0;i<p.length;i+=1){var P=x.nextNode(p,i);var e={Type:P.nodeName};if(P.nodeName==="Apply"){e.Value=c.getApplyFunctions(P);}else if(P.nodeName==="LabeledElement"){e.Value=c.getPropertyValue(P);e.Name=e.Value.Name;delete e.Value.Name;}else if(M[P.nodeName]){e.Value=c.getPropertyValue(P);}else{e.Value=x.getNodeText(P);}m.Parameters.push(e);}return m;},findNavProperty:function(e,p){var m=c._parserData.serviceMetadata;for(var i=m.dataServices.schema.length-1;i>=0;i-=1){var o=m.dataServices.schema[i];if(o.entityType){var n=o.namespace+".";var E=o.entityType;for(var k=E.length-1;k>=0;k-=1){if(n+E[k].name===e&&E[k].navigationProperty){for(var j=0;j<E[k].navigationProperty.length;j+=1){if(E[k].navigationProperty[j].name===p){return E[k].navigationProperty[j];}}}}}}return null;},replaceWithAlias:function(v){c._parserData.aliasesByLength.some(function(s){if(v.includes(s+".")&&!v.includes("."+s+".")){v=v.replace(s+".",c._parserData.aliases[s]+".");return true;}return false;});return v;},getXPath:function(){var x={};var p=c._parserData;x={setNameSpace:function(o){return o;},nsResolver:function(d){var n={"edmx":"http://docs.oasis-open.org/odata/ns/edmx","d":"http://docs.oasis-open.org/odata/ns/edm"};return n[d]||null;},selectNodes:function(P,i){var d=p.xmlDocument.evaluate(P,i,this.nsResolver,7,null);d.length=d.snapshotLength;return d;},nextNode:function(n,i){return n.snapshotItem(i);},getNodeText:function(n){return n.textContent;}};x.getPath=function(n){var P="";var I="getAttribute"in n?n.getAttribute("id"):"";var T=n.tagName?n.tagName:"";if(I){P='id("'+I+'")';}else if(n instanceof Document){P="/";}else if(T.toLowerCase()==="body"){P=T;}else if(n.parentNode){var d=1;for(var i=0;i<n.parentNode.childNodes.length;++i){if(n.parentNode.childNodes[i]===n){P=x.getPath(n.parentNode)+"/"+T+"["+d+"]";break;}else if(n.parentNode.childNodes[i].nodeType===1&&n.parentNode.childNodes[i].tagName===T){++d;}}}else{L.error("Wrong Input node - cannot find XPath to it: "+T);}return P;};return x;}};return c;});
