/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/util/deepExtend","sap/base/util/extend","sap/ui/model/ChangeReason","sap/ui/model/Context","sap/ui/model/ContextBinding"],function(d,e,C,a,b){"use strict";var O=b.extend("sap.ui.model.odata.v2.ODataContextBinding",{constructor:function(m,p,c,P,E){b.call(this,m,p,c,P,E);this.sRefreshGroupId=undefined;this.bPendingRequest=false;this.mParameters=d({},this.mParameters);this.bCreatePreliminaryContext=this.mParameters.createPreliminaryContext||m.bPreliminaryContext;this.bUsePreliminaryContext=this.mParameters.usePreliminaryContext||m.bPreliminaryContext;this.mParameters.createPreliminaryContext=this.bCreatePreliminaryContext;this.mParameters.usePreliminaryContext=this.bUsePreliminaryContext;this.bPendingRequest=false;}});O.prototype.initialize=function(){var c,r,R,p=this.oContext&&this.oContext.isPreliminary(),f=this.isRelative()&&this.oContext&&this.oContext.isTransient&&this.oContext.isTransient(),t=this;if(!this.oModel.oMetadata.isLoaded()||!this.bInitial){return;}this.bInitial=false;if(p&&!this.bUsePreliminaryContext){return;}R=this.getResolvedPath();if(!R||f){this.oElementContext=null;this._fireChange({reason:C.Context});return;}r=this.oModel._isReloadNeeded(R,this.mParameters);if(r){this.fireDataRequested();this.bPendingRequest=true;}c=this.oModel.createBindingContext(this.sPath,this.oContext,this.mParameters,function(n){var D,F=n&&n.isRefreshForced(),u=n&&n.isUpdated();if(t.bCreatePreliminaryContext&&n&&t.oElementContext){t.oElementContext.setPreliminary(false);t.oModel._updateContext(t.oElementContext,n.getPath());t._fireChange({reason:C.Context},false,true);}else if(!n||a.hasChanged(n,t.oElementContext)){t.oElementContext=n;t._fireChange({reason:C.Context},F,u);}if(r){if(t.oElementContext){D=t.oElementContext.getObject(t.mParameters);}t.oModel.callAfterUpdate(function(){t.fireDataReceived({data:D});});t.bPendingRequest=false;}},r);if(c){if(this.bCreatePreliminaryContext&&this.oElementContext!==c){c.setPreliminary(true);this.oElementContext=c;this.oModel.oMetadata.loaded().then(function(){this._fireChange({reason:C.Context});}.bind(this));}}else if(this.oContext){this.oElementContext=null;this._fireChange({reason:C.Context});}};O.prototype.checkUpdate=function(){var c,p=this.mParameters,P=this.oContext&&this.oContext.isPreliminary();if(this.bInitial||this.bPendingRequest){return;}if(this.oContext&&this.oContext.isUpdated()){this.setContext(this.oContext);return;}if(P&&!this.bUsePreliminaryContext){return;}if(p.createPreliminaryContext){p=Object.assign({},p);delete p.createPreliminaryContext;}c=this.oModel.createBindingContext(this.sPath,this.oContext,p);if(c!==undefined&&c!==this.oElementContext){this.oElementContext=c;this._fireChange({reason:C.Context});}};O.prototype.refresh=function(f,g){if(typeof f==="string"){g=f;f=false;}this.sRefreshGroupId=g;this._refresh(f);this.sRefreshGroupId=undefined;};O.prototype._refresh=function(f,c){var o,s,D,k,S,g=false,p=this.mParameters,r=this.isRelative()&&this.oContext&&this.oContext.isTransient&&this.oContext.isTransient(),R=this.getResolvedPath(),t=this;if(this.bInitial||r){return;}if(c){S=this.oModel._getObject(this.sPath,this.oContext);if(S){k=this.oModel._getKey(S);if(k in c){g=true;}}}else{g=true;}if(f||g){if(R){this.fireDataRequested();this.bPendingRequest=true;}if(this.sRefreshGroupId){p=e({},this.mParameters);p.groupId=this.sRefreshGroupId;}o=this.oModel.createBindingContext(this.sPath,this.oContext,p,function(n){if(t.bCreatePreliminaryContext&&n&&t.oElementContext){t.oElementContext.setPreliminary(false);t.oModel._updateContext(t.oElementContext,n.getPath());t._fireChange({reason:C.Context},false,true);}else if(a.hasChanged(n,t.oElementContext)||f){t.oElementContext=n;t._fireChange({reason:C.Context},f);}if(t.oElementContext){D=t.oElementContext.getObject(t.mParameters);}if(R){t.oModel.callAfterUpdate(function(){t.fireDataReceived({data:D});});t.bPendingRequest=false;}},true);if(o&&this.bCreatePreliminaryContext){if(this.oElementContext!==o||f){o.setPreliminary(true);this.oElementContext=o;s=this.oElementContext.sPath;this.oModel._updateContext(this.oElementContext,R);this._fireChange({reason:C.Context},f);this.oModel._updateContext(this.oElementContext,s);}}}};O.prototype.setContext=function(c){var B,s,D,r,R,f=c&&c.isRefreshForced(),p=c&&c.isPreliminary(),t=c&&c.isTransient&&c.isTransient(),u=c&&c.isUpdated(),g=this;if(this.bInitial||!this.isRelative()){return;}if(p&&!this.bUsePreliminaryContext){return;}if(u&&this.bUsePreliminaryContext){this._fireChange({reason:C.Context});return;}if(a.hasChanged(this.oContext,c)){this.oContext=c;R=this.getResolvedPath();if(!R||t){if(this.oElementContext!==null){this.oElementContext=null;this._fireChange({reason:C.Context});}return;}D=this.oModel._getObject(this.sPath,this.oContext);r=f||this.oModel._isReloadNeeded(R,this.mParameters);if(R&&r){this.fireDataRequested();this.bPendingRequest=true;}B=this.oModel.createBindingContext(this.sPath,this.oContext,this.mParameters,function(c){if(g.bCreatePreliminaryContext&&c&&g.oElementContext){g.oElementContext.setPreliminary(false);g.oModel._updateContext(g.oElementContext,c.getPath());g._fireChange({reason:C.Context},false,true);}else if(a.hasChanged(c,g.oElementContext)){g.oElementContext=c;g._fireChange({reason:C.Context},f,u);}if(R&&r){if(g.oElementContext){D=g.oElementContext.getObject(g.mParameters);}g.oModel.callAfterUpdate(function(){g.fireDataReceived({data:D});});g.bPendingRequest=false;}},r);if(B){if(this.bCreatePreliminaryContext){B.setPreliminary(true);this.oElementContext=B;s=this.oElementContext.sPath;this.oModel._updateContext(this.oElementContext,R);this._fireChange({reason:C.Context},f);this.oModel._updateContext(this.oElementContext,s);}}else if(this.oContext&&this.oElementContext!==null){this.oElementContext=null;this._fireChange({reason:C.Context});}}};O.prototype._fireChange=function(p,f,u){if(this.oElementContext){this.oElementContext.setForceRefresh(f);this.oElementContext.setUpdated(u);}b.prototype._fireChange.call(this,p);if(this.oElementContext){this.oElementContext.setForceRefresh(false);this.oElementContext.setUpdated(false);}};return O;});
