/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["./lib/_Helper","sap/ui/base/SyncPromise","sap/ui/model/ChangeReason","sap/ui/model/odata/OperationMode","sap/ui/model/odata/v4/Context"],function(_,S,C,O,a){"use strict";var c=[C.Context,C.Change,C.Refresh,C.Sort,C.Filter],s="sap.ui.model.odata.v4.ODataBinding",r=/\/\d|\(\$uid=/;function h(e,f){return c.indexOf(e)>c.indexOf(f);}function b(){this.mCacheByResourcePath=undefined;this.oCache=null;this.oCachePromise=S.resolve(null);this.mCacheQueryOptions=undefined;this.oFetchCacheCallToken=undefined;this.mLateQueryOptions=undefined;this.sReducedPath=undefined;this.sResumeChangeReason=undefined;}b.prototype.adjustPredicate=function(t,p){this.sReducedPath=this.sReducedPath.replace(t,p);};b.prototype.assertSameCache=function(e){var E;if(this.oCache!==e){E=new Error(this+" is ignoring response from inactive cache: "+e);E.canceled=true;throw E;}};b.prototype.checkBindingParameters=function(p,A){var t=this;Object.keys(p).forEach(function(k){var v=p[k];if(!k.startsWith("$$")){return;}if(A.indexOf(k)<0){throw new Error("Unsupported binding parameter: "+k);}switch(k){case"$$aggregation":break;case"$$groupId":case"$$updateGroupId":t.oModel.checkGroupId(v,false,"Unsupported value for binding parameter '"+k+"': ");break;case"$$ignoreMessages":if(v!==true&&v!==false){throw new Error("Unsupported value for binding parameter "+"'$$ignoreMessages': "+v);}break;case"$$inheritExpandSelect":if(v!==true&&v!==false){throw new Error("Unsupported value for binding parameter "+"'$$inheritExpandSelect': "+v);}if(!t.oOperation){throw new Error("Unsupported binding parameter $$inheritExpandSelect: "+"binding is not an operation binding");}if(p.$expand){throw new Error("Must not set parameter $$inheritExpandSelect on a binding "+"which has a $expand binding parameter");}break;case"$$operationMode":if(v!==O.Server){throw new Error("Unsupported operation mode: "+v);}break;case"$$canonicalPath":case"$$noPatch":case"$$ownRequest":case"$$patchWithoutSideEffects":case"$$sharedRequest":if(v!==true){throw new Error("Unsupported value for binding parameter '"+k+"': "+v);}break;default:throw new Error("Unknown binding-specific parameter: "+k);}});};b.prototype.checkSuspended=function(i){var R=this.getRootBinding();if(R&&R.isSuspended()&&(!i||this.isRoot()||this.getResumeChangeReason())){throw new Error("Must not call method when the binding's root binding is suspended: "+this);}};b.prototype.checkUpdate=function(f){if(arguments.length>1){throw new Error("Only the parameter bForceUpdate is supported");}this.checkUpdateInternal(f).catch(this.oModel.getReporter());};b.prototype.createAndSetCache=function(q,R,o,e,f){var g,D,G;this.mCacheQueryOptions=Object.assign({},this.oModel.mUriParameters,q);if(this.bRelative){if(o.isTransient&&o.isTransient()&&o.getProperty("@$ui5.context.isTransient")){this.oCache=null;return null;}g=this.mCacheByResourcePath&&this.mCacheByResourcePath[R];G=o.getGeneration&&o.getGeneration()||0;if(g&&g.$generation>=G){g.setActive(true);}else{D=this.oModel.resolve(this.sPath,o).slice(1);g=this.doCreateCache(R,this.mCacheQueryOptions,o,D,e,f);if(!(this.mParameters&&this.mParameters.$$sharedRequest)){this.mCacheByResourcePath=this.mCacheByResourcePath||{};this.mCacheByResourcePath[R]=g;}g.$deepResourcePath=D;g.$generation=G;}}else{g=this.doCreateCache(R,this.mCacheQueryOptions,undefined,undefined,e,f);}if(f!==g){if(f){f.setActive(false);}if(this.mLateQueryOptions){g.setLateQueryOptions(this.mLateQueryOptions);}}this.oCache=g;return g;};b.prototype.destroy=function(){this.mCacheByResourcePath=undefined;this.oCachePromise.then(function(o){if(o){o.setActive(false);}},function(){});this.oCache=null;this.oCachePromise=S.resolve(null);this.mCacheQueryOptions=undefined;this.oContext=undefined;this.oFetchCacheCallToken=undefined;};b.prototype.doDeregisterChangeListener=function(p,l){this.oCache.deregisterChange(p,l);};b.prototype.fetchCache=function(o,i,k,K){var e=this.oCache,f={oOldCache:e===undefined?this.oFetchCacheCallToken.oOldCache:e},p,t=this;if(!this.bRelative){o=undefined;}if(!e&&k){if(e===undefined){throw new Error("Unsupported bKeepQueryOptions while oCachePromise is pending");}return;}this.oCache=undefined;this.oFetchCacheCallToken=f;if(k){this.oCachePromise=S.resolve(Promise.resolve()).then(function(){return t.createAndSetCache(t.mCacheQueryOptions,e.getResourcePath(),o,K,e);});return;}p=[this.fetchQueryOptionsForOwnCache(o,i),this.oModel.oRequestor.ready()];this.mCacheQueryOptions=undefined;this.oCachePromise=S.all(p).then(function(R){var q=R[0].mQueryOptions;t.sReducedPath=R[0].sReducedPath;if(q&&!(o&&o.iIndex===a.VIRTUAL)){return t.fetchResourcePath(o).then(function(g){var E;if(t.oFetchCacheCallToken!==f){E=new Error("Cache discarded as a new cache has been created");E.canceled=true;throw E;}return t.createAndSetCache(q,g,o,K,f.oOldCache);});}t.oCache=null;return null;});this.oCachePromise.catch(function(E){t.oModel.reportError("Failed to create cache for binding "+t,s,E);});};b.prototype.fetchQueryOptionsForOwnCache=function(o,i){var H,q,R=this.oModel.resolve(this.sPath,o),t=this;function w(Q,e){return S.resolve(Q).then(function(m){return{mQueryOptions:m,sReducedPath:e||R};});}if(this.oOperation||this.bRelative&&!o||this.isMeta()){return w(undefined);}q=this.doFetchQueryOptions(o);if(this.oModel.bAutoExpandSelect&&this.aChildCanUseCachePromises&&!(this.mParameters&&this.mParameters.$$aggregation)){q=S.all([q,Promise.resolve().then(function(){return S.all(t.aChildCanUseCachePromises);})]).then(function(e){t.aChildCanUseCachePromises=[];t.updateAggregatedQueryOptions(e[0]);return t.mAggregatedQueryOptions;});}if(i||!this.bRelative||!o.fetchValue){return w(q);}if(this.oModel.bAutoExpandSelect){H=this.mParameters&&Object.keys(t.mParameters).some(function(k){return k[0]!=="$"||k[1]==="$";});if(H){return w(q);}return o.getBinding().fetchIfChildCanUseCache(o,t.sPath,q).then(function(e){return w(e?undefined:q,e);});}if(this.mParameters&&Object.keys(this.mParameters).length){return w(q);}return q.then(function(Q){return w(Object.keys(Q).length?Q:undefined);});};b.prototype.fetchResourcePath=function(o){var e,f,g,t=this;if(!this.bRelative){return S.resolve(this.sPath.slice(1));}o=o||this.oContext;if(!o){return S.resolve();}f=o.getPath();e=o.fetchCanonicalPath&&(this.mParameters&&this.mParameters.$$canonicalPath||r.test(f));g=e?o.fetchCanonicalPath():S.resolve(f);return g.then(function(i){return _.buildPath(i,t.sPath).slice(1);});};b.prototype.getGroupId=function(){return this.sGroupId||(this.bRelative&&this.oContext&&this.oContext.getGroupId&&this.oContext.getGroupId())||this.oModel.getGroupId();};b.prototype.getRelativePath=function(p){var R;if(p[0]==="/"){R=_.getRelativePath(p,this.getResolvedPath());if(R===undefined&&this.oReturnValueContext){R=_.getRelativePath(p,this.oReturnValueContext.getPath());}return R;}return p;};b.prototype.getResumeChangeReason=function(){var e=this.sResumeChangeReason;this.getDependentBindings().forEach(function(D){var f=D.getResumeChangeReason();if(f&&h(f,e)){e=f;}});return e;};b.prototype.getRootBinding=function(){if(this.bRelative){if(!this.oContext){return undefined;}if(this.oContext.getBinding){return this.oContext.getBinding().getRootBinding();}}return this;};b.prototype.getRootBindingResumePromise=function(){var R=this.getRootBinding();return R&&R.getResumePromise()||S.resolve();};b.prototype.getUpdateGroupId=function(){return this.sUpdateGroupId||(this.bRelative&&this.oContext&&this.oContext.getUpdateGroupId&&this.oContext.getUpdateGroupId())||this.oModel.getUpdateGroupId();};b.prototype.hasPendingChanges=function(i){return this.isResolved()&&(this.hasPendingChangesForPath("",i)||this.hasPendingChangesInDependents(i));};b.prototype.hasPendingChangesForPath=function(p,i){return this.withCache(function(o,e,B){return o.hasPendingChangesForPath(e,i,i&&B.isRoot());},p,true).unwrap();};b.prototype.hasPendingChangesInCaches=function(R){var t=this;if(!this.mCacheByResourcePath){return false;}return Object.keys(this.mCacheByResourcePath).some(function(e){var o=t.mCacheByResourcePath[e];return o.$deepResourcePath.startsWith(R)&&o.hasPendingChangesForPath("");});};b.prototype.isInitial=function(){throw new Error("Unsupported operation: isInitial");};b.prototype.isRoot=function(){return!this.bRelative||this.oContext&&!this.oContext.getBinding;};b.prototype.isRootBindingSuspended=function(){var R=this.getRootBinding();return R&&R.isSuspended();};b.prototype.lockGroup=function(g,l,m,f){g=g||(m?this.getUpdateGroupId():this.getGroupId());return this.oModel.lockGroup(g,this,l,m,f);};b.prototype.refresh=function(g){if(typeof g==="boolean"){throw new Error("Unsupported parameter bForceUpdate");}this.requestRefresh(g).catch(this.oModel.getReporter());};b.prototype.refreshSuspended=function(g){if(g&&g!==this.getGroupId()){throw new Error(this+": Cannot refresh a suspended binding with group ID '"+g+"' (own group ID is '"+this.getGroupId()+"')");}this.setResumeChangeReason(C.Refresh);};b.prototype.removeCachesAndMessages=function(R,e){var t=this;if(!e&&this.oCache){this.oCache.removeMessages();}if(this.mCacheByResourcePath){Object.keys(this.mCacheByResourcePath).forEach(function(f){var o=t.mCacheByResourcePath[f],D=o.$deepResourcePath;if(_.hasPathPrefix(D,R)){if(!e){o.removeMessages();}delete t.mCacheByResourcePath[f];}});}};b.prototype.requestAbsoluteSideEffects=function(g,A){var p=[],m=_.getMetaPath(this.getResolvedPath());A.some(function(e){var R=_.getRelativePath(e,m);if(R!==undefined){p.push(R);}else if(_.hasPathPrefix(m,e)){p=[""];return true;}});if(p.length){if(this.requestSideEffects){return this.requestSideEffects(g,p);}return this.refreshInternal("",g,true,true);}};b.prototype.requestRefresh=function(g){if(!this.isRoot()){throw new Error("Refresh on this binding is not supported");}if(this.hasPendingChanges()){throw new Error("Cannot refresh due to pending changes");}this.oModel.checkGroupId(g);return Promise.resolve(this.refreshInternal("",g,true)).then(function(){});};b.prototype.resetChanges=function(){var p=[];this.checkSuspended();this.resetChangesForPath("",p);this.resetChangesInDependents(p);this.resetInvalidDataState();return Promise.all(p).then(function(){});};b.prototype.resetChangesForPath=function(p,P){P.push(this.withCache(function(o,e){o.resetChangesForPath(e);},p).unwrap());};b.prototype.resetInvalidDataState=function(){};b.prototype.setResumeChangeReason=function(e){if(h(e,this.sResumeChangeReason)){this.sResumeChangeReason=e;}};b.prototype.toString=function(){return this.getMetadata().getName()+": "+(this.bRelative?this.oContext+"|":"")+this.sPath;};b.prototype.withCache=function(p,P,e,w){var o=e?S.resolve(this.oCache):this.oCachePromise,R,t=this;P=P||"";return o.then(function(f){if(f){R=t.getRelativePath(P);if(R!==undefined){return p(f,R,t);}}else if(f===undefined){return undefined;}else if(t.oOperation){return w?p(null,t.getRelativePath(P),t):undefined;}if(t.bRelative&&t.oContext&&t.oContext.withCache){return t.oContext.withCache(p,P[0]==="/"?P:_.buildPath(t.sPath,P),e,w);}return undefined;});};function d(p){if(this){b.apply(this,arguments);}else{Object.assign(p,b.prototype);}}["adjustPredicate","destroy","doDeregisterChangeListener","hasPendingChangesForPath"].forEach(function(m){d.prototype[m]=b.prototype[m];});return d;},false);
