/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/core/Core',"sap/ui/VersionInfo"],function(c,V){"use strict";var C={};var a=["sap.chart.Chart","sap.m.ColumnHeaderPopover","sap.m.FacetFilterItem","sap.m.internal.NumericInput","sap.m.IconTabBarSelectList","sap.m.LightBox","sap.m.Menu","sap.m.NotificationListBase","sap.m.NotificationListItem","sap.m.QuickViewBase","sap.m.QuickViewGroup","sap.m.QuickViewGroupElement","sap.m.TabStripItem","sap.m.TimePickerSlider","sap.m.TimePickerSliders","sap.m.UploadCollectionToolbarPlaceholder","sap.m.Wizard","sap.makit.Chart","sap.me.TabContainer","sap.suite.ui.microchart.InteractiveBarChart","sap.suite.ui.microchart.InteractiveDonutChart","sap.tnt.NavigationList","sap.ui.comp.smartform.Group","sap.ui.comp.smartform.GroupElement","sap.ui.comp.valuehelpdialog.ValueHelpDialog","sap.ui.core.mvc.HTMLView","sap.ui.core.mvc.JSONView","sap.ui.core.mvc.JSView","sap.ui.core.mvc.TemplateView","sap.ui.core.mvc.View","sap.ui.core.mvc.XMLView","sap.ui.core.tmpl.Template","sap.ui.core.UIComponent","sap.ui.core.util.Export","sap.ui.documentation.BorrowedList","sap.ui.documentation.LightTable","sap.ui.integration.cards.AnalyticalContent","sap.ui.integration.cards.AnalyticsCloudContent","sap.ui.integration.cards.CalendarContent","sap.ui.layout.BlockLayoutRow","sap.ui.layout.form.ResponsiveGridLayoutPanel","sap.ui.layout.form.ResponsiveLayoutPanel","sap.ui.mdc.chart.ChartTypeButton","sap.ui.richtexteditor.RichTextEditor","sap.ui.richtexteditor.ToolbarWrapper","sap.ui.rta.AddElementsDialog","sap.ui.rta.ContextMenu","sap.ui.suite.TaskCircle","sap.ui.table.ColumnMenu","sap.ui.unified.Menu","sap.ui.ux3.ActionBar","sap.ui.ux3.ExactList.LB","sap.ui.ux3.NotificationBar","sap.uiext.inbox.composite.InboxTaskTitleControl","sap.uiext.inbox.InboxFormattedTextView","sap.uiext.inbox.InboxTaskDetails","sap.uiext.inbox.InboxToggleTextView","sap.uiext.inbox.SubstitutionRulesManager","sap.uxap.AnchorBar","sap.uxap.BlockBase","sap.uxap.BreadCrumbs","sap.uxap.ObjectPageHeader","sap.uxap.ObjectPageSubSection","sap.viz.ui5.controls.common.BaseControl","sap.viz.ui5.controls.VizRangeSlider","sap.viz.ui5.controls.VizTooltip","sap.viz.ui5.core.BaseChart"];function b(i,r){if(!e(i,r)){return false;}if(a.indexOf(i)>-1){return false;}return true;}var d=["sap.makit.Chart","sap.ui.commons.SearchField","sap.ui.commons.SearchField.CB","sap.ui.commons.SearchFieldCB","sap.ui.commons.Tab","sap.ui.comp.transport.TransportDialog","sap.ui.core.ComponentContainer","sap.ui.core.mvc.HTMLView","sap.ui.core.mvc.JSONView","sap.ui.core.mvc.JSView","sap.ui.core.mvc.TemplateView","sap.ui.core.mvc.View","sap.ui.core.mvc.XMLView","sap.ui.core.XMLComposite","sap.ui.mdc.BaseControl","sap.ui.mdc.odata.v4.microchart.MicroChart","sap.ui.mdc.ValueHelpDialog","sap.ui.mdc.XMLComposite","sap.ui.rta.AddElementsDialog","sap.ui.rta.ContextMenu"];function e(i,r){if(d.indexOf(i)>-1){return false;}if(!r){return false;}var M=r.getMetadata();if(M.isAbstract()){return false;}return true;}C.aKnownOpenUI5Libraries=["sap.f","sap.m","sap.tnt","sap.ui.codeeditor","sap.ui.commons","sap.ui.core","sap.ui.documentation","sap.ui.dt","sap.ui.fl","sap.ui.integration","sap.ui.layout","sap.ui.rta","sap.ui.suite","sap.ui.support","sap.ui.table","sap.ui.unified","sap.ui.ux3","sap.uxap"];C.aKnownRuntimeLayerLibraries=C.aKnownOpenUI5Libraries.concat(["sap.chart","sap.makit","sap.me","sap.ndc","sap.suite.ui.microchart","sap.ui.comp","sap.ui.generic.app","sap.ui.generic.template","sap.ui.mdc","sap.ui.richtexteditor","sap.viz"]);C.isKnownRuntimeLayerLibrary=function(L){return C.aKnownRuntimeLayerLibraries.indexOf(L)>-1;};function n(){}function f(){return true;}function g(){return false;}function t(L){return L.name;}function h(F){F=F||f;return V.load().then(function(i){return i.libraries.map(t).filter(F);}).then(function(L){return Promise.all(L.map(function(i){return c.loadLibrary(i,{async:true}).catch(n);}));}).then(function(){var L=c.getLoadedLibraries();for(var i in L){if(!F(i)){delete L[i];}}return L;});}function l(i){var M=i.replace(/\./g,"/");return new Promise(function(r,u){sap.ui.require([M],function(F){r(F);},function(E){u(new Error("failed to load class "+M+":"+E));});});}function m(L,E,i){if(L){return function(r){return L.indexOf(r)>=0;};}else if(i){return function(r){return E.indexOf(r)<0;};}return function(r){return E.indexOf(r)<0&&(i||C.isKnownRuntimeLayerLibrary(r));};}C.loadLibraries=function(L){if(L==="openui5"){L=C.aKnownOpenUI5Libraries;}else if(L==="sapui5.runtime"){L=C.aKnownRuntimeLayerLibraries;}var F;if(Array.isArray(L)){F=m(L);}else if(typeof L==="function"){F=L;}else if(L==null){F=f;}else{throw new TypeError("unexpected filter "+L);}return h(F);};function j(L,Q){Q.test("Should load at least one library and some controls",function(i){i.expect(2);var r=false;for(var u in L){if(L[u]){if(!r){i.ok(L[u],"Should have loaded at least one library");r=true;}var v=L[u].controls?L[u].controls.length:0;if(v>0){i.ok(v>0,"Should find at least 10 controls in a library");break;}}}});}var s=function(i,r,E,I,u){if(!i||r.length&&r.indexOf(i)<0||E.indexOf(i)>=0){return Promise.resolve(false);}return l(i).then(function(F){var v={name:i,"class":F,canBeInstantiated:e(i,F),canBeRendered:b(i,F)};if(!u&&!v.canBeInstantiated){return false;}if(!I&&!v.canBeRendered){return false;}return v;},g);};var k=function(r,u,E,I,v,w){return new Promise(function(x,y){var z=0;var A=function(i){if(i<r.length){var B=r[i];o(B,u,E,I,v,w).then(function(D){if(D){z++;}A(i+1);});}else{x(z);}};A(0);});};function o(i,r,E,I,u,v){return s(i,r,E,I,u).then(function(w){if(w){v(i,w.class,{canInstantiate:w.canBeInstantiated,canRender:w.canBeRendered});}return new Promise(function(x){setTimeout(function(){x(!!w);},0);});});}C.run=function(i,O){window.setTimeout(function(){_(i,O);},1);};function _(i,O){if(!O){O={};}var D=O.done||n;var L=O.librariesToTest||undefined;var E=O.excludedLibraries||[];var r=O.controlsToTest||[];var u=O.excludedControls||[];var I=(O.includeDistLayer!==undefined)?O.includeDistLayer:false;var v=(O.includeElements!==undefined)?O.includeElements:false;var w=(O.includeNonRenderable!==undefined)?O.includeNonRenderable:true;var x=(O.includeNonInstantiable!==undefined)?O.includeNonInstantiable:false;var Q=O.qunit;if(Q){Q.test("Checking the given QUnit object",function(y){y.ok(true,"The given QUnit should be able to assert");});}else{var y={ok:function(z,T){if(!z){throw new Error(T);}},expect:n};Q={module:n,test:function(z,i){i(y);}};}Q.test("Checking the given options",function(y){y.ok(O.librariesToTest===undefined||Array.isArray(O.librariesToTest),"The given librariesToTest must be undefined or an array, but is: "+O.librariesToTest);y.ok(O.excludedLibraries===undefined||Array.isArray(O.excludedLibraries),"The given excludedLibraries must be undefined or an array, but is: "+O.excludedLibraries);y.ok(O.excludedControls===undefined||Array.isArray(O.excludedControls),"The given excludedControls must be undefined or an array, but is: "+O.excludedControls);y.ok(O.includeDistLayer===undefined||typeof O.includeDistLayer==="boolean","The given includeDistLayer must be undefined or a boolean, but is: "+O.includeDistLayer);y.ok(O.includeElements===undefined||typeof O.includeElements==="boolean","The given includeElements must be undefined or a boolean, but is: "+O.includeElements);y.ok(O.includeNonRenderable===undefined||typeof O.includeNonRenderable==="boolean","The given includeNonRenderable must be undefined or a boolean, but is: "+O.includeNonRenderable);y.ok(O.includeNonInstantiable===undefined||typeof O.includeNonInstantiable==="boolean","The given includeNonInstantiable must be undefined or a boolean, but is: "+O.includeNonInstantiable);y.ok(D===undefined||typeof D==="function","The given done callback must be undefined or a function, but is: "+D);});var F=m(L,E,I);return h(F).then(function(z){j(z,Q);return z;}).then(function(z){return p(z,v,r,u,w,x,i).then(function(R){D({testedControlCount:R[0],testedLibraryCount:R[1]});});});}function p(L,I,r,E,u,v,w){return new Promise(function(x){var y=Object.keys(L),z=0,A=0;var B=function(i){if(i<y.length){var D=y[i];q(L,D,I,r,E,u,v,w).then(function(R){z+=R[0];if(R[1]){A++;}B(i+1);});}else{x([z,A]);}};B(0);});}function q(L,i,I,r,E,u,v,w){return new Promise(function(x){var y=L[i];if(!y){x([0,false]);return;}var z=y.controls;if(I){z=z.concat(y.elements.slice());}k(z,r,E,u,v,w).then(function(A){x([A,true]);});});}return C;},true);
