/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/m/Button","sap/m/Dialog","sap/m/DialogRenderer","sap/m/GenericTile","sap/m/ImageContent","sap/m/Input","sap/m/Label","sap/m/SelectDialog","sap/m/StandardListItem","sap/m/TextArea","sap/m/TileContent","sap/m/VBox","sap/ui/core/library","sap/ui/core/IconPool","sap/ui/core/Title","sap/ui/layout/form/SimpleForm","sap/ui/model/Filter","sap/ui/model/FilterOperator","sap/ui/model/json/JSONModel","sap/ui/rta/Utils","sap/ui/layout/form/SimpleFormLayout","sap/ui/layout/form/ResponsiveGridLayout"],function(B,D,a,G,I,b,L,S,c,T,d,V,e,f,g,h,F,i,J,R,j){"use strict";var k=e.ValueState;var r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.rta");var o;var t;var l;var s;var m;var n;var p;var q;var u;var v;var w;var C;var x;function _(){o=new G("tile",{header:"{/title}",subheader:"{/subtitle}",ariaLabel:r.getText("APP_VARIANT_TILE_ARIA_LABEL"),tileContent:[new d({content:[new I({src:"{/icon}"})]})]}).addStyleClass("sapUiMediumMarginBegin").addStyleClass("sapUiTinyMarginTop").addStyleClass("sapUiTinyMarginBottom");}function y(N){var O=N.getParameter("value");var P=new F("name",i.Contains,O);var Q=N.getSource().getBinding("items");Q.filter([P]);}function z(N){var O=N.getParameter("selectedContexts");if(O&&O.length){O.forEach(function(P){var Q=P.getObject().name;u.setValue(Q);C.setProperty("/icon",P.getObject().icon);});}N.getSource().getBinding("items").filter([]);}function A(){if(!w){w=new S("selectDialog",{noDataText:r.getText("APP_VARIANT_ICON_NO_DATA"),title:r.getText("APP_VARIANT_ICON_SELECT_ICON"),search:function(O){y(O);},confirm:function(O){z(O);},cancel:function(O){z(O);}});}w.addStyleClass(R.getRtaStyleClassName());w.bindAggregation("items",{path:"/icons",template:new c({title:"{name}",description:"",icon:"{icon}",iconDensityAware:false,iconInset:false,type:"Active"})});var U=f.getIconNames();var N=[];U.forEach(function(O){var P=f.getIconInfo(O);N.push({icon:P.uri,name:(P.text==="")?O.toLowerCase():P.text});});x.setProperty("/icons",N);w.setModel(x);w.getBinding("items").filter([]);w.open();}function E(){t=new L({required:true,text:r.getText("APP_DIALOG_TITLE_TEXT"),textAlign:"Left"});l=new b("titleInput",{value:"{/title}",valueLiveUpdate:true,placeholder:r.getText("SAVE_AS_DIALOG_PLACEHOLDER_TITLE_TEXT"),liveChange:function(){var N=sap.ui.getCore().byId("saveButton");if(this.getValue()===""){this.setValueState(k.Error);N.setEnabled(false);}else{this.setValueState(k.None);N.setEnabled(true);}}});s=new L({text:r.getText("APP_DIALOG_SUB_TITLE_TEXT"),textAlign:"Left"});m=new b({value:"{/subtitle}",valueLiveUpdate:true});n=new L({text:r.getText("APP_DIALOG_DESCRIPTION_TEXT"),textAlign:"Left"});p=new T({rows:4});q=new L({text:r.getText("APP_DIALOG_ICON_TEXT"),textAlign:"Left"});u=new b("selectInput",{showValueHelp:true,liveChange:function(N){A(N);},valueHelpRequest:function(N){A(N);},value:"{/iconname}",valueLiveUpdate:true});}function H(){v=new h({editable:true,layout:j.ResponsiveGridLayout,labelSpanXL:4,labelSpanL:4,labelSpanM:4,labelSpanS:4,adjustLabelSpan:false,emptySpanXL:0,emptySpanL:0,emptySpanM:0,emptySpanS:0,columnsXL:2,columnsL:2,columnsM:2,singleContainerFullSize:false,content:[new g("title1"),t,l,s,m,q,u,n,p,new g("title2"),o]});return v;}function K(){var N=new V({items:[H()]}).addStyleClass("sapUISmallMargin");return N;}var M=D.extend("sap.ui.rta.appVariant.AppVariantDialog",{metadata:{library:"sap.ui.rta",events:{create:{},cancel:{}}},init:function(){D.prototype.init.apply(this);this.setTitle(r.getText("CREATE_APP_VARIANT_DIALOG_TITLE"));this.setContentWidth("860px");this.setContentHeight("250px");C=new J({title:null,subtitle:null,icon:" ",iconname:null});x=new J({icons:null});sap.ui.getCore().setModel(C);_();E();this.addContent(K());this._createButtons();this.addStyleClass(R.getRtaStyleClassName());},onAfterRendering:function(){document.getElementById('title1').style.height="0px";document.getElementById('title2').style.height="0px";document.getElementById('tile').style.float="left";},_onCreate:function(){var N=l.getValue()||" ";var O=m.getValue()||" ";var P=p.getValue()||" ";var Q=u.getValue()?f.getIconInfo(u.getValue()).uri:" ";this.fireCreate({title:N,subTitle:O,description:P,icon:Q});this.close();this.destroy();},_createButtons:function(){this.addButton(new B("saveButton",{text:r.getText("APP_VARIANT_DIALOG_SAVE"),tooltip:r.getText("TOOLTIP_APP_VARIANT_DIALOG_SAVE"),enabled:false,press:function(){this._onCreate();}.bind(this)}));this.addButton(new B({text:r.getText("SAVE_AS_APP_VARIANT_DIALOG_CANCEL"),tooltip:r.getText("TOOLTIP_SAVE_AS_APP_VARIANT_DIALOG_CANCEL"),press:function(){this.fireCancel();this.close();this.destroy();}.bind(this)}));},destroy:function(){if(C){C.destroy();}D.prototype.destroy.apply(this,arguments);},renderer:a});return M;});
