/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/util/merge","sap/base/Log","sap/ui/base/ManagedObject","sap/ui/dt/ElementUtil","sap/ui/dt/OverlayRegistry","sap/ui/dt/Util","sap/ui/fl/Utils","sap/ui/fl/Layer"],function(m,L,M,E,O,D,F,a){"use strict";function e(J){var K=E.getAggregationInformation(J.getElement());if(K.elementId){var N=O.getOverlay(K.elementId);var P=N.getParentElementOverlay();var Q=P?!!E.getAggregationInformation(P.getElement()).templateId:false;if(Q){throw D.createError("CommandFactory#evaluateTemplateBinding","Multiple template bindings are not supported","sap.ui.rta");}var T=E.extractTemplateId(K);if(T){return{templateSelector:K.elementId,originalSelector:T,content:{boundAggregation:K.aggregation}};}}return undefined;}function g(J,K){var N=(typeof J==="string")?sap.ui.getCore().byId(J):J;var P=O.getOverlay(N);if(P){var Q=E.getAggregationInformation(N);if(typeof K==="number"){Q.stack[0].index=K;}return E.extractTemplateId(Q);}return N.getId();}function b(J){if(!J){throw new Error("adjustment for template failed");}}function c(J,K){var N;var P=false;var V=false;if(typeof K==="string"){N=K;}else if(K){N=K.changeType;P=K.jsOnly===true;V=K.CAUTION_variantIndependent===true;}if(!N){return false;}J.setChangeType(N);J.setJsOnly(P);if(J.setVariantIndependent){J.setVariantIndependent(V);}else{L.error("the variant independent Flag is not available for the action used in: ",N);}return true;}function d(J,S,K){var N={changeType:S.name};if(K){Object.assign(N,K.getAction(S.name,J));}return N;}function f(S){S.element=sap.ui.getCore().byId(g(S.element));b(S.element);}function h(J,S,K){var N=S.element||sap.ui.getCore().byId(S.element.id);var P=K.getActionDataFromAggregations("createContainer",N)[0];return P;}function i(S){S.element=sap.ui.getCore().byId(g(S.element));b(S.element);S.parentId=g(S.parentId);b(S.parentId);}function j(J,S,K){var N=S.movedElements[0].element||sap.ui.getCore().byId(S.movedElements[0].id);var P=K.getAction("move",N);return P;}function k(S){var T=S.movedElements.map(function(J){var K=sap.ui.getCore().byId(g(J.element,J.sourceIndex));b(K);return K;});S.movedElements.forEach(function(J,K){J.element=T[K];});S.element=sap.ui.getCore().byId(g(S.element));b(S.element);S.source.parent=sap.ui.getCore().byId(g(S.source.parent));b(S.source.parent);S.target.parent=sap.ui.getCore().byId(g(S.target.parent));b(S.target.parent);}function l(J,S,K){return K.getAction("localReset",J);}function n(J,S,K){var R=S.renamedElement;var N=K.getAction("rename",R);return N;}function o(S){S.element=sap.ui.getCore().byId(g(S.element));b(S.element);S.renamedElement=sap.ui.getCore().byId(g(S.renamedElement));b(S.renamedElement);}function p(J,S,K){var R=S.removedElement;if(!R){R=J;}else if(!(R instanceof M)){throw new Error("No valid 'removedElement' found");}var N=K.getAction("remove",R);return N;}function q(S){S.element=sap.ui.getCore().byId(g(S.element));b(S.element);S.removedElement=sap.ui.getCore().byId(g(S.removedElement));b(S.removedElement);}function r(J,S,K){var N=S.source;var P=K.getAction("combine",N);return P;}function s(S){S.element=sap.ui.getCore().byId(g(S.element));b(S.element);S.source=sap.ui.getCore().byId(g(S.source));b(S.source);var T=S.combineElements.map(function(J){J=sap.ui.getCore().byId(g(J));b(J);return J;});S.combineElements=T;}function t(J,S,K){var N=S.source;var P=K.getAction("split",N);return P;}function u(S){S.element=sap.ui.getCore().byId(g(S.element));b(S.element);S.parentElement=sap.ui.getCore().byId(g(S.parentElement));b(S.parentElement);S.source=sap.ui.getCore().byId(g(S.source));b(S.source);}function v(J,S,K){var N=S.element;return K.getAction("add",N,"delegate");}function w(S){S.element=sap.ui.getCore().byId(g(S.element));b(S.element);S.parentId=g(S.parentId);b(S.parentId);}function x(J,S,K){var R=S.element;var N=K.getAction("reveal",R);return N;}function y(S){S.element=sap.ui.getCore().byId(g(S.element));b(S.element);if(S.revealedElementId){S.revealedElementId=g(S.revealedElementId);b(S.revealedElementId);}if(S.directParent){S.directParent=sap.ui.getCore().byId(g(S.directParent));b(S.directParent);}}function z(J,S,K){var N=K.getAction("add",S.element);if(N&&N.custom&&typeof N.custom.getItems==="function"){var P=Object.assign(N.custom,{changeOnRelevantContainer:S.changeOnRelevantContainer,changeType:S.changeType});delete S["changeOnRelevantContainer"];return P;}return undefined;}function A(J,S,K){return K.getAction("addIFrame",S.element)||K.getActionDataFromAggregations("addIFrame",S.element)[0];}function B(){return"propertyBindingChange";}function C(){return"propertyChange";}var G={composite:{clazz:"sap/ui/rta/command/CompositeCommand",noSelector:true},property:{clazz:"sap/ui/rta/command/Property",adjustForBinding:f,configure:C},bindProperty:{clazz:"sap/ui/rta/command/BindProperty",configure:B},addXML:{clazz:"sap/ui/rta/command/AddXML",configure:d,adjustForBinding:f},addXMLAtExtensionPoint:{clazz:"sap/ui/rta/command/AddXMLAtExtensionPoint",configure:d,adjustForBinding:f},createContainer:{clazz:"sap/ui/rta/command/CreateContainer",configure:h,adjustForBinding:i},move:{clazz:"sap/ui/rta/command/Move",configure:j,adjustForBinding:k},remove:{clazz:"sap/ui/rta/command/Remove",configure:p,adjustForBinding:q},localReset:{clazz:"sap/ui/rta/command/LocalReset",configure:l},rename:{clazz:"sap/ui/rta/command/Rename",configure:n,adjustForBinding:o},addDelegateProperty:{clazz:"sap/ui/rta/command/AddProperty",configure:v,adjustForBinding:w},reveal:{clazz:"sap/ui/rta/command/Reveal",configure:x,adjustForBinding:y},customAdd:{clazz:"sap/ui/rta/command/CustomAdd",configure:z},combine:{clazz:"sap/ui/rta/command/Combine",configure:r,adjustForBinding:s},split:{clazz:"sap/ui/rta/command/Split",configure:t,adjustForBinding:u},"switch":{clazz:"sap/ui/rta/command/ControlVariantSwitch"},save:{clazz:"sap/ui/rta/command/ControlVariantSave"},saveAs:{clazz:"sap/ui/rta/command/ControlVariantSaveAs"},setTitle:{clazz:"sap/ui/rta/command/ControlVariantSetTitle"},configure:{clazz:"sap/ui/rta/command/ControlVariantConfigure"},settings:{clazz:"sap/ui/rta/command/Settings"},addLibrary:{clazz:"sap/ui/rta/command/appDescriptor/AddLibrary",noSelector:true},appDescriptor:{clazz:"sap/ui/rta/command/AppDescriptorCommand",noSelector:true},addIFrame:{clazz:"sap/ui/rta/command/AddIFrame",configure:A},compVariantSaveAs:{clazz:"sap/ui/rta/command/compVariant/CompVariantSaveAs"},compVariantSwitch:{clazz:"sap/ui/rta/command/compVariant/CompVariantSwitch"},compVariantUpdate:{clazz:"sap/ui/rta/command/compVariant/CompVariantUpdate"}};function H(J,K,S,N,P,V){var Q;K=K[0].toLowerCase()+K.slice(1);var R=G[K];var T=P;if(!R){return Promise.reject(D.createError("CommandFactory#getCommandFor","Command '"+K+"' doesn't exist, check typing","sap.ui.rta"));}return new Promise(function(U){var W=R.clazz;sap.ui.require([W],function(X){U(X);});}).then(function(U){var W=J instanceof M;if(!R.noSelector){S=Object.assign({},S,!W&&{selector:J});}S=Object.assign({},S,{element:W?J:undefined,name:K});var X;if(R.configure){X=R.configure(J,S,N);}var Y;if(W){Y=O.getOverlay(J);}if(X&&X.changeOnRelevantContainer){Object.assign(S,{element:Y.getRelevantContainer()});J=S.element;Y=O.getOverlay(J);}var Z;if(Y&&J.sParentAggregationName){Z=e(Y);}if(Z){if(R.adjustForBinding){R.adjustForBinding(S);}T=m(Z,T);}Q=new U(S);var $=true;if(R.configure){$=c(Q,X);}if($){return Q.prepare(T,V,K);}return undefined;}).then(function(U){if(U){return Q;}Q.destroy();return undefined;});}var I=M.extend("sap.ui.rta.command.CommandFactory",{metadata:{library:"sap.ui.rta",properties:{flexSettings:{type:"object"}}}});I.prototype.init=function(){this.setProperty("flexSettings",{layer:a.CUSTOMER,developerMode:true});};I.prototype.setFlexSettings=function(J){this.setProperty("flexSettings",Object.assign(this.getFlexSettings(),J));};I.prototype.getCommandFor=function(J,K,S,N,V){return H(J,K,S,N,this.getFlexSettings(),V);};I.getCommandFor=function(J,K,S,N,P){if(!P){P={layer:a.CUSTOMER,developerMode:true};}if(P.scenario||P.baseId){var Q=F.buildLrepRootNamespace(P.baseId,P.scenario,P.projectId);P.rootNamespace=Q;P.namespace=Q+"changes/";}return H(J,K,S,N,P);};return I;},true);
