/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/rta/command/BaseCommand","sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/fl/Utils","sap/base/Log","sap/base/util/merge","sap/ui/fl/write/api/ChangesWriteAPI","sap/base/util/values"],function(B,J,F,L,m,C,o){"use strict";var a=B.extend("sap.ui.rta.command.FlexCommand",{metadata:{library:"sap.ui.rta",properties:{changeType:{type:"string"},jsOnly:{type:"boolean",defaultValue:false},selector:{type:"object"},variantIndependent:{type:"boolean",defaultValue:false}},associations:{},events:{}}});a.prototype.getElementId=function(){var e=this.getElement();return e?e.getId():this.getSelector().id;};a.prototype.getAppComponent=function(){var e=this.getElement();return e?F.getAppComponentForControl(e):this.getSelector().appComponent;};a.prototype.prepare=function(f,v,c){var s;if(!this.getSelector()&&f&&f.templateSelector){s={id:f.templateSelector,appComponent:this.getAppComponent(),controlType:F.getControlType(sap.ui.getCore().byId(f.templateSelector))};this.setSelector(s);}else if(!this.getSelector()&&this.getElement()){s={id:this.getElement().getId(),appComponent:this.getAppComponent(),controlType:F.getControlType(this.getElement())};this.setSelector(s);}return this._createChange(f,v,c).then(function(b){this._oPreparedChange=b;return true;}.bind(this)).catch(function(e){L.error(e.message||e.name);return false;});};a.prototype.getPreparedChange=function(){return this._oPreparedChange;};a.prototype.execute=function(){var c=this.getPreparedChange();return this._applyChange(c);};a.prototype._getChangeSpecificData=function(){var p=this.getMetadata().getProperties();var c={changeType:this.getChangeType()};o(p).filter(function(P){return P.group==="content";}).forEach(function(P){c[P.name]=P.get(this);},this);return c;};a.prototype._createChange=function(f,v,c){return this._createChangeFromData(this._getChangeSpecificData(),f,v,c);};a.prototype._createChangeFromData=function(c,f,v,s){if(f){c=m({},c,f);}c.jsOnly=this.getJsOnly();var M=this.getAppComponent().getModel(F.VARIANT_MODEL_NAME);var V;if(M&&v){V=M.getCurrentVariantReference(v);}if(V&&!this.getVariantIndependent()){var b={variantManagementReference:v,variantReference:V};c=Object.assign({},c,b);}c.command=s;c.generator=sap.ui.rta.GENERATOR_NAME;return C.create({changeSpecificData:c,selector:this._validateControlForChange(f)}).then(function(d){if(f&&f.originalSelector){d.addDependentControl(f.originalSelector,"originalSelector",{modifier:J,appComponent:this.getAppComponent()});d.getDefinition().selector=Object.assign(d.getDefinition().selector,J.getSelector(this.getSelector().id,this.getAppComponent()));d.setContent(Object.assign({},d.getContent(),f.content));}return d;}.bind(this));};a.prototype.undo=function(){var c=this.getElement()||J.bySelector(this.getSelector());var b=this.getPreparedChange();return C.revert({change:b,element:c});};a.prototype._applyChange=function(c){var b=c.change||c;var A=this.getAppComponent();var s=J.bySelector(b.getSelector(),A);var p={modifier:J,appComponent:A,view:F.getViewForControl(s)};return C.apply(Object.assign({change:b,element:s},p)).then(function(r){if(!r.success){return Promise.reject(r.error);}return undefined;});};a.prototype._validateControlForChange=function(f){if(f&&f.originalSelector&&f.content&&f.content.boundAggregation){return{id:f.originalSelector,appComponent:this.getAppComponent(),controlType:F.getControlType(sap.ui.getCore().byId(f.originalSelector))};}return this.getElement()||this.getSelector();};return a;});
