/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/base/ManagedObject","sap/ui/fl/write/api/PersistenceWriteAPI","sap/ui/fl/Utils","sap/ui/rta/command/Settings","sap/ui/rta/command/CompositeCommand","sap/ui/core/util/reflection/JsControlTreeModifier"],function(M,P,F,S,C,J){"use strict";function t(c,b,f){var o=c[f];if(o){b.push(o);}return b;}function p(c,m,s,o){var b=o.getSelector();var d=new S({selector:b,changeType:o.getDefinition().changeType,element:J.bySelector(b,c)});d._oPreparedChange=o;var e=o.getDefinition().support.compositeCommand;if(e){if(!m[e]){m[e]=new C();s.pushExecutedCommand(m[e]);}m[e].addCommand(d);}else{s.pushExecutedCommand(d);}}var a=M.extend("sap.ui.rta.command.Stack",{metadata:{library:"sap.ui.rta",properties:{},aggregations:{commands:{type:"sap.ui.rta.command.BaseCommand",multiple:true}},events:{modified:{},commandExecuted:{parameters:{command:{type:"object"},undo:{type:"boolean"}}}}}});a.initializeWithChanges=function(c,f){var s=new a();s._aPersistedChanges=f;if(f&&f.length>0){var o=F.getAppComponentForControl(c);var m={selector:o,invalidateCache:false};return P._getUIChanges(m).then(function(b){var d={};var e={};b.forEach(function(g){e[g.getDefinition().fileName]=g;});f.reduce(t.bind(null,e),[]).forEach(p.bind(null,o,d,s));return s;});}return Promise.resolve(s);};a.prototype.addCommandExecutionHandler=function(h){this._aCommandExecutionHandler.push(h);};a.prototype.removeCommandExecutionHandler=function(h){var i=this._aCommandExecutionHandler.indexOf(h);if(i>-1){this._aCommandExecutionHandler.splice(i,1);}};a.prototype.init=function(){this._aCommandExecutionHandler=[];this._toBeExecuted=-1;this._oLastCommand=Promise.resolve();};a.prototype._waitForCommandExecutionHandler=function(m){return Promise.all(this._aCommandExecutionHandler.map(function(h){return h(m);}));};a.prototype._getCommandToBeExecuted=function(){return this.getCommands()[this._toBeExecuted];};a.prototype.pushExecutedCommand=function(c){this.push(c,true);};a.prototype.push=function(c,e){if(this._bUndoneCommands){this._bUndoneCommands=false;while(this._toBeExecuted>-1){this.pop();}}this.insertCommand(c,0);if(!e){this._toBeExecuted++;}this.fireModified();};a.prototype.top=function(){return this.getCommands()[0];};a.prototype.pop=function(){if(this._toBeExecuted>-1){this._toBeExecuted--;}return this.removeCommand(0);};a.prototype.removeCommand=function(o,s){var r=this.removeAggregation("commands",o,s);this.fireModified();return r;};a.prototype.removeAllCommands=function(s){var c=this.removeAllAggregation("commands",s);this._toBeExecuted=-1;this.fireModified();return c;};a.prototype.isEmpty=function(){return this.getCommands().length===0;};a.prototype.execute=function(){this._oLastCommand=this._oLastCommand.catch(function(){}).then(function(){var c=this._getCommandToBeExecuted();if(c){return c.execute().then(function(){this._toBeExecuted--;var m={command:c,undo:false};this.fireCommandExecuted(m);this.fireModified();return this._waitForCommandExecutionHandler(m);}.bind(this)).catch(function(e){e=e||new Error("Executing of the change failed.");e.index=this._toBeExecuted;e.command=this.removeCommand(this._toBeExecuted);this._toBeExecuted--;return Promise.reject(e);}.bind(this));}return undefined;}.bind(this));return this._oLastCommand;};a.prototype._unExecute=function(){if(this.canUndo()){this._bUndoneCommands=true;this._toBeExecuted++;var c=this._getCommandToBeExecuted();if(c){return c.undo().then(function(){var m={command:c,undo:true};this.fireCommandExecuted(m);this.fireModified();return this._waitForCommandExecutionHandler(m);}.bind(this));}return Promise.resolve();}return Promise.resolve();};a.prototype.canUndo=function(){return(this._toBeExecuted+1)<this.getCommands().length;};a.prototype.undo=function(){return this._unExecute();};a.prototype.canRedo=function(){return!!this._getCommandToBeExecuted();};a.prototype.redo=function(){return this.execute();};a.prototype.pushAndExecute=function(c){this.push(c);return this.execute();};a.prototype.getAllExecutedCommands=function(){var A=[];var c=this.getCommands();for(var i=c.length-1;i>this._toBeExecuted;i--){var s=this.getSubCommands(c[i]);A=A.concat(s);}return A;};a.prototype.getSubCommands=function(c){var b=[];if(c.getCommands){c.getCommands().forEach(function(s){var d=this.getSubCommands(s);b=b.concat(d);},this);}else{b.push(c);}return b;};return a;});
