/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/util/ObjectPath","sap/base/Log","sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/dt/ElementUtil","sap/ui/fl/apply/api/DelegateMediatorAPI","sap/ui/rta/util/BindingsExtractor","sap/ui/thirdparty/jquery"],function(O,L,J,E,D,B,q){"use strict";function _(j,F,M){if(!j){return false;}var G=j.getBindingInfo(F,M);var P=G&&G.path;if(!P){return false;}if(P.indexOf(">")>-1){P=P.split(">").pop();}return P.indexOf("/")===0;}function a(j,F,G,M){var H;if(F){H=j.getBindingInfo(G,M);if(typeof H.model==="string"&&H.model!==M){H=undefined;}}else{H=j.getBindingContext(M);}return H;}function b(j,F,M){var G=_(j,F,M);var H=a(j,G,F,M);if(H){return G?H.path:H.getPath();}}function c(P){var F=P.reduce(function(j,G){if(Array.isArray(G.properties)){j=j.concat(G.properties.map(function(I){I.parentPropertyName=G.label||G.name;return I;}));}else{j.push(G);}return j;},[]);return F;}function d(j,F,G){var P={element:j,aggregationName:F,payload:G.delegateInfo.payload||{}};return G.delegateInfo.delegate.getPropertyInfo(P).then(c.bind(null));}function g(j,F){return D.getDelegateForControl({control:j,modifier:J,supportsDefault:true}).then(function(G){if(G&&G.instance){return G.instance.getPropertyInfo({element:j,aggregationName:F,payload:G.payload});}return[];});}function e(j,F,G){var H=G.addViaDelegate;var I;if(H){I=d.bind(null,j,F,H);}else{I=g.bind(null,j,F);}return I().then(function(P){return l(P);});}function f(P){return P.filter(function(j){return!(j.unsupported||j.hideFromReveal);});}function h(P){return{selected:false,label:P.label||P.name,parentPropertyName:P.parentPropertyName?P.parentPropertyName:"",duplicateName:P.duplicateName?P.duplicateName:false,tooltip:P.tooltip||P.label,originalLabel:"",type:"delegate",entityType:P.entityType,name:P.name,bindingPath:P.bindingPath};}function i(j){var F=j.element;var G=j.action;return{selected:false,label:F.__label||E.getLabelForElement(F,G.getLabel),tooltip:F.__tooltip||E.getLabelForElement(F,G.getLabel)||F.__bindingPath,parentPropertyName:F.__parentPropertyName?F.__parentPropertyName:"",duplicateName:F.__duplicateName?F.__duplicateName:false,originalLabel:F.__renamedLabel&&F.__label!==F.__originalLabel?F.__originalLabel:"",bindingPath:F.__bindingPath,type:"invisible",elementId:F.getId(),sourceAggregation:j.sourceAggregation};}function k(j,R,F,M){if(R&&R!==j){var G=b(j,F,M);return E.findAllSiblingsInContainer(j,R).filter(function(S){return G===b(S,F,M);});}return[j];}function l(P){P.forEach(function(M,F,P){if(M["duplicateName"]!==true){for(var j=F+1;j<P.length-1;j++){if(M.label===P[j].label){M["duplicateName"]=true;P[j]["duplicateName"]=true;}}}});return P;}function m(I,P){return P.some(function(M){return M.label===I.__label;});}function n(j){return Array.isArray(j)&&j.length>0;}function o(j,P){return P.filter(function(M){return j.some(function(F){return F===M.bindingPath||F.startsWith(M.bindingPath+'/');});}).pop();}function p(j){return(q.isPlainObject(j)?j.parts[0].path:!!j.getPath&&j.getPath());}function r(j,F,M,G){var H=j.getModel(M);var R=k(j,F.relevantContainer,G,M);var I=[];R.forEach(function(j){I=I.concat(B.getBindings(j,H).map(p));});return I;}function s(j,F){var P={element:j.relevantContainer,aggregationName:F,payload:j.delegateInfo.payload||{}};return j.delegateInfo.delegate.getRepresentedProperties(P);}function t(j,F,M,G){return s(F,G).then(function(R){if(R===undefined){return r(j,F,M,G);}var H=[];R.forEach(function(I){H=H.concat(I.bindingPaths);});return H;});}function u(j,F,M,G){return Promise.resolve().then(function(){var H=!!O.get("delegateInfo.delegate.getRepresentedProperties",F);if(H){return t(j,F,M,G);}return r(j,F,M,G);});}function v(I,S){I.__originalLabel=S.label;I.__tooltip=S.tooltip;I.__bindingPath=S.name;if(I.__label!==I.__originalLabel){I.__renamedLabel=true;}if(S.parentPropertyName){I.__parentPropertyName=S.parentPropertyName;}}function w(j,F){var H=!!O.get("delegateInfo.delegate.getRepresentedProperties",j);if(H){return s(j,F);}}function x(I,R){var j;R.some(function(P){if(P.id===I.getId()){j=P;return true;}});return j.bindingPaths||[];}function y(I,P,j,H){if(!n(j)){return true;}var M=o(j,P);if(M){if(M.hideFromReveal){return false;}v(I,M);return true;}return!H;}function z(j,F,I,G,R,P){var H=G.addViaDelegate;var M=A(H);var K=j.getModel(M);var N=true;var Q=[];if(R){Q=x(I,R);}else if(b(j,F,M)===b(I,F,M)){Q=B.collectBindingPaths(I,K).bindingPaths;}else if(H&&B.getBindings(I,K).length>0){N=false;}if(N){I.__duplicateName=m(I,P);N=y(I,P,Q,!!H);}return N;}function A(j){return O.get("delegateInfo.payload.modelName",j);}var C={enhanceInvisibleElements:function(j,F){var R=F.reveal;var G=F.addViaDelegate;var H=j.getMetadata().getAggregation();var I=H?H.name:F.aggregation;return Promise.all([e(j,I,F),w(G,I)]).then(function(K){var P=K[0];var M=K[1];var N=[];var Q=R.elements||[];Q.forEach(function(S){var T=S.element;var U=S.action;T.__label=E.getLabelForElement(T,U.getLabel);var V=z(j,I,T,F,M,P);if(V){N.push({element:T,action:U,sourceAggregation:S.sourceAggregation});}});return N;}).then(function(K){return K.map(i);});},getUnrepresentedDelegateProperties:function(j,F){var M=A(F);var G=j.getMetadata().getAggregation();var H=G?G.name:F.action.aggregation;return Promise.all([d(j,H,F),u(j,F,M,H)]).then(function(I){var K=I[0];var R=I[1];var N=F.action.filter?F.action.filter:function(){return true;};var U=f(K);U=U.filter(function(P){var Q=false;if(R){Q=R.some(function(S){return S===P.bindingPath;});}return!Q&&N(F.relevantContainer,P);});U=l(U);return U;}).then(function(U){return U.map(h);});}};return C;});
