/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/util/each","sap/base/Log","sap/ui/core/IconPool","sap/ui/dt/OverlayRegistry","sap/ui/dt/OverlayUtil","sap/ui/fl/write/api/FieldExtensibility","sap/ui/rta/plugin/additionalElements/AddElementsDialog","sap/ui/rta/plugin/additionalElements/AdditionalElementsAnalyzer","sap/ui/rta/plugin/Plugin","sap/ui/rta/Utils","sap/ui/rta/plugin/additionalElements/AdditionalElementsUtils","sap/ui/rta/plugin/additionalElements/CommandBuilder","sap/ui/rta/plugin/additionalElements/ActionExtractor"],function(e,L,I,O,a,F,A,b,P,U,c,C,d){"use strict";var S=true;var f=false;function i(m,p){var r=p.responsibleElementOverlay.getParentAggregationOverlay().getAggregationName();return Object.keys(m).some(function(s){return s===r;});}function h(o){return F.onControlSelected(o).then(function(){return Promise.all([U.isServiceUpToDate(o),F.isExtensibilityEnabled(o)]);}).then(function(r){var E=!!r[1];if(E){return F.getExtensionData(o);}return undefined;});}var g=P.extend("sap.ui.rta.plugin.additionalElements.AdditionalElementsPlugin",{constructor:function(p){p.dialog=new A();P.apply(this,arguments);},metadata:{library:"sap.ui.rta",properties:{commandFactory:"object"},aggregations:{dialog:{type:"sap.ui.rta.plugin.additionalElements.AddElementsDialog",multiple:false}},associations:{},events:{}},_getRelevantOverlays:function(o){var r=a.findAllOverlaysInContainer(o,true);o.setRelevantOverlays(r);return r;},getContextMenuText:function(o,j,s,H){var t;function k(){t=sap.ui.getCore().getLibraryResourceBundle("sap.ui.rta");return t.getText("CTX_ADD_ELEMENTS",t.getText("MULTIPLE_CONTROL_NAME"));}if(s==="$$OnlyChildCustomField$$"){return k();}if(H){t=sap.ui.getCore().getLibraryResourceBundle("sap.ui.rta");return t.getText("CTX_ADD_ELEMENTS_WITH_SUBMENU");}var p=c.getParents(o,j,this);var m=d.getActionsOrUndef(o,j);if(!s){s=Object.keys(m)[0];}var l=m[s];if(!l){return k();}l.aggregation=s;return c.getText("CTX_ADD_ELEMENTS",l,p.parent,S);},isAvailable:function(o,E){return E.every(function(j){return this._isEditableByPlugin(j,o);},this);},isEnabled:function(o,E,s){if(E.length>1){return false;}if(this.getExtensibilityInfo(o)){return true;}var j=this.getResponsibleElementOverlay(E[0]);var p;var k=false;if(o){p=j.getParentElementOverlay();if(p){k=true;}}else{var m=d.getActionsOrUndef(o,j);var l=m[s];if(l&&((l.reveal&&l.reveal.elements.length>0)||l.addViaDelegate)){k=true;}}var n=this.getCachedElements(o);var q=!!(n&&n.length>0);k=k&&q;return k;},registerElementOverlay:function(o){var m=o.getElement().getModel();if(m){var M=m.getMetaModel();if(M&&M.loaded){M.loaded().then(function(){this.evaluateEditable([o],{onRegistration:true});}.bind(this));}}P.prototype.registerElementOverlay.apply(this,arguments);},_checkIfCreateFunctionIsAvailable:function(m){return!m||(m&&m.content&&m.content.createFunction);},showAvailableElements:function(o,s,r,j,k,D){var R=r[0];var p=c.getParents(o,R,this);var v=o&&R.getElement();var m;var l=[];return d.getActions(o,R,this).then(function(n){if(s==="$$OnlyChildCustomField$$"){return[];}m=n[s];return this.getAllElements(o,[p.responsibleElementOverlay],k,D);}.bind(this)).then(function(n){l=n;var E=this.getExtensibilityInfo(o);this.getDialog().setCustomFieldEnabled(!!E);if(E){this.getDialog().detachEvent("openCustomField",this._onOpenCustomField,this);this.getDialog().attachEvent("openCustomField",o,this._onOpenCustomField,this);this.getDialog().setCustomFieldButtonVisible(true);return this.getDialog().addExtensionData(E.extensionData);}return this.getDialog().setCustomFieldButtonVisible(false);}.bind(this)).then(function(){var n=l.filter(function(u){return u.aggregation===s;})[0];var E=n?n.elements:[];this.getDialog().setElements(E);if(D){var t=sap.ui.getCore().getLibraryResourceBundle("sap.ui.rta");var q=t.getText("HEADER_ADDITIONAL_ELEMENTS_WITH_AGGREGATION",D);this.getDialog().setTitle(q);}else if(s||k){this._setDialogTitle(m||{},p.parent,k);}return this.getDialog().open().then(function(){var u=this.getDialog().getSelectedElements();return C.createCommands(p,v,m,j,u,s,this);}.bind(this)).then(function(){var u=O.getOverlay(v)||R;u.focus();}).catch(function(u){if(u instanceof Error){throw u;}});}.bind(this)).catch(function(E){if(E instanceof Error){throw E;}else{L.info("Service not up to date, skipping add dialog","sap.ui.rta");}});},_setDialogTitle:function(m,p,s){var D=c.getText("HEADER_ADDITIONAL_ELEMENTS",m,p,f,s);this.getDialog().setTitle(D);},_onOpenCustomField:function(E,o){var r=U.getRtaStyleClassName();return F.onTriggerCreateExtensionData(this.getExtensibilityInfo(o),r);},_isEditable:function(o,p){return Promise.all([this._isEditableCheck(p.sourceElementOverlay,true),this._isEditableCheck(p.sourceElementOverlay,false)]).then(function(j){return{asSibling:j[0],asChild:j[1]};}).catch(function(E){L.error(E);});},_isEditableCheck:function(o,j){return Promise.resolve().then(function(){var p=c.getParents(j,o,this);if(!p.relevantContainerOverlay){return false;}return d.getActions(j,o,this,true).then(function(m){this.clearCachedElements();return U.doIfAllControlsAreAvailable([o,p.parentOverlay],function(){var E=false;if(j){E=i(m,p);}else{E=Object.keys(m).some(function(s){if(m[s].addViaDelegate){E=this.checkAggregationsOnSelf(p.parentOverlay,"add",undefined,"delegate");}if(!E&&m[s].reveal){return true;}return E;}.bind(this));}return E;}.bind(this));}.bind(this)).then(function(E){if(E){E=this.hasStableId(o)&&this.hasStableId(p.parentOverlay);}return E;}.bind(this));}.bind(this));},getAllElements:function(o,E){var j=E[0];var p=c.getParents(o,j,this);var m;var k=[];var l=false;var n=this.getCachedElements(o);if(n){return n;}this.clearExtensibilityInfo(o);return d.getActions(o,j,this).then(function(q){e(q,function(s){m=q[s];m.aggregation=s;if(m.addViaDelegate){l=true;}k.push({aggregation:s,elementPromises:[m.reveal?b.enhanceInvisibleElements(p.parent,m):Promise.resolve([]),m.addViaDelegate?b.getUnrepresentedDelegateProperties(p.parent,m.addViaDelegate):Promise.resolve([])]});});if(l){return h(p.parent);}return undefined;}).then(function(q){this.setExtensibilityInfo(o,q);}.bind(this)).then(this._combineAnalyzerResults.bind(this,k)).then(function(q){this.setCachedElements(q,o);return q;}.bind(this)).catch(function(q){throw q;});},getMenuItems:function(E){var m=[];var M;this.clearCachedElements();return Promise.all([this.getAllElements(false,E),this.getAllElements(true,E)]).then(function(j){var H=j[0].length>0;var k=j[0].length>1;var l=j[1].length>0;var n=this.isAvailable(false,E);var o=this.isAvailable(true,E);if(o&&(!n||!H)){M=this._buildMenuItem("CTX_ADD_ELEMENTS_AS_SIBLING",true,E,j,false);}else if(!o&&n&&!k){M=this._buildMenuItem("CTX_ADD_ELEMENTS_AS_CHILD",false,E,j,false);}else if(!o&&n&&k){M=this._buildMenuItem("CTX_ADD_ELEMENTS_AS_CHILD",false,E,j,true);}else if(n&&o&&H&&l){M=this._buildMenuItem("CTX_ADD_ELEMENTS_CHILD_AND_SIBLING",false,E,j,true);}if(M){m.push(this.enhanceItemWithResponsibleElement(M,E,["addViaDelegate","reveal","custom"]));}return m;}.bind(this));},_buildMenuItem:function(p,o,E,j,H){var s;var v;var k;var l=E[0];if(o){var m=c.getParents(o,l,this);k=m.responsibleElementOverlay.getParentAggregationOverlay().getAggregationName();}else{var n=j[0].length===0&&j[1].length===0;k=n?"$$OnlyChildCustomField$$":j[0]&&j[0][0]&&j[0][0].aggregation;}if(H){s=this._buildSubmenuItems(false,E,j[0]);if(p==="CTX_ADD_ELEMENTS_CHILD_AND_SIBLING"){s=s.concat(this._buildSubmenuItems(true,E,j[1]));}}else{v=function(o,E){return this.showAvailableElements(o,k,E);}.bind(this,o);}var M={id:p,text:this.getContextMenuText.bind(this,o,l,k,H),enabled:H||function(o,E){return this.isEnabled(o,E,k);}.bind(this,o),rank:20,icon:"sap-icon://add",handler:v};if(H){M.submenu=s;}return M;},_buildSubmenuItems:function(o,E,j){var s=[];var p=o?"CTX_ADD_ELEMENTS_AS_SIBLING":"CTX_ADD_ELEMENTS_AS_CHILD";var k=0;I.registerFont({collectionName:"BusinessSuiteInAppSymbols",fontFamily:"BusinessSuiteInAppSymbols",fontURI:sap.ui.require.toUrl("sap/ushell/themes/base/fonts/"),lazy:true});function l(o,m,E){var n=o?E[0].getParentElementOverlay():E[0];var q=n.getDesignTimeMetadata();var N=q.getAggregationDisplayName(m,n.getElement());return N?N.singular:m;}j.forEach(function(m){var n=m.aggregation;var D=l(o,n,E);var q={id:p+'_'+k,text:D,enabled:function(o,E){return this.isEnabled(o,E,n);}.bind(this,o),handler:function(o,E){return this.showAvailableElements(o,n,E,undefined,undefined,D);}.bind(this,o),icon:o?"sap-icon://BusinessSuiteInAppSymbols/icon-add-outside":"sap-icon://add"};s.push(this.enhanceItemWithResponsibleElement(q,E,["addViaDelegate","reveal","custom"]));k++;}.bind(this));return s;},_combineAnalyzerResults:function(j){var k=[];j.forEach(function(p){k.push(Promise.all(p.elementPromises).then(function(l){var r=l[0];var m=l[1];var n=r.concat(m);return{aggregation:p.aggregation,elements:n};}));});return Promise.all(k).then(function(E){return E.filter(function(o){var l=o&&o.elements;return l.length>0;});});},clearCachedElements:function(){this._oCachedElements=undefined;},setCachedElements:function(E,o){this._oCachedElements=this._oCachedElements||{};this._oCachedElements[o?"asSibling":"asChild"]=E;},getCachedElements:function(o){if(this._oCachedElements){return this._oCachedElements[o?"asSibling":"asChild"];}return undefined;},clearExtensibilityInfo:function(o){if(this._oExtensibilityInfo){this._oExtensibilityInfo[o?"asSibling":"asChild"]=undefined;}},setExtensibilityInfo:function(o,E){this._oExtensibilityInfo=this._oExtensibilityInfo||{};this._oExtensibilityInfo[o?"asSibling":"asChild"]=E;},getExtensibilityInfo:function(o){if(this._oExtensibilityInfo){return this._oExtensibilityInfo[o?"asSibling":"asChild"];}return undefined;},exit:function(){this.getDialog().destroy();if(P.prototype.exit){P.prototype.exit.apply(this,arguments);}}});return g;});
