/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/Log","sap/ui/base/ManagedObject","sap/ui/core/Fragment","sap/ui/core/library","sap/ui/model/json/JSONModel","sap/ui/rta/Utils","sap/ui/rta/plugin/iframe/AddIFrameDialogController","sap/ui/fl/util/getContainerUserInfo"],function(L,M,F,c,J,R,A,g){"use strict";var V=c.ValueState;var _=sap.ui.getCore().getLibraryResourceBundle("sap.ui.rta");var a="https://help.sap.com/viewer/4fc8d03390c342da8a60f8ee387bca1a/latest/en-US/8db25610e91342919fcf63d4e5868ae9.html";var b=_.getText("IFRAME_ADDIFRAME_DIALOG_URL_WARNING_TEXT")+" ("+"<a href="+a+">"+_.getText("IFRAME_ADDIFRAME_DIALOG_URL_WARNING_LINKTEXT")+"</a>"+")";var d={dialogTitle:_.getText("IFRAME_ADDIFRAME_DIALOG_TITLE"),dialogCreateTitle:_.getText("IFRAME_ADDIFRAME_DIALOG_TITLE"),dialogUpdateTitle:_.getText("IFRAME_ADDIFRAME_DIALOG_UPDATE_TITLE"),sizeTitle:_.getText("IFRAME_ADDIFRAME_DIALOG_SIZE_TITLE"),widthLabel:_.getText("IFRAME_ADDIFRAME_DIALOG_WIDTH_LABEL"),widthUnitLabel:_.getText("IFRAME_ADDIFRAME_DIALOG_WIDTH_UNITLABEL"),heightLabel:_.getText("IFRAME_ADDIFRAME_DIALOG_HEIGHT_LABEL"),heightUnitLabel:_.getText("IFRAME_ADDIFRAME_DIALOG_HEIGHT_UNITLABEL"),percentUseLabel:_.getText("IFRAME_ADDIFRAME_DIALOG_PERCENT_USED"),saveText:_.getText("IFRAME_ADDIFRAME_DIALOG_BUTTON_SAVE"),cancelText:_.getText("IFRAME_ADDIFRAME_DIALOG_BUTTON_CANCEL"),previewUrlLabel:_.getText("IFRAME_ADDIFRAME_DIALOG_PREVIEW_URL_LABEL"),previewUrlMessage:_.getText("IFRAME_ADDIFRAME_DIALOG_BUTTON_PREVIEW_MESSAGE"),previewButtonText:_.getText("IFRAME_ADDIFRAME_DIALOG_BUTTON_SHOW_PREVIEW"),showPreviewButton:_.getText("IFRAME_ADDIFRAME_DIALOG_BUTTON_SHOW_PREVIEW"),updatePreviewButton:_.getText("IFRAME_ADDIFRAME_DIALOG_BUTTON_UPDATE_PREVIEW"),previewFrameLabel:_.getText("IFRAME_ADDIFRAME_DIALOG_PREVIEW_FRAME_LABEL"),parameterSearchLabel:_.getText("IFRAME_ADDIFRAME_DIALOG_PARAMETER_SEARCH_LABEL"),editUrlLabel:_.getText("IFRAME_ADDIFRAME_DIALOG_EDIT_URL_LABEL"),parametersLabel:_.getText("IFRAME_ADDIFRAME_DIALOG_PARAMETERS_LABEL"),columnParameterLabel:_.getText("IFRAME_ADDIFRAME_DIALOG_TABLE_PARAMETER_LABEL"),columnUiValueLabel:_.getText("IFRAME_ADDIFRAME_DIALOG_TABLE_UI_VALUE_LABEL")};function e(s){if(s){d.dialogTitle=d.dialogUpdateTitle;}else{d.dialogTitle=d.dialogCreateTitle;}return new J({text:d,section:{visible:false},asNewSection:{value:false},sectionName:{value:"",valueState:V.None},frameWidth:{value:100,valueState:V.None,id:"sapUiRtaAddIFrameDialog_WidthInput"},frameWidthUnit:{value:"%"},frameHeight:{value:100,valueState:V.None,id:"sapUiRtaAddIFrameDialog_HeightInput"},frameHeightUnit:{value:"%"},frameUrl:{value:"",valueState:V.None},previewUrl:{value:""},documentationLink:{HTML:b},parameters:{value:[]},unitsOfMeasure:[{name:"%"},{name:"px"},{name:"rem"}]});}var f=M.extend("sap.ui.rta.plugin.iframe.AddIFrameDialog",{metadata:{library:"sap.ui.rta",events:{opened:{}}}});f.prototype.open=function(s){return new Promise(function(r){this._fnResolve=r;this._createDialog(s);}.bind(this));};f.prototype._createDialog=function(s){var S=false;if(s){S=s.updateMode?s.updateMode:false;}this._oJSONModel=e(S);this._oController=new A(this._oJSONModel,s);F.load({name:"sap.ui.rta.plugin.iframe.AddIFrameDialog",controller:this._oController}).then(function(o){this._oDialog=o;this._oDialog.addStyleClass(R.getRtaStyleClassName());this._oDialog.setModel(this._oJSONModel);this._openDialog();}.bind(this)).catch(function(E){L.error("Error loading fragment sap.ui.rta.plugin.iframe.AddIFrameDialog: ",E);});};f.prototype._openDialog=function(){this._oDialog.attachAfterOpen(function(){this._disablePanelExpand();this.fireOpened();}.bind(this));this._oDialog.attachAfterClose(function(){this._oDialog.destroy();this._oDialog=null;this._fnResolve(this._oController.getSettings());this._oController=null;}.bind(this));this._oDialog.open();};f.prototype._disablePanelExpand=function(){var p=sap.ui.getCore().byId("sapUiRtaAddIFrameDialog_PreviewLinkPanel").getDependents()[0];if(p){p.setEnabled(false);}};f.buildUrlBuilderParametersFor=function(o){return g().then(function(u){var U=Object.keys(u).map(function(s){return{label:s,key:"{$user>/"+s+"}",value:u[s]};});var B=o.getBindingContext();var D;if(B){var h=B.getObject();D=Object.keys(h).filter(function(p){return typeof h[p]!=="object";}).map(function(p){return{label:p,key:"{"+p+"}",value:h[p]};});}else{D=[];}return U.concat(D);});};return f;});
