/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/util/deepExtend","sap/ui/base/Object","sap/ui/support/library","sap/ui/support/supportRules/Constants"],function(d,B,l,c){"use strict";var _=[];var a=function(i){var e=sap.ui.getCore().byId(i.context.id),f="";if(i.context.id==="WEBPAGE"){f="sap.ui.core";}else if(e){f=e.getMetadata().getName();}return{severity:i.severity,name:i.rule.title,description:i.rule.description,resolution:i.rule.resolution,resolutionUrls:i.rule.resolutionurls,audiences:i.rule.audiences,categories:i.rule.categories,details:i.details,ruleLibName:i.rule.libName,ruleId:i.rule.id,async:i.rule.async===true,minVersion:i.rule.minversion,context:{className:f,id:i.context.id}};};var I={addIssue:function(i){_.push(i);},walkIssues:function(C){_.forEach(C);},clearIssues:function(){_=[];},getIssues:function(){return _.slice();},getIssuesModel:function(){var v=[];this.walkIssues(function(i){v.push(a(i));});return v;},getRulesViewModel:function(r,s,i){var e={},f=0,g={},l={},h={},j=d({},r),k=d({},i);for(g in j){e[g]=d({},j[g].ruleset._mRules);l=e[g];Object.defineProperty(l,'selected',{enumerable:false,configurable:true,writable:true,value:false});Object.defineProperty(l,'issueCount',{enumerable:false,configurable:true,writable:true,value:0});for(h in j[g].ruleset._mRules){l[h]=d([],l[h]);Object.defineProperty(l[h],'selected',{enumerable:false,configurable:true,writable:true,value:false});Object.defineProperty(l[h],'issueCount',{enumerable:false,configurable:true,writable:true,value:0});if(s[h]){l[h].selected=true;l.selected=true;}if(k[g]&&k[g][h]){l[h].push.apply(l[h],k[g][h]);f=k[g][h].length;l[h].issueCount=f;l.issueCount+=f;}}}return e;},getTreeTableViewModel:function(r){var i=0,t={},e,f,g=[];e=this.getRulesViewModel(r,[],[]);for(var h in e){t[i]={name:h,id:h+" "+i,selected:true,type:"lib",nodes:g};for(var j in e[h]){f=e[h][j];g.push({name:f.title,description:f.description,id:f.id,audiences:f.audiences.toString(),categories:f.categories.toString(),minversion:f.minversion,resolution:f.resolution,title:f.title,libName:h,selected:true});}g=[];i++;}return t;},getIssuesViewModel:function(i){var t={},e=0,f=0,g=0,s,h=0,m=0,L=0;for(var j in i){t[e]={name:j,showAudiences:false,showCategories:false,type:"lib"};for(var r in i[j]){s=this._sortSeverityIssuesByPriority(i[j][r]);t[e][f]={formattedName:this._getFormattedName({name:i[j][r][0].name,highCount:s.high,mediumCount:s.medium,lowCount:s.low,highName:'H',mediumName:'M',lowName:'L'}),name:i[j][r][0].name,showAudiences:true,showCategories:true,categories:i[j][r][0].categories.join(", "),audiences:i[j][r][0].audiences.join(", "),issueCount:i[j][r].length,description:i[j][r][0].description,resolution:i[j][r][0].resolution,type:"rule",ruleLibName:i[j][r][0].ruleLibName,ruleId:i[j][r][0].ruleId,selected:i[j][r][0].selected,details:i[j][r][0].details,severity:i[j][r][0].severity};g+=i[j][r].length;f++;h+=s.high;m+=s.medium;L+=s.low;}t[e].formattedName=this._getFormattedName({name:t[e].name,highCount:h,mediumCount:m,lowCount:L,highName:'High',mediumName:'Medium',lowName:'Low'});t[e].name+=" ("+g+" issues)";t[e].issueCount=g;g=0;f=0;e++;h=0;m=0;L=0;}return t;},_getFormattedName:function(v){var h="",m="",L="";if(v.highCount>0){h="issueSeverityHigh";}if(v.mediumCount>0){m="issueSeverityMedium";}if(v.lowCount>0){L="issueSeverityLow";}return v.name+" (<span class=\""+h+"\"> "+v.highCount+" "+v.highName+", </span> "+"<span class=\""+m+"\"> "+v.mediumCount+" "+v.mediumName+", </span> "+"<span class=\""+L+"\"> "+v.lowCount+" "+v.lowName+"</span> )";},_sortSeverityIssuesByPriority:function(i){var h=0,m=0,L=0;i.forEach(function(e){switch(e.severity){case c.SUPPORT_ASSISTANT_ISSUE_SEVERITY_LOW:L++;break;case c.SUPPORT_ASSISTANT_ISSUE_SEVERITY_MEDIUM:m++;break;case c.SUPPORT_ASSISTANT_ISSUE_SEVERITY_HIGH:h++;break;}});return{high:h,medium:m,low:L};},convertToViewModel:function(o){var v=[];for(var i=0;i<o.length;i++){v.push(a(o[i]));}return v;},groupIssues:function(o){var g={},e={};for(var i=0;i<o.length;i++){e=o[i];if(!g[e.ruleLibName]){g[e.ruleLibName]={};}if(!g[e.ruleLibName][e.ruleId]){g[e.ruleLibName][e.ruleId]=[];}g[e.ruleLibName][e.ruleId].push(e);}return g;},createIssueManagerFacade:function(r){return new b(r);}};var b=function(r){this.oRule=r;};b.prototype.addIssue=function(i){i.rule=this.oRule;if(!l.Severity[i.severity]){throw"The issue from rule "+this.oRule.title+" does not have proper severity defined. Allowed values can be found"+"in sap.ui.support.Severity";}if(!i.context||!i.context.id){throw"The issue from rule '"+this.oRule.title+"' should provide a context id.";}if(!i.details){throw"The issue from rule '"+this.oRule.title+"' should provide details for the generated issue.";}I.addIssue(i);};return I;},true);
