/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/core/Control','sap/ui/Device','./library',"./Column",'./utils/TableUtils',"./extensions/ExtensionBase",'sap/ui/core/Renderer','sap/ui/core/IconPool',"sap/base/Log"],function(C,D,a,b,T,E,R,I,L){"use strict";var V=a.VisibleRowCountMode;var S=a.SortOrder;var c=T.Column;var f={Begin:"flex-start",End:"flex-end",Left:undefined,Right:undefined,Center:"center"};var d={apiVersion:2};d.render=function(r,t){delete t._iHeaderRowCount;f.Left=t._bRtlMode?"flex-end":"flex-start";f.Right=t._bRtlMode?"flex-start":"flex-end";T.getResourceBundle();r.openStart("div",t);t._getAccRenderExtension().writeAriaAttributesFor(r,t,"ROOT");r.class("sapUiTable");if(D.browser.chrome&&window.devicePixelRatio<1){r.class("sapUiTableZoomout");}if('ontouchstart'in document){r.class("sapUiTableTouch");}r.class("sapUiTableSelMode"+t.getSelectionMode());if(t.getColumnHeaderVisible()){r.class("sapUiTableCHdr");}if(T.hasRowHeader(t)){r.class("sapUiTableRowSelectors");}if(T.hasRowHighlights(t)){r.class("sapUiTableRowHighlights");}var s=a.TableHelper.addTableClass();if(s){r.class(s);}var o=t._getScrollExtension();if(o.isVerticalScrollbarRequired()&&!o.isVerticalScrollbarExternal()){r.class("sapUiTableVScr");}if(t.getEditable()){r.class("sapUiTableEdt");}if(T.hasRowActions(t)){var i=t.getRowActionCount();r.class(i==1?"sapUiTableRActS":"sapUiTableRAct");}else if(T.hasRowNavigationIndicators(t)){r.class("sapUiTableRowNavIndicator");}if(T.isNoDataVisible(t)&&!t._hasPendingRequests()){r.class("sapUiTableEmpty");}if(t.getShowOverlay()){r.class("sapUiTableOverlay");}var m=T.Grouping.getModeCssClass(t);if(m){r.class(m);}r.style("width",t.getWidth());t._getRowMode().applyTableStyles(r);if(t._bFirstRendering){r.class("sapUiTableNoOpacity");}r.openEnd();this.renderTabElement(r,"sapUiTableOuterBefore");r.openStart("div",t.getId()+"-before");r.openEnd();r.renderControl(t.getAggregation("_messageStrip"));if(t.getTitle()){this.renderHeader(r,t,t.getTitle());}if(t.getToolbar()){this.renderToolbar(r,t,t.getToolbar());}if(t.getExtension()&&t.getExtension().length>0){this.renderExtensions(r,t,t.getExtension());}r.close("div");r.openStart("div",t.getId()+"-sapUiTableCnt");r.class("sapUiTableCnt");r.attr("data-sap-ui-fastnavgroup","true");r.attr("data-sap-ui-pasteregion","true");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"CONTAINER");r.openEnd();r.openStart("div",t.getId()+"-sapUiTableGridCnt");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"CONTENT");r.openEnd();this.renderColRsz(r,t);this.renderColHdr(r,t);this.renderTable(r,t);r.close("div");var e=t.getCreationRow();if(e&&e.getVisible()){r.renderControl(e);this.renderHSbBackground(r,t);this.renderHSb(r,t);}t._getAccRenderExtension().writeHiddenAccTexts(r,t);r.openStart("div",t.getId()+"-overlay");r.class("sapUiTableOverlayArea");r.attr("tabindex","0");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"OVERLAY");r.openEnd();r.close("div");r.close("div");r.openStart("div",t.getId()+"-after");r.openEnd();if(t.getFooter()){this.renderFooter(r,t,t.getFooter());}if(t.getVisibleRowCountMode()==V.Interactive){this.renderVariableHeight(r,t);}this.renderBottomPlaceholder(r,t);r.close("div");this.renderTabElement(r,"sapUiTableOuterAfter");r.close("div");};d.renderHeader=function(r,t,o){r.openStart("div");r.class("sapUiTableHdr");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TABLEHEADER");r.openEnd();r.renderControl(o);r.close("div");};d.renderToolbar=function(r,t,o){if(!T.isA(o,"sap.ui.core.Toolbar")){return;}r.openStart("div");r.class("sapUiTableTbr");if(typeof o.getStandalone==="function"&&o.getStandalone()){o.setStandalone(false);}if(o.isA("sap.m.Toolbar")){o.setDesign("Transparent",true);o.addStyleClass("sapMTBHeader-CTX");r.class("sapUiTableMTbr");}t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TABLESUBHEADER");r.openEnd();r.renderControl(o);r.close("div");};d.renderExtensions=function(r,t,e){for(var i=0,l=e.length;i<l;i++){this.renderExtension(r,t,e[i]);}};d.renderExtension=function(r,t,e){r.openStart("div");r.class("sapUiTableExt");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TABLESUBHEADER");r.openEnd();r.renderControl(e);r.close("div");};d.renderTable=function(r,t){var h=t.getRows().length>0;this.renderTabElement(r,"sapUiTableCtrlBefore",h?"0":"-1");r.openStart("div",t.getId()+"-tableCCnt");t._getRowMode().applyRowContainerStyles(r);r.class("sapUiTableCCnt");r.openEnd();this.renderTableCCnt(r,t);r.close("div");this.renderTabElement(r,"sapUiTableCtrlAfter",h?"0":"-1");this.renderTabElement(r,null,"-1",t.getId()+"-focusDummy");var o=t.getCreationRow();if(!o||!o.getVisible()){this.renderHSbBackground(r,t);this.renderHSb(r,t);}};d.renderTableCCnt=function(r,t){this.renderTableCtrl(r,t);this.renderRowHdr(r,t);this.renderRowActions(r,t);if(!t._getScrollExtension().isVerticalScrollbarExternal()){this.renderVSb(r,t);}r.openStart("div",t.getId()+"-noDataCnt");r.class("sapUiTableCtrlEmpty");r.attr("tabindex","0");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"NODATA");r.openEnd();if(t.getNoData()instanceof C&&t._getVisibleColumns().length>0){r.renderControl(t.getNoData());}else{r.openStart("span",t.getId()+"-noDataMsg");r.class("sapUiTableCtrlEmptyMsg");r.openEnd();r.text(T.getNoDataText(t));r.close("span");}r.close("div");};d.renderFooter=function(r,t,F){r.openStart("div");r.class("sapUiTableFtr");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TABLEFOOTER");r.openEnd();r.renderControl(F);r.close("div");};d.renderVariableHeight=function(r,t){r.openStart("div",t.getId()+"-sb");r.attr("tabindex","-1");r.class("sapUiTableHeightResizer");r.style("height","5px");r.openEnd();r.close("div");};d.renderBottomPlaceholder=function(r,t){var p=t._getRowMode().getTableBottomPlaceholderStyles();if(p===undefined){return;}r.openStart("div",t.getId()+"-placeholder-bottom");r.class("sapUiTablePlaceholder");t._getRowMode().applyTableBottomPlaceholderStyles(r);r.openEnd();r.close("div");};d.renderColHdr=function(r,t){var n=T.getHeaderRowCount(t);var e=t.getColumns();var F=t.getComputedFixedColumnCount();r.openStart("div");r.class("sapUiTableColHdrCnt");r.openEnd();this.renderColRowHdr(r,t);if(F>0){r.openStart("div");r.class("sapUiTableCHA");r.class("sapUiTableCtrlScrFixed");r.class("sapUiTableNoOpacity");r.openEnd();this.renderTableControlCnt(r,t,true,0,F,true,false,0,n,true);r.close("div");}r.openStart("div",t.getId()+"-sapUiTableColHdrScr");r.class("sapUiTableCHA");r.class("sapUiTableCtrlScr");if(e.length==0){r.class("sapUiTableHasNoColumns");}if(F>0){if(t._bRtlMode){r.style("margin-right","0");}else{r.style("margin-left","0");}}r.openEnd();this.renderTableControlCnt(r,t,false,F,e.length,false,false,0,n,true);r.close("div");r.openStart("div");r.class("sapUiTableVSbHeader");r.openEnd();r.close("div");if(T.hasRowActions(t)){r.openStart("div",t.getId()+"-rowacthdr");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"ROWACTIONHEADER");r.class("sapUiTableCell");r.class("sapUiTableHeaderCell");r.class("sapUiTableRowActionHeaderCell");r.openEnd();r.openStart("span");r.openEnd();r.text(T.getResourceText("TBL_ROW_ACTION_COLUMN_LABEL"));r.close("span");r.close("div");}r.close("div");};d.renderColRowHdr=function(r,t){var e=false;var s=false;var m=t._getSelectionPlugin().getRenderConfig();r.openStart("div",t.getId()+"-selall");r.class("sapUiTableCell");r.class("sapUiTableHeaderCell");r.class("sapUiTableRowSelectionHeaderCell");var g;if(m.headerSelector.visible){var A=T.areAllRowsSelected(t);if(m.headerSelector.type==="toggle"){g=A?"TBL_DESELECT_ALL":"TBL_SELECT_ALL";}else if(m.headerSelector.type==="clear"){g="TBL_DESELECT_ALL";if(!m.headerSelector.enabled){r.class("sapUiTableSelAllDisabled");r.attr("aria-disabled","true");}}if(t._getShowStandardTooltips()&&g){r.attr("title",T.getResourceText(g));}if(!A){r.class("sapUiTableSelAll");}else{s=true;}r.class("sapUiTableSelAllVisible");e=true;}r.attr("tabindex","-1");var p={enabled:e,checked:s};t._getAccRenderExtension().writeAriaAttributesFor(r,t,"COLUMNROWHEADER",p);r.openEnd();if(m.headerSelector.visible){if(m.headerSelector.type==="clear"&&m.headerSelector.icon){r.renderControl(m.headerSelector.icon);}else{r.openStart("div");r.class("sapUiTableSelectAllCheckBox");r.openEnd();r.close("div");}}r.close("div");};d.renderCol=function(r,t,o,h,n,i,e,g,j){var l,k=!n,m=o.getIndex(),p=o.getMultiLabels();if(p.length>0){l=p[h];}else if(h==0){l=o.getLabel();}var H=o.getId();if(h===0){r.openStart("td",o);}else{H=H+"_"+h;r.openStart("td",H);}r.attr('data-sap-ui-related',o.getId());r.attr('data-sap-ui-colid',o.getId());r.attr("data-sap-ui-colindex",m);r.attr("tabindex","-1");var A={column:o,headerId:H,index:m};if(n>1){r.attr("colspan",n);A.colspan=true;}if(j){var F=o.getFiltered();var s=o.getSorted();if(F){r.class("sapUiTableColFiltered");}if(s){r.class("sapUiTableColSorted");if(o.getSortOrder()===S.Descending){r.class("sapUiTableColSortedD");}}}t._getAccRenderExtension().writeAriaAttributesFor(r,t,"COLUMNHEADER",A);r.class("sapUiTableCell");r.class("sapUiTableHeaderCell");r.class("sapUiTableHeaderDataCell");if(t.getEnableColumnReordering()||t.hasListeners("columnSelect")||o._menuHasItems()){r.class("sapUiTableHeaderCellActive");}if(i){r.class("sapUiTableCellFirst");}if(e){r.class("sapUiTableCellLastFixed");}if(g){r.class("sapUiTableCellLast");}if(k){r.class("sapUiTableHidden");}if(t.getColumnHeaderHeight()>0){r.style("height",t.getColumnHeaderHeight()+"px");}var q=o.getTooltip_AsString();if(q){r.attr("title",q);}r.openEnd();r.openStart("div",H+"-inner");r.class("sapUiTableCellInner");var u=o.getHAlign();var v=R.getTextAlign(u);if(v){r.style("text-align",v);}r.openEnd();r.openStart("div");r.style("justify-content",f[u]);r.openEnd();if(l){r.renderControl(l);}r.close("div");r.close("div");r.close("td");};d.renderColRsz=function(r,t){r.openStart("div",t.getId()+"-rsz");r.class("sapUiTableColRsz");r.openEnd();r.close("div");};d.renderRowHdr=function(r,t){r.openStart("div",t.getId()+"-sapUiTableRowHdrScr");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"PRESENTATION");r.class("sapUiTableRowHdrScr");r.class("sapUiTableNoOpacity");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"ROWHEADER_COL");r.openEnd();for(var e=0,g=t.getRows().length;e<g;e++){this.renderRowAddon(r,t,t.getRows()[e],e,true);}r.close("div");};d.renderRowActions=function(r,t){if(!T.hasRowActions(t)&&!T.hasRowNavigationIndicators(t)){return;}r.openStart("div",t.getId()+"-sapUiTableRowActionScr");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"PRESENTATION");T.hasRowActions(t)?r.class("sapUiTableRowWithAction"):r.class("sapUiTableRowActionScr");r.class("sapUiTableNoOpacity");r.openEnd();for(var e=0,g=t.getRows().length;e<g;e++){this.renderRowAddon(r,t,t.getRows()[e],e,false);}r.close("div");};d.addRowCSSClasses=function(r,t,i){var m=t._getRowCounts();var F=T.getFirstFixedBottomRowIndex(t);if(i===0){r.class("sapUiTableFirstRow");}else if(i===t.getRows().length-1){r.class("sapUiTableLastRow");}if(m.fixedTop>0){if(i==m.fixedTop-1){r.class("sapUiTableRowLastFixedTop");}if(i==m.fixedTop){r.class("sapUiTableRowFirstScrollable");}}if(F>=0&&F===i){r.class("sapUiTableRowFirstFixedBottom");}else if(F>=1&&F-1===i){r.class("sapUiTableRowLastScrollable");}};d.renderRowAddon=function(r,t,o,i,h){var e=t._getSelectionPlugin().isIndexSelected(o.getIndex());r.openStart("div");var g=o.getAggregation("_settings");var p={index:i,rowHidden:o.isEmpty(),rowNavigated:g?g.getNavigated():false};t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TR",p);r.attr("data-sap-ui-related",o.getId());r.attr("data-sap-ui-rowindex",i);r.class("sapUiTableRow");r.class("sapUiTableContentRow");if(o.isContentHidden()){r.class("sapUiTableRowHidden");}else if(e){r.class("sapUiTableRowSel");}if(i%2!=0&&t.getAlternateRowColors()&&!T.Grouping.isInTreeMode(t)){r.class("sapUiTableRowAlternate");}this.addRowCSSClasses(r,t,i);r.openEnd();r.openStart("div",t.getId()+(h?"-rowsel":"-rowact")+i);r.class("sapUiTableCell");r.class("sapUiTableContentCell");r.class(h?"sapUiTableRowSelectionCell":"sapUiTableRowActionCell");t._getRowMode().renderRowStyles(r);r.attr("tabindex","-1");p={rowSelected:e,rowHidden:o.isEmpty()};t._getAccRenderExtension().writeAriaAttributesFor(r,t,h?"ROWHEADER":"ROWACTION",p);r.openEnd();if(h){this.writeRowHighlightContent(r,t,o,i);this.writeRowSelectorContent(r,t,o,i);}else{var A=o.getRowAction();if(A){r.renderControl(A);}this.writeRowNavigationContent(r,t,o,i);}r.close("div");r.close("div");};d.renderTableCtrl=function(r,t){if(t.getComputedFixedColumnCount()>0){r.openStart("div",t.getId()+"-sapUiTableCtrlScrFixed");r.class("sapUiTableCtrlScrFixed");r.openEnd();this.renderTableControl(r,t,true);r.close("div");}r.openStart("div",t.getId()+"-sapUiTableCtrlScr");r.class("sapUiTableCtrlScr");if(t.getComputedFixedColumnCount()>0){if(t._bRtlMode){r.style("margin-right","0");}else{r.style("margin-left","0");}}r.openEnd();r.openStart("div",t.getId()+"-tableCtrlCnt");r.class("sapUiTableCtrlCnt");r.openEnd();this.renderTableControl(r,t,false);r.close("div");r.close("div");};d.renderTableControl=function(r,t,F){var s,e;if(F){s=0;e=t.getComputedFixedColumnCount();}else{s=t.getComputedFixedColumnCount();e=t.getColumns().length;}var m=t._getRowCounts();var g=t.getRows();if(m.fixedTop>0){this.renderTableControlCnt(r,t,F,s,e,true,false,0,m.fixedTop);}this.renderTableControlCnt(r,t,F,s,e,false,false,m.fixedTop,g.length-m.fixedBottom);if(m.fixedBottom>0&&g.length>0){this.renderTableControlCnt(r,t,F,s,e,false,true,g.length-m.fixedBottom,g.length);}};d.renderTableControlCnt=function(r,t,F,s,e,g,h,i,j,H){var k=H?"-header":"-table";var l=t.getId()+k;var m=[];if(F){l+="-fixed";m.push("sapUiTableCtrlFixed");}else{m.push("sapUiTableCtrlScroll");}if(g){l+="-fixrow";m.push("sapUiTableCtrlRowFixed");}else if(h){l+="-fixrow-bottom";m.push("sapUiTableCtrlRowFixedBottom");}else{m.push("sapUiTableCtrlRowScroll");}r.openStart("table",l);m.forEach(function(M){r.class(M);});t._getAccRenderExtension().writeAriaAttributesFor(r,t,H?"COLUMNHEADER_TABLE":"TABLE");r.class("sapUiTableCtrl");if(H){r.class("sapUiTableCHT");}r.style(F?"width":"min-width",t._getColumnsWidth(s,e)+"px");r.openEnd();r.openStart("thead").openEnd();r.openStart("tr");r.class("sapUiTableCtrlCol");if(i==0){r.class("sapUiTableCtrlFirstCol");}if(H){r.class("sapUiTableCHTHR");}r.openEnd();var n=t.getColumns();var o=new Array(e);var p;var q;var u=!F&&e>s;for(p=s;p<e;p++){q=n[p];var v={shouldRender:!!(q&&q.shouldRender())};if(v.shouldRender){var w=q.getWidth();if(T.isVariableWidth(w)){u=false;if(F){q._iFixWidth=q._iFixWidth||160;w=q._iFixWidth+"px";}}else if(F){delete q._iFixWidth;}v.width=w;}o[p]=v;}if(n.length===0){r.openStart("th").openEnd().close("th");}for(p=s;p<e;p++){k=H?"_hdr":"_col";q=n[p];v=o[p];if(v.shouldRender){if(i==0){r.openStart("th",t.getId()+k+p);t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TH",{column:q});}else{r.openStart("th");}r.style("width",v.width);r.attr("data-sap-ui-headcolindex",p);r.attr("data-sap-ui-colid",q.getId());r.openEnd();if(i==0&&T.getHeaderRowCount(t)==0&&!H){if(q.getMultiLabels().length>0){r.renderControl(q.getMultiLabels()[0]);}else{r.renderControl(q.getLabel());}}r.close("th");}}if(u){r.openStart("th",H&&t.getId()+"-dummycolhdr");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"PRESENTATION");r.openEnd().close("th");}r.close("tr");r.close("thead");r.openStart("tbody").openEnd();var x=t._getVisibleColumns();var y=t.getRows();var z;var A;if(H){for(z=i,A=j;z<A;z++){this.renderColumnHeaderRow(r,t,z,F,s,e,u,z===A-1);}}else{var B=t._getAccExtension().getAriaTextsForSelectionMode(true);var G=T.isRowSelectionAllowed(t);var J=t.getDragDropConfig().some(function(M){return M.getMetadata().isInstanceOf("sap.ui.core.dnd.IDragInfo")&&M.getSourceAggregation()==="rows";});var K=this.getLastFixedColumnIndex(t);for(z=i,A=j;z<A;z++){this.renderTableRow(r,t,y[z],z,F,s,e,false,x,K,u,B,G,J);}}r.close("tbody");r.close("table");};d.writeRowSelectorContent=function(r,t,o,i){t._getAccRenderExtension().writeAccRowSelectorText(r,t,o,i);if(T.Grouping.isInGroupMode(t)){r.openStart("div");r.class("sapUiTableGroupShield");r.openEnd();r.close("div");r.openStart("div",o.getId()+"-groupHeader");r.class("sapUiTableGroupIcon");r.openEnd();r.close("div");if(T.Grouping.showGroupMenuButton(t)){var e=I.getIconInfo("sap-icon://drop-down-list");r.openStart("div").class("sapUiTableGroupMenuButton").openEnd();r.text(e.content);r.close("div");}}};d.writeRowHighlightContent=function(r,t,o,i){if(!T.hasRowHighlights(t)){return;}var e=o.getAggregation("_settings");var h=e._getHighlightCSSClassName();r.openStart("div",o.getId()+"-highlight");r.class("sapUiTableRowHighlight");r.class(h);r.openEnd();t._getAccRenderExtension().writeAccRowHighlightText(r,t,o,i);r.close("div");};d.writeRowNavigationContent=function(r,t,o,i){if(!T.hasRowNavigationIndicators(t)){return;}var e=o.getAggregation("_settings");r.openStart("div",o.getId()+"-navIndicator");if(e.getNavigated()){r.class("sapUiTableRowNavigated");}r.openEnd();r.close("div");};d.renderColumnHeaderRow=function(r,t,i,F,s,e,h,l){r.openStart("tr");r.class("sapUiTableRow");r.class("sapUiTableHeaderRow");r.class("sapUiTableColHdrTr");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"COLUMNHEADER_ROW");r.openEnd();var g=this.getColumnsToRender(t,s,e),n=0,j=-1;function k(o,p,q){var u=c.getHeaderSpan(o,i),v;if(n<1){if(u>1){v=o.getIndex();u=q.slice(p+1,p+u).reduce(function(w,x){return x.getIndex()-v<u?w+1:w;},1);}o._nSpan=n=u;j=p;}else{o._nSpan=0;}n--;}g.forEach(k);function m(o,p){this.renderCol(r,t,o,i,o._nSpan,p===0,F&&(p==j),!F&&(p==j),o._nSpan===1&&!o._bIconsRendered);o._bIconsRendered=o._bIconsRendered||o._nSpan===1;delete o._nSpan;if(l){delete o._bIconsRendered;}}g.forEach(m.bind(this));if(!F&&h&&g.length>0){r.openStart("td").class("sapUiTableCellDummy");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"PRESENTATION");r.openEnd().close("td");}r.close("tr");};d.renderTableRow=function(r,t,o,i,F,s,e,g,v,l,h,m,j,k){if(!o){return;}var n=t._getSelectionPlugin();if(F){r.openStart("tr",o.getId()+"-fixed");r.attr("data-sap-ui-related",o.getId());}else{r.openStart("tr",o);}if(o._bDummyRow){r.style("opacity","0");}r.class("sapUiTableRow");r.class("sapUiTableContentRow");r.class("sapUiTableTr");if(o.isContentHidden()){r.class("sapUiTableRowHidden");}else{if(k&&F){r.attr("draggable",true);}if(n.isIndexSelected(o.getIndex())){r.class("sapUiTableRowSel");}}if(i%2!=0&&t.getAlternateRowColors()&&!T.Grouping.isInTreeMode(t)){r.class("sapUiTableRowAlternate");}this.addRowCSSClasses(r,t,i);r.attr("data-sap-ui-rowindex",i);t._getRowMode().renderRowStyles(r);var p=o.getAggregation("_settings");var P={index:i,rowHidden:o.isEmpty(),rowNavigated:p?p.getNavigated():false};t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TR",P);r.openEnd();var q=!o.isEmpty()&&n.isIndexSelected(o.getIndex());var u=o.getCells();for(var w=0,x=u.length;w<x;w++){this.renderTableCell(r,t,o,u[w],w,F,s,e,v,l,q);}if(!F&&h&&u.length>0){r.openStart("td").class("sapUiTableCellDummy");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"PRESENTATION");r.openEnd();r.close("td");}r.close("tr");};d.renderTableCell=function(r,t,o,e,i,F,s,g,v,l,h){var j=b.ofCell(e);var k=j.getIndex();if(j.shouldRender()&&s<=k&&g>k){var m=o.getId()+"-col"+i;r.openStart("td",m);r.attr("tabindex","-1");r.attr("data-sap-ui-colid",j.getId());var n=v.length;var p=n>0&&v[0]===j;var q=n>0&&v[n-1]===j;var u=F&&l===k;var P={index:k,column:j,row:o,fixed:F,rowSelected:h};t._getAccRenderExtension().writeAriaAttributesFor(r,t,"DATACELL",P);var w=R.getTextAlign(j.getHAlign());if(w){r.style("text-align",w);}r.class("sapUiTableCell");r.class("sapUiTableContentCell");r.class("sapUiTableDataCell");if(p){r.class("sapUiTableCellFirst");}if(u){r.class("sapUiTableCellLastFixed");}if(q){r.class("sapUiTableCellLast");}if(p&&T.Grouping.isInTreeMode(t)){r.class("sapUiTableCellFlex");}r.openEnd();r.openStart("div");r.class("sapUiTableCellInner");t._getRowMode().renderCellContentStyles(r);r.openEnd();this.renderTableCellControl(r,t,e,p);r.close("div");r.close("td");}};d.renderTableCellControl=function(r,t,o,i){if(i&&T.Grouping.isInTreeMode(t)){var e=o.getParent();r.openStart("span",e.getId()+"-treeicon");r.class("sapUiTableTreeIcon");r.attr("tabindex","-1");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TREEICON",{row:e});r.openEnd();r.close("span");}r.renderControl(o);};d.renderVSb=function(r,t,m){var s=t._getScrollExtension();var e=t._getRowCounts();m=Object.assign({tabIndex:true},m);r.openStart("div");r.class("sapUiTableVSbContainer");if(!s.isVerticalScrollbarRequired()){r.class("sapUiTableHidden");}r.class(m.cssClass);r.openEnd();r.openStart("div",t.getId()+"-vsb");r.class("sapUiTableVSb");r.style("max-height",s.getVerticalScrollbarHeight()+"px");if(e.fixedTop>0){r.style("top",e.fixedTop*t._getBaseRowHeight()-1+"px");}if(m.tabIndex){r.attr("tabindex","-1");}r.openEnd();r.openStart("div");r.class("sapUiTableVSbContent");r.style("height",s.getVerticalScrollHeight()+"px");r.openEnd();r.close("div");r.close("div");r.close("div");};d.renderVSbExternal=function(r,t){if(E.isEnrichedWith(t,"sap.ui.table.extensions.Synchronization")){this.renderVSb(r,t,{cssClass:"sapUiTableVSbExternal",tabIndex:false});}else{L.error("This method can only be used with synchronization enabled.",t,"TableRenderer.renderVSbExternal");}};d.renderHSb=function(r,t,m){m=Object.assign({id:t.getId()+"-hsb",cssClass:"sapUiTableHSb",tabIndex:true,hidden:true,scrollWidth:0},m);r.openStart("div",m.id);r.class(m.cssClass);if(m.hidden){r.class("sapUiTableHidden");}if(m.tabIndex){r.attr("tabindex","-1");}r.openEnd();r.openStart("div",m.id+"-content");r.class("sapUiTableHSbContent");if(m.scrollWidth>0){r.style("width",m.scrollWidth+"px");}r.openEnd();r.close("div");r.close("div");};d.renderHSbExternal=function(r,t,i,s){if(E.isEnrichedWith(t,"sap.ui.table.extensions.Synchronization")){this.renderHSb(r,t,{id:i,cssClass:"sapUiTableHSbExternal",tabIndex:false,hidden:false,scrollWidth:s});}else{L.error("This method can only be used with synchronization enabled.",t,"TableRenderer.renderVSbExternal");}};d.renderHSbBackground=function(r,t){r.openStart("div",t.getId()+"-hsb-bg");r.class("sapUiTableHSbBg");r.openEnd().close("div");};d.renderTabElement=function(r,s,t,i){r.openStart("div");if(s){r.class(s);}if(i){r.attr("id",i);}r.attr("tabindex",t==null?"0":t);r.openEnd().close("div");};d.getColumnsToRender=function(t,s,e){return t.getColumns().slice(s,e).filter(function(o){return o&&o.shouldRender();});};d.getLastFixedColumnIndex=function(t){var F=t.getComputedFixedColumnCount();var e=t.getColumns();var o,l;for(var i=F-1;i>=0;i--){o=e[i];if(o.shouldRender()){l=i;break;}}return l;};return d;},true);
