/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/model/Sorter","sap/ui/Device","sap/ui/thirdparty/jquery"],function(S,D,q){"use strict";var T=new window.WeakMap();var G={TableUtils:null,HierarchyMode:{Flat:"Flat",Group:"Group",Tree:"Tree",GroupedTree:"GroupedTree"},setHierarchyMode:function(t,m){if(!G.TableUtils.isA(t,"sap.ui.table.Table")||!(m in G.HierarchyMode)){return;}var c=G.getHierarchyMode(t);if(c!==m){T.set(t,m);t.invalidate();}},getHierarchyMode:function(t){return G.TableUtils.isA(t,"sap.ui.table.Table")?T.get(t)||G.HierarchyMode.Flat:null;},setToDefaultFlatMode:function(t){G.setHierarchyMode(t,G.HierarchyMode.Flat);},setToDefaultGroupMode:function(t){G.setHierarchyMode(t,G.HierarchyMode.Group);},setToDefaultTreeMode:function(t){G.setHierarchyMode(t,G.HierarchyMode.Tree);},isInFlatMode:function(t){return G.getHierarchyMode(t)===G.HierarchyMode.Flat;},isInGroupMode:function(t){var h=G.getHierarchyMode(t);return h===G.HierarchyMode.Group||h===G.HierarchyMode.GroupedTree;},isInTreeMode:function(t){return G.getHierarchyMode(t)===G.HierarchyMode.Tree;},getModeCssClass:function(t){switch(G.getHierarchyMode(t)){case G.HierarchyMode.Group:case G.HierarchyMode.GroupedTree:return"sapUiTableGroupMode";case G.HierarchyMode.Tree:return"sapUiTableTreeMode";default:return null;}},showGroupMenuButton:function(t){return!D.system.desktop&&G.TableUtils.isA(t,"sap.ui.table.AnalyticalTable");},isInGroupHeaderRow:function(c){var i=G.TableUtils.getCellInfo(c);if(i.isOfType(G.TableUtils.CELLTYPE.ANYCONTENTCELL)){return i.cell.parent().hasClass("sapUiTableGroupHeaderRow");}return false;},isInSummaryRow:function(c){var i=G.TableUtils.getCellInfo(c);if(i.isOfType(G.TableUtils.CELLTYPE.ANYCONTENTCELL)){return i.cell.parent().hasClass("sapUiTableSummaryRow");}return false;},calcGroupIndent:function(r){var t=G.getHierarchyMode(r.getTable())===G.HierarchyMode.GroupedTree;var R=!t&&!r.isGroupHeader()&&!r.isTotalSummary();var l=r.getLevel()-(R?1:0);var I=0;for(var i=1;i<l;i++){if(i===1){I=24;}else if(i===2){I+=12;}else{I+=8;}}return I;},calcTreeIndent:function(r){return(r.getLevel()-1)*17;},setGroupIndent:function(r,i){var d=r.getDomRefs(true);var R=d.row;var $=d.rowHeaderPart;var b=r.getTable()._bRtlMode;var f=R.find("td.sapUiTableCellFirst > .sapUiTableCellInner");var s=$.find(".sapUiTableGroupShield");if(i<=0){$.css(b?"right":"left","");s.css("width","").css(b?"margin-right":"margin-left","");f.css(b?"padding-right":"padding-left","");R.css("--CalculatedGroupIndent","0");}else{$.css(b?"right":"left",i+"px");s.css("width",i+"px").css(b?"margin-right":"margin-left",((-1)*i)+"px");f.css(b?"padding-right":"padding-left",(i+8)+"px");R.css("--CalculatedGroupIndent",i+"px");}},setTreeIndent:function(r,i){var d=r.getDomRefs(true);var R=d.row;var b=r.getTable()._bRtlMode;var t=R.find(".sapUiTableTreeIcon");t.css(b?"margin-right":"margin-left",i>0?i+"px":"");},updateTableRowForGrouping:function(r){var t=r.getTable();var d=r.getDomRefs(true);var R=d.row;var i=r.isExpanded();var I=r.isExpandable();R.toggleClass("sapUiTableSummaryRow",r.isSummary());if(G.isInGroupMode(t)){var s=r.getTitle();var a=G.calcGroupIndent(r);r.$("groupHeader").toggleClass("sapUiTableGroupIconOpen",I&&i).toggleClass("sapUiTableGroupIconClosed",I&&!i).attr("title",t._getShowStandardTooltips()&&s?s:null).text(s);G.setGroupIndent(r,a);R.toggleClass("sapUiTableRowIndented",a>0).toggleClass("sapUiTableGroupHeaderRow",r.isGroupHeader());if(G.showGroupMenuButton(t)){var $=t.$();var b=$.hasClass("sapUiTableVScr")?$.find(".sapUiTableVSb").width():0;var g=d.rowHeaderPart.find(".sapUiTableGroupMenuButton");var m=$.width()-g.width()-b-5-a;g.css(t._bRtlMode?"right":"left",m+"px");}}if(G.isInTreeMode(t)){var c=R.find(".sapUiTableTreeIcon");if(!I&&document.activeElement===c[0]){G.TableUtils.getParentCell(t,c[0]).trigger("focus");}c.toggleClass("sapUiTableTreeIconLeaf",!I).toggleClass("sapUiTableTreeIconNodeOpen",I&&i).toggleClass("sapUiTableTreeIconNodeClosed",I&&!i);G.setTreeIndent(r,G.calcTreeIndent(r));}if(!G.isInFlatMode(t)){t._getAccExtension().updateAriaExpandAndLevelState(r);}},cleanupTableRowForGrouping:function(r){var t=r.getTable();var d=r.getDomRefs(true);if(G.isInGroupMode(t)){d.row.removeClass("sapUiTableGroupHeaderRow sapUiTableSummaryRow sapUiTableRowIndented");r.$("groupHeader").removeClass("sapUiTableGroupIconOpen","sapUiTableGroupIconClosed").attr("title","").text("");G.setGroupIndent(r,0);}if(G.isInTreeMode(t)){d.row.find(".sapUiTableTreeIcon").removeClass("sapUiTableTreeIconLeaf").removeClass("sapUiTableTreeIconNodeOpen").removeClass("sapUiTableTreeIconNodeClosed");G.setTreeIndent(r,0);}t._getAccExtension().updateAriaExpandAndLevelState(r);},updateGroups:function(t){if(t.getBinding()){t.getRows().forEach(function(r){G.updateTableRowForGrouping(r);});}else{t.getRows().forEach(function(r){G.cleanupTableRowForGrouping(r);});}},setupExperimentalGrouping:function(t){if(!t.getEnableGrouping()){return;}var b=t.getBinding();var g=sap.ui.getCore().byId(t.getGroupBy());var I=g&&g.getGrouped()&&G.TableUtils.isA(b,"sap.ui.model.ClientListBinding");if(!I||b._modified){return;}b._modified=true;G.setToDefaultGroupMode(t);var p=g.getSortProperty();b.sort(new S(p));var l=t._getTotalRowCount(),c=b.getContexts(0,l);var k;var C=0;for(var i=l-1;i>=0;i--){var n=c[i].getProperty(p);if(!k){k=n;}if(k!==n){var o=c[i+1].getModel().getContext("/sap.ui.table.GroupInfo"+i);o.__groupInfo={oContext:c[i+1],name:k,count:C,groupHeader:true,expanded:true};c.splice(i+1,0,o);k=n;C=0;}C++;}var o=c[0].getModel().getContext("/sap.ui.table.GroupInfo");o.__groupInfo={oContext:c[0],name:k,count:C,groupHeader:true,expanded:true};c.splice(0,0,o);q.extend(b,{getLength:function(){return c.length;},getContexts:function(s,l){return c.slice(s,s+l);}});function a(d){var e=c[d];return(e&&e.__groupInfo&&e.__groupInfo.groupHeader)===true;}t._experimentalGroupingRowState=function(s){var d=s.context;if((d&&d.__groupInfo&&d.__groupInfo.groupHeader)===true){s.type=s.Type.GroupHeader;}s.title=d&&d.__groupInfo&&d.__groupInfo.name+" - "+d.__groupInfo.count;s.expandable=s.type===s.Type.GroupHeader;s.expanded=s.expandable&&d.__groupInfo&&d.__groupInfo.expanded;s.level=s.expandable?1:2;s.contentHidden=s.expandable;};t._experimentalGroupingExpand=function(r){var R=r.getIndex();if(a(R)&&!c[R].__groupInfo.expanded){for(var i=0;i<c[R].__childs.length;i++){c.splice(R+1+i,0,c[R].__childs[i]);}delete c[R].__childs;c[R].__groupInfo.expanded=true;b._fireChange();}};t._experimentalGroupingCollapse=function(r){var R=r.getIndex();if(a(R)&&c[R].__groupInfo.expanded){c[R].__childs=c.splice(R+1,c[R].__groupInfo.count);c[R].__groupInfo.expanded=false;b._fireChange();}};var H=G.TableUtils.Hook;H.register(t,H.Keys.Row.UpdateState,t._experimentalGroupingRowState);H.register(t,H.Keys.Row.Expand,t._experimentalGroupingExpand);H.register(t,H.Keys.Row.Collapse,t._experimentalGroupingCollapse);t._mTimeouts.groupingFireBindingChange=t._mTimeouts.groupingFireBindingChange||window.setTimeout(function(){b._fireChange();},0);},resetExperimentalGrouping:function(t){var b=t.getBinding();var H=G.TableUtils.Hook;if(b&&b._modified){G.setToDefaultFlatMode(t);t.bindRows(t.getBindingInfo("rows"));}H.deregister(t,H.Keys.Row.UpdateState,t._experimentalGroupingRowState);H.deregister(t,H.Keys.Row.Expand,t._experimentalGroupingExpand);H.deregister(t,H.Keys.Row.Collapse,t._experimentalGroupingCollapse);delete t._experimentalGroupingRowState;delete t._experimentalGroupingExpand;delete t._experimentalGroupingCollapse;}};return G;},true);
