/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['./DateTypeRange','sap/ui/core/format/DateFormat','sap/ui/core/format/NumberFormat','sap/ui/core/LocaleData','./library',"sap/base/Log"],function(D,a,N,L,l,b){"use strict";var C=D.extend("sap.ui.unified.CalendarAppointment",{metadata:{library:"sap.ui.unified",properties:{title:{type:"string",group:"Data"},text:{type:"string",group:"Data"},description:{type:"string",group:"Data"},icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},tentative:{type:"boolean",group:"Data",defaultValue:false},selected:{type:"boolean",group:"Data",defaultValue:false},key:{type:"string",group:"Data",defaultValue:null},color:{type:"sap.ui.core.CSSColor",group:"Appearance",defaultValue:null}},aggregations:{customContent:{type:"sap.ui.core.Control",multiple:true}}}});C.prototype.init=function(){this._sAppointmentPartSuffix=null;};C.prototype.applyFocusInfo=function(f){var p=this.getParent();if(p){p.applyFocusInfo(f);}return this;};C.prototype._getDateRangeIntersectionText=function(c){var s=this.getStartDate(),e=this.getEndDate()?this.getEndDate():new Date(864000000000000),f,S,o=new Date(c.getFullYear(),c.getMonth(),c.getDate(),0,0,0),n=new Date(o.getFullYear(),o.getMonth(),o.getDate()+1),t=a.getTimeInstance({pattern:"HH:mm"}),r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),h=N.getUnitInstance({allowedUnits:["duration-hour"]},sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()),m=N.getUnitInstance({allowedUnits:["duration-minute"]},sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()),H,M,d,g;if(s.getTime()>=n.getTime()||e.getTime()<=o.getTime()){f="";}else if(s.getTime()<=o.getTime()&&e.getTime()>=n.getTime()){f=r.getText("PLANNINGCALENDAR_ALLDAY");}else if(s.getTime()<o.getTime()){f=r.getText("PLANNINGCALENDAR_UNTIL");S=t.format(e);}else if(e.getTime()>n.getTime()){f=r.getText("PLANNINGCALENDAR_FROM");S=t.format(s);}else{f=t.format(s);if(e.getTime()-s.getTime()<3600000){M=(e.getTime()-s.getTime())/60000;S=m.format(M,"duration-minute");}else if(((e.getTime()-s.getTime())%3600000)===0){H=(e.getTime()-s.getTime())/3600000;S=h.format(H,"duration-hour");}else{H=Math.floor((e.getTime()-s.getTime())/3600000);d=h.format(H,"duration-hour");M=(e.getTime()-s.getTime())/60000%60;g=m.format(M,"duration-minute");S=r.getText("PLANNINGCALENDAR_APP_DURATION",[d,g]);}}return{start:f,end:S};};C._getComparer=function(d){var O=24*60*60*1000,c=new Date(d.getFullYear(),d.getMonth(),d.getDate(),0,0,0).getTime(),n=c+O;return function(A,o){var s=A.appointment.getStartDate().getTime(),S=o.appointment.getStartDate().getTime(),e=A.appointment.getEndDate()?A.appointment.getEndDate().getTime():864000000000000,E=o.appointment.getEndDate()?o.appointment.getEndDate().getTime():864000000000000,w=s<=c&&e>=n,W=S<=c&&E>=n,r;if((w&&W)||(!w&&!W)){r=s-S;if(r===0){r=E-e;}}else if(w){r=-1;}else{r=1;}return r;};};C.prototype.setColor=function(c){if(c&&!c.match(/^#[0-9a-f]{6}$/i)){b.warning("setColor accepts only full hex color value with pound symbol, but value is '"+c+"'");}return this.setProperty("color",c);};C.prototype._getCSSColorForBackground=function(h){return"rgba("+[parseInt(h.substr(1,2),16),parseInt(h.substr(3,2),16),parseInt(h.substr(5,2),16)].join(",")+", 0.2)";};C.prototype._setAppointmentPartSuffix=function(s){this._sAppointmentPartSuffix=s;return this;};C.prototype.getDomRef=function(s){if(document.getElementById(this.getId())){return document.getElementById(s?this.getId()+"-"+s:this.getId());}else if(this._sAppointmentPartSuffix){return document.getElementById(s?this.getId()+"-"+this._sAppointmentPartSuffix+"-"+s:this.getId()+"-"+this._sAppointmentPartSuffix);}var A=document.querySelectorAll(".sapUiCalendarRowApps[id^='"+this.getId()+"']");return A.length>0?A[0]:null;};return C;});
