/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/core/date/UniversalDate','sap/ui/unified/CalendarAppointment','sap/ui/unified/CalendarLegendRenderer','sap/ui/Device','sap/ui/unified/library','sap/ui/core/IconPool','sap/ui/core/InvisibleText',"sap/base/Log"],function(U,C,a,D,l,I,b,L){"use strict";var c=l.CalendarDayType;var d=l.CalendarIntervalType;var e=l.CalendarAppointmentVisualization;var f=l.CalendarAppointmentHeight;var g={apiVersion:2};g.render=function(r,R){var t=R.getTooltip_AsString();var v=R.getAppointmentsVisualization();var T=this.getLegendItems(R);r.openStart("div",R);r.class("sapUiCalendarRow");if(!D.system.phone&&R.getAppointmentsReducedHeight()){r.class("sapUiCalendarRowAppsRedHeight");}if(v!=e.Standard){r.class("sapUiCalendarRowVis"+v);}if(t){r.attr("title",t);}var w=R.getWidth();if(w){r.style("width",w);}var h=R.getHeight();if(h){r.style("height",h);}r.accessibilityState(R);r.openEnd();this.renderAppointmentsRow(r,R,T);r.close("div");};g.renderAppointmentsRow=function(r,R,t){var i=R.getId();r.openStart("div",i+"-Apps");r.class("sapUiCalendarRowApps");r.openEnd();this.renderBeforeAppointments(r,R);this.renderAppointments(r,R,t);this.renderAfterAppointments(r,R);r.close("div");};g.renderBeforeAppointments=function(r,R){};g.renderAfterAppointments=function(r,R){};g.renderResizeHandle=function(r,R,A){};g.renderAppointments=function(r,R,t){var A=R._getVisibleAppointments();var h=R._getVisibleIntervalHeaders();var s=R._getStartDate();var n=[];var S=0;var N=0;var j=[];var k=0;var m=0;var o=R.getIntervals();var p=R.getIntervalType();var w=100/o;var i=0;var q=new U(s);var F=false;var u=false;switch(p){case d.Hour:n=R.getNonWorkingHours()||[];S=s.getUTCHours();N=24;break;case d.Day:case d.Week:case d.OneMonth:case"OneMonth":n=R._getNonWorkingDays();S=s.getUTCDay();N=7;j=R.getNonWorkingHours()||[];k=s.getUTCHours();m=24;break;case d.Month:j=R._getNonWorkingDays();k=s.getUTCDay();m=7;break;default:break;}if(R._isOneMonthsRowOnSmallSizes()){this.renderSingleDayInterval(r,R,A,t,h,n,S,N,j,k,m,true,true);}else{for(i=0;i<o;i++){if(u){F=true;}else{F=false;}u=false;switch(p){case d.Hour:q.setUTCHours(q.getUTCHours()+1);if(q.getUTCHours()==0){u=true;}break;case d.Day:case d.Week:case d.OneMonth:case"OneMonth":q.setUTCDate(q.getUTCDate()+1);if(q.getUTCDate()==1){u=true;}break;case d.Month:k=q.getUTCDay();q.setUTCMonth(q.getUTCMonth()+1);if(q.getUTCMonth()==0){u=true;}break;default:break;}this.renderInterval(r,R,i,w,h,n,S,N,j,k,m,F,u);}this.renderIntervalHeaders(r,R,w,h,o);if(!(R._getRelativeInfo&&R._getRelativeInfo().bIsRelative)){r.openStart("div",R.getId()+"-Now");r.class("sapUiCalendarRowNow");r.openEnd();r.close("div");}for(i=0;i<A.length;i++){var v=A[i];this.renderAppointment(r,R,v,t);}r.openStart("div",R.getId()+"-DummyApp");r.class("sapUiCalendarApp");r.class("sapUiCalendarAppTitleOnly");r.class("sapUiCalendarAppDummy");r.class("sapUiCalendarAppHeight1");r.openEnd();r.close("div");}};g.writeCustomAttributes=function(r,R){};g.renderInterval=function(r,R,h,w,k,n,s,N,m,S,o,F,p,A){var q=R.getId()+"-AppsInt"+h;var i;var t=R.getShowIntervalHeaders()&&(R.getShowEmptyIntervalHeaders()||k.length>0);var M=R.getStartDate().getMonth();var u=new Date(R.getStartDate().getFullYear(),M+1,0).getDate();r.openStart("div",q);r.class("sapUiCalendarRowAppsInt");if(A){r.class(A);}r.style("width",w+"%");if(h>=u&&(R.getIntervalType()===d.OneMonth||R.getIntervalType()==="OneMonth")){r.class("sapUiCalItemOtherMonth");}for(i=0;i<n.length;i++){if((h+s)%N==n[i]){r.class("sapUiCalendarRowAppsNoWork");break;}}if(!t){r.class("sapUiCalendarRowAppsIntNoHead");}if(F){r.class("sapUiCalendarRowAppsIntFirst");}if(p){r.class("sapUiCalendarRowAppsIntLast");}this.writeCustomAttributes(r,R);r.openEnd();if(t){r.openStart("div");r.class("sapUiCalendarRowAppsIntHead");r.openEnd();r.close("div");}if(R.getShowSubIntervals()){var v=R.getIntervalType();var x=0;switch(v){case d.Hour:x=4;break;case d.Day:case d.Week:case d.OneMonth:case"OneMonth":x=24;break;case d.Month:var y=R._getStartDate();var z=new U(y);z.setUTCMonth(z.getUTCMonth()+h+1,0);x=z.getUTCDate();z.setUTCDate(1);s=z.getUTCDay();break;default:break;}var B=100/x;for(i=0;i<x;i++){r.openStart("div");r.class("sapUiCalendarRowAppsSubInt");r.style("width",B+"%");for(var j=0;j<m.length;j++){if((i+S)%o==m[j]){r.class("sapUiCalendarRowAppsNoWork");break;}}r.openEnd();r.close("div");}}r.close("div");};g.renderIntervalHeaders=function(r,R,w,h,j){var s=R.getShowIntervalHeaders()&&(R.getShowEmptyIntervalHeaders()||h.length>0);if(s){for(var i=0;i<h.length;i++){var o=h[i],k,m;if(R._bRTL){m=w*o.interval;k=w*(j-o.last-1);}else{k=w*o.interval;m=w*(j-o.last-1);}this.renderIntervalHeader(r,R,o,R._bRTL,k,m);}}};g.renderIntervalHeader=function(r,R,i,h,j,k){var s=i.appointment.getId(),A={labelledby:{value:s+"-Descr",append:true}},S;var o=R._calculateAppoitnmentVisualCue(i.appointment);r.openStart("div",i.appointment);r.class("sapUiCalendarRowAppsIntHead");if(j!==undefined){r.style("left",j+"%");}if(k!==undefined){r.style("right",k+"%");}r.class("sapUiCalendarRowAppsIntHeadFirst");if(i.appointment.getSelected()){r.class("sapUiCalendarRowAppsIntHeadSel");}if(i.appointment.getTentative()){r.class("sapUiCalendarRowAppsIntHeadTent");}var t=i.appointment.getTooltip_AsString();if(t){r.attr("title",t);}var T=i.appointment.getType();var m=i.appointment.getColor();if(!m&&T&&T!=c.None){r.class("sapUiCalendarRowAppsIntHead"+T);}if(m){if(h){r.style("border-right-color",m);}else{r.style("border-left-color",m);}}r.accessibilityState(i.appointment,A);r.openEnd();r.openStart("div");r.class("sapUiCalendarIntervalHeaderCont");if(m){r.style("background-color",i.appointment._getCSSColorForBackground(m));}r.openEnd();if(o.appTimeUnitsDifRowStart>0){r.icon("sap-icon://arrow-left",["sapUiCalendarAppArrowIconLeft"],{title:null,role:"img"});}var n=i.appointment.getIcon();if(n){var p=["sapUiCalendarRowAppsIntHeadIcon"];var q={};q["id"]=s+"-Icon";q["title"]=null;q["role"]="img";r.icon(n,p,q);}var u=i.appointment.getTitle();if(u){r.openStart("span",s+"-Title");r.class("sapUiCalendarRowAppsIntHeadTitle");r.openEnd();r.text(u);r.close("span");}var v=i.appointment.getText();if(v){r.openStart("span",s+"-Text");r.class("sapUiCalendarRowAppsIntHeadText");r.openEnd();r.text(v);r.close("span");}if(o.appTimeUnitsDifRowEnd>0){r.icon("sap-icon://arrow-right",["sapUiCalendarAppArrowIconRight"],{title:null,role:"img"});}S=R._oRb.getText("CALENDAR_START_TIME")+": "+R._oFormatAria.format(i.appointment.getStartDate())+"; "+R._oRb.getText("CALENDAR_END_TIME")+": "+R._oFormatAria.format(i.appointment.getEndDate());if(T&&T!==c.None){S+="; "+this.getAriaTextForType(T,this.getLegendItems(R));}r.openStart("span",s+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(S);r.close("span");r.close("div");r.close("div");};g.renderAppointment=function(r,R,A,t,h){var o=A.appointment;var T=o.getTooltip_AsString();var s=o.getType();var i=o.getColor();var j=o.getTitle();var k=o.getText();var m=o.getDescription();var n=o.getIcon();var p=o.getId();var q=R._getAppointmentReducedHeight(A);var u={labelledby:{value:b.getStaticId("sap.ui.unified","APPOINTMENT")+" "+p+"-Descr",append:true},selected:null};var v=R._getAppointmentRowCount(A,q);var w=R.getAriaLabelledBy();var x=R._calculateAppoitnmentVisualCue(o);if(w.length>0){u["labelledby"].value=u["labelledby"].value+" "+w.join(" ");}if(j){u["labelledby"].value=u["labelledby"].value+" "+p+"-Title";}if(k){u["labelledby"].value=u["labelledby"].value+" "+p+"-Text";}r.openStart("div",o);r.class("sapUiCalendarApp");r.class("sapUiCalendarAppHeight"+v);if(o.getSelected()){r.class("sapUiCalendarAppSel");u["labelledby"].value=u["labelledby"].value+" "+b.getStaticId("sap.ui.unified","APPOINTMENT_SELECTED");}if(o.getTentative()){r.class("sapUiCalendarAppTent");u["labelledby"].value=u["labelledby"].value+" "+b.getStaticId("sap.ui.unified","APPOINTMENT_TENTATIVE");}if(v===1){r.class("sapUiCalendarAppTitleOnly");}if(n){r.class("sapUiCalendarAppWithIcon");}if(!h){if(R._bRTL){r.style("right",A.begin+"%");r.style("left",A.end+"%");}else{r.style("left",A.begin+"%");r.style("right",A.end+"%");}}r.attr("data-sap-level",A.level);if(R._sFocusedAppointmentId==p){r.attr("tabindex","0");}else{r.attr("tabindex","-1");}if(T){r.attr("title",T);}if(!i&&s&&s!=c.None){r.class("sapUiCalendarApp"+s);}if(i){if(R._bRTL){r.style("border-right-color",i);}else{r.style("border-left-color",i);}}r.accessibilityState(o,u);r.openEnd();r.openStart("div");r.class("sapUiCalendarAppCont");if(i&&R.getAppointmentsVisualization()===e.Filled){r.style("background-color",o._getCSSColorForBackground(i));}r.openEnd();if(o.getCustomContent().length){o.getCustomContent().forEach(function(F){r.renderControl(F);});}else{if(x.appTimeUnitsDifRowStart>0){r.icon("sap-icon://arrow-left",["sapUiCalendarAppArrowIconLeft"],{title:null,role:"img"});}if(n){var y=["sapUiCalendarAppIcon"];var z={};z["id"]=p+"-Icon";z["title"]=null;z["role"]="img";r.icon(n,y,z);}r.openStart("div");r.class("sapUiCalendarAppTitleWrapper");r.openEnd();if(j){r.openStart("span",p+"-Title");r.class("sapUiCalendarAppTitle");r.openEnd();r.text(j);r.close("span");}if(k&&A.size!==f.HalfSize){r.openStart("span",p+"-Text");r.class("sapUiCalendarAppText");r.openEnd();r.text(k);r.close("span");}if(m&&A.size!==f.HalfSize&&(A.size!==f.Regular||!k)){r.openStart("span",p+"-Info");r.class("sapUiCalendarAppDescription");r.openEnd();r.text(m);r.close("span");}r.close("div");if(x.appTimeUnitsDifRowEnd>0){r.icon("sap-icon://arrow-right",["sapUiCalendarAppArrowIconRight"],{title:null,role:"img"});}}var B=R._oRb.getText("CALENDAR_START_TIME")+": "+R._oFormatAria.format(o.getStartDate());B=B+"; "+R._oRb.getText("CALENDAR_END_TIME")+": "+R._oFormatAria.format(o.getEndDate());if(R._getRelativeInfo&&R._getRelativeInfo().bIsRelative){var E=R._getRelativeInfo();B=R._oRb.getText("CALENDAR_START_TIME")+": "+E.intervalLabelFormatter(E._getIndexFromDate(o.getStartDate()));B=B+"; "+R._oRb.getText("CALENDAR_END_TIME")+": "+E.intervalLabelFormatter(E._getIndexFromDate(o.getEndDate()));}if(s&&s!=c.None){B=B+"; "+this.getAriaTextForType(s,t);}r.openStart("span",p+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(B);r.close("span");r.close("div");this.renderResizeHandle(r,R,o);r.close("div");};g.renderSingleDayInterval=function(r,R,A,t,h,n,s,N,k,S,m,F,o){var p=1,w=100,q=R.getId()+"-AppsInt"+p,i,u=R.getShowIntervalHeaders()&&(R.getShowEmptyIntervalHeaders()||h.length>0),v=new Date(R.getStartDate()),M=v.getMonth(),x=new Date(v.getFullYear(),M+1,0).getDate(),y,P=R._getPlanningCalendar(),z,B,E=[];v.setHours(0,0,0,0);z=A.concat(R.getIntervalHeaders().filter(function(W){var X=W.getStartDate().getTime(),Y=W.getEndDate().getTime(),Z=v.getTime(),$=Z+1000*60*60*24;return!(X>=$||Y<=Z);}).map(function(W){return{appointment:W,isHeader:true};})).sort(C._getComparer(v));if(P){E=P._getSelectedDates();}r.openStart("div",q);r.class("sapUiCalendarRowAppsInt");r.class("sapUiCalendarMonthRowAppsS");r.style("width",w+"%");if(p>=x&&(R.getIntervalType()===d.OneMonth||R.getIntervalType()==="OneMonth")){r.class("sapUiCalItemOtherMonth");}for(i=0;i<n.length;i++){if((p+s)%N==n[i]){r.class("sapUiCalendarRowAppsNoWork");break;}}if(!u){r.class("sapUiCalendarRowAppsIntNoHead");}if(F){r.class("sapUiCalendarRowAppsIntFirst");}if(o){r.class("sapUiCalendarRowAppsIntLast");}r.openEnd();if(u){r.openStart("div");r.class("sapUiCalendarRowAppsIntHead");r.openEnd();r.close("div");}if(E.length>0){var G=0,H=z.length;if(P.getRows()[0]._calculateVisibleAppointments){var J=P.getRows()[0]._calculateVisibleAppointments(E,z);G=J.iStart;H=J.iEnd;}for(i=G;i<H;i++){B=z[i];r.openStart("div");r.class("sapUiCalendarAppContainer");r.openEnd();r.openStart("div");r.class("sapUiCalendarAppContainerLeft");r.openEnd();r.openStart("div");r.class("sapUiCalendarAppStart");r.openEnd();r.text(B.appointment._getDateRangeIntersectionText(v).start);r.close("div");r.openStart("div");r.class("sapUiCalendarAppEnd");r.openEnd();r.text(B.appointment._getDateRangeIntersectionText(v).end);r.close("div");r.close("div");r.openStart("div");r.class("sapUiCalendarAppContainerRight");r.openEnd();if(B.isHeader){this.renderIntervalHeader(r,R,B);}else{this.renderAppointment(r,R,B,t,true);}r.close("div");r.close("div");}}if(A.length===0||E.length===0){r.openStart("div");r.class("sapUiCalendarNoApps");r.openEnd();var K=sap.ui.getCore().byId(R.getAssociation("row"));y=K.getNoAppointmentsText()?K.getNoAppointmentsText():sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("PLANNINGCALENDAR_ROW_NO_APPOINTMENTS");r.text(y);r.close("div");}if(!(R._getRelativeInfo&&R._getRelativeInfo().bIsRelative)){r.openStart("div",R.getId()+"-Now");r.class("sapUiCalendarRowNow");r.openEnd();}r.close("div");r.openStart("div",R.getId()+"-DummyApp");r.class("sapUiCalendarApp");r.class("sapUiCalendarAppTitleOnly");r.class("sapUiCalendarAppDummy");r.style("margin","0");r.style("height","0px");r.openEnd();r.close("div");if(R.getShowSubIntervals()){var O=R.getIntervalType();var Q=0;switch(O){case d.Hour:Q=4;break;case d.Day:case d.Week:case d.OneMonth:case"OneMonth":Q=24;break;case d.Month:var T=new U(v);T.setUTCMonth(T.getUTCMonth()+p+1,0);Q=T.getUTCDate();T.setUTCDate(1);s=T.getUTCDay();break;default:break;}var V=100/Q;for(i=0;i<Q;i++){r.openStart("div");r.class("sapUiCalendarRowAppsSubInt");r.style("width",V+"%");for(var j=0;j<k.length;j++){if((i+S)%m==k[j]){r.class("sapUiCalendarRowAppsNoWork");break;}}r.openEnd();r.close("div");}}r.close("div");};g.getLegendItems=function(o){var r=[],h,s=o.getLegend();if(s){h=sap.ui.getCore().byId(s);if(h){r=h.getItems();}else{L.error("CalendarLegend with id '"+s+"' does not exist!",o);}}return r;};g.getAriaTextForType=function(t,h){var T,s,o,i;if(h&&h.length){for(var i=0;i<h.length;i++){o=h[i];if(o.getType()===t){T=o.getText();break;}}}if(!T){s=a.getTypeAriaText(t);if(s){T=s.getText();}}return T;};return g;},true);
