/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['./ColorPickerDisplayMode',"sap/ui/Device"],function(C,D){"use strict";var a={apiVersion:2};a.render=function(r,c){var d=c.getDisplayMode(),R=c.bResponsive;r.openStart("div",c);r.accessibilityState(c,{role:"group",roledescription:sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified").getText("COLOR_PICKER_TITLE")});if(R){r.class("sapUiColorPicker-ColorPickerMatrix");r.class("sapUiColorPicker-"+d);r.class("sapUnifiedColorPicker");if(c._bHSLMode){r.class("sapUiColorPickerHSL");}}if(D.system.phone){r.class("sapUiCPPhone");}r.openEnd();if(!R){r.renderControl(c.getAggregation("_grid"));}else{switch(d){case C.Default:this.renderDefaultColorPicker(r,c);break;case C.Large:this.renderLargeColorPicker(r,c);break;case C.Simplified:this.renderSimplifiedColorPicker(r,c);}}r.close("div");};a.renderDefaultColorPicker=function(r,c){r.renderControl(c.getAggregation("_oCPBox"));if(D.system.phone){r.openStart("div");r.class("sapUiCPPhoneContent");r.openEnd();r.openStart("div");r.class("sapUiCPSlidersPhone");r.openEnd();r.renderControl(c.getAggregation("_oSlider"));r.renderControl(c.getAggregation("_oAlphaSlider"));r.close("div");this.renderMobileSwatches(r,c);r.close("div");}else{r.renderControl(c.getAggregation("_oSlider"));r.renderControl(c.getAggregation("_oAlphaSlider"));this.renderDesktopSwatchesAndHexFields(r,c);}r.openStart("div");r.class("sapUiCPDefaultWrapper");r.openEnd();if(D.system.phone){r.renderControl(c.getAggregation("_oHexField"));r.openStart("div");r.class("sapUiCPHexText");r.openEnd();r.text("Hex");r.close("div");}r.openStart("div");r.class("sapUiCPDefaultRGB");r.openEnd();r.renderControl(c.getAggregation("_oRedField"));this.renderEmptyDiv(r);r.renderControl(c.getAggregation("_oGreenField"));this.renderEmptyDiv(r);r.renderControl(c.getAggregation("_oBlueField"));this.renderEmptyDiv(r);r.renderControl(c.getAggregation("_oAlphaField"));r.close("div");r.openStart("div");r.class("sapUiCPDefaultHSLV");r.openEnd();r.renderControl(c.getAggregation("_oHueField"));this.renderEmptyDiv(r);r.renderControl(c.getAggregation("_oSatField"));r.openStart("div");r.class("sapUiCPPercentSymbol");r.openEnd();r.text("%");r.close("div");r.renderControl(c.getAggregation("_oLitField"));r.renderControl(c.getAggregation("_oValField"));if(c.getMode()==="HSL"){r.openStart("div");r.class("sapUiCPPercentSymbol");r.openEnd();r.text("%");r.close("div");}else{this.renderEmptyDiv(r);}r.renderControl(c.getAggregation("_oAlphaField2"));r.close("div");r.renderControl(c.getAggregation("_oButton"));this.renderRGBLabel(r,c);this.renderHSLVLabel(r,c);r.close("div");};a.renderLargeColorPicker=function(r,c){r.renderControl(c.getAggregation("_oCPBox"));r.renderControl(c.getAggregation("_oSlider"));r.renderControl(c.getAggregation("_oAlphaSlider"));this.renderDesktopSwatchesAndHexFields(r,c);r.renderControl(c.oRGBorHSLRBUnifiedGroup);r.openStart("div");r.class("sapUiCPRGBA");r.openEnd();r.renderControl(c.getAggregation("_oRedField"));this.renderEmptyDiv(r);r.renderControl(c.getAggregation("_oGreenField"));this.renderEmptyDiv(r);r.renderControl(c.getAggregation("_oBlueField"));this.renderEmptyDiv(r);r.renderControl(c.getAggregation("_oAlphaField"));r.close("div");this.renderRGBLabel(r,c);r.openStart("div");r.class("sapUiCPHSLV");r.openEnd();r.renderControl(c.getAggregation("_oHueField"));this.renderEmptyDiv(r);r.renderControl(c.getAggregation("_oSatField"));r.openStart("div");r.class("sapUiCPPercentSymbol");r.openEnd();r.text("%");r.close("div");c.getMode()==="HSL"?this.renderLFirst(r,c):this.renderVFirst(r,c);r.close("div");this.renderHSLVLabel(r,c);};a.renderSimplifiedColorPicker=function(r,c){r.renderControl(c.getAggregation("_oCPBox"));if(D.system.phone){r.openStart("div");r.class("sapUiCPPhoneContent");r.openEnd();r.openStart("div");r.class("sapUiCPSlidersPhone");r.openEnd();r.renderControl(c.getAggregation("_oSlider"));r.close("div");r.renderControl(c.getAggregation("_oHexField"));this.renderMobileSwatches(r,c);r.openStart("div");r.class("sapUiCPHexWrapper");r.openEnd();r.openStart("div");r.class("sapUiCPHexText");r.openEnd();r.text("Hex");r.close("div");r.close("div");r.close("div");}else{r.renderControl(c.getAggregation("_oSlider"));this.renderDesktopSwatchesAndHexFields(r,c);}};a.renderDesktopSwatchesAndHexFields=function(r,c){r.openStart("div");r.class("sapUiCPComparisonWrapper");r.openEnd();r.openStart("div",c.getId()+"-ocBox");r.class("sapUiColorPicker-ColorPickerOldColor");r.openEnd();r.close("div");r.openStart("div",c.getId()+"-ncBox");r.class("sapUiColorPicker-ColorPickerNewColor");r.openEnd();r.close("div");r.close("div");r.openStart("div");r.class("sapUiCPHexWrapper");r.openEnd();r.openStart("span");r.class("sapUiCPHexText");r.openEnd();r.text("Hex");r.close("span");r.close("div");r.renderControl(c.getAggregation("_oHexField"));};a.renderMobileSwatches=function(r,c){r.openStart("div");r.class("sapUiCPComparisonWrapper");r.class("sapUiCPComparisonWrapperPhone");r.openEnd();r.openStart("div",c.getId()+"-ocBox");r.class("sapUiColorPicker-ColorPickerOldColor");r.openEnd();r.close("div");r.openStart("div",c.getId()+"-ncBox");r.class("sapUiColorPicker-ColorPickerNewColor");r.openEnd();r.close("div");r.close("div");};a.renderLFirst=function(r,c){r.renderControl(c.getAggregation("_oLitField"));r.openStart("div");r.class("sapUiCPPercentSymbol");r.openEnd();r.text("%");r.close("div");r.renderControl(c.getAggregation("_oValField"));};a.renderVFirst=function(r,c){r.renderControl(c.getAggregation("_oValField"));this.renderEmptyDiv(r);r.renderControl(c.getAggregation("_oLitField"));};a.renderEmptyDiv=function(r){r.openStart("div");r.class("sapUiCPEmptyDiv");r.openEnd();r.close("div");};a.renderRGBLabel=function(r,c){r.openStart("div");r.class("sapUiCPRGBText");r.openEnd();r.openStart("span");r.class("sapUiCPText");r.openEnd();r.text("R");r.close("span");this.renderEmptyDiv(r);r.openStart("span");r.class("sapUiCPText");r.openEnd();r.text("G");r.close("span");this.renderEmptyDiv(r);r.openStart("span");r.class("sapUiCPText");r.openEnd();r.text("B");r.close("span");this.renderEmptyDiv(r);if(c.getDisplayMode()==="Default"){r.openStart("span");r.class("sapUiCPText");r.openEnd();r.text("A");r.close("span");}else{r.openStart("span");r.class("sapUiCPText");r.openEnd();r.close("span");}r.close("div");};a.renderHSLVLabel=function(r,c){r.openStart("div");r.class("sapUiCPHSLVText");r.openEnd();r.openStart("span");r.class("sapUiCPText");r.openEnd();r.text("H");r.close("span");this.renderEmptyDiv(r);r.openStart("span");r.class("sapUiCPText");r.openEnd();r.text("S");r.close("span");this.renderEmptyDiv(r);if(c.getMode()==="HSL"){r.openStart("span");r.class("sapUiCPText");r.openEnd();r.text("L");r.close("span");}else{r.openStart("span");r.class("sapUiCPText");r.openEnd();r.text("V");r.close("span");}this.renderEmptyDiv(r);r.openStart("span");r.class("sapUiCPText");r.openEnd();r.text("A");r.close("span");r.close("div");};return a;},true);
