/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/thirdparty/jquery","sap/ui/base/Object","sap/ui/core/Core","sap/ui/core/CustomData","sap/ui/core/Configuration","sap/ui/base/ManagedObjectObserver","./AnchorBar","sap/m/Button","sap/m/MenuButton","sap/m/Menu","sap/m/MenuItem","sap/ui/core/IconPool","sap/ui/core/InvisibleText"],function(q,B,C,a,b,M,A,c,d,e,f,I,g){"use strict";var h=B.extend("sap.uxap._helpers.AB",{constructor:function(o){this._oObjectPageLayout=o;this._oObserver=new M(this._proxyStateChanges.bind(this));this._aMenusWithAttachPressHandler=[];},getInterface:function(){return this;}});h._focusSection=function(s,p){var S=s.getDomRef();if(S){S.focus(p);}};h.prototype.getObjectPageLayout=function(){return this._oObjectPageLayout;};h.prototype._proxyStateChanges=function(o){var O=o.object,j=this._findExistingClone(O),p=o.name,v=o.current,s="set"+i(p);if(j){j[s].call(j,v);}};h.prototype._findExistingClone=function(o){var j,s=o.getId()+"-__clone",k=this._getAnchorBar(),l=k.getContent();l.some(function(m){if(m.getId().indexOf(s)===0){j=m;return true;}});return j;};h.prototype._getAnchorBar=function(){var o=this.getObjectPageLayout(),j=o.getAggregation("_anchorBar");if(!j){j=new A({id:o.getId()+"-anchBar",showPopover:o.getShowAnchorBarPopover(),backgroundDesign:o.getBackgroundDesignAnchorBar()});j.attachEvent("_anchorPress",o.onAnchorBarTabPress,o);this.getObjectPageLayout().setAggregation("_anchorBar",j,true);}return j;};h.prototype._setCustomData=function(o,s,O,j){O._oSectionInfo[s.getId()].buttonId=o.getId();o.addCustomData(new a({key:"sectionId",value:s.getId()}));o.addCustomData(new a({key:"bTitleVisible",value:s._getInternalTitleVisible()}));if(!j){o.addCustomData(new a({key:"secondLevel",value:true}));}};h.prototype._buildAnchorBar=function(){var o=this.getObjectPageLayout(),s=o.getSections()||[],j=this._getAnchorBar(),p=q.proxy(j.onButtonPress,j),k,l,m,n,S=g.getStaticId("sap.m","SPLIT_BUTTON_DESCRIPTION");if(j&&this.getObjectPageLayout().getShowAnchorBar()){j._resetControl();this._oObserver.disconnect();s.forEach(function(r){if(!r.getVisible()||!r._getInternalVisible()){return;}var t,u=r.getSubSections()||[];t=this._buildAnchorBarButton(r,true);if(t){j.addContent(t);if(t instanceof d){var v=new e({});t.enhanceAccessibilityState=function(E,w){var x=j.getContent(),y=x.indexOf(E.getParent());if(y!==-1){w.role="option";w.setsize=x.length;w.posinset=y+1;w.labelledby=w.labelledby.split(" ").filter(function(z){return z!==S;}).join(" ");}};v._setCustomEnhanceAccStateFunction(function(E,w){w.controls=E.data("sectionId");});t.setMenu(v);}u.forEach(function(w){if(!w.getVisible()||!w._getInternalVisible()){return;}var x=this._buildAnchorBarButton(w,false),y=j.getId()+"-"+w.getId()+"-anchor";if(x){j.addContent(x);}if(t instanceof d){n=w.getCustomAnchorBarButton();if(n){k=n.getText();l=n.getIcon();}else{k=w._getInternalTitle()||w.getTitle();l='';}m=new f(y,{"text":k,"icon":l});m.addCustomData(new a({key:"sectionId",value:w.getId()}));m.attachPress(p);this._setCustomData(m,w,o,false);t.getMenu().addItem(m);}},this);}},this);}};h.prototype._moveFocusOnSection=function(s){var S=s.data(),o=sap.ui.getCore().byId(S.sectionId),F={preventScroll:true},D;if(o){if(o.isActive()){h._focusSection(o,F);}else{D={"onAfterRendering":function(){o.removeEventDelegate(D);h._focusSection(o,F);}};o.addEventDelegate(D);}}};h.prototype._instantiateAnchorBarButton=function(j,s,k){var l,S;if(j){l=d;S={type:"Transparent",buttonMode:"Split",useDefaultActionOnly:true,ariaDescribedBy:s};}else{l=c;S={ariaDescribedBy:s};}if(k){S.id=k;}return new l(S);};h.prototype._buildAnchorBarButton=function(s,j){var o=null,O=this.getObjectPageLayout(),k,l=this._getAnchorBar(),m,S,H,v,n=s.getAggregation("subSections"),p=q.proxy(l.onButtonPress,l);if(s.getVisible()&&s._getInternalVisible()){k=s.getCustomAnchorBarButton();if(!k){m=l.getId()+"-"+s.getId()+"-anchor";if(j){if(n&&n.length>1){v=n.filter(function(r){return r.getVisible()&&r._getInternalVisible();}).length;}}H=j&&v>1&&l.getShowPopover();if(H){o=this._instantiateAnchorBarButton(true,s,m);o.attachDefaultAction(p);o._getButtonControl().attachPress(function(){this.getParent().focus();});o._getButtonControl().attachArrowPress(function(){var r=o._getButtonControl();if(this._aMenusWithAttachPressHandler[r.getId()]){return;}o.getMenu().attachItemSelected(function(E){this._moveFocusOnSection(E.getParameter("item"));},this);this._aMenusWithAttachPressHandler[r.getId()]=true;},this);o.addCustomData(new a({key:"bHasSubMenu",value:true}));}else if(j){o=this._instantiateAnchorBarButton(false,s,m);o.attachPress(function(E){this._moveFocusOnSection(E.getSource());},this);o.attachPress(p);}else{S=l.getId()+"-"+s.getId()+"-sub-anchor";o=this._instantiateAnchorBarButton(false,s,S);}var t=(s._getInternalTitle()!="")?s._getInternalTitle():s.getTitle();o.setText(t);}else{o=k.clone();o.attachPress(function(E){this._moveFocusOnSection(E.getSource());},this);o.attachPress(p);this._oObserver.observe(k,{properties:true});}this._setCustomData(o,s,O,j);}return o;};function i(n){return n.substring(0,1).toUpperCase()+n.substring(1);}return h;});
